C
C	SUBROUTINE RHIC(*,NFR,IX,NU,NV,KF)
C      INTEGER*2 BUF(256),IX(NU,NV,KF),JX(512)
C	INCLUDE 'picdir.inc'
C      CHARACTER*9 FILEN
C      COMMON/TPINFO/LUN(8),CHAR(8),JFILE(8),JREC(8),NDRV
C	NII(NFR)=512
C	NJJ(NFR)=512
C  100 FORMAT (' ','ENTER FILE NUMBER ')
C   21 WRITE(6,100)
C      READ(5,*) N
C      M=2
C      K=0
C   20 CALL TPMGR ('READ',10,N,M,BUF(1),512,I,IER)
C      DO 30 J=1,256
C      L=M/2
C      JJ=J+K
C   30 IX(JJ,L,NFR)=BUF(J)
C      IF (K.EQ.0) GO TO 50
C      K=0
C      GO TO 60
C   50 K=256
C   60 M=M+1
C      IF(M.LE.1024) GO TO 20
C      WRITE(6,300) IX(256,1,NFR),IX(510,256,NFR),
C     *       IX(256,510,NFR),IX(1,256,NFR)
C  300 FORMAT (10I6)
C	RETURN1
C	END
C   
C     SUBROUTINE TO WRITE HICKSON'S IMAGES ON TO DISK
C
C
	SUBROUTINE WHIC(*,NFR,IPAR,IX,NU,NV,KF)
      INTEGER*2 IX(NU,NV,KF),JX(512)
	CHARACTER*9 FILEN
	INCLUDE 'picdir.inc'
  101 FORMAT (' ',' ENTER IMAGE NAME, n FOR NO WRITE ')
      WRITE(6,101)
   52 FORMAT (A9)
      READ (4,52) FILEN
	IF (FILEN.EQ.'n') RETURN1
	OPEN(UNIT=20,FILE=FILEN,STATUS='NEW',FORM='UNFORMATTED',RECL=128)
  200 FORMAT(' ',' SMOOTHING BY 2? 1 IF YES')
      WRITE(6,200)
      READ(5,*) IANS
      DO 40 IC=1,512
      JX(1)=IX(IC,1,NFR)
      DO 70 K=2,512
      IF (IANS.NE.1) GO TO 201
      JX(K)=IX(IC,K-1,NFR)/2+IX(IC,K,NFR)/2
      GO TO 70
  201 JX(K)=IX(IC,K,NFR)
   70 CONTINUE
      WRITE(20) (JX(J),J=1,256)
   40 WRITE(20) (JX(J),J=257,512)
      CLOSE(UNIT=20)
	RETURN1
      END
C
C  SUBROUTINE TO CORRECT HICKSON PHOTON COUNTING IMAGE
C
C
	SUBROUTINE CORHIC(*,NFR,IPAR,IX,NU,NV,KF)
	INTEGER*2 IX(NU,NV,KF)
	real zratio(1)
c	REAL ZRATIO(1000)
	INCLUDE 'picdir.inc'
	NI=NII(NFR)
	NJ=NJJ(NFR)
	K1=NI/3-15
	K2=K1+30
	K3=NJ/3-15
	K4=K3+30
	NZR=0
	CALL PSTAT(*110,NFR,K1,K3,K2,K4,PM,PSIG,1)
 110	THRESU=PM+2.*PSIG
	THRESL=PM-2.*PSIG
	SIGTHR=2.*PSIG
	DO 100 I=30,480,2
	CALL PSTAT(*111,NFR,I,0,0,0,RM1,RSIG1,-9)
 111	CALL PSTAT(*112,NFR,I+1,0,0,0,RM2,RSIG2,-9)
 112	CONTINUE
C	TYPE*,I,RM1,RSIG1,RM2,RSIG2,RM2/(RM1+.001)
C	IF (RM1.GT.THRESU.OR.RM2.GT.THRESU) GO TO 100
C	IF (RM1.LT.THRESL.OR.RM2.LT.THRESL) GO TO 100
	IF (RSIG1.GT.SIGTHR.OR.RSIG2.GT.SIGTHR) GO TO 100
	NZR=NZR+1
	IF (RM1.NE.0.) ZRATIO(NZR)=1000.*RM2/RM1
 100	CONTINUE
	CALL MMM(ZRATIO,NZR,NZ,ZAVE,ZMEDS,RATMODE,RATSIG,ZSK,
     *           ZREJ,NIT,1.,OM)
	WRITE(6,*) ZAVE,ZMEDS,RATMODE,NIT,ZREJ
	RATMODE=RATMODE*.001
	RATSIG=RATSIG*.001
	WRITE(6,200) RATMODE,RATSIG,NZR,NZ
 200	FORMAT(' ODD-EVEN RATIO: ',F6.4,'  SIGMA: ',F6.5,
     *         ' DETERMINED FROM ',I3,I4,' LINE PAIRS',/,
     *         '   ----- EVEN LINES TO BE SCALED -----')
	DO 150 J=2,512,2
	DO 150 I=1,NI
 	XT=RATMODE*IX(I,J,NFR)
 150	IF (ABS(XT).LT.32767.) IX(I,J,NFR)=XT
	RETURN1
	END
C
C     SUBROUTINE SHEAR : CORRECTION FOR 1-D DISTORTION 
C
	SUBROUTINE SHEAR(*,NFR,IPAR,IX,NU,NV,KF)
	INTEGER*2 IX(NU,NV,KF)
	CHARACTER*9 FILEN
c	REAL SINC(33),CEN(512),DD(9)
	REAL SINC(1),CEN(1),DD(1)
	INCLUDE 'picdir.inc'
	NI=NII(NFR)
	NJ=NJJ(NFR)
	PI=3.14159
601	WRITE(6,*) ' ENTER CENTROID FILE NAME'
 	READ(5,10) FILEN
	OPEN(UNIT=20,FILE=FILEN,STATUS='OLD',ERR=601)
 10	FORMAT(A9)
 600	WRITE(6,*) ' ENTER DESIRED CENTER OF SPECTRUM (REAL)'
	READ(5,*,ERR=600) SPCEN
	DO 199 J=1,NJ
 199	READ(20,*) NDUM, XI,CEN(J)
	DO 200 J=1,NJ
C	DO 200 J=5,NJ-4
C	DO 197 K=1,9
C 197	DD(K)=CEN(J+K-3)
C	DO 196 M=1,9
C	DO 196 N=1,9
C	IF (DD(N).LT.DD(N+1)) GO TO 196
C	T=DD(N)
C	DD(N)=DD(N+1)
C	DD(N+1)=T
C196	CONTINUE
C	CEN1=DD(5)
	CEN1=CEN(J)
	XI=CEN1-SPCEN
 	ISH=XI+.5
	IF (XT.LT.0.) ISH=XI-.5
	X=ISH-XI
	DO 201 K=1,33
	XT=PI*(X+FLOAT(K-17))
	IF (XT) 202,203,202
 202	SINC(K)=SIN(XT)/XT
	GOTO 201
 203	SINC(K)=1.
 201	CONTINUE
	DO 205 I=1,NI
	KK=I-17+ISH
	XT=0.
	DO 206 K=1,33
	KKK=KK+K
	IF (KKK.LT.1.OR.KKK.GT.NI) GO TO 206
	XT=XT+SINC(K)*IX(KKK,J,NFR)
 206	CONTINUE
 205 	IX(I,J,KF)=XT
 200 	CONTINUE
	CALL MOVE (KF,NFR,IX,NUNV,KF)
	CLOSE(UNIT=20)
	RETURN1
	END
	
C    SUBROUTINE SNAKE : DETERMINE CENTROID OF SPECTRUM
C        AS  A FUNCTION OF WAVELENGTH
C
C	
	SUBROUTINE SNAKE(*,NFR,IPR,IX,NU,NV,KF)
	INTEGER*2 IX(NU,NV,KF)
	CHARACTER*9 FILEN
	REAL XT(1),CEN(1)
c	REAL XT(512),CEN(512)
	INCLUDE 'picdir.inc'
	NI=NII(NFR)
	NJ=NJJ(NFR)
	NJC=NJ/2
	MAX=0
	IH=30
	DO 100 I=30,NI-30
	IF (IX(I,NJC,NFR).LT.MAX) GO TO 100
	MAX=IX(I,NJC,NFR)
	IH=I
 100	CONTINUE
	WRITE(6,*) ' PEAK AT I=',IH,MAX
 600	WRITE(6,*) ' ENTER CENTER I'
	READ(5,*,ERR=600) IC
 601	WRITE(6,*) ' ENTER HALF STRIP SIZE AND NUMBER OF SECTIONS'
	READ(5,*,ERR=601) ISS,NSEC
 602	WRITE(6,*) ' ENTER OUTPUT FILE NAME, "n" FOR NO WRITE'
 	READ(5,10,ERR=602) FILEN
 10	FORMAT(A9)
	IF (FILEN.EQ.'n') GO TO 603
	OPEN(UNIT=20,FILE=FILEN,STATUS='NEW')
 603	LINC=NJ/NSEC
	K3A=IC-ISS-ISS+1
	K4A=IC-ISS
	K3B=IC+ISS
	K4B=K3B+ISS-1
	DO 101 K=1,NSEC
	K1=(K-1)*LINC+1
	K2=K*LINC
	CALL PSTAT(*120,NFR,K3A,K1,K4A,K2,RMODE1,SIG1,-1,IX,NU,NV,KF)
 120	CALL PSTAT(*121,NFR,K3B,K1,K4B,K2,RMODE2,SIG2,-1,IX,NU,NV,KF)
 121	SKY=.5*(RMODE1+RMODE2)
	SUMX=0.
	SUMXJ=0.
	MJ=0
	DO 103 I=K4A,K3B
	MJ=MJ+1
	XT(MJ)=0.
	DO 102 J=K1,K2
 102	XT(MJ)=XT(MJ)+FLOAT(IX(I,J,NFR))-SKY
C   CENTROIDING
	SUMX=SUMX+XT(MJ)
 103	SUMXJ=SUMXJ+XT(MJ)*FLOAT(I)
 	IF (SUMX.NE.0.) CEN(K)=SUMXJ/SUMX
 101 	CONTINUE
	XIN=FLOAT(NI)/FLOAT(NSEC)
	DO 107 K=1,NSEC
	XT(K)=XIN*(FLOAT(K)-.5)
	WRITE(20,*) K,XT(K),CEN(K)
 107	WRITE(6,*) K,XT(K),CEN(K)
	CALL LSQF(NSEC,XT,CEN,A,B)
	WRITE(6,*) 'A',A,'B',B
	IF (FILEN.NE.'n') CLOSE(UNIT=20)
	RETURN1
	END
C
C    SUBROUTINE JSNAKE : DETERMINE CENTROID OF SPECTRUM
C        AS  A FUNCTION OF WAVELENGTH
C
C	
	SUBROUTINE JSNAKE(*,NFR,IPAR,IX,NU,NV,KF)
	INTEGER*2 IX(NU,NV,KF)
	REAL XT(1),CEN(1)
c	REAL XT(128),CEN(128)
	INCLUDE 'picdir.inc'
	NI=NII(NFR)
	NJ=NJJ(NFR)
	NIC=200
	MAX=0
	JH=30
	DO 100 J=30,NJ-30
	IF (IX(NIC,J,NFR).LT.MAX) GO TO 100
	MAX=IX(NIC,J,NFR)
	JH=J
 100	CONTINUE
	WRITE(6,*) ' PEAK AT J=',JH,MAX
 600	WRITE(6,*) ' ENTER CENTER J'
	READ(5,*,ERR=600) JC
 601	WRITE(6,*) ' ENTER HALF STRIP SIZE AND NUMBER OF SECTIONS'
	READ(5,*,ERR=601) ISS,NSEC
	LINC=NI/NSEC
	K3A=JC-ISS-ISS+1
	K4A=JC-ISS
	K3B=JC+ISS
	K4B=K3B+ISS-1
	DO 101 K=1,NSEC
	K1=(K-1)*LINC+1
	K2=K*LINC
	CALL PSTAT(*120,NFR,K1,K3A,K2,K4A,RMODE1,SIG1,1,IX,NU,NV,KF)
 120	CALL PSTAT(*121,NFR,K1,K3B,K2,K4B,RMODE2,SIG2,1,IX,NU,NV,KF)
 121	SKY=.5*(RMODE1+RMODE2)
	SUMX=0.
	SUMXJ=0.
	MJ=0
	DO 103 J=K4A,K3B
	MJ=MJ+1
	XT(MJ)=0.
	DO 102 I=K1,K2
 102	XT(MJ)=XT(MJ)+FLOAT(IX(I,J,NFR))-SKY
C   CENTROIDING
	SUMX=SUMX+XT(MJ)
 103	SUMXJ=SUMXJ+XT(MJ)*FLOAT(J)
 	IF (SUMX.NE.0.) CEN(K)=SUMXJ/SUMX
 101 	CONTINUE
	DO 107 K=1,NSEC
 107	WRITE(6,*) K,CEN(K)
	RETURN1
	END
C
C SIN CURVE DE-MODULATION
	SUBROUTINE DESIN(*,NFR,IPAR,IX,NU,NV,KF)
	INTEGER*2 IX(NU,NV,KF)
	INCLUDE 'picdir.inc'
	NI=NII(NFR)
	NJ=NJJ(NFR)
 600	WRITE(6,*) '  ENTER AMP(%), PERIOD(PIXEL,REAL), PEAK (REAL)'
	READ(5,*,ERR=600) AMP,PER,PEAK
	PP=6.2832/PER
	DO 100 I=1,NI
	FRA=1.+AMP*COS((FLOAT(I)-PEAK)*PP)
	DO 100 J=1,NJ
	XTR=FLOAT(IX(I,J,NFR))/FRA
	IF (ABS(XTR).GT.32767.) GO TO 100
	IX(I,J,NFR)=XTR
 100	CONTINUE
	RETURN1
	END
C
 	SUBROUTINE LSQF(NO,HBN,OIIIN,A,B,RSQ)
	DIMENSION HBN(1),OIIIN(1)
	REAL*8 X,XX,XY,Y,YY,AA,BB,SEY,T,SXY,SXX,SYY
	XX=0.
	YY=0.
	X=0.
	Y=0.
	XY=0.
	DO 300 I=1,NO
	X=X+HBN(I)
	XX=XX+HBN(I)*HBN(I)
	XY=XY+HBN(I)*OIIIN(I)
	Y=Y+OIIIN(I)
 300	YY=YY+OIIIN(I)*OIIIN(I)
	SXX=XX-X*X/NO
	SXY=XY-X*Y/NO
	SYY=YY-Y*Y/NO
	BB=0.
	RSQ=0.
	IF (SXX.NE.0.) BB=SXY/SXX
	A=(Y-BB*X)/NO
	B=BB
	IF (SYY.NE.0.) RSQ=BB*SXY/SYY
	RETURN
	END
