CC***********************************************************************
C SUBROUTINE PACKAGE FOR IO OPERATIONS FOR PPP                         *
C     INCLUDES INPUT FROM TAPE, DISK, OUTPUT TO DISK,                  *
C              PRINTNG ARRY, AND PLOTTING                              *
C***********************************************************************
C
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE FOR PRINTING PART OF THE ARRAY
C
C///////////////////////////////////////////////////////////////////////
	SUBROUTINE PRINTZ(*,NFRA,SCOM,IPAR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INTEGER NFRA(5),IB(10),IE(10),ISHI(10)
	CHARACTER STR*10,CODE(10)*1,SCOM*60,ian*1
	CHARACTER*64 FSTR3, FSTR4, FSTR22, string
	INCLUDE 'picdir.inc'
	NFR=NFRA(1)
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	NI=NII(NFR)
	NJ=NJJ(NFR)
	IF (SCOM.EQ.'*') GO TO 100
	IX0=NFRA(2)
	IY0=NFRA(3)
	IDX=NFRA(4)
	IDY=NFRA(5)
 100	CALL PINP(IX0,IY0,IDX,IDY,*999,*21001)
21001	IF (IDX.GT.75.OR.IDY.GT.19) THEN
	  WRITE(6,10) 
 10	FORMAT(' ??? Do you really want to print out such a big block?',
     *         ' (y/n): ',$)
	  call readstr(1,ian,*999,*999)
c	  READ(5,11,END=999,ERR=999) IAN
 11	FORMAT(A1)
	  IF (IAN.NE.'y') GO TO 100
	END IF
	IF (IDY.GT.22) THEN
	  WRITE(6,*) ' **** BLOCK TOO LARGE, OUTPUT OVERFLOW ****'
	  RETURN1
	END IF
 101	J1=MAX0(1,IY0-IDY/2)
 1	J2=MIN0(J1+IDY-1,J1+11)
	ISTATUS=ENCODE(STRING,FLOAT(MAX0(J2-J1+1,1)),1,0,IDUM)
	FSTR4='(/1X,''F'',I2,''<--J '','
&	    //string(1:lnblnk(string))//'('' #'',I4)/)'
c&		//'('' #'',I4)/)'
	WRITE(6,FSTR4) NFR,(J,J=J2,J1,-1)
	IF (IPAR.EQ.0) WRITE(8,FSTR4) NFR,(J,J=J2,J1,-1)
C 4	FORMAT(/1X,'F',I2,'<--J ',<MAX0(J2-J1+1,1)>(' #',I4)/)
	I1=MAX0(1,IX0-IDX/2)
	I2=I1+IDX-1
	DO 200 I=I1,I2
	  ISTATUS=ENCODE(STRING,FLOAT(MAX0(J2-J1+1,1)),1,0,IDUM)
	  FSTR3='('' #'',I4,'':  '','//string(1:lnblnk(string))//'I6)'
	  IF (IPAR.EQ.0) WRITE(8,FSTR3) I,(IX(I,J,NFR),J=J2,J1,-1)
 200	  WRITE(6,FSTR3) I,(IX(I,J,NFR),J=J2,J1,-1)
C 3	FORMAT(' #',I4,':  ',<MAX0(J2-J1+1,1)>I6)
C   input for moving window
 600	WRITE(6,20)
 20	FORMAT('  ln,rn,un,dn,in,jn,fn (n=INT) to MOVE window,',
     *        ' <cr>=out: ',$)
	call readstr(10,str,*999,*600)
c	READ(5,23,END=999,ERR=600) STR
c 23	FORMAT(A10)
	CALL FSTR(STR,10,IB,IE,NS)
	IF (NS.EQ.0) RETURN1
	DO 102 I=1,NS
	  READ(STR(IB(I):IB(I)),21,ERR=600,END=600) CODE(I)
	  ISTATUS=ENCODE(STRING,FLOAT(MAX0(1,IE(I)-IB(I))),1,0,IDUM)
	  FSTR22='(I'//string(1:lnblnk(string))//')'
C 22	FORMAT(I< MAX0(1,IE(I)-IB(I)) >)
	  READ(STR(IB(I)+1:IE(I)),FSTR22,ERR=600,END=600) ISHI(I)
1111	FORMAT(3X,A1,I4)
	  IF (CODE(I).EQ.'f') THEN
	    NFR=ISHI(I)
	    CALL QUERYNFR(NFR,KF,0,*999,*20002)
20002	    GO TO 102
	  ELSE IF (CODE(I).EQ.'i') THEN
	    IX0=ISHI(I)
	  ELSE IF (CODE(I).EQ.'j') THEN
	    IY0=ISHI(I)
	  ELSE
	    IF (CODE(I).EQ.'r'.OR.CODE(I).EQ.'u') ISHI(I)=-ISHI(I)
	    IF (CODE(I).EQ.'r'.OR.CODE(I).EQ.'l') THEN
	      IY0=IY0+ISHI(I)
	    ELSE IF (CODE(I).EQ.'u'.OR.CODE(I).EQ.'d') THEN
	      IX0=IX0+ISHI(I)
	    ELSE
	    WRITE(6,24) I
 24	FORMAT('  *** error in input, re-enter movement',I2,
     *             ' and beyond')
	    GO TO 600
	    END IF
	  END IF
 102	CONTINUE
	GO TO 101
 21	FORMAT(A1)
C 22	FORMAT(I<MAX0(1,IE(I)-IB(I))>)
 999   RETURN1
       END
C
C///////////////////////////////////////////////////////////////////////
C
      SUBROUTINE LESQR(POW,NUM,Z,X,HH,B)
c     INTEGER*2 NUM
      INTEGER NUM
      INTEGER POW
      DIMENSION Z(25),X(25)
      REAL HH(25),B(10)
      DO 30 L=1,10
   30 B(L)=0.
      IF(NUM) 1,2,1
    1 NW=POW+1
      DO 3 JJ=1,NW
      UU=0.
      DO 4 II=1,NUM
      UX=1.
      JP=JJ-1
      DO 5 IJ=1,JP
      IF (JP) 5,5,20
   20 UX=UX*X(II)
    5 CONTINUE
    4 UU=UU+Z(II)*UX
      B(JJ)=UU
      IHH=JJ-NW
      DO 6 LL=1,NW
      UU=0.
      DO 7 II=1,NUM
      UX=1.
      JUG=JJ+LL-2
      DO 8 IJ=1,JUG
      IF (JUG) 8,8,21
   21 UX=UX*X(II)
    8 CONTINUE
    7 UU=UU+UX
      IHH1=IHH+LL*NW
    6 HH(IHH1)=UU
    3 CONTINUE
    2 RETURN
      END

C
C///////////////////////////////////////////////////////////////////////
C
      SUBROUTINE SIMQ(A,B,N,KS)
      DIMENSION A(1),B(1)
      TOL=0.0
      KS=0
      JJ=-N
      DO 65 J=1,N
      JY=J+1
      JJ=JJ+N+1
      BIGA=0
      IT=JJ-J
      DO 30 I=J,N
      IJ=IT+I
      IF(ABS(BIGA)-ABS(A(IJ))) 20,30,30
   20 BIGA=A(IJ)
      IMAX=I
   30 CONTINUE
      IF(ABS(BIGA)-TOL) 35,35,40
   35 KS=1
      RETURN
   40 I1=J+N*(J-2)
      IT=IMAX-J
      DO 50 K=J,N
      I1=I1+N
      I2=I1+IT
      SAVE=A(I1)
      A(I1)=A(I2)
      A(I2)=SAVE
   50 A(I1)=A(I1)/BIGA
      SAVE=B(IMAX)
      B(IMAX)=B(J)
      B(J)=SAVE/BIGA
      IF(J-N) 55,70,55
   55 IQS=N*(J-1)
      DO 65 IX=JY,N
      IXJ=IQS+IX
      IT=J-IX
      DO 60 JX=JY,N
      IXJX=N*(JX-1)+IX
      JJX=IXJX+IT
   60 A(IXJX)=A(IXJX)-A(IXJ)*A(JJX)
   65 B(IX)=B(IX)-B(J)*A(IXJ)
   70 NY=N-1
      IT=N*N
      DO 80 J=1,NY
      IA=IT-J
      IB=N-J
      IC=N
      DO 80 K=1,J
      B(IB)=B(IB)-A(IA)*B(IC)
      IA=IA-N
   80 IC=IC-1
      RETURN
      END

C
C///////////////////////////////////////////////////////////////////////
C
C  INPUT CO-ORD
C
	SUBROUTINE PINP(IX0T,IY0T,IDXT,IDYT,*,*)
	IF (IX0T.EQ.0.OR.IY0T.EQ.0) THEN
 600	  WRITE(6,10) IX0,IY0
 10	FORMAT('  Enter center co-ordinates I,J [',2I5,']: ',$)
	  CALL READ2I(IX0,IY0,*999,*600)
	  IX0T=IX0
	  IY0T=IY0
	ELSE
	  IX0=IX0T
	  IY0=IY0T
	END IF
	IF (IDXT.EQ.0.OR.IDYT.EQ.0) THEN
 601	  WRITE(6,11) IDX,IDY
 11	FORMAT('  Enter block size in I and J [',2I3,']: ',$)
	  CALL READ2I(IDX,IDY,*999,*601)
	  IDXT=IDX
	  IDYT=IDY
	ELSE
	  IDX=IDXT
	  IDY=IDYT
	END IF
	RETURN2
 999	RETURN1
	END

C
C
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO CREATE FAKE PICTURE (SIMPLE VERSION)
C
C///////////////////////////////////////////////////////////////////////
	SUBROUTINE MAKE(*,NFR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF),IOB(20),JOB(20)
	INTEGER IX(NU,NV,KF),IOB(20),JOB(20)
	DIMENSION STAR(50,50),TI(20),RANDOM(80000)
	character trun*1,iann*1
	INCLUDE 'picdir.inc'
	INCLUDE 'pppcore.inc'
	EQUIVALENCE (iscr(1),RANDOM(1)),(iscr(300001),star(1,1))
	CALL QUERYNFR(NFR,KF,0,*900,*20001)
20001	CALL SIZE(*80,NII,NJJ,NFR,NU,NV,KF)
 80	WRITE(6,9) BK
	CALL READ1R(BK,*900,*80)
 9	FORMAT('   Enter background counts  (deflt:',F8.2,'): ',$)
 800 	WRITE(6,19)
 19	FORMAT('  Do you want nearest integer (n), truncate up (u) or'
     *       ,' down (d) (Dflt: n): ',$)
	call readstr(1,trun,*900,*800)
	IF (TRUN.EQ.'u') THEN
	  ADD=0.499999999
	ELSE IF (TRUN.EQ.'d') THEN
	  ADD=-0.49999999
	ELSE
	  ADD=0.000000000
	END IF
	IF (BK.GT.32000.) THEN
	  WRITE(6,*)  '  **** Too large, try again *****'
	  GO TO 80
	END IF
 600	WRITE(6,11) FWHM
 11	FORMAT('   Enter FWHM in FRACTIONAL pixel (dflt:',F7.3,') ',$)
	CALL READ1R(FWHM,*900,*600)
	IF (FWHM.GT.6.2.OR.FWHM.LE..1) THEN
	  WRITE(6,*) '  ***** FWHM must be between 0.1 and 6.2 *****'
	  GO TO 600
	END IF
 601	WRITE(6,12) KOB
 12	FORMAT('   Enter number of objects desired (dflt:',I4,') ',$)
	CALL READ1I(KOB,*900,*601)
	WRITE(6,13) KOB
 13	FORMAT( '  Enter, for',I4,' objects, I J co-ord. (Integer) and'
     *          ,' total intensity (Real)...'/)
	DO 100 I=1, KOB
 602	  WRITE(6,14) I
 14	FORMAT( '   OBJECT #',I3,': ',$)	 
 	  READ(5,*,ERR=602,END=900) IOB(I),JOB(I),TI(I)
 100	CONTINUE
 603	IF (IBK.GE.2) THEN
 6031	  WRITE(6,15) 
 15	FORMAT(' Do you want to add Guassian noise ? (sigma=root(bkg)'
     *          ,' (y/n): ',$)
	  call readstr(1,iann,*900,*6031)
	ELSE
	  IANN='n'
	END IF
	NI=NII(NFR)
	NJ=NJJ(NFR)
	NF(NFR)=0
	OPEN (UNIT=23,FILE='makelis.dat',STATUS='NEW')
	WRITE(6,57) 
 57	FORMAT('  ...File <makelis.dat> containing position and flux'
     *       ,' of objects is created')
	WRITE(23,200) BK,FWHM,KOB
	DO 108 J=1,KOB
 108	  WRITE(23,201) J,IOB(J),JOB(J),TI(J)
 200	FORMAT(1X,'BK=',F7.1,' FWHM=',F5.2,' NUM OF OBJ',I3)
 201	FORMAT(1X,3(I4,1X),F10.1)
	CLOSE(UNIT=23)
	C1=-.5/(FWHM*FWHM/4.)
	C2=-C1/3.14159
	IAS=8.*FWHM
	IF (MOD(IAS,2).EQ.0) IAS=IAS+1
	IIC=IAS/2
	ICEN=IIC+1
C   create master star profile
	DO 102 J=1,IAS
	  DO 102 I=1,IAS
 102	    STAR(I,J)=C2*EXP(C1*((I-ICEN)*(I-ICEN)+(J-ICEN)*(J-ICEN)))
C  fill background with markers -1000
	  DO 101 J=1,NJ
	    DO 101 I=1,NI
 101	      IX(I,J,NFR)=-1000
C  ADD NOISE
	IRAN=MIN0(NI*NJ,80000)
	IF (IANN.EQ.'y') THEN
	  SIG=1./SQRT(AMAX1(1.,BK))
	  WRITE(6,*)  '  ....generating random numbers for noise...'
	  CALL RANGENG(IRAN,RANDOM,SIG)
	ELSE
	  DO 130 J=1,IRAN
 130	    RANDOM(J)=0.0000000
	END IF
C  put in objects and noise (for places with object only)
	DO 104 N=1,KOB
	  JJ=0
	  DO 104 J=JOB(N)-IIC, JOB(N)+IIC
	    II=0
	    JJ=JJ+1
	    JR=(J-1)*NJ
	    DO 104 I=IOB(N)-IIC, IOB(N)+IIC
	      II=II+1
C  pick out randomnumber
C  note that noise is only added to the back ground but not the object
C this  is so that one can test the photometry without worrying additional
C noise being added to the object.  Truncation, however, are included)
	      IPIX=JR+I
	      IXX=NINT(BK*(1.+RANDOM(IPIX))+TI(N)*STAR(II,JJ)+ADD)
 104	      IX(I,J,NFR)=INTLIMI(IXX)
C now fill in background
	IPIX=0
	DO 105 J=1,NJ
	  DO 105 I=1,NI
	    IPIX=IPIX+1
	    IF (IPIX.GT.IRAN) IPIX=1
 105	    IF (IX(I,J,NFR).EQ.-1000)
     *         IX(I,J,NFR)=NINT(BK*(1.+RANDOM(IPIX))+ADD)
C	      SIGMA=1./SQRT(FLOAT(IX(I,J,NFR)))
C	      CALL RANGENU(3,RNU1)
C	      CALL RANGENG(5,RNU2,SIGMA)
C	      V=RNU2(INT(5.*RNU1(3))+1)
C 105	  IX(I,J,NFR)=IX(I,J,NFR)*(1.+V)
C	ELSE
C	  DO 101 J=1,NJ
C	    DO 101 I=1,NI
C101	      IX(I,J,NFR)=NINT(BK+ADD)
C	END IF
 900	RETURN1
	END

C///////////////////////////////////////////////////////////////////////
C
	SUBROUTINE RANDUP(X,Y)
	Y=(3.14159+X)**5.
	Y=Y-INT(Y)
	RETURN
	END
