c ppprcs 2 pipeline version: modified from Feb 14 2004
c  ppp :
C        Modified for use with lower case commands
C                      Mar. 24, 1990
C
C  ppp - a PICTURE PROCESSING PROGRAM - 
c                 main program: command interpreter
c
C  default output UNITS  5,6=TT
C
c See subprogram HELP for a description of the structure and command of
c  the system.
c memory storage for image ixb(), equivalenced to ix(1,1,1).
c To increase size of memory, adjust dimension of ixb in main program
c   and the pppcore.inc file, AND change ALL the equivalence statements
c   involving ixb in the subprograms to reflect the larger working array.
C
c  To crete ppp: see Makefile.  Libraries required: pgplot (see pgplot
c    manual from Tim Pearson on creating pgplot); dtalib (DAOPHOT
c   library: not needed if you don't need to read Figaro format pictures,
c   simply get rid of RDAO subroutine). The following are Unix only
c   set up: for displaying pictures on SUNview, install the program ds
c   from Bill Sebok (called by the system command system(ds....); to 
c   write fits format picture onto tape ppp uses the unix command dd.  
c
c                                           April 28, 1990
c
c   version 5: designed for RCS pipeline
c           CFTSIO is used for reading images, MEF extension: ^n
C
	program ppp
	INTEGER ILK(263,3),NFR(5),IISP(0:3),ICOM(41)
	INTEGER IX(1,1,1),NFLAG,NID,NJD,IFILE
	REAL RN(5)
	CHARACTER*80 CSTR(41)
	CHARACTER*60 SCOM(6)
	CHARACTER*24 NFILEN,fitsname*24
	CHARACTER*24 ATIME,tempname
	CHARACTER*36 NCOM,NCOMC,imdir*55,headbst*2880
	CHARACTER*18 HPLOT,SPLOT,tape,noper*1
	character headblk*2880,nfrstr*2,mnd*4,headtemp*10,nametemp*18
c fits header directory
	common/headerst/bzest(15),bscst(15),headbst(20,15),nhbst(15)
c current fits header info
	common/header/bzero,bscale,headblk(20),nhb
c  boxes are defined as i1,i2,j1,j2 
	COMMON/BOX/IBOX(4,10),NBOX
	include 'pppcore.inc'
c	common/iodev/idin,idout,idhis
	include 'ppparm.inc'
 	include 'pipeparm.inc'
	COMMON/PLOTDEV/ HPLOT,SPLOT,ipinit
	common/imagedir/imdir
	character ppppath*48
        common/pppname/ppppath
	common/buffsize/nbuff,nu,nv
	COMMON/DIR/nof,NCOM(254),NFILEN(254),NFLAG(5,254)
     *	            ,NID(254),NJD(254),iextend(254)
	include 'picdir.inc'
	include 'imagepar.inc'
	include 'galfitparm.inc'
	COMMON/PICC/ NCOMC(15),fitsname(15)
	COMMON/CURSPOS/ICUR(10),JCUR(10),ipro(10)
	COMMON/HDFIT/CLRPLT,NFITHD,P(5)
	common/bstarxy/nbstar,bstx(10),bsty(10),bsrad(10),bsmag(10)
	common/photdata/reali,realj,counts,terr
        common/bsmaskdata/ghostplx(2,2,36,3),ghostply(2,2,36,3),
     *         bsmaskrad(0:3),bspmag(3,2),ighostread
	EQUIVALENCE (IX(1,1,1),IXB(1))
        include 'objcat.inc' 
	include 'apert.inc'
	include 'tvparm.inc'
	idin=5
	idout=6
	idevtty=idin
	ighostread=0
c	open(unit=idin)
c	open(unit=idout)
	KX1=0.
	NFITF=0
	NFITHD=5
	IMACRUN=0
	ipinit=0
	nbstar=0
	ITV=0
	NBOX=0
	maxap=455
	bscale=1.0
	bzero=0.0
c initialize fits headers
	do 276 i=1,15
	  bzest(i)=0.
	  bscst(i)=1.0
	  nhbst(i)=0 
	  pixscale(i)=0.
	  saturate(i)=0.
	  nsct(i)=0
 276	continue
	iisp(0)=0
	iisp(3)=0
c initialize position file boundry values to be zeros
c   i.e., default = size of image
	do 271 i=1,2
	  ilpos(i)=0
	  iupos(i)=0
	  jlpos(i)=0
	  jupos(i)=0
	  iisp(i)=0
 271	continue
c!  max number of commands in command stack
	LCOM=41            
c	DO 270 I=1,LCOM-1
	DO 270 I=1,LCOM
	  icom(i)=0
 270	  CSTR(I)=' ' 
	DO 277 I=1,7
 277	  NCOMC(I)='                                  '
	CALL setgalfit(*1624,' ',' ',0,0.,0)
 1624	CALL setrcspipe(*1623,' ',' ',0,0.,0)
 1623	CALL SETPARM(*1622,' ',0,0.,' ',0)
c   set number of frames -- nbuff, nu, and nv are read from setparm
c      1000000 is the size of the scartch buffer
c          
 1622	KF=min0((nbuff-1000000)/(NU*NV)+1,nbuff/(nu*nv))
c  kf cannot be greater than 15
	kf=min0(15,kf)
c  read pppcore directory
	call rwdir(-1)
c  create a backup version of current directory
	CALL RWDIR(1)
	INIT=0
c initialize section number
C
C    begin session
C
c	CALL DATE(ADATE)
c	CALL TIME(ATIME)
c	READ(ATIME(4:8),1631) ITM2,ITS2
 	call fdate(atime)
c	atime=fdate()
	read(atime(15:19),1631) itm2,its2
1631	format(i2,1x,i2)
	write(idout,161) ATIME
 161	FORMAT(//,' ---Picture Processing Package V5.1---  ',A24,//)
	CALL MAXSIZE(*1621,NU,NV,KF,nbuff,1)
 1621	IENDATA=0
c       CALL RBELL(1)
 	write(idout,*) 'No. of files in directory',NOF
c!  always operate on the LCOMth CSTR
	KOP=LCOM-1   
c   command interpretor:
 99	call command(cstr,icom,lcom,mnd,scom,nfr,rn,5,kop,'ppp',iecho,
     *                imacrun,idin,idout,idhis,*9999,*999)
C
C  search for the proper command subroutine
C
	IF (MND.EQ.'parm')   CALL SETPARM(*99,SCOM(2),NFR(2),RN(2),
     *                                    SCOM(3),1)
	IF (MND.EQ.'set')    CALL SETPARM(*99,SCOM(2),NFR(2),RN(2),
     *                                    SCOM(3),1)
	IF (MND.EQ.'pset')    CALL setrcspipe(*99,SCOM(2),scom(3),NFR(2),
     *                                    rn(2),1)
	IF (MND.EQ.'gset')    CALL setgalfit(*99,SCOM(2),scom(3),NFR(2),
     *                                    rn(2),1)
	IF (MND.EQ.'pltf') THEN
	                     CALL PLOTFILE(1)
	                     GO TO 99
	                   END IF
	IF (MND.EQ.'help')   CALL HELP(*99,'TT',SCOM(2))
	IF (MND.EQ.'phel')   CALL HELP(*99,'LP',' ')
	IF (MND.EQ.'end')    CALL ENDMACRO(*99,idin,idevtty,IMACRUN,iecho)
	IF (MND.EQ.'mac1')   CALL GOMACRO(*99,SCOM(2),1,idin,idevtty,
     *                                     'ppp       ',IMACRUN,iecho)
	IF (MND.EQ.'mac2')   CALL GOMACRO(*99,SCOM(2),2,idin,idevtty,
     *                                     'ppp       ',IMACRUN,iecho)
	IF (MND.EQ.'mac3')   CALL GOMACRO(*99,SCOM(2),3,idin,idevtty,
     *                                     'ppp       ',IMACRUN,iecho)
	IF (MND.EQ.'macr')   CALL GOMACRO(*99,SCOM(2),0,idin,idevtty,
     *                                     'ppp       ',IMACRUN,iecho)
	IF (MND.EQ.'hist')   CALL TYCOMM(*99,CSTR,LCOM,icom)
	IF (MND.EQ.'savh')   CALL COMFIL(*99,SCOM(2),CSTR,LCOM)
	IF (MND.EQ.'msiz')   CALL MAXSIZE(*99,NU,NV,KF,nbuff,0)
	IF (MND.EQ.'cc')     CALL ARITHM(*99)
	IF (MND.EQ.'gran')   CALL genrandoms(1,*99)
	IF (MND.EQ.'uran')   CALL genrandoms(0,*99)
	IF (MND.EQ.'crbp')   CALL CRBPIX(*99,IX,NU,NV,KF,0)
	IF (MND.EQ.'+crb')   CALL CRBPIX(*99,IX,NU,NV,KF,-1)
	IF (MND.EQ.'crbd')   CALL CRBPIX(*99,IX,NU,NV,KF,1)
	IF (MND.EQ.'cmas')   CALL mkmask(*99,nfr(1),nfr(2),ix,nu,nv,kf)
	IF (MND.EQ.'mkhd')   CALL msposdr(*99,nfr(1),nfr(2),0,ix,nu,nv,kf)
	IF (MND.EQ.'mkms')   CALL msposdr(*99,nfr(1),nfr(2),1,ix,nu,nv,kf)
	IF (MND.EQ.'mspo')   CALL msposdr(*99,nfr(1),nfr(2),2,ix,nu,nv,kf)
	IF (MND.EQ.'bldm')   CALL bleedmap(*99,nfr(1),nfr(2),ix,nu,nv,kf,
     *                                     0,1,0)
	IF (MND.EQ.'+bld')   CALL bleedmap(*99,nfr(1),nfr(2),ix,nu,nv,kf,
     *                                     0,0,0)
	IF (MND.EQ.'saoc')   CALL saocrbp(*99,nfr(1),iorient,0)
	IF (MND.EQ.'saop')   CALL saocrbp(*99,nfr(1),iorient,1)
	IF (MND.EQ.'mbdi')   CALL bpborder(*99,nfr(1),0,IX,NU,NV,KF)
	IF (MND.EQ.'mbdo')   CALL bpborder(*99,nfr(1),1,IX,NU,NV,KF)
	IF (MND.EQ.'dir')    CALL WDIREC(*99,'TT',NFR(1),NFR(2),KF)
	IF (MND.EQ.'dirp')   CALL WDIREC(*99,'LP',NFR(1),NFR(2),KF)
	IF (MND.EQ.'del')    CALL DELDIR(*99,NF,SCOM(2))
c	IF (MND.EQ.'rewd')   CALL REWD(*99,NFITF)
	IF (MND.EQ.'box')    CALL MAKEBOX(*99,NFR(1),NFR(2),NFR(3),
     *                                    NFR(4),NFR(5),SCOM(3),0)
	IF (MND.EQ.'boxa')   CALL MAKEBOX(*99,NFR(1),NFR(2),NFR(3),
     *                                    NFR(4),NFR(5),SCOM(3),1)
	IF (MND.EQ.'boxc')   CALL MAKEBOX(*99,NFR(1),NFR(2),NFR(3),
     *                                    NFR(4),NFR(5),SCOM(3),2)
	IF (MND.EQ.'boxe')   CALL MAKEBOX(*99,NFR(1),NFR(2),NFR(3),
     *                                    NFR(4),NFR(5),SCOM(3),3)
	IF (MND.EQ.'posf'.OR.MND.EQ.'mfo') THEN
	  IF (KOP.NE.LCOM-1) THEN
	    WRITE(idout,777)
 777	FORMAT(' ****Warning typed-ahead commands CANCELLED****')
	    DO 778 KL=KOP+1,LCOM-1
	      CSTR(KL)='CANCELLED'
 778	    KOP=LCOM-1
	  END IF
	  IF (MND.EQ.'posf') CALL POSFIL(*99,CSTR,LCOM,ITM2,ITS2,
     *                                      IX,NU,NV,KF)
	  IF (MND.EQ.'mfo')  CALL MULFIL(*99,CSTR,LCOM,NFITF,ITM2,ITS2,
     *                                      IX,NU,NV,KF)
	END IF
C	IF (MND.EQ.'wind') CALL WINDOW(*99,KX1,KY1,KX2,KY2,0)
C	IF (MND.EQ.'cwin') CALL WINDOW(*99,KX1,KY1,KX2,KY2,1)
	IF (MND.EQ.'par')  CALL PARITH(*99,SCOM(2),SCOM(3),IX,NU,NV,KF)
	IF (MND.EQ.'pdiv') CALL PDIV(*99,NFR(1),NFR(2),NFR(3),RN(4),
     *                                 IX,NU,NV,KF)
	IF (MND.EQ.'medp') CALL SMEDIAN(*99,SCOM(2),NFR(2),NFR(3),IPAR,
     *                                 IX,NU,NV,KF)
C    TV DISPLAY COMMANDS
C      commands for TV display are put in a separate subroutine to
C      allow easier switching of dispaly system
C
	CALL PPPCOMTV(*99,MND,NFR,SCOM,RN,ILK,ITV,JRAST,IISP,
     *                  IX,NU,NV,KF)
	if (mnd.eq.'head') call headout(*99,nfr(1),scom(2),
     *                                  ifitshead,kf)
	if (mnd.eq.'pipe') call rcspipe(*99,nfr(1),nfr(2),3,
     *                                   ix,nu,nv,kf)
	if (mnd.eq.'pipf') call rcspipe(*99,nfr(1),nfr(2),1,
     *                                   ix,nu,nv,kf)
	if (mnd.eq.'piph') call rcspipe(*99,nfr(1),nfr(2),2,
     *                                   ix,nu,nv,kf)
	if (mnd.eq.'pmk0') call maskpipe(*99,nfr(1),nfr(2),0,1,
     *                                   ix,nu,nv,kf)
	if (mnd.eq.'pout') call polywrt(*99)
	if (mnd.eq.'pmk1') call maskpipe(*99,nfr(1),nfr(2),1,1,
     *                                   ix,nu,nv,kf)
	if (mnd.eq.'pmf0') call maskpipe(*99,nfr(1),nfr(2),0,0,
     *                                   ix,nu,nv,kf)
	if (mnd.eq.'pmf1') call maskpipe(*99,nfr(1),nfr(2),1,0,
     *                                   ix,nu,nv,kf)
	if (mnd.eq.'pstm') call frstdri(*99,ix,nu,nv,kf)
	if (mnd.eq.'rdgh') call rdghostpoly(*99)
c	if (mnd.eq.'pmk2') call maskpipe(*99,nfr(1),nfr(2),2,1,
c     *                                   ix,nu,nv,kf)
c	if (mnd.eq.'pmk3') call maskpipe(*99,nfr(1),nfr(2),3,1,
c     *                                   ix,nu,nv,kf)
	if (mnd.eq.'pipa') call rcspipeadd(*99,nfr(1),nfr(2),
     *                                   ix,nu,nv,kf)
	if (mnd.eq.'cshi') call mulshdri(*99,nfr(1),nfr(2),
     *                                   ix,nu,nv,kf)
	if (mnd.eq.'galf') call galfitdri(*99,nfr(1),ipar,
     *                                   ix,nu,nv,kf)
	IF (MND.EQ.'get*')  call usnodri(*99,nfr(1),kf,bsmag1,bsmag2,
     *                                      igetstar)
C  commands requiring one frame number before calling
	IF (NFR(1).LE.0.OR.NFR(1).GE.KF) THEN
	  DO 400 M=1,4
	    SCOM(M)=' '
	    RN(M)=0.
 400	    NFR(M)=0
	  SCOM(5)=' '
	  NFR(5)=0
	END IF
C    IO COMMANDS
	IF (MND.EQ.'tty')  CALL PRINTZ(*99,NFR,SCOM(3),1,IX,NU,NV,KF)
	IF (MND.EQ.'rdis') CALL rdkfits(*99,NFR(1),SCOM(3),1,IX,NU,NV,
     *                                   KF,IDUM,0)
	IF (MND.EQ.'rdf')  CALL RDIRFIL(*99,NFR(1),scom(3),IX,NU,NV,KF)
	if (mnd.eq.'fkey') call fitsvals(*99,nfr(1),kf)
	if (mnd.eq.'lkey') call fitsvals(*99,nfr(1),kf)
	if (mnd.eq.'pkey') call fitsvals(*99,nfr(1),kf)
c	IF (MND.EQ.'rd8k') CALL read8k(*99,NFR(1),scom(3),IX,NU,NV,KF)
	IF (MND.EQ.'wdis') CALL wdkfits(*99,NFR(1),SCOM(3),0,IX,NU,NV,
     *                                  KF,IDUM)
c 	IF (MND.EQ.'wpic') CALL wdkfits(*99,NFR(1),SCOM(3),1,IX,NU,NV,
c     *                                  KF,IDUM)
c	IF (MND.EQ.'rfit') CALL RFITSD(*99,NFR(1),NFITF,0,IFILE,
c    *                                   IX,NU,NV,KF)
c	if (mnd.eq.'ddfi') call ddfits(tape,*99)
c	if (mnd.eq.'rewd') call rewd(*99,nfitf)
c	IF (MND.EQ.'rvis') CALL VISTAIO(*99,NFR,SCOM(3),IX,NU,NV,KF,0)
c	IF (MND.EQ.'rffd') CALL RFITSDK(*99,NFR,SCOM(3),IX,NU,NV,KF)
	IF (MND.EQ.'nega') CALL searchpix(*99,NFR(1),NFR(2),
     *                    scom(3),scom(4),3,IX,NU,NV,KF)
	IF (MND.EQ.'posi') CALL searchpix(*99,NFR(1),NFR(2),
     *                    scom(3),scom(4),4,IX,NU,NV,KF)
	IF (MND.EQ.'rple') CALL searchpix(*99,NFR(1),NFR(2),
     *                    scom(3),scom(4),1,IX,NU,NV,KF)
	IF (MND.EQ.'rpge') CALL searchpix(*99,NFR(1),NFR(2),
     *                    scom(3),scom(4),2,IX,NU,NV,KF)
	IF (MND.EQ.'rpbd') CALL repborder(nfr(1),nfr(2),scom(3),
     *                     ix,nf,nv,kf,*99)
	IF (MND.EQ.'rpsa') CALL fixsatpix(*99,nfr(1),nfr(2),ix,nu,nv,kf)
	IF (MND.EQ.'sdis') CALL SCRDIS(*99,NFR,scom(3),IX,NU,NV,KF)
	IF (MND.EQ.'curp') CALL CURPOS(*99,NFR,1,IX,NU,NV,KF)
	IF (MND.EQ.'hard') CALL PGHARD(*99,NFR(1),SCOM(3),SCOM(4),
     *                                0,ipgdate,IX,NU,NV,KF)
	IF (MND.EQ.'nhar') CALL PGHARD(*99,NFR(1),SCOM(3),SCOM(4),
     *                                1,ipgdate,IX,NU,NV,KF)
	IF (MND.EQ.'nplt') CALL PGHARD(*99,NFR(1),SCOM(3),SCOM(4),
     *                                2,ipgdate,IX,NU,NV,KF)
	IF (MND.EQ.'rand') CALL randomcheck(*99)
	IF (MND.EQ.'make') CALL MAKE(*99,NFR(1),IX,NU,NV,KF)
	IF (MND.EQ.'makd') CALL GENDRI(NFR(1),NII(NFR(1)),NJJ(NFR(1)),
     *                                  1,IX,NU,NV,KF,*99)
	IF (MND.EQ.'makl') CALL GENDRI(NFR(1),NII(NFR(1)),NJJ(NFR(1)),
     *                                  -1,IX,NU,NV,KF,*99)
	IF (MND.EQ.'gend') CALL GENDRI(NFR(1),NII(NFR(1)),NJJ(NFR(1)),
     *                                  2,IX,NU,NV,KF,*99)
	IF (MND.EQ.'genl') CALL GENDRI(NFR(1),NII(NFR(1)),NJJ(NFR(1)),
     *                                 -2,IX,NU,NV,KF,*99)
	IF (MND.EQ.'gcld') CALL GENDRI(NFR(1),NII(NFR(1)),NJJ(NFR(1)),
     *                                  3,IX,NU,NV,KF,*99)
	IF (MND.EQ.'gcll') CALL GENDRI(NFR(1),NII(NFR(1)),NJJ(NFR(1)),
     *                                 -3,IX,NU,NV,KF,*99)
	IF (MND.EQ.'gcbd') CALL GENDRI(NFR(1),NII(NFR(1)),NJJ(NFR(1)),
     *                                  4,IX,NU,NV,KF,*99)
	IF (MND.EQ.'gcbl') CALL GENDRI(NFR(1),NII(NFR(1)),NJJ(NFR(1)),
     *                                  -4,IX,NU,NV,KF,*99)
	IF (MND.EQ.'mcbd') CALL GENDRI(NFR(1),NII(NFR(1)),NJJ(NFR(1)),
     *                                  5,IX,NU,NV,KF,*99)
	IF (MND.EQ.'mcbl') CALL GENDRI(NFR(1),NII(NFR(1)),NJJ(NFR(1)),
     *                                  -5,IX,NU,NV,KF,*99)
	IF (MND.EQ.'addn') CALL addnoise(*99,NFR(1),IX,NU,NV,KF,*99)
	IF (MND.EQ.'rpof') CALL RPOF(*99,NFR(1),SCOM(3),nfr(2),0)
	if (mnd.eq.'pfli') call pfbound(nfr(1),*99)
	if (mnd.eq.'rejp') call rchkpos(*99,nfr(1),ix,nu,nv,kf)
	if (mnd.eq.'rejc') call rchkpos(*99,nfr(1),ix,nu,nv,kf)
	if (mnd.eq.'rejh') call chalopos(*99,nfr(1),nfr(2),ix,nu,nv,kf)
c	if (mnd.eq.'coo') call makecoo(*99,nfr(1),1)
c	if (mnd.eq.'dcoo') call makecoo(*99,nfr(1),0)
	if (mnd.eq.'coo') call makereg(*99,nfr(1),1)
	if (mnd.eq.'dcoo') call makereg(*99,nfr(1),0)
	IF (MND.EQ.'rpau') CALL RPOF(*99,NFR(1),SCOM(3),nfr(2),-1)
	IF (MND.EQ.'rrpa') CALL RPOF(*99,NFR(1),SCOM(3),nfr(2),-2)
	IF (MND.EQ.'rpsm') CALL SIMPOSF(*99,NFR(1))
	IF (MND.EQ.'objn')    CALL objnum(*99,NFR(1),nfr(2),nfr(3),
     *                                 IX,NU,NV,KF)
	IF (MND.EQ.'medf') CALL MEDFIL(*99,NFR,0,0,IX,NU,NV,KF)
	IF (MND.EQ.'mdfi') CALL MEDFIL2(*99,NFR,0,0,IX,NU,NV,KF)
	IF (MND.EQ.'mfbf') CALL MEDFIL3(*99,NFR,0,0,IX,NU,NV,KF)
	IF (MND.EQ.'smat') CALL simposmat(nfr(1),iir,iret,1,0,
     *                                     ix,nu,nv,kf,*99)
	IF (MND.EQ.'smap') CALL simposmat(nfr(1),iir,iret,1,1,
     *                                     ix,nu,nv,kf,*99)
	IF (MND.EQ.'matp') CALL posmatch(*99,NFR(1),nfr(2),0,0)
	IF (MND.EQ.'matc') CALL posmatch(*99,NFR(1),nfr(2),1,0)
	IF (MND.EQ.'mttp') CALL posmatch(*99,NFR(1),nfr(2),0,1)
	IF (MND.EQ.'mttc') CALL posmatch(*99,NFR(1),nfr(2),1,1)
	IF (MND.EQ.'ftra') CALL transfdri(NFR(1),nfr(2),ix,nu,nv,kf,1,*99)
	IF (MND.EQ.'ftrs') CALL transfdri(NFR(1),nfr(2),ix,nu,nv,kf,2,*99)
	IF (MND.EQ.'ftpa') CALL transfdri(NFR(1),nfr(2),ix,nu,nv,kf,-1,*99)
	IF (MND.EQ.'ftps') CALL transfdri(NFR(1),nfr(2),ix,nu,nv,kf,-2,*99)
	IF (MND.EQ.'tran') CALL tposdri(NFR(1),kf,*99)
	IF (MND.EQ.'lmed') CALL cubflat(*99,NFR(1),nfr(2),nfr(3),0,2,
     *                      IX,NU,NV,KF)
	IF (MND.EQ.'pflt') CALL cubflat(*99,NFR(1),nfr(2),nfr(3),0,0,
     *                      IX,NU,NV,KF)
	IF (MND.EQ.'lflt') CALL cubflat(*99,NFR(1),nfr(2),nfr(3),0,1,
     *                      IX,NU,NV,KF)
	IF (MND.EQ.'rrpo') CALL RPOF(*99,NFR(1),SCOM(3),nfr(2),1)
	IF (MND.EQ.'bpfi') CALL BPFIX(*99,NFR(1),NFR(2),0,IX,NU,NV,KF)
	IF (MND.EQ.'bpfx') CALL BPFIX(*99,NFR(1),NFR(2),1,IX,NU,NV,KF)
	IF (MND.EQ.'bpfy') CALL BPFIX(*99,NFR(1),NFR(2),2,IX,NU,NV,KF)
	IF (MND.EQ.'fixz') CALL fixzerord(*99,nfr,ix,nu,nv,kf)
c	IF (MND.EQ.'bpf2') CALL BPFIX(*99,NFR(1),NFR(2),3,IX,NU,NV,KF)
c	IF (MND.EQ.'bpf3') CALL BPFIX(*99,NFR(1),NFR(2),4,IX,NU,NV,KF)
	IF (MND.EQ.'crm1') CALL COSRAYMAP(*99,NFR(1),NFR(2),SCOM(3),
     *                        SCOM(4),nscrit,iprt,0,rwd,IX,NU,NV,KF)
	IF (MND.EQ.'crmo') CALL COSRAYMAP(*99,NFR(1),NFR(2),SCOM(3),
     *                        SCOM(4),nscrit,iprt,1,rwd,IX,NU,NV,KF)
	IF (MND.EQ.'crms') CALL COSRAYMAP(*99,NFR(1),NFR(2),SCOM(3),
     *                        SCOM(4),nscrit,iprt,2,rwd,IX,NU,NV,KF)
	if (mnd.eq.'spma') call spectromask(*99,nfr(1),ix,nu,nv,kf)
     	IF (MND.EQ.'skma')   CALL skymask(*99,nfr(1),1,ix,nu,nv,kf)
	if (mnd.eq.'objm') call objmask(*99,nfr(1),nfr(2),ix,nu,nv,kf)
	IF (MND.EQ.'scbc') CALL SCBC(*99,NFR(1),0,0,SCOM(3),1,
     *                               dum1,dum2,IX,NU,NV,KF)
	IF (MND.EQ.'scbr') CALL SCBC(*99,NFR(1),0,0,SCOM(3),3,
     *                               dum1,dum2,IX,NU,NV,KF)
	IF (MND.EQ.'flbc') CALL SCBC(*99,NFR(1),0,0,SCOM(3),-1,
     *                               dum1,dum2,IX,NU,NV,KF)
c	if (mnd.eq.'dcoo') call makecoo(*99,nfr(1),1)
	IF (MND.EQ.'flbr') CALL SCBC(*99,NFR(1),0,0,SCOM(3),-3,
     *                               dum1,dum2,IX,NU,NV,KF)
	IF (MND.EQ.'size') CALL SIZE(*99,NII,NJJ,NFR(1),NU,NV,KF)
	IF (MND.EQ.'colp') CALL CSCUT(*99,NFR(1),NFR(2),NFR(3),SCOM(4),
     *                                SCOM(5),1,IGRAPH,IX,NU,NV,KF)
	IF (MND.EQ.'rowp') CALL CSCUT(*99,NFR(1),NFR(2),NFR(3),SCOM(4),
     *                                  SCOM(5),0,IGRAPH,IX,NU,NV,KF)
	IF (MND.EQ.'ptsp') CALL P2PTCUT(*99,NFR,IX,NU,NV,KF,0)
	IF (MND.EQ.'nass') CALL nodshuf(*99,NFR,IX,NU,NV,KF)
	IF (MND.EQ.'move'.OR.MND.EQ.'comm'.OR.MND.EQ.'hop'.OR.MND.EQ.
     *      'cmsi'.OR.MND.EQ.'csim'.OR.MND.EQ.'wind'.OR.MND.EQ.'cwin')
     *    THEN
	  WRITE(idout,*) 
     *       '  +++ Command word has been changed, see "help" +++'
	  GO TO 99
	END IF
	IF (MND.EQ.'cplt') CALL CONTOURPG(*99,NFR(1),SCOM(3),nfr(2),
     *                                   nfr(3),0,IX,NU,NV,KF)
	if (mnd.eq.'pend') call pgclose(*99)
	IF (MND.EQ.'cpl') CALL CONTOURPG(*99,NFR(1),SCOM(3),1,nfr(2),
     *                                     nfr(3),IX,NU,NV,KF)
	IF (MND.EQ.'pgim') CALL PGSHOW(*99,NFR(1),SCOM(3),0,IX,NU,NV,KF)
	IF (MND.EQ.'pgsh') CALL PGSHOW2(*99,SCOM(2),0,IX,NU,NV,KF)
	IF (MND.EQ.'npgi') CALL PGSHOW(*99,NFR(1),SCOM(3),1,IX,NU,NV,KF)
C    PHOTOMETRY COMMANDS
	IF (MND.EQ.'find')  CALL FINOBD(*99,NFR(1),SCOM(3),SCOM(4),RN(4)
     *                                  ,0,IX,NU,NV,KF)
	IF (MND.EQ.'qfin')  CALL FINOBD(*99,NFR(1),SCOM(3),SCOM(4),RN(4)
     *                                  ,2,IX,NU,NV,KF)
	IF (MND.EQ.'qfnd')  CALL FINOBD(*99,NFR(1),SCOM(3),SCOM(4),RN(4)
     *                                  ,7,IX,NU,NV,KF)
	IF (MND.EQ.'fins')  CALL FINOBD(*99,NFR(1),SCOM(3),SCOM(4),RN(4)
     *                                  ,3,IX,NU,NV,KF)
	IF (MND.EQ.'afin')  CALL FINOBD(*99,NFR(1),SCOM(3),SCOM(4),RN(4)
     *                                  ,1,IX,NU,NV,KF)
	IF (MND.EQ.'afim')  CALL FINOBD(*99,NFR(1),SCOM(3),SCOM(4),RN(4)
     *                                  ,-1,IX,NU,NV,KF)
	IF (MND.EQ.'satf')  CALL FINOBD(*99,NFR(1),SCOM(3),SCOM(4),RN(4)
     *                                  ,-2,IX,NU,NV,KF)
	IF (MND.EQ.'sfin')  CALL FINOBD(*99,NFR(1),SCOM(3),SCOM(4),RN(4)
     *                                  ,4,IX,NU,NV,KF)
	IF (MND.EQ.'cfin')  CALL FINOBD(*99,NFR(1),SCOM(3),SCOM(4),RN(4)
     *                                  ,6,IX,NU,NV,KF)
	IF (MND.EQ.'ccen')  CALL CHCKCN(*99,NFR(1),1,IX,NU,NV,KF)
	IF (MND.EQ.'acen')  CALL CCENTER(*99,NFR(1),1,IX,NU,NV,KF)
	IF (MND.EQ.'phot')  CALL PHODRI(*99,NFR,SCOM(3),SCOM(4),0
     *                                  ,IX,NU,NV,KF)
	IF (MND.EQ.'1pho')  CALL PHODRI(*99,NFR,SCOM(3),SCOM(4),1
     *                                  ,IX,NU,NV,KF)
	IF (MND.EQ.'lpho')  CALL PHODRI(*99,NFR,SCOM(3),SCOM(4),2
     *                                  ,IX,NU,NV,KF)
	IF (MND.EQ.'auph')  CALL APDRI(*99,NFR,SCOM(3),SCOM(4),0
     *                                  ,IX,NU,NV,KF)
	IF (MND.EQ.'1aup')  CALL APDRI(*99,NFR,SCOM(3),SCOM(4),1
     *                                  ,IX,NU,NV,KF)
	IF (MND.EQ.'laup')  CALL APDRI(*99,NFR,SCOM(3),SCOM(4),2
     *                                  ,IX,NU,NV,KF)
	IF (MND.EQ.'aucp')  CALL ACPDRI(*99,NFR,SCOM(3),SCOM(4)
     *                                  ,IX,NU,NV,KF)
	IF (MND.EQ.'ppph')  CALL PPPDRI(*99,NFR,SCOM(3),SCOM(4)
     *                                  ,0,IX,NU,NV,KF)
	IF (MND.EQ.'apph')  CALL PPPDRI(*99,NFR,SCOM(3),SCOM(4)
     *                                  ,1,IX,NU,NV,KF)
	IF (MND.EQ.'appg')  CALL PPPDRI(*99,NFR,SCOM(3),SCOM(4)
     *                                  ,2,IX,NU,NV,KF)
	IF (MND.EQ.'psph')  CALL sapdri(*99,NFR,SCOM(3),SCOM(4)
     *                                  ,1,IX,NU,NV,KF)
	IF (MND.EQ.'morp')  CALL morphdri(*99,NFR(1),IX,NU,NV,KF)
	IF (MND.EQ.'see')   CALL APDRI(*99,NFR,SCOM(3),SCOM(4),3
     *                                  ,IX,NU,NV,KF)
	IF (MND.EQ.'mskf')  CALL nmaskfile(NFR(1),ix,nu,nv,kf,*99)
	IF (MND.EQ.'aref')  CALL autoref(NFR(1),ix,nu,nv,kf,1,*99)
	IF (MND.EQ.'arf')   CALL autoref(NFR(1),ix,nu,nv,kf,0,*99)
	IF (MND.EQ.'fhdr')  CALL fixhdr(*99,NFR(1),1)
	IF (MND.EQ.'hfhd')  CALL fixhdr(*99,NFR(1),-1)
	IF (MND.EQ.'cent')  CALL DPCENT(*99,NFR,IX,NU,NV,KF,1)
	IF (MND.EQ.'csli')  CALL centslit(*99,NFR(1),IX,NU,NV,KF)
	IF (MND.EQ.'spho')  CALL SURPHO(*99,NFR(1),SCOM(3),
     *                                 0,IX,NU,NV,KF)
	IF (MND.EQ.'ssph')  CALL SURPHO(*99,NFR(1),SCOM(3),
     *                                 1,IX,NU,NV,KF)
	IF (MND.EQ.'isop')  CALL ISOPHOT(*99,NFR,1,IX,NU,NV,KF)
C    OPERATION COMMANDS
	DUM=0.
 1111	format(1x,a60)
	if (mnd.eq.'car')   call carith(*99,nfr(1),noper,dum,
     *                              scom(3),scom(4),0,ix,nu,nv,kf)
	IF (MND.EQ.'sfla')  CALL SELFLAT(*99,NFR(1),scom(3),IPAR,
     *                              IX,NU,NV,KF)
	IF (MND.EQ.'shr')   CALL SHRINK(*99,NFR(1),RN(2),IX,NU,NV,KF)
	IF (MND.EQ.'shk')   CALL SHRINKI(*99,NFR(1),NFR(2),IX,NU,NV,KF)
c	IF (MND.EQ.'expn')  CALL expandp(*99,NFR(1),NFR(2),IX,NU,NV,KF)
	IF (MND.EQ.'tran')  CALL TRANSP(*99,NFR(1),IX,NU,NV,KF)
	IF (MND.EQ.'mirj')  CALL MIRROR(*99,NFR(1),0,IX,NU,NV,KF)
	IF (MND.EQ.'miri')  CALL MIRROR(*99,NFR(1),1,IX,NU,NV,KF)
	IF (MND.EQ.'r90')   CALL ROT90(*99,NFR(1),0,IX,NU,NV,KF)
	IF (MND.EQ.'r90c')  CALL ROT90(*99,NFR(1),1,IX,NU,NV,KF)
	IF (MND.EQ.'r180')  CALL ROT90(*99,NFR(1),2,IX,NU,NV,KF)
	IF (MND.EQ.'shif')  CALL SHIFTP(*99,NFR(1),RN(2),RN(3)
     *                               ,IX,NU,NV,KF,0)
	IF (MND.EQ.'shtr')  CALL SHIFTP(*99,NFR(1),RN(2),RN(3)
     *                               ,IX,NU,NV,KF,1)
	IF (MND.EQ.'isht')  CALL SHIFTP(*99,NFR(1),RN(2),RN(3)
     *                               ,IX,NU,NV,KF,2)
	IF (MND.EQ.'sshi')  CALL SINCSHIF(*99,NFR(1),RN(2),RN(3)
     *                               ,IX,NU,NV,KF)
	IF (MND.EQ.'fudg')  CALL FUDGE(*99,NFR,IX,NU,NV,KF)
	IF (MND.EQ.'rot')   CALL ROTATE(*99,NFR(1),RN(2),RN(3),RN(4)
     *                                  ,IX,NU,NV,KF)
	IF (MND.EQ.'smoo')  CALL SMOOTH(*99,NFR(1),0,1,IX,NU,NV,KF)
	IF (MND.EQ.'tsmo')   CALL SMOOTH(*99,NFR(1),0,0,IX,NU,NV,KF)
	IF (MND.EQ.'amag')   CALL MAGN(*99,NFR(1),1,IX,NU,NV,KF)
	IF (MND.EQ.'dmag')   CALL MAGN(*99,NFR(1),0,IX,NU,NV,KF)
 	IF (MND.EQ.'trim')  CALL TRIMP(*99,NFR(1),IDA,ID2,ID3,ID4,0
     *                                ,IX,NU,NV,KF)
	IF (MND.EQ.'rfla')  CALL FLATROW(*99,NFR(1),NFR(2),NFR(3),
     *                           0,0,0,0,0,IX,NU,NV,KF,IJFLAT,IPRT)
	IF (MND.EQ.'cfla')  CALL FLATCOL(*99,NFR(1),NFR(2),NFR(3),
     *                           0,0,0,0,0,IX,NU,NV,KF,IJFLAT,IPRT)
	IF (MND.EQ.'prfl')  CALL FLATROW(*99,NFR(1),NFR(2),NFR(3),
     *                           0,0,0,0,1,IX,NU,NV,KF,IJFLAT,IPRT)
	IF (MND.EQ.'pcfl')  CALL FLATCOL(*99,NFR(1),NFR(2),NFR(3),
     *                           0,0,0,0,1,IX,NU,NV,KF,IJFLAT,IPRT)
	IF (MND.EQ.'lmap')  CALL LINMAP(*99,NFR(1),IX,NU,NV,KF)
	IF (MND.EQ.'lsub')  CALL LINSUB(*99,NFR(1),IX,NU,NV,KF)
	IF (MND.EQ.'psfs')  CALL PSFSUB(*99,NFR(1),SCOM(3),IX,NU,NV,KF)
	IF (MND.EQ.'psfa')  CALL PSFADD(*99,NFR(1),nfr(2),IX,NU,NV,KF)
	IF (MND.EQ.'smps')  CALL smopsfd(*99,NFR(1),IX,NU,NV,KF)
	IF (MND.EQ.'mpsf')  CALL MPSFSUB(*99,NFR(1),SCOM(3),IX,NU,NV,KF)
	IF (MND.EQ.'psfm')  CALL MATPSF(*99,NFR(1),NFR(2),IX,NU,NV,KF)
	IF (MND.EQ.'cpsf')  CALL CENPSF(*99,NFR(1),NFR(2),IX,NU,NV,KF)
	IF (MND.EQ.'sky')   CALL CSKY(*99,NFR(1),NFR(2),NFR(3),
     *                                DUM1,DUM2,idum,IX,NU,NV,KF,' ')
	IF (MND.EQ.'rbst')  call bstarlis(*99)
	IF (MND.EQ.'ssca')  CALL SSSCALE(*99,NFR(1),IX,NU,NV,KF)
	IF (MND.EQ.'cut')   CALL CUTPIC(*99,NFR(1),NFR(2),IX,NU,NV,KF)
	IF (MND.EQ.'past')  CALL PASTE(*99,NFR(1),NFR(2),IX,NU,NV,KF)
	if (mnd.eq.'xspx')  call specext(*99,nfr(i),0,ix,nu,nv,kf)
	if (mnd.eq.'xspy')  call specext(*99,nfr(i),1,ix,nu,nv,kf)
	if (mnd.eq.'sksx')  call spskysub(*99,nfr(1),0,ix,nu,nv,kf)
	if (mnd.eq.'sksy')  call spskysub(*99,nfr(1),1,ix,nu,nv,kf)
C
C    STATISTICS COMMANDS
C
	IF (MND.EQ.'csmo')  CALL SCBC(*99,NFR(1),0,0,SCOM(3),0,
     *                              dum1,dum2,IX,NU,NV,KF)
	IF (MND.EQ.'rsmo')  CALL SCBC(*99,NFR(1),0,0,SCOM(3),2,
     *                              dum1,dum2,IX,NU,NV,KF)
	IF (MND.EQ.'psta')  CALL PSTAT(*99,NFR(1),0,KY1,KX2,KY2,A,B,
     *                                 NDUM,0,IX,NU,NV,KF)
	IF (MND.EQ.'pmod')  CALL PSTAT(*99,NFR(1),0,KY1,KX2,KY2,A,B,
     *                                 NDUM,1,IX,NU,NV,KF)
	if (mnd.eq.'gsky')  call stripmode(*99,nfr,ix,nu,nv,kf)
	IF (MND.EQ.'csta') THEN
	  IF (NFR(2).EQ.0) THEN
 	   CALL PSTAT(*99,NFR(1),KX1,KY1,KX2,KY2,A,B,NDUM,2,IX,NU,NV,KF)
	  ELSE
	    CALL PSTAT(*99,NFR(1),NFR(2),KY1,KX2,KY2,A,B,NDUM,
     *                  6,IX,NU,NV,KF) 
	  END IF
	END IF
	IF (MND.EQ.'rsta') THEN 
	  IF (NFR(2).EQ.0) THEN
 	    CALL PSTAT(*99,NFR(1),KX1,KY1,KX2,KY2,A,B,NDUM,
     *                  4,IX,NU,NV,KF)
	  ELSE
 	    CALL PSTAT(*99,NFR(1),NFR(2),KY1,KX2,KY2,A,B,NDUM,
     *                  8,IX,NU,NV,KF)
 	  END IF
	END IF
	IF (MND.EQ.'cmod') THEN
	  IF (NFR(2).EQ.0) THEN
	    CALL PSTAT(*99,NFR(1),KX1,KY1,KX2,KY2,A,B,NDUM,
     *                  3,IX,NU,NV,KF)
	  ELSE
	    CALL PSTAT(*99,NFR(1),NFR(2),KY1,KX2,KY2,A,B,NDUM,
     *                  7,IX,NU,NV,KF)
	  END IF
 	END IF
	IF (MND.EQ.'rmod') THEN
	  IF (NFR(2).EQ.0) THEN
	    CALL PSTAT(*99,NFR(1),KX1,KY1,KX2,KY2,A,B,NDUM,
     *                  5,IX,NU,NV,KF)
	  ELSE
 	    CALL PSTAT(*99,NFR(1),NFR(2),KY1,KX2,KY2,A,B,NDUM,
     *                  9,IX,NU,NV,KF)
 	  END IF
	END IF
C	COMMANDS THAT TAKES TWO FRAME NUMBERS 
 87	IF (MND.EQ.'sum')   CALL SUMPIC(*99,NFR(1),NFR(2),NFR(3),
     *                               0,IX,NU,NV,KF)
 	IF (MND.EQ.'aver')  CALL SUMPIC(*99,NFR(1),NFR(2),NFR(3),
     *                               1,IX,NU,NV,KF)
 	IF (MND.EQ.'wtav')  CALL combine2(*99,nfr,ix,nu,nv,kf)
 	IF (MND.EQ.'conv')  CALL CONVOLVE(*99,NFR(1),NFR(2),NFR(3),
     *                               IX,NU,NV,KF)
 	IF (MND.EQ.'ssum')  CALL SHIFSUM(*99,NFR(1),NFR(2),NFR(3),
     *                               1,IX,NU,NV,KF)
 	IF (MND.EQ.'ssub')  CALL SHIFSUM(*99,NFR(1),NFR(2),NFR(3),
     *                               -1,IX,NU,NV,KF)
c	IF (MND.EQ.'cmap')  CALL mkcmap(*99,NFR(1),NFR(2),NFR(3),0
c    *                                    ,IX,NU,NV,KF)
c	IF (MND.EQ.'dscm')  CALL discmap(*99,NFR(1),NFR(2),IX,NU,NV,KF)
        IF (MND.EQ.'clcr')  CALL CLCOS(*99,NFR(1),NFR(2),0,IX,NU,NV,KF)
	IF (MND.EQ.'crm2')  CALL CLCOSB(*99,NFR(1),NFR(2),iir,ior,0,
     *         IX,NU,NV,KF)
	IF (MND.EQ.'cr2o')  CALL CLCOSA(*99,NFR(1),NFR(2),0,IX,NU,NV,KF)
	IF (MND.EQ.'padm')  CALL padmap(*99,NFR(1),IX,NU,NV,KF,-1)
	IF (MND.EQ.'spbx')  CALL pickspecbox(*99,NFR(1),nfr(2),
     *                          IX,NU,NV,KF)
	IF (MND.EQ.'cona')  CALL CONAREA(*99,NFR,0,IX,NU,NV,KF)
 	if (mnd.eq.'csee')  call conseed(*99,nfr,0,ix,nu,nv,kf)
	IF (MND.EQ.'rppr')  CALL RATREPIX(*99,0,IX,NU,NV,KF)
	IF (MND.EQ.'rppi')  CALL REPIX(*99,NFR(1),NFR(2),NFR(3),0,
     *                                 IX,NU,NV,KF)
	IF (MND.EQ.'rppo')  CALL REPIX(*99,NFR(1),NFR(2),NFR(3),1,
     *                                 IX,NU,NV,KF)
	IF (MND.EQ.'copy')  THEN
	  CALL QUERYNFR(NFR(1),KF,1,*99,*20001)
20001	  CALL QUERYNFR(NFR(2),KF,2,*99,*20002)
20002	  CALL MOVE(NFR(1),NFR(2),IX,NU,NV,KF)
	  GO TO 99
	END IF
c  rarely used commands
c	IF (MND.EQ.'ur1')    CALL USER1(*99,NFR(1),IX,NU,NV,KF)
c	IF (MND.EQ.'ur2')    CALL USER2(*99,NFR(1),IX,NU,NV,KF)
c	IF (MND.EQ.'ur3')    CALL USER3(*99,NFR(1),IX,NU,NV,KF)
c	IF (MND.EQ.'prin') CALL PRINTZ(*99,NFR,scom(3),0,IX,NU,NV,KF)
c
c	call gladders(*99,MND,NFR,SCOM,RN,IX,NU,NV,KF)
	call mosaicom(*99,MND,NFR,SCOM,RN,IX,NU,NV,KF)
	IF (MND.EQ.'stop')   GO TO 9999
	IF (MND.EQ.'quit')   GO TO 9999
	IF (MND.EQ.'quco')   GO TO 9999
 999    write(idout,20)
 20   FORMAT(' **** Invalid command ****')
	GO TO 99
c  delete temporary files before exiting
 9999	do 9990 n=1,14
	  istatus=encode(nfrstr,float(n),1,0,idum) 
	open(unit=41,file='ppptemp'//nfrstr(1:lnblnk(nfrstr))//'.fits'
     *      ,status='old',err=9990)
	close (unit=41,status='delete')  
 9990	continue
c	saoname=saoregname(1:lnblnk(saoregname))//'.'
	do 9980 n=1,6
	  istatus=encode(nfrstr,float(n),1,0,idum) 
	  tempname='saoimage'//nfrstr(1:lnblnk(nfrstr))//'.reg'
     	  open(unit=41,file=tempname,status='old',err=9991)
	  close (unit=41,status='delete')  
 9991	  tempname=tempname(1:lnblnk(tempname))//'.'
	  do 9992 kk=1,6
	    tempname=tempname(1:lnblnk(tempname))//'B'
 	    open(unit=41,file=tempname,status='old',err=9992)
	    close (unit=41,status='delete')  
 9992	  continue
 9982	open(unit=41,file='ppptemp'//nfrstr(1:lnblnk(nfrstr))//'.coo'
     *      ,status='old',err=9983)
	  close (unit=41,status='delete')  
 9983	open(unit=41,file='ppptemp'//nfrstr(1:lnblnk(nfrstr))//'.COO'
     *      ,status='old',err=9984)
	  close (unit=41,status='delete')  
 9984	open(unit=41,file='ppptemp'//nfrstr(1:lnblnk(nfrstr))//'.ap'
     *      ,status='old',err=9980)
	  close (unit=41,status='delete')  
 9980   continue
	call chfitsname(nametemp,iisp(0),headtemp)
	if (mnd.eq.'quco') then
	  if (imdir.eq.' ') then
	    if (ipppfile.ne.1) then
	      call system('compress *.fits &')
	    else 
	      call system('gzip *.fits &')
	    end if
	  else
	  if (ipppfile.eq.0) then
	  call system('compress '//imdir(1:lnblnk(imdir))//'*.fits &')
	  else
	   call system('gzip '//imdir(1:lnblnk(imdir))//'*.fits &')
	  end if
	  end if
	end if
 991	CALL RWDIR(0)
 	call fdate(atime)
c	atime=fdate()
	write(idout,162) ATIME
 162	format('  ...Exit ppp: ',a24)
	STOP
	END

C/////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO TYPE MANUAL
	SUBROUTINE HELP(*,NTY,IHT)
	common/iodev/idin,idout,idhis
	CHARACTER*2 NTY,IH, IHT*60
	IF (NTY.EQ.'LP') THEN
	  write(idout,*) '  +++ Menu written to file pppmenu.doc +++ '
	  call opennew(28,1,18,'pppmenu.doc',*999)
c	  OPEN(UNIT=28,FILE='pppmenu.doc',status='NEW',ERR=999)
	  WRITE(28,100) 
	  WRITE(28,1001) 
	  write(28,1101)
	  WRITE(28,101)
	  WRITE(28,102)
	  WRITE(28,1021)
	  WRITE(28,1022)
	  write(28,1023)
	  WRITE(28,1025)
	  WRITE(28,103)
	  WRITE(28,1031)
	  WRITE(28,104)
	  WRITE(28,105)
	  WRITE(28,106)
	  WRITE(28,1061)
	  WRITE(28,107)
	  write(28,109)
	  CALL HELPTV(28)
	  WRITE(28,108)
	  CLOSE(UNIT=28)
	ELSE
C interactive HELP
	  IF (iht.EQ.' ') THEN
 	    write(idout,1101)
	    go to 50
	  ELSE
	    IH=IHT(1:2)
	    GO TO 350
	  END IF
C commands
 50	    write(idout,110)
	    call readstr(2,ih,*999,*50)
 350	  IF (IH.EQ.'q'.OR.IH.EQ.' ') THEN
	    RETURN1
	  else if (ih.eq.'pp') then
	    write(idout,100)
 6002	    write(idout,500)
	    call readstr(2,ih,*999,*6002)
	    write(idout,1001) 
	    write(idout,1101) 
	  ELSEIF (IH.EQ.'io') THEN
 	    write(idout,101)
	  ELSEIF (IH.EQ.'op') THEN
 	    write(idout,102)
	    write(idout,500)
	    call readstr(2,ih,*999,*50)
	    write(idout,1021)
	  else if (ih.eq.'fi') then
	    write(idout,1022)
	    write(idout,500)
	    call readstr(2,ih,*999,*50)
	    write(idout,1023)
	  ELSEIF (IH.EQ.'ph') THEN
  	    write(idout,103)
	    write(idout,500)
	    call readstr(2,ih,*999,*50)
	    write(idout,1031)
	  ELSEIF (IH.EQ.'ms') THEN
 	    write(idout,104)
	  ELSEIF (IH.EQ.'st') THEN
 	    write(idout,1025)
	  ELSEIF (IH.EQ.'pf') THEN
 	    write(idout,105)
	  ELSEIF (IH.EQ.'mf') THEN
 	    write(idout,106)
	    write(idout,500)
	    call readstr(2,ih,*999,*50)
	    write(idout,1061)
	  else if (ih.eq.'pi') then
	    write (idout,1201)
	  ELSEIF (IH.EQ.'ds') THEN
 	    write(idout,107)
	    write(idout,500)
	    call readstr(2,ih,*999,*50)
	    CALL HELPTV(idout)
	  ELSEIF (IH.EQ.'si') THEN
	    write(idout,108)
	  elseif (ih.eq.'cc') then
	    write(idout,109)
	  else if (ih.eq.'sp') then
	    write(idout,120)
	  END IF
	  GO TO 50
	END IF
	RETURN1
 10	FORMAT(A2)
 100    FORMAT(//'     //// Picture Processing Package, APR 1990 ////',
     *//'   TO RUN, run "ppp". Commands have the following'/
     *'   format:     NAME <F1> <F2> <Optional inputs>'/
     *'   A maximum of 5 inputs (incl. frame #s) can be accepted; but'/
     *'   only the name is absolutely necessary. If absent, the program' 
     */'   will request further information as needed.  The optional'/
     *'   inputs follow the same sequence as that requested by the'/
     *'   command.  Optional inputs are indicated by: N=name (no space'/
     *'   allowed), S=string (enclosed by " if there are spaces), F='/
     *'   frame #, I=int, R=real, B=box #.  No explanations to these'
     */'   are provided in help, since one can run the program faster'/
     *'   by simply letting the command do the prompting instead of'/
     *'   looking them up in HELP.  For 530X530 (default picture size),'
     */'   a total of 9 frames are available in the program core buffer'
     */'   for immediate operation by the program. A 10th frame is used'
     */'   as the scratch frame for many of the operations.  The use of'
     */'   it is possible for some commands but it is not recommended.'/
     *'   The core picture buffer can be partitioned to larger size,'/
     *'   with the maximum being 1 (+1 scratch) 1280X1280 pictures.'/
     *'   Up to 250 pictures can be stored in the DISK directory '/
     *'   which can be called up to the core by "rdisk" or "rdf".')
 1001	FORMAT('  Pictures in directory can ',
     *'be operated on directly using "mfo" commands.  A'/
     *'   file of the directory of stored pictures (named pppdir.dat)'
     */'   is created and continuously updated. '//
     *'       Entering CTRL<d> for any prompt will return you to ppp,'/
     *'   **NOTE** however, 3 CTRL<d>s in a row in ppp will end ppp.'/
     *'   Files created by ppp have the following qualifiers:'/
     *'         Pictures: .pic,   Position file: .pos, '/
     *'         Photometry: .phm,   Surface profile: .sph'/
     *'         Printronix plots: .vec,  C2 vs mag plot: .pc2'/
     *'         Object map plot: .map,  Simulation file: .sim'//
     *      '   To make a copy of the manual use the command "phelp"'/)
 1101	format('   LIST OF AVAILABLE COMMANDS BY TOPICS',/
     *      '    pp - overview of ppp'/
     *     ,'    io - I/O COMMANDS',/,
     *      '    op - OPERATION COMMANDS',/,
     *      '    fi - IMAGE COSMETIC FIXING COMMANDS'/
     *      '    ds - INTERACTIVE DISPLAY (TV AND GRAPHICS) COMMANDS'/
     *      '    cc - GRAPHICS CURSOR COMMANDS'/
     *      '    st - STATISTICS COMMANDS',/,
     *      '    ph - PHOTOMETRY COMMANDS',/,
     *      '    ms - MISCELLANEOUS COMMANDS'/
     *      '    pf - OBJECT POSITION FILE MANIPULATION SUBSECTION'/
     *      '    mf - MULTIPLE FILE OPERATOR SUBSECTION'/
     *      '    pi - RCS pipeline commands'/
     *      '    sp - spectral data commands'/
     *      '    si - SIMULATION OF IMAGING DATA')
 110	FORMAT(/'  Enter keyword for list: pp,io,op,fi,ds,cc,ph,st,ms,',
     *             'pf,mf,pi,sp,si, <cr>=out: ',$) 
 101	FORMAT(//' INPUT/OUTPUT',/,
c     *'   rpds <F>  - read picture from DAO PDS tape into core.',/,
     *'   rdisk <F> N - read picture from disk into core frame <F>.'/
     *'   rdf   <F> I - read PPP Directory file no. I into frame <F>.'/
     *'   wdisk <F> N S - write picture to disk in fits format.'/
     *'   wpic <F> N S - write picture to disk in .ppp format.'/
c    *'   rfits <F> - read picture with FITS format ', 
c    *                    ' from tapes into core.',/,
c    *'   ddfit - generalize fits tape writer using unix dd'/
     *'   rffd <F>  - read picture with FITS format on disk into core'/	
     *'   head <F>/N - list fitsheader of frame F or fits file N'/
c    *'   rewd      - rewind FITS tape and set file counter to 0.'/
     *'   rdao/rfig  <F> N - read picture in DAOPHOT/FIGARO',
     *  ' format into <F>.',/,
c    */'   rvis <F> N - read VISTA FITS format disk picture'/
     *'   wdao/wfig  <F> N - write <F> to DAOPHOT/FIGARO format',/
     *'   head <F>/N - output headerfile of core frame F, or file N'/
     *'   lkey <F> - output header keys of core frame F'/
     *'   print <F> - print out sub block of the picture on PRINTER.',
     */'   tty <F> 4I - type out sub block of the picture on TERMINAL.'
     */'   rowp <F> 2I S - plot cut in I (fixed J) direction, .'
     */'               Option of sum over J''s and Printronix plot.'
     */'   colp <F> 2I S - same as ROWP, but in J (fixed I) direction.'
     */'   ptsp <F> 4I - plot cut between two pionts (bilinear interp.)'
C     */,'   pl   <F>  - quick look grey level symbol plot on printer.',
     */,'   blck <F>  - type picture in NXN averaged block.')
 102	FORMAT(//' PICTURE OPERATIONS'/
     *'   par S B - PICTURE ARITHMETICS, perform a completely',
     *' generalized'/,14X,'arithmetical expression with any',
     *' combination of core frames,'/,14X,
     *'done in real numbers. 2nd string (BOXn) defines the box number'/
     *'   car <F> S B- CONSTANT ARITHMETICS, see "par".'/
     *'   pdiv 3F R - Const*P1/P2, place result in P3,'
     *,' Const, P1,2,3, to be requested.'/
     *'   aver 3<F> - average frame 1 and 2, store in 3 (same size).'/
     *'   wtav  3<F> - weighted average 1 and 2, store in 3.'/
     *'   sum 3<F>  - sum frame 1 and 2, store in 3 (same size).'/
     *'   ssum 3<F> - add <1> to <2>, diff size, arbitrary int shift.'/
     *'   ssub 3<F> - same as "ssum", but subtract <2> from <1>.'/
     *'   amag <F>  - convert pixel by pixel to magnitudes.'/
     *'   medp S F - create a median frame from specified core frames.'/
     *'   shift <F> 2R - picture shifting, (conserving intensity).'/
     *'   shtr  <F> - same as shift, dx/dy from smat/p transform'/
     *'   ishtr <F> - same as shtr, but nearest integer pix shift.'/
     *'   sshift <F> 2R - picture shifting using SINC interpolator.'/
     *'   rot  <F>  3R - picture rotation about a given pixel.'/
     *'   r180 F  - rotate picture by 180 degrees.'/
     *'   r90  <F>  - rotate picture by 90 deg clockwise.'/
     *'   r90c <F>  - rotate picture by 90 deg c-clockwise.')
500	FORMAT('  <Cr> to continue ..... ',$)
1021	FORMAT(
     *'   trans F - transpose picture.(i.e., (I,J) to (J,I))'/ 
     *'   miri F  - mirror picture about I axis. (J==>NJJ-J+1)'/
     *'   mirj F  - mirror picture about J axis. (I==>NII-I+1)'/
     *'   medf/mdfi F 4I - median filter a section of F, sq filter',
     *                   ' rectanglar filter'/
     *'   mfbf F  - median filter a section of F using brute force med'/
     *'   lmed F 2I - smooth line by line (I only) by med filter'/
     *'   smooth F I - smooth with N X N mean filter.'/
     *'   tsmooth F I - smooth with N X N tapered mean filter.'/
     *'   conv 3<F>  - convolve <1> and kernel <2>, store in <3>.'/
     *'   cmap F1 F2 - create colour map using F1 and F2.'/
     *'   psfs F I - PSF subtraction.'/
     *'   psfa F I - Add PSF .'/
     *'   mpsfs <F1> I - PSF sub of <11 objs of known shifts & scales.'/
     *'   psfm <F1> - iterative recentroiding of PSF to find best match'
     *' with obj.'/
     *'   cpsf <F1> I - iteratively centering obj to an int. centroid.'/
     *'   smpsf <F1> - azmithally smooth the outer part of a psf.'
     */'   shr <F> R  - shrink image by factor (real) to 0,0 corner.'/
     *'   shk <F> I  - shrink image by factor (integer) to 0,0 corner'/
     *'   trim <F>  - trim frame <F>.'/
     *'   cut  <F> I - cut picture within specified corners.'/
     *'   paste <F> I - cut part of frame F to put in frame I.'/
     *'   sscale  <F> - scale a subsection of a picture.')
 1022	FORMAT('  IMAGE COSMETIC FIXING COMMANDS:'/
     *'   sflat <F> - self-flattening, using modal value of small blks'/
     *'   rflat <F>  - self-flattening in J direction using row modes.'/
     *'   cflat <F>  - self-flattening in I direction using col modes.'/
     *'   prfl/pcfl  - same as rflat/cflat, but for part of picture.'/
     *'   lflt <F> - flatten each row by med filter smoothed lines',/
     *'   pflt <F> - same as lflt with added polynomial smoothing',/
     *'   scbr <F>  - scale bad rows using neighbouring rows.'/
     *'   scbc <F>  - scale bad columns using neighbouring columns.'/
     *'   flbc <F>  - fill bad columns using neighbouring columns.'/
     *'   flbr <F>  - fill bad rows using neighbouring rows.'/
c     *'   fixp <F>  - fix bad pixels for Steward data.'/
     *'   crbp <F>  - create mask frame for "bpfix".'/
     *'   +crbp <F>  - create mask map (crbp) onto existing map.'/
     *'   saocrbp <F>  - create mask frame from a sao region file.'/
     *'   bldm <F>  - create bleeding column image on a clean mask.'/
     *'   +bldm <F>  - same as bldm but add map to existing mask F.'/
     *'   cmask <F>  - create mask frame by assuming 0=bad pix map'/
     *'   crbd <F>  - same as crbp, but creat border only'/
     *'   mbdi <F>  - make an existing mask into inside border.'/
     *'   mbdo <F>  - make an existing mask into outside border.'/
     *'   objm <F>  - "unmask" area near posfile object positions.'/
     *'   bpfix <F> - fix bad pixels using a mask defined by "crbp".'/
     *'   bpfx <F> -  same as bpfix, but always interpolate across I'/
     *'   bpfy <F> -  same as bpfix, but always interpolate across J'/
     *'   fixz <F> -  fix zero order for MOS data '/
c    *'   bpf2 <F> -  bpfix, but use 2nd mask: 10=I, 100=J'/
c    *'   bpf3 <F> -  bpfix, but use 2nd mask: 10=J, 100=I'/
     *'   clcr <F1> <F2> - suppress cosmic rays using TWO frames.'/
     *'   rple/ge F I B - replace all pix less/greater than threshold'/
     *'   rpbd F I - replace all pix outside pflim(1) limits by I'/
     *'   rpsa F I - randomize saturated pixels by +/-10'/
     *'   addn <F1> - add artificial noise to smoothed image')
 1023	format(
     *'   nega F I B - search for all pix less than threshold (IPRT)'/
     *'   posi F I B - search for all pix greater than threshold(IPRT)'/
     *'   fudg <F> 3I - replace a particular pix with entered value..'/
     *'   crm1 <F1> (F2) BOXn - create cosmic ray map using 1 frame'
     *       ,' within BOXn.'/
     *'   crmo - same as crm1, but only for obj specs',
     *          ' (specmask pix=10)'/
     *'   crms - same as crm1, but only for skylines',
     *          ' (specmask pix=100)'/
     *'   crm2 <F1> <F2> - create a map of cosmic rays using 2 frames.'/
     *'   spmask <F1> - create a mask map from axf file (spectra/sky).'/
     *'   spbx <F1> - pick a clean box on spectrum, based on spec map.'/
     *'   rbst   - read in x,y,radius for 5 bright stars for masking'/
     *'   padmap <F> - pad with a layer of badpix around all badpixes.'/
     *'   cseed 3<F> - create a map of connected areas starting with',
     *' a seed map'/
     */'   cona <F1> <F2> - create a map of connected areas above a t'
     *,'hershold.'/
     *'   rppr - replace map with pixels with a variable scaling.'/
     *'   rppi <F1> <F2> - replace pixels from 1 by 2 using a map.'/
     *'   rppo <F1> <F2> - as  rppi, but exclude area near objects.'/)
 1025	FORMAT(/' STATISTIC COMMANDS:'/
     *'   pstat <F> - AVERAGE, SIGMA, MAX and MIN pixel of <F>',
     *                   ' within window.'/
     *'   rstat <F> - AVERAGE, SIGMA, MAX and MIN of row.'/
     *'   cstat <F> I - AVERAGE, SIGMA, MAX and MIN of column.'/
     *'   pmode <F> I - MODE and MEDIAN of <F> within window or box.'/
     *'   rmode <F> I - MODE and MEDIAN of row.'/
     *'   cmode <F> I - MODE and MEDIAN of column.'/
     *'   rsmode <F> S - MODES and MEDIANS of a number of rows.'/
     *'   csmode <F> S - MODES and MEDIANS of a number of columns.'/
     *'   gsky <F> 4I - global sky & sig from equally spaced strips.'/
     *'   box I -  set box number (1-9) for statistics etc.'/
     *'   boxc I 4I - set co-ord of box I, entering central pix+extend'/
     *'   boxa I 4I - set co-ord of box I, entering edge pix+extend'/
     *'   boxe I 4I - set co-ord of box I, entering ending pix co-ords'/
     *'   sky  <F>  - Calculate sky value using various geomteric '
     *     ,'shapes.')
 103	FORMAT(//' PHOTOMETRY COMMANDS'/'   qfind <F> N S R - Quick ',
     *'object finding routine.'/'   find <F> " - locate objects above',
     *' a threshold (KRON).'/
     *'   fins <F> " - same as "find", but uses a shrunken array.'/
     *'   afin <F> " - same as "find", but uses ring aperture ',
     *'for sky.'/
     *'   afim <F> " - Same as "afin", with masking capability.'/
     *'   satf <F> " - local objects only if pixel>0.9adusat.'/
     *'   sfin <F> " - Same as "afin", but uses a shrunken array.'/
     *'   rejcr <F> - rejection of CosRays in position file.'/
     *'   rejh  <F> - rejection of halo objs in position file.'/
     *'   cfin <F> N S - object finding by area connection.'/
     *'   ccen <F>  - semi-automatic iterative routine for finding'/
     *'               the best centroids for objects in POS file.'/       
     *'   acen <F>  - completely automatic version of "ccen".'/
     *'   cent <F> 4I - determine centroid using fractional pixels.'/
     *'   cslit <F> - compute centroid for an object in a slit.'/
     *'   phot <F> N S 2I - Derive total intensity, centroid, peak'
     *,' value, and'/,17X,'ellipticity of object from positions in the',
     *' position file.'/'   1phot <F> 4I - same as "phot", for a ',
     *'single ',
     *'object.'/'   lphot <F> 4I -same as "1phot", with option to ',
     *'repeat',
     *' inputs'/'   aupho <F> N S 2I - same as "phot", for a series',
     *' of '/
     *'                apertures to determine the best magnitude'
     */'   1auph <F> 3I - same as "aupho", but for a single object.'/
     *'   lauph <F> 3I - same as "1auph", but with option to repeat.'/
     *'   aucp  <F> 3I - crowded-field aperture photometry.'/
     *'   ppph  <F>  - partial-pixel crowded-field aperture '
     *,'photometry.')
 1031	FORMAT(
     *'   apph  <F>  - "ppph" with auto selection for reference ',
     *'stars.'/
     *'   psph  <F>  - stellar photometry using sinc shifted ',
     *      ' centroids'/
     *'   aref  <F> - auto creation of .ref file'/
     *'   sphot <F> - surface photometry of an object (circular apt).'/
     *'   ssph  <F> - sectional surface photometry of an object.'/
     *'   isop  <F> - isophotal surface photometry.'/
     *'   mskf  <F> - create a file of neigbours plus mask radius'/
     *'   fhdr  <F> - create .hdr fix file from saoimage entries.'/
     *'   hfhd  <F> - fhdr for old mspos format.'/
     *'   cc1 <F1> <F2> F - correct for colour term for 1 & 2.'/
     *'   rpof <F>  - read position file for "phot" or "aupho".'
     *,/'   rrpof <F> - read position file with real number input.')
 104	FORMAT(//' MISCELLANEOUS COMMANDS'/
     *'   %  - (1st character) denotes Operating System commands.'/
     *'   help      - if you are reading this, you already know',
     *                   ' about this.'/
     *'   phelp     - output HELP file onto a file for printing.'/
     *'   hist      - type out the previous 40 commands.'/
     *'   savh      - save in a file the  previous 40 commands.'/
     *'   set N I/R - set (to I/R) or display program parameters'/
     *'   pset N I/R - set (to I/R) or display RCS pipe parameters'/
     *'   see <F>   - estimate FWHM (seeing) of an object'/
     *'   cc        - enter into calculator mode.'/
     *'   g/uran    - generate gaussian/uniform random numbers.'/
     *'   posf      - to enter POSITION FILE MANIPULATION SUBSECTION'/
     *'   mfo       - to enter MULTIPLE FILE OPERATION SUBSECTION'/
     *'   size <F>   - give size of picture F and ask for new size.'/
     *'   dir I I   - type picture directory on terminal.'/
c     *'   dirp      - print picture directory on line printer.'/
     *'   del N     - delete a picture file from disk and the'
     *                 ,  ' DIRECTORY LISTING.'/
     *'   msize     - show/set maximum picture size allowed in core'/
     *'   mac1/2    - run macro file ppp.macro1/2 '/
     *'   macr s    - run macro file s.macro.  Macro file MUST end'
     *,' with end'/
     *,'  # - denotes comment line'/ 
     *'   stop or quit     - to exit.'/
     *'   quco - compress all fits files (compress or gzip) and exit.'/
     *'   ! I1 (I2) - execute commands I1 (to I2).'/
     *'   -i        - repeat the ith command back of the current one.'/
     *'   COMMANDS for Hickson''S PHOTON COUNTING IMAGES:'/
     *'        rhic,whic,corh,snak,dsin,ur1,ur2,shear,sfuz'/
     *'   Other random COMMANDS: wvcm')
 106	FORMAT(/' MULTIPLE FILE COMMANDS:'/
     *'  To enter this subsection issue the command "mfo", to return to'
     */'   ppp type q. Commands in this sublevel allow operations to be'
     */'   performed directly on a set of pictures IN THE DISK(changing'
     */'   them!!). Parameter IPURGE sets the on-off switch for purging' 
     */'   the oringal files.  After issuing the command, a file number'
     */'   sequence is requested.  Numbers in the sequence must be'/
     *'   separated by blanks or a dash: e.g. 2 5 8-11 18 means operate'
     */'   on files 2,5,8,9,10,11,18.  **NOTE** Here, FILE means file'/
     *'   numbers of the disk DIR and in some some cases, file numbers'/
     *'   on tape.  Alternatively, one can enter with the file sequence'
     */'   (" enclosure not necessary) at the same time as the command.'
     */'   Disk files with qualifiers other then .pic will be rejected'/
     *'   by mfo commands.  '/
     *'   COMMANDS AVAILABLE with same meaning as those in ppp are:'/
     *'      rfit,trim,pdiv,fixpic,del,r90,r90c,r180,miri,mirj,bpfix,'/
     *'      scbr,scbc,flbr,flbc,rflat,cflat,lflt,pflt,prfl, and pcfl.'
     *//' --Plus the following additional COMMANDS :'/)
 1061	FORMAT(
     *'   wfit  - write frames to tape in FITS format (simple header) '/
     *'   mpic  - match frames according to references by trimming.'/
     *'   com   - change comment field of DIR pictures.'/ 
     *'   bias  - Subtract a constant determined from a section of pic'
     */'   psub - Subtract a designated frame from the files.'/
     *'   fdiv - Same as "pdiv", with auto scaling from dividing ',
     *'frame.'/
     *'   wsum - Sums N pictures with weights.'/
     *'   aver - average of N pictures.'/
c    *'   waver - average of N pictures with weights.'//
     *'     To do PRELIMINARY REDUCTION, i.e.: flatfielding, bias sub.,'
     */'   etc., use a combination of bias, trim, psub, and, fdiv.'/
     *'   As of now, no provision exists for multiple defringing.')
1201	format(/' RCS MEF File Pipeline Commands:'/
     * '  MEF chip format: name^n (or F^n) for chip n, max n=40'/
     * ' pipe c1 c2: pipe line obj finding and photometry for chips'/
     *               'c1 to c2; blank=all chips'/
     * ' pipf c1 c2: pipe line object finding (only)'/
     * ' piph c1 c2: pipe line photometry (only)'/
     * ' pipa c1 c2: pipe line to add photometry of new filters'/
     * ' pmk0 c1 c2: create and save mask image: bad columns only'/
     * ' pmk1 c1 c2: same as pmk0, for bad columns + bright stars'/
     * ' pmk2 c1 c2: same as pmk0, for bad columns + cosmic rays'/
     * ' pmk3 c1 c2: same as pmk0, bad columns + cosmic rays + stars'/
     * ' rdgh      : read in ghost image offset polynomial for megacam'/
     * ' cshi c1 c2: find shifts between filters from c1 to c2;'/
     *               ' replace bad chip with average; used in piph'/
     * ' pmf0 c1 c2: same as pmk0, but create .mkp pixel list file'/
     * ' pmf1 c1 c2: same as pmk1, but create .mkp pixel list file'/
     * ' pset      : set pipeline paramters')
 105	FORMAT(/' POSITION FILE (PF) MANIPULATION COMMANDS:'/
     *'   Enter by issuing "posf" in ppp, to return to ppp,'/
     *'   enter "q" or "ppp". Selected commands are also available'/
     *'   within ppp.  Commands have the same format as ppp.'/
     */' COMMANDS AVAILABE:'
     */'   t <F> 2I    - type PF for frame <F> between #I1 and I2.'
     */'   tp <F> 2I    - type PF for frame <F> between pix J1 & J2.'
     */'   objn <F> 2I - find ppp number for obj at position I,J.'
     */'   save <F> N S - save PF in disk.'
     */'   pflim <F> - set up posfil pixel limits. '
     */'   rpof <F> N - read PF from disk for frame <F>.'
     */'   rpau <F> N - read integer PF from disk "auph" file for <F>.'
     */'   rrpau <F> N - read real PF from disk "auph" file for <F>.'
     */'   frpo <F> - read PF with flexible format.'/
     */'   frps <F> - read PF with flexible format and scale.'/
     */'   coo <F> - combine or create position file(s) for ds '
     */'   scoo <F> - output pos file to saoimage.reg file '
     */'   scon <F> - output obj numbers from pos file to saoimage.reg'
     */'   spos <F> - incoporate sao-image pos file editing into ppp'
     */'   edit <F>  - edit position file <F>'
     */'   merp <F>  - merge close objects into one'
     */'   trim <F>  - trim position file <F> to within I,J limits.'
     */'   scpf <F>  - scale position file by a constant'
     */'   tfpo <F1> <F2>  - scale and rotate pof1 to pof2'
     */'   miri/j,tran, rot r/90/90c/180 - same as OP commands, '
     *        ,'but for pos'
     */'   matp <F1> <F2> - replace F2 pos with F1 after matching &',
     *        ' transforming'/
     */'   matc <F1> <F2> - as in matp, but save transf co-eff',
     */'   mttp/mttc - same as matp/mttc, but allows initial transform'  
     */'   del <F>   - delete position file <F>, (set NOB to 0).'
     */'   rec <F>   - recover deleted PF <F> (reset NOB).'
     */'   shift <F1> 2I - integer shift of co-ordinates in PF <F>.'
     */'   copy <F1> <F2> - move (copy) position file of frame 1 to 2'
     */'   comb <F1> <F2> - combine position file of frame 1 & 2'
     */'   rcros <F1> <F2> - cross-correlate PF of <F1> & <F2>'
     *,' using REAL centroids.'
     */'   icros <F1> <F2> - cross-correlate PF of <F1> & <F2> (Integer'
     *       ,' centroids')
 107	FORMAT(//,' DISPLAY COMMANDS (system dependent, Tek compatible',
     *   ' terminal assumed)'/ 
     *' **** Co-ordinate convention: for all display commands and most'/
     *'   other commands, the 1st co-ord is I (or X), 2nd, J (or Y).'/
     *'   Pictures are displayed with (1,1) at upper right hand corner'/
     *'   with I increasing downward and J increasing to the left.'//
     *'   sdis <F> - display two-level picture on graphics terminal.'/
     *'             ...see help section cc for cursor command menu...'/
     *'   curp <F> - type the last 10 cursor readings from "sdis"'/
     */'  The following are PGplot commands (subcomands help=m):'/
     *'   cplt/cpl <F> S - contour plot of section of F1 on device S.'/
     *'   pend - close (i.e., save) current pgplot window'/
     *'  pgim <F> - plot picture in pgplot gray scale.'
     */'  npgim <F> - same as pgim but with posf objects marked.'/
     *'   pltf   - plot one data set vs another from 1 or 2 disk files.'
     */'   hard <F>  - two-level hard copy plot file of picture.'/
     *'   nhard <F> - same as "hard", but with object position ',
     *   'marked and numbered.'/
     *'   nplt <F>  - same as "hard", but plot position file only.'/)
 108	FORMAT(//'  SIMULATION COMMANDS: Simulate CCD direct imaging,'/
     *'     data files for simulation are label as .sim. ++ Simulation'
     */'     will destroy all frames in core. ++  Cluster simulation'/
     *'     requires a .cls file created by the program GCA.'/
     *5X,'Parameter NCOSRAY: cosmic ray rate, MODGAL: galaxy model.'//
     *'   makd - create an image, entered (tty or .sim file) x,y,mag.'/
     *'   makl - same as "makd" , but creates only .sim file.'/
     *'   gend - create an image, randomly generated x,y,mag.'/
     *'   genl - same as "gend" , but creates only .sim file.'/
     *'   gcld - create an image of a cluster at z.'/
     *'   gcll - same as "gcld" , but creates only .sim file.'/
     *'   gcbd - create an image of a cluster at z + background objs.'/
     *'   gcbl - same as "gcbd" , but creates only .sim file.'/
     *'   mcbd - same as "gcbd", but background objs from .sim file.'/
     *'   mcbl - same as mcbd , but creates only .sim file.'/
     *'   rpsm <F> - creat posf file from .sim(ulation) file.'/
     *'   make <F>  - create an image of simple Gaussian PSFs.')
 109	format(1x,/'  sdis/cplt CURSOR COMMANDS:'//
     *     '  h -- home (return to ppp)'/
     *     '  ? -- type out cursor menu'/
     *     '  s -- show image (sdis only)'/
     *     '  c -- type co-ordinate of cursor and save in cursor file'/
     *     '  e -- erase image and re-display'/
     *     '  n -- plot object positions from position file'/
     *     '  N -- plot object positions with numbers marked'/
     *     '  m -- plot object positions from file of another frame'/
     *     '  M -- same as m, but with numbers marked'/
     *     '  f -- change frame number for display'/
     *    '  l + r -- zoom region defined by ''l'' cursor = lower left'/
     *           '          and ''r'' cursor value = upper right'/
     *     '  z + v -- zoom in region definded by z and v cursor values'
     *     /'  u -- unzoom'/
     *     '  y -- display image with entry boundry points'/
     *     '  b -- defining a box'/
     *     '  a -- adding an object to the position file'/
     *     '  d -- deleting a list of objects from position file'/
     *     '  x -- deleting an object from the position file'/
     *     '  p -- making a hardcopy file of the plot'/
     *     '  + -- computing centroid of region around cursor'/
     *     '  * -- aperture photometry of object marked by cursor'/
     *     '  w -- compute FWHM (see) of object marked by cursor'/
     *     '  t -- type out a 10X10 region around the cursor'/
     *     '  k -- compute sky of a circular region marked by cursor')
 120	format('  Spectral Data Inspection Commands:'/
     *   '  xspx <F> -- simple extraction of spectrum dispersed in I'/
     *   '  xspy <F> -- simple extraction of spectrum dispersed in J'/
     *   '  sksx <F> -- 2-D sky sub of spectrum dispersed in I'/
     *   '  sksy <F> -- 2-D sky sub of spectrum dispersed in J'/
     *  '  dssp F   - display individual MOS spectrum from frame F')
c        
 999	RETURN1
     	END

