C/////////////////////////////////////////////////////////////////
C
C  POINT SPREAD FUNCTION SUBTRACTION PROGRAM
C
C////////////////////////////////////////////////////////////////
	SUBROUTINE PSFSUB(*,NFR,STR,IX,NU,NV,KF)
 	INTEGER IX(NU,NV,KF),ipsff2,jpsff2,iob2,job2,ipsf2,jpsf2
c	INTEGER*2 IX(NU,NV,KF),ipsff2,jpsff2,iob2,job2,ipsf2,jpsf2
	DIMENSION ITGRAD(8),ING(3),temp1(5),temp2(8)
	CHARACTER NCOMC*36,IAN*1,PSH*1,STR*60,IAN1*1,gradstr*2,
     *             fitsname*24
	INCLUDE 'picdir.inc'
	COMMON/PICC/ NCOMC(15),fitsname(15)
	INCLUDE 'ppparm.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IF (STR.EQ.'*') THEN
	  WRITE(6,*) '   Default object position: ',IOB,JOB
	  GO TO 699
	END IF
 6100	WRITE(6,70)
 70	FORMAT('  Enter frame number of PSF:'/'   <cr> if PSF is in' 
     *         ,' same frame as object: ',$)
	CALL READI4(1,KF1A,idut1,idut2,*999,*6100,*6101,*20002)
20002	IF (KF1A.EQ.NFR) THEN
 6101	  PSH='a'
	ELSE
	  PSH='b'
	END IF
	IF (PSH.EQ.'a') THEN
	  KF1=KF-1
	  WRITE(6,*) '  ++++ Warning: frame ',KF1,' to be used for PSF'
	  IF (KF1.LE.NFR) THEN
	    WRITE(6,*) '  **** ERROR: Cannot do PSFS for frame ',NFR
	    RETURN1
	  END IF
	  KPSF=NFR
	ELSE 
	  KF1=KF1A
	  CALL QUERYNFR(KF1,KF,0,*999,*20003)
20003	  WRITE(6,73) KF1
 73	FORMAT('  +++ assuming PSF in',I2,' already shifted to match')
	  KPSF=KF1
	END IF
 600	WRITE(6,1) IOB,JOB
 1	FORMAT('  Enter integer co-ordinates of object (dflt',2I5,
     *           '): ',$)
	CALL READ2I(IOB,JOB,*999,*600)
 6002	WRITE(6,40) IDIAM,IROBJ
 40	FORMAT('   Enter inner and outer sky ring diameters for object ',
     *     '(dflt',2I4,'): ',$)
	CALL READ2I(IDIAM,IROBJ,*999,*6002)
	CDIAM=IDIAM
C determine fractional centroid and back ground
 699	iob2=iob
	job2=job
	CALL PCENTR(NFR,0,IX,NU,NV,KF,CENOX,CENOY,DUM,OBJSKY,
     *              IOB2,JOB2,1,CDIAM,IROBJ,1,20)
	WRITE(6,9) CENOX,CENOY,OBJSKY
 9	FORMAT( '     Centroid: ',2F9.4,'   Sky: ',F8.2)

	IF (STR.EQ.'*') GO TO 6991
 601	WRITE(6,2) IPSF,JPSF
	CALL READ2I(IPSF,JPSF,*999,*601)
 2	FORMAT('  Enter integer co-ordinates of PSF (dflt:',2I5,'): ',$)
 6011	WRITE(6,41) IRPSF
 41	FORMAT('   Enter outer sky ring diameter for PSF (dflt',I4,
     *            '): ',$)
	CALL READ1I(IRPSF,*999,*6011)	
 6991	ipsf2=ipsf
	jpsf2=jpsf
	CALL PCENTR(KPSF,0,IX,NU,NV,KF,CENSX,CENSY,DUM,PSFSKY,
     *             IPSF2,JPSF2,1,CDIAM,IRPSF,1,20)
	WRITE(6,9) CENSX,CENSY,PSFSKY
	IF (STR.EQ.'*') GO TO 6992
 602	WRITE(6,3) IDSUB
 3	FORMAT('   Enter DIAMETER (int pix) of region of subtraction '
     *             ,'(default',I4,'): ',$)
	CALL READ1I(IDSUB,*999,*602)
C  cut out PSF and place in frame KF-1, shift PSF to match pk of obj.
 6992	IF (PSH.EQ.'a') THEN
	  NII(KF1)=IDSUB+ISINCF-1
	  NJJ(KF1)=NII(KF1)
	  ITT=IPSF-NII(KF1)/2-1
	  JTT=JPSF-NJJ(KF1)/2-1
	  DO 100 J=1,NJJ(KF1)
	    JJ=JTT+J
	    DO 100 I=1,NII(KF1)
 100	      IX(I,J,KF1)=IX(ITT+I,JJ,NFR)
	  XSH=CENOX-IOB-CENSX+IPSF
	  YSH=CENOY-JOB-CENSY+JPSF
 	  IPSFF=NII(KF1)/2+1
	  JPSFF=NJJ(KF1)/2+1
 6024	  WRITE(6,30) XSH,YSH,IAN
 30	FORMAT( '   ..Relative position (I, J axis):',2F8.4,
     *    /'   Enter d=default shift, m=iterative matching (2pt), n=ite'
     *   ,'r matching (9pt),'/'    e=user entered shift: (',A1,'):',$)
	  call readstr(1,ian1,*999,*6024)
	  IF (IAN1.NE.' ') IAN=IAN1
	  IF (IAN.EQ.'d') THEN
	    CALL SINCSHIF(*130,KF1,XSH,YSH,IX,NU,NV,KF)
	  ELSE IF (IAN.EQ.'e') THEN
 6021	    WRITE(6,32)
 32	FORMAT('   Enter fractional pixel shift for PSF in I, J: ',$)
	    call read2r(xsh,ysh,*999,*6021)
	    CALL SINCSHIF(*130,KF1,XSH,YSH,IX,NU,NV,KF)
	  ELSE IF (IAN.EQ.'m') THEN
	    WRITE(6,*) ' ...Iterative matching of 2nd highest points:'
	    CALL PSFMAT(NFR,KF1,IOB,JOB,IPSFF,JPSFF,OBJSKY,PSFSKY,
     *                 XSH,YSH,TXSH,TYSH,IX,NU,NV,KF)
	  ELSE IF (IAN.EQ.'n') THEN
	    WRITE(6,*) ' ...Iterative matching of central 9 pixels:'
	    WRITE(6,*) '    +++ NOT AVAILABLE +++'
	    GO TO 6024
C	    CALL PSFMAT9(NFR,KF1,IOB,JOB,IPSFF,JPSFF,OBJSKY,PSFSKY,
C    *                 XSH,YSH,TXSH,TYSH,IX,NU,NV,KF)
	  END IF
 130	  ipsff2=ipsff
	  jpsff2=jpsff
	CALL PCENTR(KF1,0,IX,NU,NV,KF,CENSXF,CENSYF,DUM,DUM1,
     *                IPSFF2,JPSFF2,1,CDIAM,MIN0(IRPSF,NII(KF1)),1,20)
	  WRITE(6,14) CENSXF,CENSYF
 14	FORMAT('   Centroid of shifted PSF: ',2F10.4)
c ! for the case of manually shifted picture
	ELSE 
	  IPSFF=IPSF
	  JPSFF=JPSF
	END IF
C   ratio between PSF and OBJECT
c	PORATIO=(FLOAT(IX(IOB,JOB,NFR))-OBJSKY)/
c  NOTE ***  psfsky is used for objsky because objsky often is not accurate
	PORATIO=(FLOAT(IX(IOB,JOB,NFR))-PSFSKY)/
     *	           (FLOAT(IX(IPSFF,JPSFF,KF1))-PSFSKY)
c 603	WRITE(6,4) IX(IOB,JOB,NFR)-NINT(OBJSKY),
 603	WRITE(6,4) IX(IOB,JOB,NFR)-NINT(PSFSKY),
     *             IX(IPSFF,JPSFF,KF1)-NINT(PSFSKY),PORATIO,scale
 4	FORMAT('  Net peak value for obj:',I6,',  for PSF:',I6,3X,F6.2/,
     *         '    Enter scaling as fraction of PSF peak'/
     *   '    (0 for subtracting. max. psf possible) dr:',f5.2,': ',$)
	call read1r(scale,*999,*603)
C single subtraction
	nfl(6,nfr)=1
	IF (SCALE.GT.0.00001) THEN
	  SC=SCALE/PORATIO
	  WRITE(6,11) SCALE,SC,-2.5*ALOG10(AMAX1(.00001,SCALE))
 11	FORMAT( '  --- PSF multiplied by',F6.3,' for scaling to',F6.3,
     *         ' times of pk of obj,'/'      (delta m from *:',F7.3,')')
	  CALL PSSUB(NFR,KF1,IOB,JOB,IPSFF,JPSFF,PSFSKY,SCALE,IDSUB,
     *                 IX,NU,NV,KF)
	ELSE
C iteration to find the maximally subtracted psf
C start with .5, cutting the  fraction by 1/2 each time in the right direction
	  IF (SCALE.LT.-.0000001) THEN
 6006	    WRITE(6,80) ING(1),ING(2),ING(3)
 80	FORMAT('  Enter directions (3) for no gradient check (1-8, 1=0'
     *          ,' deg, c-clockwise)'/'   (dflt: ',3I2,'): ',$)
	    CALL READI4(3,ING(1),ING(2),ING(3),*999,*6006,*20005,*20005)
20005	    DO 141 I=1,8
	      ITGRAD(I)=1
	      DO 141 J=1,3
	        IF (ING(J).EQ.I) ITGRAD(I)=99
 141	    CONTINUE
	  ELSE
	    DO 142 I=1,8
 142	      ITGRAD(I)=1
	  END IF
c sc=current scale, sc1= last iteration scale
	  SC=0.5
	  SC1=0.
 6004	  WRITE(6,36) NGRAD1
 36	FORMAT('   Enter gradient test radius (int., default',I3,')'/
     *  '     (Options: integers, m1,m2,a1,a2=median/ave of rings): ',$)
	  read(5,'(a2)',end=999) gradstr
	  if (gradstr.eq.' ') then
	    ngrad1=max0(1,ngrad1)
	  else
	    read(gradstr(1:1),*,err=161) ngrad1
	  end if
C save a copy of the area to be subtracted in KF (after the PSF picture)
 161	  ITT=IOB-NII(KF1)/2-1
	  JTT=JOB-NJJ(KF1)/2-1
	  DO 101 J=1,NJJ(KF1)
	    JJ=JTT+J
	    DO 101 I=1,NII(KF1)
 101	      IX(I,J,KF)=IX(ITT+I,JJ,NFR)
C  subtraction
	  DO 300 K=1,20
	    WRITE(6,*) '  Iter# ',K,'  SC = ',SC
c  !  saving current scale value
	    SC2=SC    
	    SCALE=SC*PORATIO
	    CALL PSSUB(NFR,KF1,IOB,JOB,IPSFF,JPSFF,PSFSKY,SCALE,IDSUB,
     *                    IX,NU,NV,KF)
	    DO 302 I=IOB-1,IOB+1
 302	      WRITE(6,15) (IX(I,J,NFR),J=JOB+1,JOB-1,-1)
 15	FORMAT(3I7)
	  if (gradstr(1:1).ne.'m'.and.gradstr(1:1).ne.'a') then
C check if there is any positive gradient as on goes out from center
C  find derivative out from 8 directions, out to 1/4 of area of subtration
C  fill array for derivative
	    IF (ITGRAD(1).NE.99) CALL SETDER(IOB,JOB,IOB-NGRAD1,
     *                  JOB,ITGRAD(1),IX(1,1,NFR),NU,NV,*170,*20011)
20011	    IF (ITGRAD(2).NE.99) CALL SETDER(IOB,JOB,IOB-NGRAD1,
     *               JOB+NGRAD1,ITGRAD(2),IX(1,1,NFR),NU,NV,*170,*20012)
20012	    IF (ITGRAD(3).NE.99) CALL SETDER(IOB,JOB,IOB,
     *               JOB+NGRAD1,ITGRAD(3),IX(1,1,NFR),NU,NV,*170,*20013)
20013	    IF (ITGRAD(4).NE.99) CALL SETDER(IOB,JOB,IOB+NGRAD1,
     *               JOB+NGRAD1,ITGRAD(4),IX(1,1,NFR),NU,NV,*170,*20014)
20014	    IF (ITGRAD(5).NE.99) CALL SETDER(IOB,JOB,IOB+NGRAD1,
     *                  JOB,ITGRAD(5),IX(1,1,NFR),NU,NV,*170,*20015)
20015	    IF (ITGRAD(6).NE.99) CALL SETDER(IOB,JOB,IOB+NGRAD1,
     *               JOB-NGRAD1,ITGRAD(6),IX(1,1,NFR),NU,NV,*170,*20016)
20016	    IF (ITGRAD(7).NE.99) CALL SETDER(IOB,JOB,IOB,
     *               JOB-NGRAD1,ITGRAD(7),IX(1,1,NFR),NU,NV,*170,*20017)
20017	    IF (ITGRAD(8).NE.99) CALL SETDER(IOB,JOB,IOB-NGRAD1,
     *               JOB-NGRAD1,ITGRAD(8),IX(1,1,NFR),NU,NV,*170,*20018)
20018	    DO 171 LL=1,8
	      IF (ITGRAD(LL).EQ.0) THEN
	        IGRAD=0
	        GO TO 175
	      END IF
 171	    CONTINUE
	    IGRAD=1
	    GO TO 175
 170	    IGRAD=-1
	  else 
	    if (gradstr(2:2).eq.'1') then
c  compute average or median of 4 points immediately around the center
	      temp2(1)=ix(iob,job-1,nfr)
	      temp2(2)=ix(iob-1,job,nfr)
	      temp2(3)=ix(iob+1,job,nfr)
	      temp2(4)=ix(iob,job+1,nfr)  
	      if (gradstr(1:1).eq.'m') then
	        call slomed(4,temp2,ring1,nfr)
	      else 
	        ring1=.25*(temp2(1)+temp2(2)+temp2(3)+temp2(4))
	      end if
	      peak1=ix(iob,job,nfr)
	    else
c compare central 5 points with outer 8 points
	      temp1(1)=ix(iob-1,job,nfr)
	      temp1(2)=ix(iob,job-1,nfr)
	      temp1(3)=ix(iob,job,nfr)
	      temp1(4)=ix(iob,job+1,nfr)  
	      temp1(5)=ix(iob+1,job,nfr)
c
	      temp2(1)=ix(iob-2,job,nfr)
	      temp2(2)=ix(iob-1,job-1,nfr)
	      temp2(3)=ix(iob-1,job+1,nfr)
	      temp2(4)=ix(iob,job-2,nfr)
	      temp2(5)=ix(iob,job+2,nfr)
	      temp2(6)=ix(iob+1,job-1,nfr)
	      temp2(7)=ix(iob+1,job+1,nfr)
	      temp2(8)=ix(iob+2,job,nfr)
	      if (gradstr(1:1).eq.'m') then
	        call slomed(8,temp2,ring1,nfr)
	        call slomed(5,temp1,peak1,nfr)
	      else 
	        ring1=0.
	        peak1=0.
	        do 167 m=1,5
	          peak1=peak1+temp1(m)
	          ring1=ring1+temp2(m)
 167	        continue
	        do 168 m=6,8
	          ring1=ring1+temp2(m)
 168	        continue
	        ring1=ring1/8.
	        peak1=peak1/5.
	      end if 
	    end if
c  determine igrad
	    peak1=peak1-ring1
	    if (peak1.gt.0.1) then
	      igrad=1
	    else if (peak1.lt.0.00) then
	      igrad=-1
	    else
	      igrad=0
	    end if
	  end if
 175	    IF (IGRAD.LT.0) THEN
c  gradient negative, sc is decrease by 1/2 of difference from previous
	      SC=SC-.5*ABS(SC-SC1)
	    ELSE IF (IGRAD.GT.0) THEN
C all gradient positive, SC is increased
	      SC=SC+.5*ABS(SC-SC1)
	    ELSE IF (IGRAD.EQ.0) THEN
	      GO TO 400
	    END IF
 	    SC1=SC2   
C    test: if difference less than .02 %, (10 iterations in the same direction)
	    IF (ABS(SC-SC1).LE.0.0002) THEN
	      IF (IGRAD.GE.0) GO TO 400
c over subtraction, sc is set to smaller value and try again
 	      write(6,*) '  ... slight over-subtraction, refining...'
	      SC=SC1-.0005
	    END IF
C  otherwise, replace the original picture and try again
	    DO 102 J=1,NJJ(KF1)
	      JJ=JTT+J
	      DO 102 I=1,NII(KF1)
 102	        IX(ITT+I,JJ,NFR)=IX(I,J,KF)
 300	  CONTINUE
 400	  WRITE(6,21) SC1,SCALE,-2.5*ALOG10(AMAX1(.000001,SCALE))
 21	FORMAT(' -- Best solution: SC (fraction of object subtracted)=',
     *  F5.3,/,'  Scale as fraction of PSF:',F7.3,' (del mag ',F7.3,')')
	END IF
 999	RETURN1
	END
c/////////////////////////////////////////////////////////////////
C
C  MULTIPLE POINT SPREAD FUNCTION SUBTRACTION PROGRAM
C
C////////////////////////////////////////////////////////////////
	SUBROUTINE MPSFSUB(*,NFR,STR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF),ipsf2,jpsf2,iob2(10),job2(10)
	INTEGER IX(NU,NV,KF),ipsf2,jpsf2,iob2(10),job2(10)
	DIMENSION IOB(10),JOB(10),XSH(10),YSH(10),SCALE(10)
	CHARACTER NCOMC*36,STR*60,fitsname*24
	INCLUDE 'picdir.inc'
	COMMON/PICC/ NCOMC(15),fitsname(15)
	INCLUDE 'ppparm.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IF (STR.EQ.'*') GO TO 700
 600	WRITE(6,70) IPSFF,IPSFT
 70	FORMAT('  Enter frame number of PSF and scratch frame ['
     *         ,2I2,']: ',$)
	CALL READ2I(IPSFF,IPSFT,*999,*600)
	CALL QUERYNFR(IPSFF,KF,2,*999,*20003)
20003	CALL QUERYNFR(IPSFT,KF,3,*999,*6002)
 6002	WRITE(6,40) IDIAM,IROBJ
 40	FORMAT('   Enter inner and outer sky ring diameters for object ',
     *     '[',2I4,']: ',$)
	CALL READ2I(IDIAM,IROBJ,*999,*6002)
	CDIAM=IDIAM
 6003	WRITE(6,2) IPSF,JPSF
	CALL READ2I(IPSF,JPSF,*999,*6003)
 2	FORMAT('  Enter integer co-ordinates of PSF [',2I5,']: ',$)
 6011	WRITE(6,41) IRPSF
	ipsf2=ipsf
	jpsf2=jpsf
 41	FORMAT('   Enter outer sky ring diameter for PSF [',I4,
     *            ']: ',$)
	CALL READ1I(IRPSF,*999,*6011)	
 601	WRITE(6,10) NSTAR
 10	FORMAT('  Enter number (<=10) of objects to be subtracted ['
     *        ,I3,']: ',$)
	CALL READ1I(NSTAR,*999,*601)
	NSTAR=MAX0(1,MIN0(10,NSTAR))
 700	CONTINUE
 	DO 124 I=1,NSTAR
 	  WRITE(6,11) I
 11	FORMAT('  ...Object',I3)
 602	  WRITE(6,12) IOB(I),JOB(I)
 12	FORMAT('   Enter integer position [',2I5,']: ',$)
	  CALL READ2I(IOB(I),JOB(I),*999,*602)
 603	  WRITE(6,13) XSH(I),YSH(I),SCALE(I)
 13	FORMAT('   Enter x and y shift [',2F8.4,'] * scale [',F6.3,
     *            ']: ',$)
	  iob2(i)=iob(i)
	  job2(i)=job(i)
	  CALL READR4(3,XSH(I),YSH(I),SCALE(I),*999,*603,*124,*124)
 124	CONTINUE
 6991	CALL PCENTR(IPSFF,0,IX,NU,NV,KF,CENSX,CENSY,DUM,PSFSKY,
     *             IPSF2,JPSF2,1,CDIAM,IRPSF,1,20)
	WRITE(6,9) CENSX,CENSY,PSFSKY
 6021	WRITE(6,3) IDSUB
 3	FORMAT('   Enter DIAMETER (int pix) of region of subtraction '
     *             ,'(default',I4,'): ',$)
	CALL READ1I(IDSUB,*999,*6021)
	nfl(6,nfr)=1
	DO 125 I=1,NSTAR
	  WRITE(6,*) '  ..... subtracting object',I
	  CALL MOVE(IPSFF,IPSFT,IX,NU,NV,KF)
 	  CALL SINCSHIF(*130,IPSFT,XSH(I),YSH(I),IX,NU,NV,KF)
 130	  CALL PCENTR(IPSFT,0,IX,NU,NV,KF,CENSX,CENSY,DUM,DUM1,
     *                IPSF2,JPSF2,1,CDIAM,MIN0(IRPSF,NII(IPSFT)),1,20)
	  WRITE(6,14) CENSX,CENSY
 14	FORMAT('     Centroid of shifted PSF: ',2F10.4)
C determine fractional centroid and back ground
 699	  CALL PCENTR(NFR,0,IX,NU,NV,KF,CENOX,CENOY,DUM,OBJSKY,
     *              IOB2(I),JOB2(I),1,CDIAM,IROBJ,1,20)
	  WRITE(6,9) CENOX,CENOY,OBJSKY
 9	FORMAT( '     Centroid of object: ',2F9.4,'   Sky: ',F8.2)
c	  PORATIO=(FLOAT(IX(IOB(I),JOB(I),NFR))-OBJSKY)/
	  PORATIO=(FLOAT(IX(IOB(I),JOB(I),NFR))-PSFSKY)/
     *	           (FLOAT(IX(IPSF,JPSF,IPSFF))-PSFSKY)
 	  WRITE(6,4) IX(IOB(I),JOB(I),NFR)-NINT(PSFSKY),
     *                  IX(IPSF,JPSF,IPSFF)-NINT(PSFSKY),PORATIO
 4	FORMAT('   Net peak value for obj:',I6,',  for PSF:',I6,3X,F6.2)
	  SC=SCALE(I)/PORATIO
	  WRITE(6,16) SCALE(I),SC,-2.5*ALOG10(AMAX1(.00001,SCALE(I)))
 16	FORMAT( '  --- PSF multiplied by',F6.3,' for scaling to',F6.3,
     *         ' times of pk of obj,'/'      (delta m from *:',F7.3,')')
	  CALL PSSUB(NFR,IPSFT,IOB(I),JOB(I),IPSF,JPSF,DUM1,SCALE(I)
     *                ,IDSUB,IX,NU,NV,KF)
 125	CONTINUE
 999	RETURN1
	END
C
C////////////////////////////////////////////////////////////////////
C
C   find gradients in given direction
C
	SUBROUTINE SETDER(I1,J1,I2,J2,ITG,IX,NU,NV,*,*)
c	INTEGER*2 IX(NU,NV),IY(20)
	INTEGER IX(NU,NV),IY(20)
	KK=0
C form 1-D data stream
	IF (I1.EQ.I2.OR.J1.EQ.J2) THEN
	  DO 100 J=J1,J2,ISIGN(1,J2-J1)
	    DO 100 I=I1,I2,ISIGN(1,I2-I1)
	      KK=KK+1
 100	      IY(KK)=IX(I,J)
	ELSE
	  IT=ISIGN(1,I2-I1)
	  IT1=I1-IT
	  DO 101 J=J1,J2,ISIGN(1,J2-J1)
	    IT1=IT1+IT
	    KK=KK+1
 101	    IY(KK)=IX(IT1,J)
	END IF
c	write(6,*)(IY(I),I=1,KK)
C negative gradient
	DO 102 I=1,KK-1
	  IF (IY(I).LT.IY(I+1)) THEN
	    ITG=-1
	    RETURN1
	  END IF
 102	CONTINUE
C gradient of 0
	DO 103 I=1,KK-3
	  IF (IY(I).EQ.IY(I+1)) THEN
	    ITG=0
	    RETURN2
	  END IF
 103	CONTINUE
C positive gradient
	ITG=1
	RETURN2
	END
C
C////////////////////////////////////////////////////////////////////
C
C   SUBTRACTION USED BY PSFSUB
C
	SUBROUTINE PSSUB(NFR,NFR2,IOB,JOB,IPSFF,JPSFF,PSFSKY,SCALE,
     *                      IDSUB,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INCLUDE 'picdir.inc'
	IDSQ=NINT(.25*IDSUB*IDSUB)
	SCSKY=SCALE*PSFSKY
	DO 100 J=2,NJJ(NFR2)-1
	  JJ=JOB-JPSFF+J
	  JSQ=(J-JPSFF)*(J-JPSFF)
	  DO 100 I=2,NII(NFR2)-1
	    IF ((I-IPSFF)*(I-IPSFF)+JSQ.GT.IDSQ) GO TO 100
	    II=IOB-IPSFF+I
    	    ITT=INTLIMI(NINT(SCALE*IX(I,J,NFR2)-SCSKY))
	    IX(II,JJ,NFR)=IX(II,JJ,NFR)-ITT
 100	CONTINUE
 999	RETURN
	END
C/////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO SCALE A SUBSECTION OF A PICTURE
C    INPUT are  THE CO-ORDINATES OF THE CORNERS OR A CENTRAL POINT+EXTEND.
C
	SUBROUTINE SSSCALE(*,NFR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER*36 NCOMC,fitsname*24
	COMMON/PICC/NCOMC(15),fitsname(15)
	INCLUDE 'picdir.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*601)
 601	WRITE(6,10) ILT,JLT
 10	FORMAT('  Enter upper right corner (smallest I,J; -''ve '
     *   ,'to change input to center+extend)'/'     [dflt:',2I5,']: ',$)
	CALL READ2I(ILT,JLT,*999,*601)
	IF (ILT.LT.0.OR.JLT.LT.0) THEN
 610	  WRITE(6,41) ICEN,JCEN
 41	FORMAT('  Enter center of section to be scaled (I,J) [dflt:',
     *           2I5,']: ',$) 
	  CALL READ2I(ICEN,JCEN,*999,*610)
 611	  WRITE(6,42) IEX,JEX
 42	FORMAT('  Enter extends of  section (I,J) [dflt:',
     *           2I5,']: ',$) 
	  CALL READ2I(IEX,JEX,*999,*611)
	  IL=MAX0(1,ICEN-(IEX-1)/2)
	  JL=MAX0(1,JCEN-(JEX-1)/2)
	  IR=MIN0(NII(NFR),IL+IEX-1)
	  JR=MIN0(NJJ(NFR),JL+JEX-1)
	ELSE
	  IL=MAX0(ILT,1)
	  JL=MAX0(JLT,1)
 602	  WRITE(6,11) IRT,JRT
 11	FORMAT('  Enter lower left corner (largest I,J) [dflt:',
     *           2I5,']: ',$) 
	  CALL READ2I(IRT,JRT,*999,*602)
	  IR=MIN0(IRT,NII(NFR))
	  JR=MIN0(JRT,NJJ(NFR))
	END IF
 603	WRITE(6,19) SCALE
 19	FORMAT('  Enter scaling constant [',F8.4,']: ',$)
	CALL READ1R(SCALE,*999,*603)
	DO 100 J=JL,JR
	  DO 100 I=IL, IR
	    IX(I,J,NFR)=INTLIMR(SCALE*IX(I,J,NFR))
 100	CONTINUE
	NCOMC(NFR)=NCOMC(NFR)(1:28)//'ssscale'
	nfl(6,nfr)=1
 999	RETURN1
	END
C/////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO CUT A SECTION OF PICTURE OUT, SAME AS TRIM, BUT
C    INPUT IS THE CO-ORDINATES OF THE CORNERS OR A CENTRAL POINT+EXTEND.
C
	SUBROUTINE CUTPIC(*,NFR,NFRES,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER*36 NCOMC,fitsname*24
	COMMON/PICC/NCOMC(15),fitsname(15)
	INCLUDE 'picdir.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IF (NFRES.EQ.0) THEN
 600	  WRITE(6,9) inres
 9	FORMAT('  Enter frame # for result: 0=overwrite (df:',
     *          i2,'): ',$)
	  call read1i(nfres,*999,*600)
	  IF (NFRES.LE.0) THEN
	    WRITE(6,*) ' ..... Overwrite .....'
	    NFRES=NFR
	  ELSE IF (NFRES.GT.KF) THEN
	    WRITE(6,*) ' *** Frame number too large ***'
	    GO TO 600
	  END IF
	END IF
 601	WRITE(6,10) ILT,JLT
 10	FORMAT('  Enter upper right corner (smallest I,J)'/'   [-''ve '
     *    ,'to change input to center+extend (df:',2I5,'): ',$)
	CALL READ2I(ILT,JLT,*999,*601)
	IF (ILT.LT.0.OR.JLT.LT.0) THEN
 610	  WRITE(6,41) ICEN,JCEN
 41	FORMAT('  Enter center of section to be cut (I,J) (dflt:',
     *           2I5,'): ',$) 
	  CALL READ2I(ICEN,JCEN,*999,*610)
 611	  WRITE(6,42) IEX,JEX
 42	FORMAT('  Enter extends of cut section (I,J) (dflt:',
     *           2I5,': ',$) 
	  CALL READ2I(IEX,JEX,*999,*611)
	  IL=MAX0(1,ICEN-(IEX-1)/2)
	  JL=MAX0(1,JCEN-(JEX-1)/2)
	  IR=MIN0(NII(NFR),ICEN+IEX/2)
	  JR=MIN0(NJJ(NFR),JCEN+JEX/2)
	  WRITE(6,43) MIN0(ICEN,(IEX+1)/2),MIN0(JCEN,(JEX+1)/2)
 43	FORMAT('  ....Center pixel of cut frame is (I,J):',2I5)
	ELSE
	  IL=MAX0(ILT,1)
	  JL=MAX0(JLT,1)
 602	  WRITE(6,11) IRT,JRT
 11	FORMAT('  Enter lower left corner (largest I,J) (dflt:',
     *           2I5,': ',$) 
	  CALL READ2I(IRT,JRT,*999,*602)
	  IR=MIN0(IRT,NII(NFR))
	  JR=MIN0(JRT,NJJ(NFR))
	END IF
	JK=0
	DO 100 J=JL,JR
	  JK=JK+1
	  IK=0
	  DO 100 I=IL, IR
	    IK=IK+1
	    IX(IK,JK,NFRES)=IX(I,J,NFR)
 100	CONTINUE
	NII(NFRES)=IR-IL+1
	NJJ(NFRES)=JR-JL+1
	NFL(1,NFRES)=1
	nfl(6,nfres)=1
	NF(NFRES)=NF(NFR)
	NCOMC(NFRES)=NCOMC(NFR)(1:28)//'section'
 999	RETURN1
	END
C/////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO PASTE A SECTION OF A PICTURE TO ANOTHER
C    INPUTS ARE THE CO-ORDINATES OF THE CORNERS.
C      NFP= FRAME TO BE PASTED
C      NFH= HOST FOR THE PASTING
	SUBROUTINE PASTE(*,NFP,NFH,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER*36 NCOMC,fitsname*24
	COMMON/PICC/NCOMC(15),fitsname(15)
	INCLUDE 'picdir.inc'
	CALL QUERYNFR(NFP,KF,0,*999,*20001)
20001	WRITE(6,8) NFP
 8	FORMAT('  Frame ',I2,' is the donor.')
	IF (NFH.EQ.0.OR.NFH.GT.KF) THEN
 600	  WRITE(6,9) 
 9	FORMAT('  Enter frame # to receive the paste: ',$)
	  call read1i(nfh,*999,*600)
	  IF (NFH.EQ.NFP) THEN
	    WRITE(6,*) ' ** Cannot paste picture onto itself **'
	    GO TO 600
	  ELSE IF (NFH.GT.KF-1.OR.NFH.LE.0) THEN
	    WRITE(6,*) ' **** incorrect frame number ****'
	    GO TO 600
	  END IF
	END IF
 601	WRITE(6,10) il,jl
 10	FORMAT('  Enter upper right corner (smallest I,J) of section ',
     *    'to be cut '/'   0 0 for whole picture (df:',2I5,'): ',$) 
	call read2i(il,jl,*999,*601)
c  note IL is actually the right coord, and IR is the left!!
	IF (IL.EQ.0.AND.JL.EQ.0) THEN
	   IL=1
	   JL=1
	   IR=NII(NFP)
	   JR=NJJ(NFP)
	ELSE
	  IL=MAX0(IL,1)
	  JL=MAX0(JL,1)
 602	  WRITE(6,11)ir,jr
 11	FORMAT('  Enter lower left corner (largest I,J) of section',/
     *           'to be cut (df:',2i5,'): ',$) 
	  call read2i(ir,jr,*999,*602)
	  IR=MIN0(IR,NII(NFP))
	  JR=MIN0(JR,NJJ(NFP))
	END IF
 603	WRITE(6,12)ih,jh
 12	FORMAT('  Enter upper right corner in',
     *        '  host frame for pasting (df:',2i5,'): '/,
     *      '    This is where the first pix of the paste will go: ',$)
	call read2i(ih,jh,*999,*603)
C if want to paste to the negative pisel side of the picture
	IF (IH.LE.0.OR.JH.LE.0) THEN
C check picture size
	  NIIT=NII(NFH)-MIN0(1,IH)+1
	  NJJT=NJJ(NFH)-MIN0(1,JH)+1
	  IF (NIIT.GT.NU.OR.NJJT.GT.NV) GO TO 900
	  CALL MOVE(NFH,KF,IX,NU,NV,KF)
C shift picture
	  ISH=-IH+1
	  JSH=-JH+1
	  JK=0
	write(6,*) ' ....padding enlarged picture with 0''s',NIIT,NJJT
	  DO 140 J=1,NJJT
	    IF (J.LT.JSH) THEN
	      DO 141 I=1,NIIT
 141	        IX(I,J,NFH)=0
 	    ELSE
	      JK=JK+1
	      IK=0
	      DO 142 I=1,NIIT
	        IF (I.LT.ISH) THEN
 	          IX(I,J,NFH)=0
	        ELSE
	          IK=IK+1
	          IX(I,J,NFH)=IX(IK,JK,KF)
	        END IF
 142	      CONTINUE
	    END IF
 140	  CONTINUE
C shift all parameter to new field size
	  NII(NFH)=MAX0(NII(NFH),NIIT)
	  NJJ(NFH)=MAX0(NJJ(NFH),NJJT)
	  IH=MAX0(1,IH)
	  JH=MAX0(1,JH)
	END IF
C NORMAL case
	write(6,*) ' ......pasting begins'
	NIIT=IH+IR-IL
	NJJT=JH+JR-JL
	IF (NIIT.GT.NU.OR.NJJT.GT.NV) GO TO 900
	JK=JH-1
	DO 100 J=JL, JR
	  JK=JK+1
	  IK=IH-1
	  DO 100 I=IL,IR
	    IK=IK+1
	    IX(IK,JK,NFH)=IX(I,J,NFP)
 100	CONTINUE
C pad extra area with 0's
C pad extra area with 0's
	IF (NIIT.GT.NII(NFH)) THEN
	  DO 111 J=1,JH-1
	    DO 111 I=NII(NFH)+1,NIIT
	      IX(I,J,NFH)=0
 111	    CONTINUE
	  DO 112 J=JH+JR-JL+2,NJJ(NFH)
	    DO 112 I=NII(NFH)+1,NIIT
	      IX(I,J,NFH)=0
 112	    CONTINUE
	END IF
	IF (NJJT.GT.NJJ(NFH)) THEN
	  DO 113 J=NJJ(NFH)+1,NJJT
	    DO 113 I=1,IH-1
	      IX(I,J,NFH)=0
 113	  CONTINUE
	  DO 114 J=NJJ(NFH)+1,NJJT
	    DO 114 I=IH+IR-IL+2,NJJ(NFH)
	      IX(I,J,NFH)=0
 114	  CONTINUE
	END IF
	NII(NFH)=MAX0(NII(NFH),NIIT)
	NJJ(NFH)=MAX0(NJJ(NFH),NJJT)
	nfl(6,nfh)=1
	NCOMC(NFH)=NCOMC(NFH)(1:29)//'pasted'
 999	RETURN1
 900	WRITE(6,*) ' *** PASTED PICTURE TOO LARGE, PASTING NOT DONE **'
	  RETURN1
	END
C/////////////////////////////////////////////////////////////////
C
C
C////////////////////////////////////////////////////////////////
	SUBROUTINE LINMAP(*,NFR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INCLUDE 'picdir.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*600)
 600	WRITE(6,11)
 11	FORMAT('  Simple linear re-mapping of pixel value:'/
     *         '       IX(I,J)_new= (A*I+B*J+C)*IX(I,J)_old '//
     *         '  ....Enter 3 constants: ',$)
	call readr4(3,a,b,c,*999,*690,*2001,*2001)
 2001	DO 100 J=1,NJJ(NFR)
	  BJ=B*J+C
	  DO 100 I=1,NII(NFR)
c	    RR=(A*I+B*J)*IX(I,J,NFR)
	    RR=IX(I,J,NFR)+A*I+B*J+C
 100	    IX(I,J,NFR)=INTLIMR(RR)
	nfl(6,nfr)=1
 999	RETURN1
 690	write(6,*) '  +++ input error, not done +++'
	return1
	END 
C/////////////////////////////////////////////////////////////////
C
C
C////////////////////////////////////////////////////////////////
	SUBROUTINE LINSUB(*,NFR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INCLUDE 'picdir.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*600)
 600	WRITE(6,11)
 11	FORMAT('  Simple subtraction of tilted plane:'/
     *         '       IX(I,J)_new= *IX(I,J)_old - (A*I+B*J+C) '//
     *         '  ....Enter 3 constants: ',$)
	call readr4(3,a,b,c,*999,*690,*2001,*2001)
 2001	DO 100 J=1,NJJ(NFR)
	  BJ=B*J+C
	  DO 100 I=1,NII(NFR)
	    RR=IX(I,J,NFR)-(A*I+BJ)
 100	    IX(I,J,NFR)=INTLIMR(RR)
	nfl(6,nfr)=1
 999	RETURN1
 690	write(6,*) '  +++ input error, not done +++'
	return1
	END 

C/////////////////////////////////////////////////////////////////////
C
C  SINC FUNCTION INTERPOLATION FOR SHIFTING: SINC FILTER SIZE=ISINCF FROM PPPARM
C       SINC FNC IS TAPERED WITH A HAMMING FILTER, EDGES ARE SET TO MEAN VALUES
C       DOING IT ONE DIMENSION AT A TIME
C
	SUBROUTINE SINCSHIF(*,NFR,XSHT,YSHT,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	REAL SINC(151)
	INCLUDE 'picdir.inc'
	INCLUDE 'ppparm.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IF (abs(XSHT).lt.0.0000001.AND.abs(YSHT).le.0.0000001) THEN
  600	  WRITE(6,150) XSH,YSH
  150	FORMAT( '   SINC function interpolation shift: ENTER X,Y shifts'
     *         ,', REAL,'/'   New IX(i+sx,j+sy)=Old Ix(i'
     *        ,',j), (dflt:',2F8.4,'): ',$)
	  CALL READ2R(XSH,YSH,*999,*600)
	  continue
	ELSE
	  XSH=XSHT
	  YSH=YSHT
	END IF
C shifting X and Y axis separately
C first check if the shift in X is zero
c  !  central index of filter = size of filter+1
	IS2=(ISINCF+2)/2    
	nfl(6,nfr)=1
	IF (ABS(XSH).LT.0.00001) THEN
C must move the frame to the scartch
	  CALL MOVE(NFR,KF,IX,NU,NV,KF)
	ELSE
C shifting in X (I) directiion, the temp frame is stored in scratch
	  CALL MAKESINC(-XSH,ISINCS,ISINCF,IS2,ISH,SINC)
C  first determine means of edges I=1 I=NII
	    CALL PSTAT(*220,NFR,1,0,0,0,ED1,DUM,NDUM,-7,IX,NU,NV,KF)
 220	    CALL PSTAT(*221,NFR,NII(NFR),0,0,0,ED2,DUM,NDUM,
     *                  -7,IX,NU,NV,KF)
 221	    DO 200 J=1,NJJ(NFR)
	      DO 205 I=1,NII(NFR)
	        KK=I-IS2+ISH
	        SUMT=0.
	        DO 206 K=1,ISINCF
	          KKK=KK+K
	          IF (KKK.LT.1) THEN
	            SUMT=SUMT+SINC(K)*ED1
	          ELSE IF (KKK.GT.NJJ(NFR)) THEN
	            SUMT=SUMT+SINC(K)*ED2
	          ELSE
	            SUMT=SUMT+SINC(K)*IX(KKK,J,NFR)
	          END IF
 206	        CONTINUE
 205 	      IX(I,J,KF)=INTLIMR(SUMT)
 200 	    CONTINUE
	END IF
C shifting in Y (J) directiion,  
C check if the y shift if zero
	IF (ABS(YSH).LT.0.00001) THEN
	  CALL MOVE(KF,NFR,IX,NU,NV,KF)
	ELSE
C the array is moved back to NFR during the shift
	  CALL MAKESINC(-YSH,JSINCS,ISINCF,IS2,ISH,SINC)
	    CALL PSTAT(*230,NFR,1,0,0,0,ED1,DUM,NDUM,-9,IX,NU,NV,KF)
 230	    CALL PSTAT(*231,NFR,NJJ(NFR),0,0,0,ED2,DUM,NDUM,
     *                 -9,IX,NU,NV,KF)
 231	    DO 300 J=1,NJJ(NFR)
	      KK=J-IS2+ISH
	      DO 305 I=1,NII(NFR)
	        SUMT=0.
	        DO 306 K=1,ISINCF
	          KKK=KK+K
	          IF (KKK.LT.1) THEN
	            SUMT=SUMT+SINC(K)*ED1
	          ELSE IF (KKK.GT.NJJ(NFR)) THEN
	            SUMT=SUMT+SINC(K)*ED2
	          ELSE
	            SUMT=SUMT+SINC(K)*IX(I,KKK,KF)
	          END IF
 306	        CONTINUE
 305 	      IX(I,J,NFR)=INTLIMR(SUMT)
 300 	    CONTINUE
	END IF
	nfl(6,nfr)=1
 999	RETURN1
	END
C////////////////////////////////////////////////////////////
C
C  subroutine MAKESINC creates the sinc funtion for SINCSHIFT
C
	SUBROUTINE MAKESINC(SHIFT,NSCALE,ISINCF,IS2,ISH,SINC)
	DIMENSION SINC(*)
c  !  central index of filter = size of filter+1
	IS2=(ISINCF+2)/2    
	SCALE=FLOAT(NSCALE)
	PSC=3.14159/SCALE
C  calculate sinc function (ISH = integer part of shift)
 	  ISH=NSCALE*NINT(SHIFT/SCALE)
	  X=ISH-SHIFT
	  SUMFIL=0.
	  DO 201 K=1,ISINCF
	    XT=PSC*(X+FLOAT(K-IS2))
	    IF (ABS(XT).GT.0.001) THEN
	      SINC(K)=SIN(XT)/XT
	    ELSE
 	      SINC(K)=1.
	    END IF
C  taper by Hamming filter (see Digital Filter by R.W. Hamming)
	    SINC(K)=SINC(K)*(.46*COS(XT/FLOAT(IS2-1))+.55)
	    SUMFIL=SUMFIL+SINC(K)
 201	  CONTINUE
C  Normalize the filter
 	  WRITE(6,*) '  Filter normalization: ',SUMFIL
	  DO 207 K=1,ISINCF
 207	    SINC(K)=SINC(K)/SUMFIL
	RETURN
	END
C/////////////////////////////////////////////////////////////////////
C
C  Subroutine to sinc shift part of a picture, for use in CENPSF
C    size of shift = 2*NPS+1 centered around I0 and J0
C
	SUBROUTINE PSINCSHIF(NFR,XSH,YSH,I0,J0,NPS,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	REAL SINC(151)
	INCLUDE 'picdir.inc'
	INCLUDE 'ppparm.inc'
C shifting X and Y axis separately
C first check if the shift in X is zero
	IF (ABS(XSH).LT.0.00001) THEN
C must move the frame to the scartch
	  CALL MOVE(NFR,KF,IX,NU,NV,KF)
	ELSE
C shifting in X (I) directiion, the temp frame is stored in scratch
	  CALL MAKESINC(-XSH,ISINCS,ISINCF,IS2,ISH,SINC)
C  first determine means of edges I=1 I=NII
	    CALL PSTAT(*220,NFR,1,0,0,0,ED1,DUM,NDUM,-7,IX,NU,NV,KF)
 220	    CALL PSTAT(*221,NFR,NII(NFR),0,0,0,ED2,DUM,NDUM,
     *                  -7,IX,NU,NV,KF)
 221	    DO 200 J=MAX0(1,J0-IS2-NPS),MAX0(NJJ(NFR),J0+IS2+NPS)
	      DO 205 I=I0-NPS,I0+NPS
	        KK=I-IS2+ISH
	        SUMT=0.
	        DO 206 K=1,ISINCF
	          KKK=KK+K
	          IF (KKK.LT.1) THEN
	            SUMT=SUMT+SINC(K)*ED1
	          ELSE IF (KKK.GT.NJJ(NFR)) THEN
	            SUMT=SUMT+SINC(K)*ED2
	          ELSE
	            SUMT=SUMT+SINC(K)*IX(KKK,J,NFR)
	          END IF
 206	        CONTINUE
 205 	      IX(I,J,KF)=INTLIMR(SUMT)
 200 	    CONTINUE
	END IF
C shifting in Y (J) directiion,  
C check if the y shift if zero
	IF (ABS(YSH).LT.0.00001) THEN
	  CALL MOVE(KF,NFR,IX,NU,NV,KF)
	ELSE
C the array is moved back to NFR during the shift
	  CALL MAKESINC(-YSH,JSINCS,ISINCF,IS2,ISH,SINC)
	    CALL PSTAT(*230,NFR,1,0,0,0,ED1,DUM,NDUM,-9,IX,NU,NV,KF)
 230	    CALL PSTAT(*231,NFR,NJJ(NFR),0,0,0,ED2,DUM,NDUM,
     *                 -9,IX,NU,NV,KF)
 231	    DO 300 J=J0-NPS,J0+NPS
	      KK=J-IS2+ISH
	      DO 305 I=I0-NPS,I0+NPS
	        SUMT=0.
	        DO 306 K=1,ISINCF
	          KKK=KK+K
	          IF (KKK.LT.1) THEN
	            SUMT=SUMT+SINC(K)*ED1
	          ELSE IF (KKK.GT.NJJ(NFR)) THEN
	            SUMT=SUMT+SINC(K)*ED2
	          ELSE
	            SUMT=SUMT+SINC(K)*IX(I,KKK,KF)
	          END IF
 306	        CONTINUE
 305 	      IX(I,J,NFR)=INTLIMR(SUMT)
 300 	    CONTINUE
	END IF
 999	RETURN
	END
C
C///////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO DETERMINE THE BEST SHIFT BETWEEN TWO OBJECTS BY 
C     INTERATIVELY SHIFTING THE PSF TO MATCH THE CENTRAL 9 PIXELS 
C
	SUBROUTINE MATPSF(*,NFR,NFR2,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF),iob2,job2,ipsf2,jpsf2,ipsff2,jpsff2
	INTEGER IX(NU,NV,KF),iob2,job2,ipsf2,jpsf2,ipsff2,jpsff2
	INCLUDE 'picdir.inc'
	INCLUDE 'ppparm.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IF (KF.LE.2) THEN
	  WRITE(6,7)
 7	FORMAT('   *** NOT ENOUGH CORE FRAMES TO DO THIS COMMAND ***')
	  RETURN1
	ELSE
	  KF1=KF-1
	  WRITE(6,12) KF1
 12	FORMAT(' ++++ WARNING: frame',I2,' will be used to store PSF')
	END IF
	IF (NFR2.EQ.0) THEN
 600	  WRITE(6,60)
 60	FORMAT('   Enter frame number of 2nd frame, '/
     *         '    <cr> if both objects are from same frame: ',$)
	  CALL READI4(1,NFR2,idut1,idut2,*999,*600,*655,*666)
 655	  NFR2=NFR
	END IF
 666	CALL QUERYNFR(NFR2,KF,0,*999,*20002)
20002	IF (NFR.EQ.NFR2.AND.KF.LE.3) THEN
	  WRITE(6,7) 
	  RETURN1
	END IF
 602	WRITE(6,13) NFR2, NFR,IOB,JOB
 13	FORMAT('  PSF in frame',I2,' will be shifted to match object'
     *        ,' in frame ',I2,
     *    /'   Default co-ordinates: ',2I5,
     *    /'   Enter integer co-ordinates of object (2 int): ',$)
	CALL READ2I(IOB,JOB,*999,*602)
 603	WRITE(6,40) IDIAM,IROBJ
 40	FORMAT('   Enter inner and outer sky ring diameters for object ',
     *     '(default',2I4,'): ',$)
	CALL READ2I(IDIAM,IROBJ,*999,*603)
	CDIAM=IDIAM
	iob2=iob
	job2=job
C determine fractional centroid and back ground
	CALL PCENTR(NFR,0,IX,NU,NV,KF,CENOX,CENOY,DUM,OBJSKY,
     *              IOB2,JOB2,1,CDIAM,IROBJ,1,20)
	WRITE(6,9) CENOX,CENOY,OBJSKY
 9	FORMAT( '     Centroid: ',2F9.4,'   Sky: ',F8.2)
 601	WRITE(6,2) IPSF,JPSF
	CALL READ2I(IPSF,JPSF,*999,*601)
 2	FORMAT('   Enter integer co-ordinates of PSF (2 int, default',
     *          2I5,'): ',$)
 604	WRITE(6,41) IRPSF
 41	FORMAT('   Enter outer sky ring diameter for PSF (default',
     *          I4,'): ',$)
	CALL READ1I(IRPSF,*999,*604)
	ipsf2=ipsf
	jpsf2=jpsf
	CALL PCENTR(NFR2,0,IX,NU,NV,KF,CENSX,CENSY,DUM,PSFSKY,
     *             IPSF2,JPSF2,1,CDIAM,IRPSF,1,20)
	WRITE(6,9) CENSX,CENSY,PSFSKY
C  cut out PSF and place in frame KF-1, shift PSF to match pk of obj.
	NII(KF1)=2*ISINCF+1
	NJJ(KF1)=NII(KF1)
	ITT=IPSF-NII(KF1)/2-1
	JTT=JPSF-NJJ(KF1)/2-1
	IPSFF=NII(KF1)/2+1
	JPSFF=NJJ(KF1)/2+1
	DO 103 J=1,NJJ(KF1)
	  JJ=JTT+J
	  DO 103 I=1,NII(KF1)
 103	    IX(I,J,KF1)=IX(ITT+I,JJ,NFR2)
	ipsff2=ipsff
	jpsff2=jpsff
	CALL PCENTR(KF1,0,IX,NU,NV,KF,CENSXF,CENSYF,DUM,DUM1,
     *                IPSFF2,JPSFF2,1,CDIAM,MIN0(IRPSF,NII(KF1)),1,20)
	WRITE(6,14) CENSXF,CENSYF
 14	FORMAT('   Centroid of PSF: ',2F9.4)
C  initial guess
	XSH=CENOX-IOB-CENSXF+IPSFF
	YSH=CENOY-JOB-CENSYF+JPSFF
	CALL PSFMAT(NFR,KF1,IOB,JOB,IPSFF,JPSFF,OBJSKY,PSFSKY,
     *                 XSH,YSH,TXSH,TYSH,IX,NU,NV,KF)
	ipsff2=ipsff
	jpsff2=jpsff
	CALL PCENTR(KF1,0,IX,NU,NV,KF,CENSXF,CENSYF,DUM,DUM1,
     *                IPSFF2,JPSFF2,1,CDIAM,MIN0(IRPSF,NII(KF1)),1,20)
	WRITE(6,14) CENSXF,CENSYF
 999	RETURN1
	END

C
C///////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO DO THE ACTUAL MATCHING OF PSF
C
C
C
	SUBROUTINE PSFMAT(NFR,KF1,IOB,JOB,IPSFF,JPSFF,OBJSKY,PSFSKY,
     *                 XSH,YSH,TXSH,TYSH,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	DIMENSION XX(5,5),YY(5,5),DERI(5),DERJ(5),DERDUM(5),YT(5)
	CHARACTER IAN*1
	INCLUDE 'picdir.inc'
	TXSH=1.25*XSH
	TYSH=1.25*YSH
	ITER=0
	WRITE(6,30) TXSH,TYSH
 30	FORMAT( ' ..Initial guess (Obj-PSF: I, J axis):',2F8.4)
C  fill 5X5 array for matching
	DO 103 J=1,5
	  K=JOB-3+J
	  DO 103 I=1,5
 103	    XX(I,J)=FLOAT(IX(IOB-3+I,K,NFR))-OBJSKY
C determine which point to match:
 610	WRITE(6,27)
 27	FORMAT('   What kind of matching do you want to do:'/
     *         '     h or <cr>= 2nd highest pixel of each direction'/
     *         '     s = same ratio across peak '/
     *         '     e = user specified pixels     ---- : ',$)
	call readstr(1,ian,*999,*610)
	IF (IAN.EQ.'h'.OR.IAN.EQ.' ') THEN
	  IF (XX(3,2).GT.XX(3,4)) THEN
	    JH=2
	  ELSE
	    JH=4
	  END IF
	  IF (XX(2,3).GT.XX(4,3)) THEN
	    IH=2
	  ELSE
	    IH=4
	  END IF
	ELSE IF (IAN.EQ.'e') THEN
 611	  WRITE(6,29)
  29	FORMAT('  Enter 2=U or 4=L (I co-ord) and 2=R or 4=L '
     *            ,'(J co-ord): ',$)
	  call read2i(ih,jh,*999,*611)	
	ELSE IF (IAN.EQ.'s') THEN
	  WRITE(6,*) '   +++ This option not yet available +++'
 	  GO TO 610
	ELSE
	  WRITE(6,*) '   +++ TRY AGAIN +++ '
	  GO TO 610
	END IF
C save a copy of the unshifted PSF
	DO 101 J=1,NJJ(KF1)
	  DO 101 I=1,NII(KF1)
 101       IX(I+NII(KF1),J+NJJ(KF1),KF1)=IX(I,J,KF1)
 555	CALL SINCSHIF(*130,KF1,TXSH,TYSH,IX,NU,NV,KF)
C   ratio between PSF and OBJECT
 130	RATIO=XX(3,3)/(FLOAT(IX(IPSFF,JPSFF,KF1))-PSFSKY)
C   fill array for PSF
	DO 104 J=1,5
	  K=JPSFF-3+J
	  DO 104 I=1,5
 104	    YY(I,J)=(FLOAT(IX(IPSFF-3+I,K,KF1))-PSFSKY)*RATIO
	DO 115 J=1,5
 115	  YT(J)=YY(3,J)
	CALL DERIV(YY(1,3),DERI,DERDUM,1.,5)
	CALL DERIV(YT,DERJ,DERDUM,1.,5)
C calculate shifts
	IF (DERJ(JH).NE.DERJ(3)) THEN
	  YSH=(YY(3,JH)-XX(3,JH))/(DERJ(JH)-DERJ(3))
	ELSE
	  YSH=0.
	END IF
	write(6,*) ' Y',YSH,DERJ(JH),DERJ(3)
	YSH=SIGN(AMIN1(ABS(YSH),1.),YSH)
	IF (ABS(YSH).GT..15) THEN
	  YSH=YSH*.8
	ELSE 
	  YSH=YSH*.75
	END IF
	IF (DERI(IH).NE.DERI(3)) THEN
	  XSH=(YY(IH,3)-XX(IH,3))/(DERI(IH)-DERI(3))
	ELSE
	  XSH=0.
	END IF
	write(6,*) ' X',XSH,DERI(IH),DERI(3)
	XSH=SIGN(AMIN1(ABS(XSH),1.),XSH)
	IF (ABS(XSH).GT..15) THEN
	  XSH=XSH*.8
	ELSE 
	  XSH=XSH*.75
	END IF
	ITER=ITER+1
	WRITE(6,17) ITER
 17	FORMAT(/'  ..Iteration #',I3)
	DO 108 I=1,5
 108	  WRITE(6,18) (XX(I,J),J=5,1,-1),(YY(I,J),J=5,1,-1)
 18	FORMAT(2(3X,5F7.0))
	WRITE(6,19) TXSH,TYSH,XSH,YSH
 19	FORMAT('   Total shift (I,J):',2F8.4,',   next increments:',
     *           2F8.4)
 600	WRITE(6,20)
 20	FORMAT('  Do you want to continue? (<cr>,y/n/e): ',$)
	call readstr(1,ian,*999,*600)
	IF (IAN.EQ.'e') THEN
 601	  WRITE(6,23) xsh,ysh
 23	FORMAT('    Enter delta I and J (df:',2f8.4,'): ',$)
	  call read2r(xsh,ysh,*999,*601)
	END IF
	IF (IAN.NE.'n') THEN
	  TXSH=TXSH+XSH
	  TYSH=TYSH+YSH
C reset PSF
	  DO 111 J=1,NJJ(KF1)
	    DO 111 I=1,NII(KF1)
 111          IX(I,J,KF1)=IX(I+NII(KF1),J+NJJ(KF1),KF1)
	  GO TO 555
	END IF
 999	RETURN
	END
C
C///////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO ITERATIVELY SHIFT AN OBJECT TO CENTROID ON AN INTEGER PIXEL
C
	SUBROUTINE CENPSF(*,NFR,KF1,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF),ii2,jj2,ipsff,jpsff
	INTEGER IX(NU,NV,KF),ii2,jj2,ipsff,jpsff
	INCLUDE 'picdir.inc'
	INCLUDE 'ppparm.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	CALL QUERYNFR(KF1,KF,4,*999,*20002)
20002	IF (KF1.EQ.NFR) WRITE(6,*) 
     *       '  +++ Warning: CPSF will overwrite input frame '
	WRITE(6,10) KF1,2*ISINCF+1,2*ISINCF+1
 10	FORMAT('  -- Resultant picture to be stored in <f>',I2,', size'
     *         ,I4,' x',I4)
 602	WRITE(6,13) IOB,JOB
 13	FORMAT('   Enter integer co-ordinates of object (dflt'
     *         ,2I5,'): ',$)
	CALL READ2I(IOB,JOB,*999,*602)
 603	WRITE(6,40) IDIAM,IROBJ
 40	FORMAT('   Enter inner and outer ring diameter for centroid ',
     *         '(dflt',2I4,'): ',$)
	CALL READ2I(IDIAM,IROBJ,*999,*603)
	CDIAM=IDIAM
C determine fractional centroid and back ground
	ii2=IOB
	jj2=JOB
	CALL PCENTR(NFR,0,IX,NU,NV,KF,CENOX,CENOY,DUM,OBJSKY,
     *              ii2,jj2,1,CDIAM,IROBJ,1,20)
	WRITE(6,9) CENOX,CENOY,OBJSKY
 9	FORMAT( '     Orignial Centroid: ',2F9.4,'   Sky: ',F8.2)
C  cut out PSF and place in frame KF1, 
	NII(KF1)=MAX0(IROBJ+2,2*ISINCF+1)
	NJJ(KF1)=NII(KF1)
	nfl(6,kf1)=1
	ITT=IOB-NII(KF1)/2-1
	JTT=JOB-NJJ(KF1)/2-1
	IPSFF=NII(KF1)/2+1
	JPSFF=NJJ(KF1)/2+1
	DO 103 J=1,NJJ(KF1)
	  JJ=JTT+J
	  DO 103 I=1,NII(KF1)
 103	    IX(I,J,KF1)=IX(ITT+I,JJ,NFR)
	CALL PSFCEN(KF1,IPSFF,JPSFF,CDIAM,IROBJ,TXSH,TYSH,IX,NU,NV,KF)
	CALL PCENTR(KF1,0,IX,NU,NV,KF,CENSXF,CENSYF,DUM,DUM1,
     *                IPSFF,JPSFF,1,CDIAM,MIN0(IROBJ,NII(KF1)),1,20)
	nfl(6,kf1)=1
	WRITE(6,14) TXSH,TYSH,CENSXF,CENSYF
 14	FORMAT('  ...To center object: apply sinc shift:',2F8.4,/
     *         '     Centroid of object in result frame:',2F10.4/)
 999	RETURN1
	END

C
C///////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO CENTER OBJECT
C
	SUBROUTINE PSFCEN(KF1,IPSFF,JPSFF,CDIAM,IROBJ,TXSH,TYSH,
     *           IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF),ipsff,jpsff
	INTEGER IX(NU,NV,KF),ipsff,jpsff
	DIMENSION YY(5,5),DERI(5),DERJ(5),DERDUM(5),YT(5)
	CHARACTER IAN*1
	INCLUDE 'picdir.inc'
C determine fractional centroid and back ground
	CALL PCENTR(KF1,0,IX,NU,NV,KF,CENOX,CENOY,DUM,OBJSKY,
     *              IPSFF,JPSFF,1,CDIAM,IROBJ,1,20)
	WRITE(6,9) CENOX,CENOY,OBJSKY
 9	FORMAT( '     Centroid in cut frame: ',2F9.4,'   Sky: ',F8.2)
	TXSH=IPSFF-CENOX
	TYSH=JPSFF-CENOY
	ITER=0
	WRITE(6,30) TXSH,TYSH
 30	FORMAT( ' ..Initial guess (I, J axis shifts):',2F8.4,
     *         /     '      First 5 interations are automatic...')
	ipsff4=ipsff
	jpsff4=jpsff	
C save a copy of the unshifted PSF
	DO 101 J=1,NJJ(KF1)
	  DO 101 I=1,NII(KF1)
 101       IX(I+NII(KF1),J+NJJ(KF1),KF1)=IX(I,J,KF1)
 555	CALL PSINCSHIF(KF1,TXSH,TYSH,IPSFF4,JPSFF4,3,IX,NU,NV,KF)
C   ratio between PSF and OBJECT
C   fill array for TESTING
 130	DO 104 J=1,5
	  K=JPSFF-3+J
	  DO 104 I=1,5
 104	    YY(I,J)=FLOAT(IX(IPSFF-3+I,K,KF1))-OBJSKY
	DO 115 J=1,5
 115	  YT(J)=YY(3,J)
	CALL DERIV(YY(1,3),DERI,DERDUM,1.,5)
	CALL DERIV(YT,DERJ,DERDUM,1.,5)
	IF (DERJ(2).NE.DERJ(3)) THEN
	  YSH=0.5*(YY(3,2)-YY(3,4))/(DERJ(2)-DERJ(3))
	ELSE
	  YSH=0.
	END IF
	write(6,*)' Y',YSH,DERJ(2),DERJ(3)
	YSH=SIGN(AMIN1(ABS(YSH),1.),YSH)
	IF (ABS(YSH).GT..15) THEN
	  YSH=YSH*.8
	ELSE 
	  YSH=YSH*.75
	END IF
	IF (DERI(2).NE.DERI(3)) THEN
	  XSH=0.5*(YY(2,3)-YY(4,3))/(DERI(2)-DERI(3))
	ELSE
	  XSH=0.
	END IF
	write(6,*)' X',XSH,DERI(2),DERI(3)
	XSH=SIGN(AMIN1(ABS(XSH),1.),XSH)
	IF (ABS(XSH).GT..15) THEN
	  XSH=XSH*.8
	ELSE 
	  XSH=XSH*.75
	END IF
	ITER=ITER+1
	WRITE(6,17) ITER
 17	FORMAT(/'  ..Iteration #',I3)
	DO 108 I=1,5
 108	  WRITE(6,18) (YY(I,J),J=5,1,-1)
 18	FORMAT(3X,5F7.0)
	WRITE(6,19) TXSH,TYSH,XSH,YSH
 19	FORMAT('   Total shift (I,J):',2F8.4,',   next increments:',
     *           2F8.4)
	IF ((ABS(XSH).GT.0.005.OR.ABS(YSH).GT.0.005).AND.ITER.LT.5) THEN
C atuomatically do the first 5 iterations
	  IAN='y'
	ELSE
 600	  WRITE(6,20)
 20	FORMAT('  Enter: y (dflt):continue=dflt / e:user entered shift'/
     *  '  / n:exit / s =shift whole PSF * exit -- (<cr>/e/n/s): ',$)
	  call readstr(1,ian,*999,*600)
	END IF
C reset PSF
	  DO 111 J=1,NJJ(KF1)
	    DO 111 I=1,NII(KF1)
 111          IX(I,J,KF1)=IX(I+NII(KF1),J+NJJ(KF1),KF1)
	IF (IAN.EQ.'e') THEN
 601	  WRITE(6,23) xsh,ysh
 23	FORMAT('    Enter delta I and J (df:',2f8.4,'): ',$)
	  call read2r(xsh,ysh,*999,*601)
	END IF
	IF (IAN.EQ.'s') THEN
C  shift the PSF before exiting
	  WRITE(6,*) ' Shifting the whole frame....'
 	  CALL SINCSHIF(*999,KF1,TXSH,TYSH,IX,NU,NV,KF)
	ELSE IF (IAN.EQ.'n') THEN
	  WRITE(6,*) '  replacing original PSF: NO shifting is gone...'
	ELSE  
C  enter the new shift and do the test shift again
	  TXSH=TXSH+XSH
	  TYSH=TYSH+YSH
	  GO TO 555
	END IF
 999	RETURN
	END
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO ADD OR SUBTRACT TWO FRAMES OF ARBITRARY SIZE AND
C     AN ARBITRARY INTEGER SHIFT
C      IPAR=1  ADD
C      IPAR=-1 SUBTRACT
C                      
	SUBROUTINE SHIFSUM(*,NFR1,NFR2,NFR3,IPAR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER*36 NCOMC,NCOMT,fitsname*24
	COMMON/PICC/NCOMC(15),fitsname(15)
	INCLUDE 'picdir.inc'
	CALL QUERYNFR(NFR1,KF,1,*900,*20001)
20001	CALL QUERYNFR(NFR2,KF,2,*900,*20002)
20002	CALL QUERYNFR(NFR3,KF,4,*900,*20003)
C  request for matching centers
20003	IF (IPAR.EQ.1) THEN
	  WRITE(6,11) NFR1,NFR2,NFR1
	ELSE
	  WRITE(6,12) NFR2,NFR1,NFR1
	END IF
 11	FORMAT('  Adding frame',I2,' to',I2,'.  Resultant frame will'
     *         ,' have size of frame',I2)
 12	FORMAT('  Subtracting frame',I2,' from',I2,'.  Resultant frame' 
     *         ,' will have size of frame',I2)
	IF (NFR3.EQ.NFR1.OR.NFR3.EQ.NFR2) WRITE(6,13) NFR3
 13	FORMAT('      Warning: will overwrite frame',I2)
 600	WRITE(6,14) NFR1,IREF1,JREF1
 14	FORMAT('   Enter reference I,J position for frame',I2,' (dflt:'
     *         ,2I5,'): ',$)
	CALL READ2I(IREF1,JREF1,*900,*600)
 601	WRITE(6,14) NFR2,IREF2,JREF2
	CALL READ2I(IREF2,JREF2,*900,*601)
	NCOMT=NCOMC(NFR1)
	IF (NFR3.NE.NFR1) CALL MOVE(NFR1,NFR3,IX,NU,NV,KF)
	ISH=IREF2-IREF1
	JSH=JREF2-JREF1
	I1=MAX0(1,-ISH+1)
	I2=MIN0(NII(NFR1),I1+NII(NFR2)-1)
	J1=MAX0(1,-JSH+1)
	J2=MIN0(NJJ(NFR1),J1+NJJ(NFR2)-1)
	IF (IPAR.EQ.1) THEN
	  write(6,*) '   .... adding'
	  DO 110 J=J1,J2
	    JJ=J+JSH
	    DO 110 I=I1,I2
	      IX(I,J,NFR3)=INTLIMR(FLOAT(IX(I,J,NFR3))
     *                            +FLOAT(IX(I+ISH,JJ,NFR2)))
 110	  CONTINUE
	  NCOMC(NFR3)=NCOMT(1:30)//'ssum'
	ELSE
	  write(6,*) '   .... subtracting'
	  DO 111 J=J1,J2
	    JJ=J+JSH
	    DO 111 I=I1,I2
	      IX(I,J,NFR3)=INTLIMR(FLOAT(IX(I,J,NFR3))
     *                            -FLOAT(IX(I+ISH,JJ,NFR2)))
 111	  CONTINUE
	  NCOMC(NFR3)=NCOMT(1:30)//'ssub'
	END IF
	nfl(6,nfr3)=1
 900	RETURN1
	END
