C/////////////////////////////////////////////////////////////////
C 
C  SUBROUTINE TO CHECK CENTROID OF POSITION FILE (SIMPLFIED VERSION
C     NO INPUT OPTION, MAXIMUM CHANGE=1 PIXEL
C
	SUBROUTINE CCENTER(*,NFR,IPAR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF),II(0:35),IJ(0:35)
	INTEGER IX(NU,NV,KF),II(0:35),IJ(0:35)
	INTEGER KFR(5)
	CHARACTER*60 DSC1,DSC2,string, fstr55
	INCLUDE 'picdir.inc'
	INCLUDE 'ppparm.inc'
	include 'objcat.inc'
	include 'apert.inc'
	include 'pipeparm.inc'
	DIMENSION RI(5),REALI(56000),REALJ(56000),RMAG(56000)
     *          ,RJ(5),JRG(8),RRMAG(35),DSQ(8),DII(8),DJJ(8)
	INCLUDE 'pppcore.inc'
c  the equivalence is good for 60000 objects
c	EQUIVALENCE (iscr(1),REALI(1)),(iscr(120001),REALJ(1)),
c     *              (iscr(240001),RMAG(1)),(iscr(360001),rrmag(1))
	CALL QUERYNFR(NFR,KF,0,*900,*20001)
20001	IF (NFR.GT.nposfil) THEN
	  WRITE(6,*) '  ***Position file number must be <= ',nposfil
	  RETURN1
	END IF
	DSC1=' '
	DSC2=' '
	WRITE(6,1200) PCOMMENT(NFR)
 1200	FORMAT(1X,A60)
C first call to set up aperture array for ring of 7,31
	CDIAM=FLOAT(NAPCEN)
	if (ircspipe.eq.0) then
 6001	  WRITE(6,66) NAPCEN
 66	FORMAT('  Enter aperture diameter for centroiding,'/
     *   '    default=photometry centroid diameter (NAPCEN=',I3,'): ',$)
	  CALL READ1R(CDIAM,*900,*6001)
	else
	  cdiam=cdiampipe 
	end if
c changed Dec 26/1997: the iteration number used to be 4, now it is
c   set as the parameter itercen.
	write(6,*) ' cdiam ',cdiam
	CALL PCENTR(NFR,1,IX,NU,NV,KF,REALI(1),REALJ(1),RMAG(1),DUM,
     *              IJOI(1,NFR),IJOJ(1,NFR),1,CDIAM,31,0,itercen)
c	write(6,*) '  pcentr  2nd obj '
	CALL PCENTR(NFR,0,IX,NU,NV,KF,REALI(2),REALJ(2),RMAG(2),DUM,
     *              IJOI(2,NFR),IJOJ(2,NFR),NOB(NFR)-1,0.,0,0,intercen)
	if (ircspipe.eq.0) 
     *	 WRITE(6,*)'  List: Objs with centroid >3 pix from integer pos'
	n2p=0
	DO 100 I=1,NOB(NFR)
	  if (ijoi(i,nfr).lt.1.or.ijoi(i,nfr).gt.nii(nfr)) goto 100
	  if (ijoj(i,nfr).lt.1.or.ijoj(i,nfr).gt.njj(nfr)) goto 100
	  DELI=REALI(I)-FLOAT(IJOI(I,NFR))
	  DELJ=REALJ(I)-FLOAT(IJOJ(I,NFR))
 	  IF (ABS(DELI).GT.2..OR.ABS(DELJ).GT.2.) THEN
	    n2p=n2p+1
	    if (ircspipe.eq.0) then
 	      IF (ABS(DELI).GT.3.0.OR.ABS(DELJ).GT.3.0) 
     *          WRITE(6,1) I,IJOI(I,NFR),IJOJ(I,NFR),REALI(I),
     *              REALJ(I),DELI,DELJ,IDOB(I,NFR)
	    end if
 1	FORMAT('-',I5,'-',1X,2I5,2X,2F7.2,3X,2F7.2,3X,I2)
	  END IF
 100	CONTINUE
	write (6,*) '  --- Total of ',n2p,' objects with >2.0pix'
C Finish first round of centroiding
c	CALL RBELL(IBELL)
	ISHMAX=1
	if (ircspipe.eq.0) then
 600	  WRITE(6,10) 
 10	FORMAT('  Iterative re-centroiding: Enter maximum convergent'
     *          ,' shift acceptable,'/,'   (default=1 pix, recommended'
     *         ,' for FWHM<3 pix): ',$)
	  CALL READ1I(ISHMAX,*900,*600)
	else
	  ishmax=ishmaxpipe
	end if
	IF (ISHMAX.GT.3) THEN
	  WRITE(6,*) '   **** Maximum shift allowed  = 3 ***'
	  GO TO 600
	END IF
	ixbright=int(adusat)*0.4
 2	FORMAT(A1)
C
C   big loop for checking every object
	DO 101 I=1,NOB(NFR)
	  if (ijoi(i,nfr).lt.1.or.ijoi(i,nfr).gt.nii(nfr)) goto 101
	  if (ijoj(i,nfr).lt.1.or.ijoj(i,nfr).gt.njj(nfr)) goto 101
	  DI=REALI(I)-IJOI(I,NFR)
	  DJ=REALJ(I)-IJOJ(I,NFR)
C  got to next object if centroid is okay
	  IF (ABS(DI).LE.0.5.AND.ABS(DJ).LE.0.5) GO TO 101
	  DO 1011 KK=1,3
	    RI(KK)=0.
 1011	    RJ(KK)=0.
	  JGD=0
	  RI(4)=REALI(I)
	  RJ(4)=REALJ(I)
C  else
C  one of the co-ords is off by >0.5
	  II(0)=IJOI(I,NFR)
	  IJ(0)=IJOJ(I,NFR)
	  if (ircspipe.eq.0) 
     * 	  WRITE(6,5) I,IJOI(I,NFR),IJOJ(I,NFR),REALI(I),REALJ(I),
     *      DI,DJ,RMAG(I),IDOB(I,NFR),IX(IJOI(I,NFR),IJOJ(I,NFR),NFR)
 5	FORMAT(' OBJ#',I5,1X,2I5,2(2X,2F7.2),F8.3,I3,1X,I6)
C
C  iterate on object I up to 10 times (iteration J1 to J2)
	  J1=1
	  J2=10
	  DO 102 J=J1,J2
C
C For discrepancies bewteen 2.1 and 3.5, the correction is 1/2 only
C
	    DDI=0.
	    DDJ=0.
	    IF (ABS(DI).GT.2.1) DDI=DI*.5
	    IF (ABS(DJ).GT.2.1) DDJ=DJ*.5
C 
C  for larg discrepancies, a new co-ord, changed by only 1 pixel is tried
	    IF (ABS(DI).GT.3.5.OR.ABS(DJ).GT.3.5) THEN
	      if (ircspipe.eq.0) 
     *        WRITE(6,*) ' ++DELTA POS TOO LARGE, NEXT POSITION EST++'
	      II(J)=II(J-1)+SIGN(AMIN1(1.,ABS(DI)),DI)+.49
	      IJ(J)=IJ(J-1)+SIGN(AMIN1(1.,ABS(DJ)),DJ)+.49
	    ELSE
	      II(J)=RI(4)+.49-DDI
	      IJ(J)=RJ(4)+.49-DDJ
	    END IF
	    IDI=II(J)-IJOI(I,NFR)
	    IDJ=IJ(J)-IJOJ(I,NFR)
C  check if the new position is too far from the very original one
C  position is too far from original, quit iteration
	    IF (IABS(IDI).GT.4.OR.IABS(IDJ).GT.4) THEN
	      GO TO 111
	    ELSE
	      CALL PCENTR(NFR,0,IX,NU,NV,KF,RI(5),RJ(5),RRMAG(J),DUM,
     *            II(J),IJ(J),1,0.,0,0,itercen)
	      DI=RI(5)-FLOAT(II(J))
	      DJ=RJ(5)-FLOAT(IJ(J))
	      if (ircspipe.eq.0)
     *	         WRITE(6,9) J,II(J),IJ(J),RI(5),RJ(5),DI,DJ,RRMAG(J)
     *            ,IX(II(J),IJ(J),NFR)
 9	FORMAT(' ITN#',I2,1X,2I5,1X,2F9.2,2X,2F8.2,F9.3,1X,I6)
C check delta position, if good:
C  and if new mag is within .075 of original, if it isn''t, then the new
c  position must be within 1 pixel of original
	      IF (ABS(DI).LE..51.AND.ABS(DJ).LE..51) THEN
	        IDI=IABS(II(J)-IJOI(I,NFR))
	        IDJ=IABS(IJ(J)-IJOJ(I,NFR))
c check if position within max allowable
c   for bright star, there is no limit on the amount of shift
	        if (ix(ii(j),ij(j),nfr).gt.ixbright) then
	          ishmax1=3
	        else
	          ishmax1=ishmax
	        end if
	        if (idi.gt.ishmax1.or.idj.gt.ishmax1) then
	          if (ircspipe.eq.0) 
     *             write(6,*) ' -- delta position larger than limit --'
	          JGD=max0(j-1,0)
c check delta mag
	        else 
	          if (RRMAG(J).lt.(RMAG(I)+0.075)) THEN
	            GO TO 107
	          else
c object is .075 fainter, check distance
	            if (ircspipe.eq.0) 
     *            WRITE(6,*)' -- unacceptable decrease in magnitude--'
	            IF (IDI.LE.1.AND.IDJ.LE.1) then
c save the position if no other position can be found
	              JGD=J
	            ELSE
	              if (ircspipe.eq.0)
     *                  WRITE(6,*) '  --- and Delta position > 1 ---'
	            end if
	          END IF
	        end if
	        GO TO 112
	      ELSE    
C otherwise, set up for next iteration
C  check for Oscillating co-ordinates
	        IF (II(J).EQ.IJOI(I,NFR).AND.IJ(J).EQ.IJOJ(I,NFR)) THEN
	          if (ircspipe.eq.0) WRITE(6,50)
 50	FORMAT('   &&&& Oscillating Co-ordinates, iteration stopped ')
c ! quit iteration
	          GO TO 112 
	        END IF
	        DO 105 M=1,4
	          IF (RI(5).EQ.RI(M).AND.RJ(5).EQ.RJ(M)) THEN
	            if (ircspipe.eq.0) WRITE(6,50)
c ! quit iteration
	            GO TO 112
	          END IF
C shift iteration co-ord in stack
	          RI(M)=RI(M+1)
	          RJ(M)=RJ(M+1)
 105	        CONTINUE
	      END IF
	    END IF
 102	  CONTINUE     
 111	  if (ircspipe.eq.0) WRITE(6,*) ' ****NON-CONVERGING****'
C iterations fail to find a stable position, set up to go around 
C     the original position to check for possible stable position
 112	  if (ircspipe.eq.0) WRITE(6,91)
 91	FORMAT( 1X,'  ----Going around the original position---')
 	  I1=MAX0(1,IJOI(I,NFR)-1)
	  I2=MIN0(NII(NFR),IJOI(I,NFR)+1)
	  J1=MAX0(1,IJOJ(I,NFR)-1)
	  J2=MIN0(NJJ(NFR),IJOJ(I,NFR)+1)
	  J=11
	  NN=0
c  ! = number of good centroid found around original
	  IRG=0 
	  DO 120 L=I1,I2
	    DO 120 M=J1,J2
	      IF (L.EQ.IJOI(I,NFR).AND.M.EQ.IJOJ(I,NFR)) GO TO 120
	      NN=NN+1
	      J=J+1
	      II(J)=L
	      IJ(J)=M
	      CALL PCENTR(NFR,0,IX,NU,NV,KF,RI(5),RJ(5),RRMAG(J),DUM,
     *                  II(J),IJ(J),1,0.,0,0,itercen)
	      DI=RI(5)-FLOAT(II(J))
	      DJ=RJ(5)-FLOAT(IJ(J))
	      DII(NN)=DI
	      DJJ(NN)=DJ
	      if (ircspipe.eq.0) 
     *        WRITE(6,9) J,II(J),IJ(J),RI(5),RJ(5),DI,DJ,RRMAG(J)
     *            ,IX(II(J),IJ(J),NFR)
	      IF (ABS(DI).LT.0.51.AND.ABS(DJ).LT.0.51.AND.
     *             RRMAG(J).LT.(RMAG(I)+0.075)) THEN
	        IRG=IRG+1
	        JRG(IRG)=J
	      END IF
120	  CONTINUE
C  finish going around
	  IF (IRG.EQ.1) THEN
C one good pixel accepted
	    J=JRG(1)
	    GO TO 107
	  ELSE IF (IRG.GT.1) THEN
C more than one good pixel, pick the one with highest flux
	    istatus=encode(string,float(irg),1,0,idum)
	    fstr55='(''  --- Good centroids: '','//
     *	          string(1:lnblnk(string))//'(''# '',I2,3X))'
	    if (ircspipe.eq.0) WRITE(6,fstr55) (JRG(KK),KK=1,IRG)
c 55	FORMAT('  --- Good centroids: ', <IRG>('# ',I2,3X))
	    J=JRG(1)
	    BEST=RRMAG(JRG(1))
	    DO 121 KK=2,IRG
	      IF (RRMAG(JRG(KK)).LT.BEST) THEN
	        J=JRG(KK)
	        BEST=RRMAG(J)
	      END IF
 121	    CONTINUE
	    GO TO 107
	  ELSE IF (IRG.EQ.0) THEN
C recheck oringal and accept at lower criteria
	    DELI=REALI(I)-IJOI(I,NFR)
	    DELJ=REALJ(I)-IJOJ(I,NFR)
	    DSQO=DELI*DELI+DELJ*DELJ
C   RECHECK 8 pixels around
	    if (ircspipe.eq.0) 
     *         WRITE(6,*) '  ....Rechecking the central 8 pixels..'
C first see if any position within 0.84 (rsq 0.7) pixel and no decrease
C in mag
	    IF (JGD.EQ.0) THEN
	      LL1=1
	    ELSE
	      LL1=3
	    END IF
	    DO 123 LL=1,LL1
	      DCRIT=.45+LL*.25
	      DMAGC=LL*.05
	      DMIN=2.
c ! no change
	      IF (DSQO.LE.DCRIT) GO TO 108 
	      IF (LL.EQ.1) THEN
	        DO 122 NN=1,8
 122	          DSQ(NN)=DII(NN)*DII(NN)+DJJ(NN)*DJJ(NN)
	      END IF
	      DO 124 NN=1,8
	        IF (DSQ(NN).LE.DCRIT.AND.
     *	          RRMAG(NN+11).LT.(RMAG(I)+DMAGC)) THEN
	          IRG=IRG+1
	          JRG(IRG)=NN
	          IF (DSQ(NN).LT.DMIN) THEN
	            DMIN=DSQ(NN)
	            JRGDMIN=NN
	          END IF
	        END IF
 124	      CONTINUE
c	      WRITE(6,*) ' TURN ',LL,IRG
C  still no good centroid
	      IF (IRG.GE.1) THEN
                BRIGHT=0.
	        DO 125 NN=1,IRG
	          if (ircspipe.eq.0)
     *            WRITE(6,*) JRG(NN)+11,DSQ(JRG(NN)),RRMAG(JRG(NN)+11)
	          IF (RRMAG(JRG(NN)+11).LT.BRIGHT) THEN
	            JRGBMAX=JRG(NN)
	            BRIGHT=RRMAG(JRG(NN)+11)
	          END IF
 125	        CONTINUE
C  check if closeset pos. is within .1 mag of brightest pos.
	        IF (RRMAG(JRGDMIN+11).LT.(RMAG(I)+.02)) THEN
	          J=JRGDMIN+11
	        ELSE IF (RRMAG(JRGDMIN+11).LT.BRIGHT+0.1) THEN
	          J=JRGDMIN+11
	        ELSE
	          J=JRGBMAX+11
	        END IF
C      final check original pixel is not any better
	        IF (DSQO.LT.DCRIT.AND.RRMAG(J).GT.RMAG(I)) THEN
c  !  no change
	          GO TO 121 
	        ELSE
	          if (ircspipe.eq.0) WRITE(6,15) 
 15	FORMAT('  ///Best Co-ord from inner 8 pixels accepted')
	          GO TO 107
	        END IF
	      END IF
 123	    CONTINUE
C   Not successful in finding good postion in inner 8
	    IF (JGD.NE.0) THEN
	      J=JGD
	      if (ircspipe.eq.0) WRITE(6,59) 
	      GO TO 107
 59	FORMAT('   --- Previous best iterative position accepted ')
	    END IF
	    GO TO 108
	  END IF
 107	  if (ircspipe.eq.0) 
     *     WRITE(6,61) I,IJOI(I,NFR),IJOJ(I,NFR),IX(IJOI(I,NFR),
     *        IJOJ(I,NFR),NFR),J,II(J),IJ(J)
c,IX(II(J),IJ(J),NFR)
 61	FORMAT('/New Co-ord accptd/ Obj#',
     *        I4,' Old',2I5,1X,I6,1X,' New: j=',I2,1X,
     *            2I5,1X,I6)
 	    IJOI(I,NFR)=II(J)
	    IJOJ(I,NFR)=IJ(J)
	    IDOB(I,NFR)=IDOB(I,NFR)+4
	  GO TO 101
 108	  if (ircspipe.eq.0) WRITE(6,*) '   --- NO CHANGE MADE ---'

 101	CONTINUE
	IF (IPAR.EQ.1) THEN
	  WRITE(6,19) 
 19	FORMAT(/'  DONE!!  ')
	  CALL RBELL(IBELL)
	  CALL PTYPE(*900,NFR,DSC1,DSC2,0,0,2,IX,NU,NV,KF)
	ELSE
	  WRITE(6,*) '  +++ Interative centroiding done +++'
	END IF
 900	RETURN1
	END
c////////////////////////////////////////////////////////
c  subroutine for recentroiding one object
	subroutine rcentr(i,i0,j0,reali,realj,rmag,id,ipar,nfr,
     *                  ix,nu,nv,kf)
	INTEGER IX(NU,NV,kf),II(0:35),IJ(0:35)
	DIMENSION RI(5),RJ(5),JRG(8),RRMAG(35),DSQ(8),DII(8),DJJ(8)
	CHARACTER*60 string, fstr55
	include 'picdir.inc'
	include 'pipeparm.inc'
	DI=REALI-I0
	DJ=REALJ-J0
C  got to next object if centroid is okay
	IF (ABS(DI).LE.0.5.AND.ABS(DJ).LE.0.5) GO TO 101
	DO 1011 KK=1,3
	  RI(KK)=0.
 1011	  RJ(KK)=0.
	JGD=0
	RI(4)=REALI
	RJ(4)=REALJ
C  else
C  one of the co-ords is off by >0.5
	if (ipar.eq.1) WRITE(6,5) I,I0,J0,REALI,REALJ,
     *      DI,DJ,RMAG,ID,IX(I0,J0,NFR)
 5	FORMAT(' OBJ#',I5,1X,2I4,2(2X,2F7.2),F8.3,I3,1X,I6)
	II(0)=I0
	IJ(0)=J0
C
C  iterate on object I up to 10 times (iteration J1 to J2)
	J1=1
	J2=10
	DO 102 J=J1,J2
C
C For discrepancies bewteen 2.1 and 3.5, the correction is 1/2 only
C
	  DDI=0.
	  DDJ=0.
	  IF (ABS(DI).GT.2.1) DDI=DI*.5
	  IF (ABS(DJ).GT.2.1) DDJ=DJ*.5
C 
C  for large discrepancies, a new co-ord, changed by only 1 pixel is tried
	  IF (ABS(DI).GT.3.5.OR.ABS(DJ).GT.3.5) THEN
	    if (ipar.eq.1) 
     *	     WRITE(6,*) ' ++ Delta pos too large, next pos estimated++'
	    II(J)=II(J-1)+SIGN(AMIN1(1.,ABS(DI)),DI)+.49
	    IJ(J)=IJ(J-1)+SIGN(AMIN1(1.,ABS(DJ)),DJ)+.49
	  ELSE
	    II(J)=RI(4)+.49-DDI
	    IJ(J)=RJ(4)+.49-DDJ
	  END IF
	  IDI=II(J)-I0
	  IDJ=IJ(J)-J0
C  check if the new position is too far from the very original one
C  position is too far from original, quit iteration
	  IF (IABS(IDI).GT.4.OR.IABS(IDJ).GT.4) THEN
	    GO TO 111
	  ELSE
	    CALL PCENTR(NFR,0,IX,NU,NV,KF,RI(5),RJ(5),RRMAG(J),DUM,
     *          II(J),IJ(J),1,0.,0,0,itercen)
	    DI=RI(5)-FLOAT(II(J))
	    DJ=RJ(5)-FLOAT(IJ(J))
	    if (ipar.eq.1)
     *	    WRITE(6,9) J,II(J),IJ(J),RI(5),RJ(5),DI,DJ,RRMAG(J)
     *            ,IX(II(J),IJ(J),NFR)
 9	FORMAT(' ITN#',I2,1X,2I5,1X,2F9.2,2X,2F8.2,F9.3,1X,I6)
C check delta position, if good:
C  and if new mag is within .075 of original, if it isn't, then the new
c  position must be within 1 pixel of original
	    IF (ABS(DI).LE..51.AND.ABS(DJ).LE..51) THEN
	      IDI=IABS(II(J)-I0)
	      IDJ=IABS(IJ(J)-J0)
c check if position within max allowable
c   for bright star, there is no limit on the amount of shift
	      if (ix(ii(j),ij(j),nfr).gt.ixbright) then
	        ishmax1=3
	      else
	        ishmax1=ishmax
	      end if
	      if (idi.gt.ishmax1.or.idj.gt.ishmax1) then
	        if (ipar.eq.1) 
     *	        write(6,*) ' -- delta position larger than limit --'
	        JGD=max0(j-1,0)
c check delta mag
	      else 
	        if (RRMAG(J).lt.(RMAG+0.075)) THEN
	          GO TO 107
	        else
c object is .075 fainter, check distance
	          if (ipar.eq.1) 
     *	           WRITE(6,*)'  -- unacceptable decrease in mag --'
	          IF (IDI.LE.1.AND.IDJ.LE.1) then
c save the position if no other position can be found
	            JGD=J
	          ELSE if (ipar.eq.1) then
	            WRITE(6,*) '  --- and Delta position > 1 ---'
	          end if
	        END IF
	      end if
	      GO TO 112
	    ELSE    
C otherwise, set up for next iteration
C  check for Oscillating co-ordinates
	      IF (II(J).EQ.I0.AND.IJ(J).EQ.J0) THEN
	        if (ipar.eq.1) WRITE(6,50)
 50	FORMAT('   &&&& Oscillating Co-ordinates, iteration stopped ')
c ! quit iteration
	        GO TO 112 
	      END IF
	      DO 105 M=1,4
	        IF (RI(5).EQ.RI(M).AND.RJ(5).EQ.RJ(M)) THEN
	          WRITE(6,50)
c ! quit iteration
	          GO TO 112
	        END IF
C shift iteration co-ord in stack
	        RI(M)=RI(M+1)
	        RJ(M)=RJ(M+1)
 105	      CONTINUE
	    END IF
	  END IF
 102	CONTINUE     
 111	if (ipar.eq.1) WRITE(6,*) ' ****NON-CONVERGING****'
C iterations fail to find a stable position, set up to go around 
C     the original position to check for possible stable position
 112	if (ipar.eq.1)  WRITE(6,91)
 91	FORMAT( 1X,'  ----Going around the original position---')
 	I1=MAX0(1,I0-1)
	I2=MIN0(NII(NFR),I0+1)
	J1=MAX0(1,J0-1)
	J2=MIN0(NJJ(NFR),J0+1)
	J=11
	NN=0
c  ! = number of good centroid found around original
	IRG=0 
	DO 120 L=I1,I2
	  DO 120 M=J1,J2
	    IF (L.EQ.I0.AND.M.EQ.J0) GO TO 120
	    NN=NN+1
	    J=J+1
	    II(J)=L
	    IJ(J)=M
	    CALL PCENTR(NFR,0,IX,NU,NV,KF,RI(5),RJ(5),RRMAG(J),DUM,
     *                II(J),IJ(J),1,0.,0,0,itercen)
	    DI=RI(5)-FLOAT(II(J))
	    DJ=RJ(5)-FLOAT(IJ(J))
	    DII(NN)=DI
	    DJJ(NN)=DJ
	    if (ipar.eq.1)
     *	    WRITE(6,9) J,II(J),IJ(J),RI(5),RJ(5),DI,DJ,RRMAG(J)
     *          ,IX(II(J),IJ(J),NFR)
	    IF (ABS(DI).LT.0.51.AND.ABS(DJ).LT.0.51.AND.
     *           RRMAG(J).LT.(RMAG+0.075)) THEN
	      IRG=IRG+1
	      JRG(IRG)=J
	    END IF
120	CONTINUE
C  finish going around
	IF (IRG.EQ.1) THEN
C one good pixel accepted
	  J=JRG(1)
	  GO TO 107
	ELSE IF (IRG.GT.1) THEN
C more than one good pixel, pick the one with highest flux
	  if (ipar.eq.1) then
	    istatus=encode(string,float(irg),1,0,idum)
	    fstr55='(''  --- Good centroids: '','//
     *	        string(1:lnblnk(string))//'(''# '',I2,3X))'
	    WRITE(6,fstr55) (JRG(KK),KK=1,IRG)
	  end if
	  J=JRG(1)
	  BEST=RRMAG(JRG(1))
	  DO 121 KK=2,IRG
	    IF (RRMAG(JRG(KK)).LT.BEST) THEN
	      J=JRG(KK)
	      BEST=RRMAG(J)
	    END IF
 121	  CONTINUE
	  GO TO 107
	ELSE IF (IRG.EQ.0) THEN
C rechecoringal and accept at lower criteria
	  DELI=REALI-I0
	  DELJ=REALJ-J0
	  DSQO=DELI*DELI+DELJ*DELJ
C   RECHECK 8 pixels around
	  if (ipar.eq.1) WRITE(6,*) 
     *        '  ....Rechecking the central 8 pixels..'
C first see if any position within 0.84 (rsq 0.7) pixel and no decrease
C in mag
	  IF (JGD.EQ.0) THEN
	    LL1=1
	  ELSE
	    LL1=3
	  END IF
	  DO 123 LL=1,LL1
	    DCRIT=.45+LL*.25
	    DMAGC=LL*.05
	    DMIN=2.
c ! no change
	    IF (DSQO.LE.DCRIT) GO TO 108 
	    IF (LL.EQ.1) THEN
	      DO 122 NN=1,8
 122	        DSQ(NN)=DII(NN)*DII(NN)+DJJ(NN)*DJJ(NN)
	    END IF
	    DO 124 NN=1,8
	      IF (DSQ(NN).LE.DCRIT.AND.
     *	        RRMAG(NN+11).LT.(RMAG+DMAGC)) THEN
	        IRG=IRG+1
	        JRG(IRG)=NN
	        IF (DSQ(NN).LT.DMIN) THEN
	          DMIN=DSQ(NN)
	          JRGDMIN=NN
	        END IF
	      END IF
 124	    CONTINUE
	    if (ipar.eq.1) WRITE(6,*) ' TURN',LL,IRG
C  still no good centroid
	    IF (IRG.GE.1) THEN
              BRIGHT=0.
	      DO 125 NN=1,IRG
	        if (ipar.eq.1)
     *          WRITE(6,*) JRG(NN)+11,DSQ(JRG(NN)),RRMAG(JRG(NN)+11)
	        IF (RRMAG(JRG(NN)+11).LT.BRIGHT) THEN
	          JRGBMAX=JRG(NN)
	          BRIGHT=RRMAG(JRG(NN)+11)
	        END IF
 125	      CONTINUE
C  check if closeset pos. is within .1 mag of brightest pos.
	      IF (RRMAG(JRGDMIN+11).LT.(RMAG+.02)) THEN
	        J=JRGDMIN+11
	      ELSE IF (RRMAG(JRGDMIN+11).LT.BRIGHT+0.1) THEN
	        J=JRGDMIN+11
	      ELSE
	        J=JRGBMAX+11
	      END IF
C      final check original pixel is not any better
	      IF (DSQO.LT.DCRIT.AND.RRMAG(J).GT.RMAG) THEN
c  !  no change
	        GO TO 121 
	      ELSE
	        if (ipar.eq.1) WRITE(6,15) 
 15	FORMAT('  ///Best Co-ord from inner 8 pixels accepted')
	        GO TO 107
	      END IF
	    END IF
 123	  CONTINUE
C   Not successful in finding good postion in inner 8
	  IF (JGD.NE.0) THEN
	    J=JGD
	    if (ipar.eq.1) WRITE(6,59) 
	    GO TO 107
 59	FORMAT('   --- Previous best iterative position accepted ')
	  END IF
	  GO TO 108
	END IF
 107	continue
	if (ipar.eq.1) WRITE(6,61) I,I0,J0,IX(I0,
     *        J0,NFR),J,II(J),IJ(J)
c,IX(II(J),IJ(J),NFR)
 61	FORMAT('  ///// New Co-ordinates accepted /////',
     *       /' OBJ#',I4,' OLD',2I5,2X,I6,2X,'SAVED NEW J=',I2,1X,
     *          2I5,2X,I6)
 	I0=II(J)
	I0=IJ(J)
	ID=ID+4
 101	return
 108	continue
	if (ipar.eq.1) WRITE(6,*) '   --- NO CHANGE MADE ----'
 	return
	end
