C
C
C SUBROUTINE TO MAKE HARD COPY OF PICTURE Using PGPLOT
C      HIGH CONTRAST: THREE LEVELS (WHITE AND BLACK AND WHITE)
C                SET AT DEFAULT 2.5 AND 20 SIGMA ABOVE BACKGROUND
C           IPNUM=0  PICTURE ONLY
C	    IPNUM=1 PICTURE PLUS POSITION FILE MARKED
C           IPNUM=2 POSITION FILE ONLY
c
	SUBROUTINE PGHARD(*,NFR,STR1,STR2,IPNUM,ipgdate,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER STR1*30,STR2*60,DEVICE*60,STR*4,DEV*18,IAN*1,NAM*13
     *          ,hplot*18,splot*18
	INCLUDE 'picdir.inc'
        include 'objcat.inc' 
	common/plotdev/hplot,splot,ipinit
	CALL QUERYNFR(NFR,KF,0,*900,*20001)
20001	IF (NFR.GT.6) THEN
	  WRITE(6,*) ' *** OBJECT FILE NUMBER MUST BE <=6 ****'
	  RETURN1
	END IF
	IF (STR1.EQ.' ') THEN
 	NI=NII(NFR)
 600	  WRITE(6,*) '  Enter title,    30 characters maximum:'
	  call readstr(30,str1,*900,*600)
	END IF
	DO 309 K=1,12
	  IAN=STR1(K:K)
	  IF (IAN.NE.' ') GO TO 308
 309	CONTINUE
 308	DO 310 I=K,12
	  IAN=STR1(I:I)
	  IF (IAN.EQ.' '.OR.IAN.EQ.'.'.OR.IAN.EQ.'-'.OR.IAN.EQ.'+')
     *        GO TO 311
 310	CONTINUE
 311	IF (I-1.GE.K) THEN
	  NAM=STR1(K:I-1)//'.map'
	ELSE
	  NAM='pgplot.map'
	END IF
 18	FORMAT(A8)
	NJ=NJJ(NFR)
	IF (IPNUM.LE.1) THEN
	  K1=NI/3-15
	  K2=K1+30
	  K3=NJ/3-15
	  K4=K3+30
	  CALL PSTAT(*110,NFR,K1,K3,K2,K4,RMODE,SIG,NDUM,1,IX,NU,NV,KF)
 110	  IF (STR2.EQ.' ') THEN
 601	    WRITE(6,15) 
 15	FORMAT('   ENTER plot level in units of sigma (dflt=2.5): ',$)
	    call read1r(rmult,*900,*601)
	  ELSE
	    READ(STR2(1:9),1200) RMULT
	  END IF
 1200	FORMAT(F9.0)
	  IF (RMULT.EQ.0.) RMULT=2.5
	  IPTHRES=INT(RMODE+RMULT*SIG)
	  IPTH2=(RMODE+8.*RMULT*SIG)
	END IF
	RR=0.
	RL=NJ
	YMINT=NI
	YMAXT=0.
 602	WRITE(6,10)
 10	FORMAT('   Enter plot device name (/xwin,/tek,/sun) '/
     *         '       default = hplot default: ',$)
	call readstr(18,dev,*900,*602)
 770	IF (DEV.EQ.'/tek'.or.dev.eq.'/sun'.or.dev.eq.'/xwin') THEN
	  DEVICE=DEV
	ELSE
	  IF (DEV.EQ.' ') THEN
	    DEVICE=NAM(1:lnblnk(nam))//hplot
	  ELSE
	    DEVICE=NAM(1:lnblnk(nam))//DEV
	  END IF
	  WRITE(6,'(a13)') NAM
	END IF
	call openpg(device,ipinit,*900)
	if (dev.eq.'/sun/'.or.dev.eq.'/xwin') then
c	  call pgscr(0,red,green,blue)
c	  call pgshls(0,hue,light,sat)
c	  call pgsci(indc)
	  call pgscr(0,0.3,1.,0.)
	  call pgshls(0,140.,.2,1.)
	  call pgsci(8)
 312	FORMAT(1X,'  --- PG Plot-file named: ',A16)
	end if
 790	CALL PGENV(RL,RR,YMINT,YMAX,1,0)
	IF (IPNUM.LE.1) THEN
C Plot image
	  DO 101 J=1,NJ
	    DO 101 I=1,NI
	      IF (IX(I,J,NFR).LT.IPTHRES.OR.IX(I,J,NFR).GT.IPTH2) GOTO 101
	    CALL PGPOINT(1,FLOAT(J),FLOAT(I),-1)
 101	  CONTINUE
	END IF
	CALL PGLABEL('J/y Axis','I/x axis',STR1)
	IF (IPNUM.NE.0) THEN
C plot object file
	  CALL PGSCH(.7)
	  UP=ABS(YMINT-YMAXT)*.017
	  DO 105 I=1,NOB(NFR)
	    XB=IJOI(I,NFR)
	    YB=IJOJ(I,NFR)
	    istat=encode(str,float(i),1,0,idum)
	    CALL PGPOINT(1,YB,XB,10)
	    CALL PGTEXT(YB,XB-UP,STR)
 105	  CONTINUE
	  CALL PGSCH(1.)
	END IF
 799	IF (DEV.EQ.'/tek'.or.dev.eq.'/sun'.or.dev.eq.'/xwin') THEN
	  CALL ITACUR(RL,RR,YMINT,YMAXT,CX,CY,DEV,ipinit,IRET)
	ELSE
	  if (ipgdate.eq.1) call pgiden
	  CALL closepg(ipinit)
	  RETURN1
	END IF
	IF (IRET.EQ.1) THEN
	  GO TO 790
	ELSE IF (IRET.EQ.2) THEN
	  if (dev.ne.'/sun'.and.dev.ne.'/xwin') call closepg(ipinit)
	  GO TO 770
	ELSE IF (IRET.EQ.-1) THEN
	  WRITE(6,*) CX,CY
	  GO TO 799
	ELSE IF (IRET.EQ.0) THEN
	  if (dev.ne.'/sun'.and.dev.ne.'/xwin') call closepg(ipinit)
	  RETURN1
	ELSE IF (IRET.EQ.3.OR.IRET.EQ.4) THEN
	  GO TO 601
	ELSE IF (IRET.EQ.10) THEN
	  GO TO 790
	END IF
 900	RETURN1
	END
c////////////////////////////////////////////////////////////////////
c
	SUBROUTINE PGSHOW(*,NFR,DEVICE,numpar,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER IAN*1,DEVICE*60,IAN1*1,IAN2*1,str1*20,NAM*13
 	DIMENSION ARRAY(670,670),TR(6)
	INCLUDE 'pppcore.inc'
	INCLUDE 'ppparm.inc'
	INCLUDE 'picdir.inc'
	character*18 HPLOT,SPLOT,dev
	common/PLOTDEV/HPLOT,SPLOT,ipinit
	COMMON/CLEVEL/CTL(20)
        include 'objcat.inc' 
	EQUIVALENCE (iscr(1),ARRAY(1,1))
C	DATA TR/0.,-1.,0.,0.,0.,-1./
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IF (DEVICE.NE.' '.AND.DEVICE.NE.'*') THEN
	  READ(DEVICE,9,ERR=6001) FDUM
	  DEVICE=' '
	  WRITE(6,*) '  ---default device assigned--- '
	END IF
 9	FORMAT(F10.0)
	IF (DEVICE.EQ.'*') THEN
	  IF (ICEN.EQ.0) THEN
	    GO TO 600
	  ELSE
 	    GO TO 699
	  END IF
	END IF
C  enter co-ordinate of two corners
 6001	  write(6,28) ibeg,jbeg
 28	format('  Enter smallest IJ co-ord [:',2I5,']',
     *         /'    (Enter 0 0 for input of center+extend): ',$)
	  call read2i(ibeg,jbeg,*999,*6001)
 	if (ibeg.eq.0.and.jbeg.eq.0) then 
 600	  WRITE(6,10) ICEN,JCEN
 10	FORMAT('  Enter center of plot in I,J [',2I5,']: ',$)
	  CALL READ2I(ICEN,JCEN,*999,*600)
	  IF (ICEN.GT.NII(NFR).OR.JCEN.GT.NJJ(NFR).OR.
     *            ICEN.LT.0.OR.JCEN.LE.0) THEN
	    WRITE(6,*)  '  **** CO-ORD TOO LARGE OR TOO SMALL ****'
	    GO TO 600
	  END IF
 601	  WRITE(6,11) IEX,JEX
 11	FORMAT('  Enter extend of plot in I and J direction [',
     *           2I5,']: ',$)
	  CALL READ2I(IEX,JEX,*999,*601)
 699	  IF (IEX.GT.670.OR.JEX.GT.670) THEN
	    WRITE(6,*) ' *** can only plot 670x670 maximum ***'
	    GO TO 601
	  END IF
	  IBEG=MAX0(1,ICEN-IEX/2)
	  IEND=MIN0(NII(NFR),ICEN+IEX/2)	
	  JBEG=MAX0(1,JCEN-JEX/2)
	  JEND=MIN0(NJJ(NFR),JCEN+JEX/2)
	else
 6002	  write(6,29) iend,jend
 29	format('  Enter largest IJ co-ord [',2I5,']: ',$)
	  call read2i(iend,jend,*999,*6002)
 	  iend=min0(iend,nii(nfr))
	  jend=min0(jend,njj(nfr)) 
 	  ibeg=max0(1,ibeg)
	  jbeg=max0(1,jbeg) 
	  if (iend.le.ibeg.or.jend.le.jbeg) then
	    write(6,*) ' *** incorrect range input, try again....'
	    go to 6001
	  end if
	  iex=iend-ibeg+1
	  jex=jend-jbeg+1
	  icen=ibeg+iex/2
	  jcen=jbeg+jex/2
	end if
c  TR is the transformation matrix for mapping ARRAY on to the picture
c     x=tr1+tr2*i+tr3*j
c     y=tr4+tr5*i+tr6*j
c        for iorient=0 tr2=tr6=0 (ie x=J, and Y=I)
c                      tr1=largest J, tr2=largest i
c                      tr3=tr5=-1 (increment increasing backward)
c        for iorient=1 tr3=tr5=0
c                      tr1=ibeg, tr4=jbeg
c                      tr2=tr6=1 (increment)
c  for transformation of co-ordinates
c              tr1,4,3,5: input
c                
	IF (ITRANS.ge.1) THEN
 651	  WRITE(6,50) TR(1),TR(4)
 50	  FORMAT('  User-entered co-rodinate transformation:'/
     *       '   Enter plot origin co-ord [horiz. ',F5.1,
     *          ' vert. :',F5.1,']: ',$)
	  CALL READ2R(TR(1),TR(4),*999,*651)
 652	  WRITE(6,51) TR23,TR56
 51	  FORMAT('  Enter scaling (Dflt: horiz.:',F5.2,
     *         ' vert.:',F5.2,'): ',$)
	  CALL READ2R(TR23,TR56,*999,*652)
	  IF (ABS(TR23).LT.0.0001.OR.ABS(TR56).LT.0.0001) GOTO 652
	  if (iorient.eq.0) then
	    tr(2)=0.
	    tr(6)=0.
	    tr(3)=tr23
	    tr(5)=tr56
	  else
	    tr(3)=0
	    tr(5)=0.
	    tr(2)=tr23
	    tr(6)=tr56
	  end if
	ELSE
	  if (iorient.eq.0) then
	    TR(2)=0.
	    TR(6)=0.
	    TR(1)=JEND
	    TR(4)=IEND
	    TR(3)=-1.
	    TR(5)=-1.
	  else
	    TR(2)=1.
	    TR(6)=1.
	    TR(1)=ibeg
	    TR(4)=jbeg
	    TR(3)=0.
	    TR(5)=0.
	  end if
	END IF
	XMIN=TR(1)
	YMIN=TR(4)
	if (iorient.eq.0) then
	  XMAX=XMIN+TR(3)*(JEND-JBEG+1)
	  YMAX=YMIN+TR(5)*(IEND-IBEG+1)
	else
	  XMAX=XMIN+TR(2)*(IEND-IBEG+1)
	  YMAX=YMIN+TR(6)*(JEND-JBEG+1)
	end if
	write(6,*) 'TR1-6',tr
	write(6,*) 'xmin/max',xmin,xmax,' ymin/max',ymin,ymax
	CALL BORDERSKY(NFR,ICEN,JCEN,IEX/2-3,JEX/2-3,2,RM,SIG,1,
     *       nsk,IX,NU,NV,KF)
C	CALL PSTAT(*200,NFR,IBEG+IEX/4,0,0,0,RM1,SIG1,NDUM,-8,IX,NU,NV,KF)
C 200	CALL PSTAT(*201,NFR,ICEN,0,0,0,RM2,SIG2,NDUM,-8,IX,NU,NV,KF)
C 201	CALL PSTAT(*202,NFR,IEND-IEX/4,0,0,0,RM3,SIG3,NDUM,-8,IX,NU,NV,KF)
C 202	RM=(RM1+RM2+RM3)/3.
C	SIG=(SIG1+SIG2+SIG3)/3.
	IF (DEVICE.NE.'*') 
     *     CALL CSKY(*200,NFR,ICEN,JCEN,RM,SIG,nsky,IX,NU,NV,KF,' ')
 200	MAX=IX(IBEG,JBEG,NFR)
	LL1=1
    	LL2=JEND-JBEG+1
	KK1=1
	KK2=IEND-IBEG+1	
c (1,1)= upper right, iorient=0
	if (iorient.eq.0) then
	  L=LL2
	  DO 100 J=JBEG,JEND
	    L=L-1
	    K=KK2
	    DO 100 I=IBEG,IEND
	      K=K-1
	      IF (IX(I,J,NFR).GT.MAX) MAX=IX(I,J,NFR)
 100	      ARRAY(K,L)=IX(I,J,NFR)
	else 
c (1,1)= lower left, iorient=1
	  l=0
	  DO 101 J=JBEG,JEND
	    l=l+1
	    k=0
	    DO 101 I=IBEG,IEND
	      k=k+1
	      IF (IX(I,J,NFR).GT.MAX) MAX=IX(I,J,NFR)
 101	      ARRAY(k,l)=IX(I,J,NFR)
	end if
c look-up table limits
	up=8.
        down=-2.
	bg1=rm-2.*sig
	fg1=rm+8.*sig
c	bg=bg1
c	fg=fg1
 6994	  WRITE(6,21) RM,SIG,bg1,fg1
 21	FORMAT(' sky=',F9.2,'  sigma=',F9.3,'  dflt limits: ',2f8.1 /
     *   '  Enter lower and upper bound in sig (dflt=-2,+8 sig): ',$)
c     *          2f8.1,': ',$)
c 523	bg=bg1
c	fg=fg1
c	call readr4(2,bg,fg,dum,*999,*6994,*523,*301)
	call read2r(down,up,*999,*6994)
	bg=rm+down*sig
	fg=rm+up*sig
 301	IF (DEVICE.EQ.' '.OR.DEVICE.EQ.'*') then
	  DEV=SPLOT
	else
	  dev=device(1:18)
	end if
	if (dev.eq.'print'.or.dev.eq.'/ps'.or.dev.eq.
     *       '/vps'.or.dev.eq.'/imp'.or.dev.eq.'/vimp') goto 560 
c  interactive 
	WRITE(6,17)
 17	FORMAT('  pgim subcommands:  h = exit, return to ppp;'
     *        /'                     g = change gray scale contrast;'
     *        /'                     c = type co-ordinate (alpha mode);'
     *        /'                   l,r = zoom within L,R limits.')
	jtop=1
 302	if (dev.eq.'/tek'.or.dev.eq.'/TEK') then
 610	  write(6,45) 
 45	format(' +++Warning, pgim on /tek is VERY slow'
     *     /'    Do you want to continue? (y=dflt/n): ',$)
	  call readstr(1,ian,*999,*610)
	  if (ian.eq.'N'.or.ian.eq.'n') return1
	end if
	call openpg(dev,ipinit,*999)
 888	CONTINUE
c	if (device.eq.'/sun'.or.device.eq.'/SUN') then
c	  call pgscr(0,0.,0.,1.)
c	  call pgshls(0,0.,.5,1.)
c	  call pgsci(7)  
c	end if
c	IF (ILABEL.EQ.1) THEN
c	  CALL PLABELS(XMIN,XMAX,YMIN,YMAX,1,0,tr,iend,jend,itrans,*999)
c	ELSE
c	  CALL PGENV(XMIN,XMAX,YMIN,YMAX,1,0)
c	END IF
	IF (ILABEL.ge.1) THEN
 617        WRITE(6,60) WLD,CSIZ
 60     FORMAT('  Enter label plot thickness and char. siz:'
     *        ,'(dflt:',F4.0,F6.2,'): ',$)
            CALL READ2R(WLD,CSIZ,*999,*617)
            IWLD=NINT(WLD)
	else
	  iwld=1
	  csiz=1.
	END IF
        CALL pgslw(IWLD)
        CALL PGSCH(CSIZ)
	CALL PGENV(XMIN,XMAX,YMIN,YMAX,1,0)
        CALL pgslw(1)
        CALL PGSCH(1.)
	CALL PGGRAY(ARRAY,670,670,KK1,KK2,LL1,LL2,fg,bg,TR)
c have to plot string again on top of gray scale plot
	IF (ILABEL.ge.1) CALL PLABELSB(XMIN,XMAX,YMIN,YMAX,1,0,tr,
     *       ibeg,jbeg, iend,jend,itrans,ilabel,*999)
	if (jtop.ne.1) call pglabel('','',str1)
C plot object file
	if (numpar.eq.1) then
	  IF (NFR.GT.6) THEN
	    WRITE(6,*) ' *** OBJECT FILE NUMBER MUST BE <=6 ****'
	    return1
	  END IF
	  call pgsci(1)
	  UP=ABS(YMIN-YMAX)*.019
	  DO 105 I=1,NOB(NFR)
	    XB=tr(5)*(iend-ijoi(i,nfr))+tr(4)
	    YB=tr(3)*(jend-ijoj(i,nfr))+tr(1)
	    CALL PGPOINT(1,YB,XB,10)
c	    if (ian1.eq.'y') then 
c	      istat=encode(obnum,float(i),1,0,idum)
c	      CALL PGTEXT(YB,XB-UP,obnum)
c	    end if
 105	  CONTINUE
	end if
	IF (DEV.eq.'/tek'.or.dev.eq.'/sun'.or.dev.eq.'/xwin') THEN
	  go to 799
	else
	  if (ipgdate.eq.1) call pgiden
	  CALL closepg(ipinit)
	  return1
	END IF
799	icl=1
c	ICL=0
	IAN1='c'
 800	CALL PGCURSE(CX,CY,IAN1)
	IF (IAN1.EQ.'h') THEN
	  if (dev.ne.'/sun'.and.dev.ne.'/xwin') call closepg(ipinit)
	  RETURN1
	ELSE IF (IAN1.EQ.'g') THEN
	  if (dev.ne.'/sun'.and.dev.ne.'/xwin') call closepg(ipinit)
c 810 	  WRITE(6,23) RM,SIG,bg1,fg1
c 23	FORMAT(' background=',F9.2,'  sigma=',F9.3,/ '  Enter new'
c     *     ,' lower and upper values (dflt:',f7.1,f7.2,'): ',$)
c	  call readr4(2,bg,fg,tem1,*999,*810,*345,*301)
c 345	  fg=fg1
c	  bg=bg1
	  go to 6994
	else if (ian1.eq.'p') then
 811	  write(6,49) 
 49	format('  Enter new plot device: /ps,/sun,/tek,/xwin: ',$)
	  goto 561
 560 	  if (dev.eq.'print') then
	      write(6,39)
	  else
	      go to 562
	  end if
 39	format('  Enter printer device name: /(v)ps,/(v)imp,/gplot: '
     *          ,$)
 561	  call readstr(18,dev,*999,*561)
 562	  if (dev.ne.'/sun'.and.dev.ne.'/tek'.or.dev.eq.'/xwin') then
	     jtop=0
 6101	     WRITE(6,*) '  Enter title,    20 characters maximum:'
	     call readstr(20,str1,*999,*6101)
	     DO 309 K=1,9
	       IAN2=STR1(K:K)
	       IF (IAN2.NE.' ') GO TO 308
 309	     CONTINUE
 308	     DO 310 I=K,12
	       IAN2=STR1(I:I)
	       IF (IAN2.EQ.' '.OR.IAN2.EQ.'.'.OR.IAN2.EQ.'-'.OR.IAN2.EQ.'+')
     *         GO TO 311
 310	     CONTINUE
 311	     IF (I-1.GE.K) THEN
	       if (dev.eq.'/ps'.or.dev.eq.'/vps') then
	         NAM=STR1(K:I-1)//'.gray'
	       else if (dev.eq.'/imp'.or.dev.eq.'/vimp') then
	         NAM=STR1(K:I-1)//'.gray'
	       else  
	         NAM='pgplot.gray'
	       end if
	     ELSE
	       NAM='pgplot.gray'
	     END IF
	     dev=NAM(1:lnblnk(nam))//dev
	     write(6,24) nam
24	     format('*** plotfile is named: ',A13)
             GO TO 302
	  else if (dev.eq.'/tek'.or.dev.eq.'/sun'.or.dev.eq.'/xwin')
     *        then
	     go to 301
	  else
	     write(6,25)
25	     format('*** Invalid device, try again !')	
	     go to 560  
	  end if
	ELSE IF (IAN1.EQ.'l') THEN
	  XMIN=CX
	  YMIN=CY
 303	  CALL PGCURSE(CX,CY,IAN1)
	  IF (IAN1.EQ.'r') THEN
	    XMAX=CX
	    YMAX=CY
	  ELSE
	    GO TO 303
	  END IF
	  GO TO 888
	ELSE IF (IAN1.EQ.'c') THEN
C	  IC=IEND-NINT(CY)
C	  JC=JEND-NINT(CX)
C	  TCY=IEND-CY
C	  TCX=JEND-CX
	  IC=IEND-NINT((CY-TR(4))/TR(5))
	  JC=JEND-NINT((CX-TR(1))/TR(3))
	  TCY=CY
	  TCX=CX
	  DO 140 M=1,ICL
c    ! make blank lines for writing in Alpha mode
 140	    WRITE(6,141)      
 141	FORMAT(1X)
	  ICL=ICL+1
	  WRITE(6,142) TCY,TCX,IC,JC,IX(IC,JC,NFR)
	  IAN1='1'
 142	FORMAT(1X,2F8.2,3X,2I5,I6)
	ELSE IF (IAN1.EQ.'1') THEN
	  GO TO 800
	END IF
	GO TO 800
C
 999	RETURN1
	END
c////////////////////////////////////////////////////////////////////
c
	SUBROUTINE PGSHOW2(*,DEVICE,numpar,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER IAN*1,DEVICE*60,IAN1*1,IAN2*1,str1*20,NAM*18
	parameter (maxi=1050)
	parameter (maxj=2100)
 	DIMENSION ARRAY(maxi,maxj),TR(6)
	INCLUDE 'pppcore.inc'
	INCLUDE 'ppparm.inc'
	INCLUDE 'picdir.inc'
	character*18 HPLOT,SPLOT,dev
	common/PLOTDEV/HPLOT,SPLOT,ipinit
	COMMON/CLEVEL/CTL(20)
        include 'objcat.inc' 
	EQUIVALENCE (ixb(8610001),ARRAY(1,1))
C	DATA TR/0.,-1.,0.,0.,0.,-1./
	device(1:18)=hplot
	nfr=1
	write(6,31)
 31	format('  ---Warning: pgsh works on frame 1 only',/
     *     '    and it overwrites the other frames'
     *   ,'  Do you want to continue? [y=dflt/n]:',$)
	read(5,'(a1)',end=999) ian
	if (ian.eq.'n') return1
	IF (DEVICE.NE.' '.AND.DEVICE.NE.'*') THEN
	  READ(DEVICE,9,ERR=6001) FDUM
	  DEVICE=' '
	  WRITE(6,*) '  ---default device assigned--- '
	END IF
 9	FORMAT(F10.0)
	IF (DEVICE.EQ.'*') THEN
	  IF (ICEN.EQ.0) THEN
	    GO TO 600
	  ELSE
 	    GO TO 699
	  END IF
	END IF
C  enter co-ordinate of two corners
 6001	  write(6,28) ibeg,jbeg
 28	format('  Enter smallest IJ co-ord [:',2I5,']',
     *         /'    (Enter 0 0 for input of center+extend): ',$)
	  call read2i(ibeg,jbeg,*999,*6001)
 	if (ibeg.eq.0.and.jbeg.eq.0) then 
 600	  WRITE(6,10) ICEN,JCEN
 10	FORMAT('  Enter center of plot in I,J [',2I5,']: ',$)
	  CALL READ2I(ICEN,JCEN,*999,*600)
	  IF (ICEN.GT.NII(NFR).OR.JCEN.GT.NJJ(NFR).OR.
     *            ICEN.LT.0.OR.JCEN.LE.0) THEN
	    WRITE(6,*)  '  **** CO-ORD TOO LARGE OR TOO SMALL ****'
	    GO TO 600
	  END IF
 601	  WRITE(6,11) IEX,JEX
 11	FORMAT('  Enter extend of plot in I and J direction [',
     *           2I5,']: ',$)
	  CALL READ2I(IEX,JEX,*999,*601)
 699	  IF (IEX.GT.maxi.OR.JEX.GT.maxj) THEN
	    WRITE(6,33) maxi,maxj
 33	format(' *** can only plot ',i6,' X',i6,' maximum ***')
	    GO TO 601
	  END IF
	  IBEG=MAX0(1,ICEN-IEX/2)
	  IEND=MIN0(NII(NFR),ICEN+IEX/2)	
	  JBEG=MAX0(1,JCEN-JEX/2)
	  JEND=MIN0(NJJ(NFR),JCEN+JEX/2)
	else
 6002	  write(6,29) iend,jend
 29	format('  Enter largest IJ co-ord [',2I5,']: ',$)
	  call read2i(iend,jend,*999,*6002)
 	  iend=min0(iend,nii(nfr))
	  jend=min0(jend,njj(nfr)) 
 	  ibeg=max0(1,ibeg)
	  jbeg=max0(1,jbeg) 
	  if (iend.lt.ibeg.or.jend.lt.jbeg) then
	    write(6,*) ' *** incorrect range input, try again....'
	    go to 6001
	  end if
	  iex=iend-ibeg+1
	  jex=jend-jbeg+1
	  icen=ibeg+iex/2
	  jcen=jbeg+jex/2
	end if
c  TR is the transformation matrix for mapping ARRAY on to the picture
c     x=tr1+tr2*i+tr3*j
c     y=tr4+tr5*i+tr6*j
c        for iorient=0 tr2=tr6=0 (ie x=J, and Y=I)
c                      tr1=largest J, tr2=largest i
c                      tr3=tr5=-1 (increasing backward)
c        for iorient=1 tr3=tr5=0
c                      tr1=ibeg, tr2=jbeg
c                      tr2=tr6=1
c  for transformation of co-ordinates
c              tr1,4,3,5: input
c                
	IF (ITRANS.ge.1) THEN
 651	  WRITE(6,50) TR(1),TR(4)
 50	  FORMAT('  User-entered co-ordinate transformation:'/
     *       '   Enter initial co-ord (Dflt: horiz. :',F5.1,
     *          ' vert. :',F5.1,'): ',$)
	  CALL READ2R(TR(1),TR(4),*999,*651)
 652	  WRITE(6,51) TR23,TR56
 51	  FORMAT('  Enter scaling (Dflt: horiz.:',F5.2,
     *         ' vert.:',F5.2,'): ',$)
	  CALL READ2R(TR23,TR56,*999,*652)
	  IF (ABS(TR23).LT.0.0001.OR.ABS(TR56).LT.0.0001) GOTO 652
	  if (iroient.eq.0) then
	    tr(2)=0.
	    tr(6)=0.
	    tr(3)=tr23
	    tr(5)=tr56
	  else
	    tr(3)=0
	    tr(5)=0.
	    tr(2)=tr23
	    tr(6)=tr56
	  end if
	ELSE
	  if (iorient.eq.0) then
	    TR(2)=0.
	    TR(6)=0.
	    TR(1)=JEND
	    TR(4)=IEND
	    TR(3)=-1.
	    TR(5)=-1.
	  else
	    TR(2)=1.
	    TR(6)=1.
	    TR(1)=ibeg
	    TR(4)=jbeg
	    TR(3)=0.
	    TR(5)=0.
	  end if
	END IF
	XMIN=TR(1)
	YMIN=TR(4)
	if (iorient.eq.0) then
	  XMAX=XMIN+TR(3)*(JEND-JBEG+1)
	  YMAX=YMIN+TR(5)*(IEND-IBEG+1)
	else
	  XMAX=XMIN+TR(2)*(IEND-IBEG+1)
	  YMAX=YMIN+TR(6)*(JEND-JBEG+1)
	end if
	CALL BORDERSKY(NFR,ICEN,JCEN,IEX/2-3,JEX/2-3,2,RM,SIG,
     *         1,nsk,IX,NU,NV,KF)
C	CALL PSTAT(*200,NFR,IBEG+IEX/4,0,0,0,RM1,SIG1,NDUM,-8,IX,NU,NV,KF)
C 200	CALL PSTAT(*201,NFR,ICEN,0,0,0,RM2,SIG2,NDUM,-8,IX,NU,NV,KF)
C 201	CALL PSTAT(*202,NFR,IEND-IEX/4,0,0,0,RM3,SIG3,NDUM,-8,IX,NU,NV,KF)
C 202	RM=(RM1+RM2+RM3)/3.
C	SIG=(SIG1+SIG2+SIG3)/3.
	IF (DEVICE.NE.'*') 
     *     CALL CSKY(*200,NFR,ICEN,JCEN,RM,SIG,nsky,IX,NU,NV,KF,' ')
 200	MAX=IX(IBEG,JBEG,NFR)
c (1,1)= upper right, iorient=0
	if (iorient.eq.0) then
	  LL1=1
      	  LL2=JEND-JBEG+1
	  KK1=1
	  KK2=IEND-IBEG+1	
	  L=LL2
	  imaxx=maxi
	  jmaxy=maxj
	  DO 100 J=JBEG,JEND
	    L=L-1
	    K=KK2
	    DO 100 I=IBEG,IEND
	      K=K-1
	      IF (IX(I,J,NFR).GT.MAX) MAX=IX(I,J,NFR)
 100	      ARRAY(K,L)=IX(I,J,NFR)
	else 
c (1,1)= lower left, iorient=1
	  LL1=1
      	  LL2=JEND-JBEG+1
	  KK1=1
	  KK2=IEND-IBEG+1	
	  l=0
	  imaxx=maxi
	  jmaxy=maxj
	  DO 101 J=JBEG,JEND
c	    l=l+1
c	    k=0
	    DO 101 I=IBEG,IEND
c	      k=k+1
	      IF (IX(I,J,NFR).GT.MAX) MAX=IX(I,J,NFR)
 101	      ARRAY(i,j)=IX(I,J,NFR)
	end if
c look-up table limits
	up=8.
        down=-2.
	bg1=rm-2.*sig
	fg1=rm+8.*sig
c	bg=bg1
c	fg=fg1
 6994	  WRITE(6,21) RM,SIG,bg1,fg1
 21	FORMAT(' sky=',F9.2,'  sigma=',F9.3,'  dflt limits: ',2f8.1 /
     *   '  Enter lower and upper bound in sig (dflt=-2,+8 sig): ',$)
c     *          2f8.1,': ',$)
c 523	bg=bg1
c	fg=fg1
c	call readr4(2,bg,fg,dum,*999,*6994,*523,*301)
	call read2r(down,up,*999,*6994)
	bg=rm+down*sig
	fg=rm+up*sig
 301	IF (DEVICE.EQ.' '.OR.DEVICE.EQ.'*') then
	  DEV=SPLOT
	else
	  dev=device(1:18)
	end if
	if (dev.eq.'print'.or.dev.eq.'/ps'.or.dev.eq.
     *       '/vps'.or.dev.eq.'/imp'.or.dev.eq.'/vimp') goto 560 
c  interactive 
	WRITE(6,17)
 17	FORMAT('  pgim subcommands:  h = exit, return to ppp;'
     *        /'                     g = change gray scale contrast;'
     *        /'                     c = type co-ordinate (alpha mode);'
     *        /'                   l,r = zoom within L,R limits.')
	jtop=1
 302	if (dev.eq.'/tek'.or.dev.eq.'/TEK') then
 610	  write(6,45) 
 45	format(' +++Warning, pgim on /tek is VERY slow'
     *     /'    Do you want to continue? (y=dflt/n): ',$)
	  call readstr(1,ian,*999,*610)
	  if (ian.eq.'N'.or.ian.eq.'n') return1
	end if
	call openpg(dev,ipinit,*999)
 888	CONTINUE
c	if (device.eq.'/sun'.or.device.eq.'/SUN') then
c	  call pgscr(0,0.,0.,1.)
c	  call pgshls(0,0.,.5,1.)
c	  call pgsci(7)  
c	end if
c	IF (ILABEL.EQ.1) THEN
c	  CALL PLABELS(XMIN,XMAX,YMIN,YMAX,1,0,tr,iend,jend,itrans,*999)
c	ELSE
c	  CALL PGENV(XMIN,XMAX,YMIN,YMAX,1,0)
c	END IF
	IF (ILABEL.ge.1) THEN
 617        WRITE(6,60) WLD,CSIZ
 60     FORMAT('  Enter label plot thickness and char. siz:'
     *        ,'(dflt:',F4.0,F6.2,'): ',$)
            CALL READ2R(WLD,CSIZ,*999,*617)
            IWLD=NINT(WLD)
	else
	  iwld=1
	  csiz=1.
	END IF
        CALL pgslw(IWLD)
        CALL PGSCH(CSIZ)
	CALL PGENV(XMIN,XMAX,YMIN,YMAX,1,0)
        CALL pgslw(1)
        CALL PGSCH(1.)
	CALL PGGRAY(ARRAY,imaxx,jmaxy,KK1,KK2,LL1,LL2,fg,bg,TR)
c have to plot string again on top of gray scale plot
	IF (ILABEL.ge.1) CALL PLABELSB(XMIN,XMAX,YMIN,YMAX,1,0,tr,
     *        ibeg,jbeg,iend,jend,itrans,ilabel,*999)
	if (jtop.ne.1) call pglabel('','',str1)
C plot object file
	if (numpar.eq.1) then
	  IF (NFR.GT.6) THEN
	    WRITE(6,*) ' *** OBJECT FILE NUMBER MUST BE <=6 ****'
	    return1
	  END IF
	  call pgsci(1)
	  UP=ABS(YMIN-YMAX)*.019
	  DO 105 I=1,NOB(NFR)
	    XB=tr(5)*(iend-ijoi(i,nfr))+tr(4)
	    YB=tr(3)*(jend-ijoj(i,nfr))+tr(1)
	    CALL PGPOINT(1,YB,XB,10)
c	    if (ian1.eq.'y') then 
c	      istat=encode(obnum,float(i),1,0,idum)
c	      CALL PGTEXT(YB,XB-UP,obnum)
c	    end if
 105	  CONTINUE
	end if
	IF (DEV.eq.'/tek'.or.dev.eq.'/sun'.or.dev.eq.'/xwin') THEN
	  go to 799
	else
	  if (ipgdate.eq.1) call pgiden
	  CALL closepg(ipinit)
	  return1
	END IF
799	icl=1
c	ICL=0
	IAN1='c'
 800	CALL PGCURSE(CX,CY,IAN1)
	IF (IAN1.EQ.'h') THEN
	  if (dev.ne.'/sun'.and.dev.ne.'/xwin') call closepg(ipinit)
	  RETURN1
	ELSE IF (IAN1.EQ.'g') THEN
	  if (dev.ne.'/sun'.and.dev.ne.'/xwin') call closepg(ipinit)
c 810 	  WRITE(6,23) RM,SIG,bg1,fg1
c 23	FORMAT(' background=',F9.2,'  sigma=',F9.3,/ '  Enter new'
c     *     ,' lower and upper values (dflt:',f7.1,f7.2,'): ',$)
c	  call readr4(2,bg,fg,tem1,*999,*810,*345,*301)
c 345	  fg=fg1
c	  bg=bg1
	  go to 6994
	else if (ian1.eq.'p') then
 811	  write(6,49) 
 49	format('  Enter new plot device: /ps,/sun,/tek,/xwin: ',$)
	  goto 561
 560 	  if (dev.eq.'print') then
	      write(6,39)
	  else
	      go to 562
	  end if
 39	format('  Enter printer device name: /(v)ps,/(v)imp,/gplot: '
     *          ,$)
 561	  call readstr(18,dev,*999,*561)
 562	  if (dev.ne.'/sun'.and.dev.ne.'/tek'.or.dev.eq.'/xwin') then
	     jtop=0
 6101	     WRITE(6,*) '  Enter title,    20 characters maximum:'
	     call readstr(20,str1,*999,*6101)
	     DO 309 K=1,9
	       IAN2=STR1(K:K)
	       IF (IAN2.NE.' ') GO TO 308
 309	     CONTINUE
 308	     DO 310 I=K,12
	       IAN2=STR1(I:I)
	       IF (IAN2.EQ.' '.OR.IAN2.EQ.'.'.OR.IAN2.EQ.'-'.OR.IAN2.EQ.'+')
     *         GO TO 311
 310	     CONTINUE
 311	     IF (I-1.GE.K) THEN
	       if (dev.eq.'/ps'.or.dev.eq.'/vps') then
	         NAM=STR1(K:I-1)//'.gray'
	       else if (dev.eq.'/imp'.or.dev.eq.'/vimp') then
	         NAM=STR1(K:I-1)//'.gray'
	       else  
	         NAM='pgplot.gray'
	       end if
	     ELSE
	       NAM='pgplot.gray'
	     END IF
	     dev=NAM(1:lnblnk(nam))//dev
	     write(6,24) nam
24	     format('*** plotfile is named: ',A18)
             GO TO 302
	  else if (dev.eq.'/tek'.or.dev.eq.'/sun'.or.dev.eq.'/xwin')
     *        then
	     go to 301
	  else
	     write(6,25)
25	     format('*** Invalid device, try again !')	
	     go to 560  
	  end if
	ELSE IF (IAN1.EQ.'l') THEN
	  XMIN=CX
	  YMIN=CY
 303	  CALL PGCURSE(CX,CY,IAN1)
	  IF (IAN1.EQ.'r') THEN
	    XMAX=CX
	    YMAX=CY
	  ELSE
	    GO TO 303
	  END IF
	  GO TO 888
	ELSE IF (IAN1.EQ.'c') THEN
C	  IC=IEND-NINT(CY)
C	  JC=JEND-NINT(CX)
C	  TCY=IEND-CY
C	  TCX=JEND-CX
	  IC=IEND-NINT((CY-TR(4))/TR(5))
	  JC=JEND-NINT((CX-TR(1))/TR(3))
	  TCY=CY
	  TCX=CX
	  DO 140 M=1,ICL
c    ! make blank lines for writing in Alpha mode
 140	    WRITE(6,141)      
 141	FORMAT(1X)
	  ICL=ICL+1
	  WRITE(6,142) TCY,TCX,IC,JC,IX(IC,JC,NFR)
	  IAN1='1'
 142	FORMAT(1X,2F8.2,3X,2I5,I6)
	ELSE IF (IAN1.EQ.'1') THEN
	  GO TO 800
	END IF
	GO TO 800
C
 999	RETURN1
	END

C/////////////////////////////////////////
C
C Subroutine to input labels
c    1= 
C
        SUBROUTINE PLABELSB(XMIN,XMAX,YMIN,YMAX,IA,IB,tr,
     *        ibeg,jbeg,iend,jend,itrans,ilabel,*)
        CHARACTER TEXTFILE*20,TEXT(300)*30
        DIMENSION XTEXT(300),YTEXT(300),ANG(300),FJUST(300),tr(6)
 610      WRITE (6,59)
 59     FORMAT(' Labelling: enter filename or t for terminal input: ',$)
          READ(5,1,ERR=610,END=999) TEXTFILE
 1      FORMAT(A20)
          IF (TEXTFILE.EQ.'t') THEN
            IF (WLD.LT..99) WLD=1.
            IF (CSIZ.LE..1) CSIZ=1.
 617        WRITE(6,60) WLD,CSIZ
 60     FORMAT('  Enter string plot thickness and char. siz:'
     *        ,'(dflt:',F4.0,F6.2,'): ',$)
            CALL READ2R(WLD,CSIZ,*999,*617)
            IWLD=NINT(WLD)
            DO 340 I=1,100
 611          WRITE(6,61) XTEXT(I),YTEXT(I)
              CALL READ2R(XTEXT(I),YTEXT(I),*999,*611)
 612          WRITE(6,62) ANG(I),FJUST(I)
              CALL READ2R(ANG(I),FJUST(I),*999,*612)
 61     FORMAT('   Enter unscaled co-ordinates (horiz, vert) '
     *         ,'(dflt:',2F6.1,'):',$)
 62     FORMAT('   Enter angle(horiz=0) and Fjust(0.0-1.0)'
     *         ,' (dflt:',F6.1,F4.2,'): ',$)
 613          WRITE(6,63)
 63     FORMAT('   Enter text string (30 chars. max., end to end): ',$)
              CALL readstr(30,text(i),*999,*613)
              IF (TEXT(I).EQ.'end') GO TO 341
 340        CONTINUE
          ELSE
C read text intruction from file
            OPEN(UNIT=26,FILE=TEXTFILE,STATUS='OLD',ERR=610)
	    shscale=1.
            READ(26,*,ERR=6151,END=6151) IWLD,CSIZ,shscale
	    if (abs(shscale).le.0.001) shscale=1.
            DO 342 I=1,300
 6101         READ(26,*,ERR=6151,END=343) XTEXT(I),YTEXT(I),
     *               ANG(I),FJUST(I)
	      xtext(i)=xtext(i)*shscale
	      ytext(i)=ytext(i)*shscale
              READ(26,64,ERR=6101,END=343) TEXT(I)
	      if (text(i).eq.'end') go to 343
 64     format(a30)
 342        CONTINUE
 343        CLOSE(UNIT=26)
            GO TO 341
 6151       WRITE(6,*) '  ***ERROR in input file *** ',I
	    close(unit=26)
            GO TO 610
          END IF
 341      NTEXT=I-1
          WRITE(6,*) NTEXT,' strings will be labelled..'
C   special section for adding numbers
          IF (IWLD.LE.0) IWLD=1
          IF (CSIZ.LE.0.1) CSIZ=1.
          CALL pgslw(IWLD)
c          CALL PGENV(XMIN,XMAX,YMIN,YMAX,IA,IB)
          CALL PGSCH(CSIZ)
          DO 344 I=1,NTEXT
            if (itrans.ne.0) then
c     x=tr1+tr2*i+tr3*j
c     y=tr4+tr5*i+tr6*j
                ytem=tr(6)*(ytext(i)-float(jbeg))+
     *               tr(5)*(xtext(i)-float(ibeg))+tr(4)
                xtem=tr(3)*(ytext(i)-float(jbeg))+
     *	             tr(2)*(xtext(i)-float(ibeg))+tr(1)
c  old 
c               ytem=tr(5)*(float(iend)-ytext(i))+tr(4)
c               xtem=tr(3)*(float(jend)-xtext(i))+tr(1)
            else
              xtem=xtext(i)
              ytem=ytext(i)
            end if
       write(6,*) xtext(i),xtem,ytext(i),ytem
c	    if (xtem.lt.xmin.or.xtem.gt.xmax) go to 344
c	    if (ytem.lt.ymin.or.ytem.gt.ymax) go to 344
            CALL PGPTEXT(XTEM,YTEM,ANG(I),FJUST(I),TEXT(I))
 344	  continue
c  plot scale and NE direction, and/or Mpc bar
          CALL pgslw(max0(3,IWLD))
          if (ilabel.ge.2) call drawscale(*999,itran,iend,jend,tr,
     *               ilabel)
          CALL pgslw(1)
          CALL PGSCH(1.)
          RETURN
 999    RETURN1
        END
c//////////////////////////////////////////////////////////
c  subroutine for simple spectral extraction (for purpose
c    of inspection only
c     takes colum or rows defined and plot the sky subtracted result
c
	subroutine specext(*,nfr,ipar,ix,nu,nv,kf)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER hplot*18,splot*18,idir*1,device*60
	dimension spec(2048),pp(2048)
	INCLUDE 'picdir.inc'
	include 'pppcore.inc'
	common/plotdev/hplot,splot,ipinit
	EQUIVALENCE (iscr(1),spec(1)),(iscr(10001),pp(1))
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	if (ipar.eq.0) then
c dispersion is in I direction 
	  idir='J'
	else
	  idir='I'
	end if
 600	write(6,1) idir,iob1,iob2
 1	format('  Enter ',a1,' object pixel limits [',2i5,']: ',$)
	call read2i(iob1,iob2,*999,*600)
 601	write(6,2) idir,isk1,isk2
 2	format('  Enter first',a1,' sky pixel limits [',2i5,']: ',$)
	call read2i(isk1,isk2,*999,*601)
 602	write(6,3) idir,isk3,isk4
 3	format('  Enter second ',a1,' sky pixel limits [',2i5,']: ',$)
	call read2i(isk3,isk4,*999,*602)
 603	write(6,4) idir,isp3,isp4
 4	format('  Enter ',a1,' spectral pixel limits [',2i5,']: ',$)
	call read2i(isp3,isp4,*999,*602)
c extraction
c   sum spect
	rnob=float(iob2-iob1+1)
	rnsk=float(isk2-isk1+isk4-isk3+2)
	obskrat=rnob/rnsk
	rmax=-10000.
	rmin=10000.
	i=0
	if (ipar.eq.0) then
	  do 100 k=isp1,isp2
	    i=i+1
	    pp(i)=k
	    spec(i)=0.
	    sky=0.
	    do 101 j=iob1,iob2
	      spec(i)=spec(i)+ix(j,k,nfr)
 101	    continue
c   sum sky
	    do 102 j=isk1,isk2
	      sky=sky+ix(j,k,nfr)
 102	    continue
	    do 103 j=isk3,isk4
	      sky=sky+ix(j,k,nfr)
 103	    continue
	    spec(i)=spec(i)-obskrat*sky 
	    if (spec(i).gt.rmax) rmax=spec(i)
	    if (spec(i).lt.rmin) rmin=spec(i)
 100	  continue
	else
	  do 200 k=isp1,isp2
	    i=i+1
	    pp(i)=k
	    spec(i)=0.
	    sky=0.
	    do 201 j=iob1,iob2
	      spec(i)=spec(i)+ix(k,j,nfr)
 201	    continue
c   sum sky
	    do 202 j=isk1,isk2
	      sky=sky+ix(k,j,nfr)
 202	    continue
	    do 203 j=isk3,isk4
	      sky=sky+ix(k,j,nfr)
 203	    continue
	    spec(i)=spec(i)-obskrat*sky 
	    if (spec(i).gt.rmax) rmax=spec(i)
	    if (spec(i).lt.rmin) rmin=spec(i)
 200	  continue
	end if
c plot
	ntot=isp2-isp1+1
	call graphcut(device,ipinit,isp1,isp2,rmin,rmax,ntot,spec,
     *         pp,ipar)
 999	return1
	end
c//////////////////////////////////////////////////////////
c  subroutine for 2-D sky subtraction
c
	subroutine spskysub(*,nfr,ipar,ix,nu,nv,kf)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER hplot*18,splot*18,idir*1,device*60
	dimension sky(2048)
	INCLUDE 'picdir.inc'
	include 'pppcore.inc'
	common/plotdev/hplot,splot,ipinit
	EQUIVALENCE (iscr(1),sky(1))
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	if (ipar.eq.0) then
c dispersion is in I direction 
	  idir='J'
	else
	  idir='I'
	end if
 601	write(6,2) idir,isk1,isk2
 2	format('  Enter first ',a1,' sky pixel limits [',2i5,']: ',$)
	call read2i(isk1,isk2,*999,*601)
 602	write(6,3) idir,isk3,isk4
 3	format('  Enter second ',a1,' sky pixel limits [',2i5,']: ',$)
	call read2i(isk3,isk4,*999,*602)
 603	write(6,4) idir,isp1,isp2
 4	format('  Enter ',a1,' spectral pixel limits [',2i5,']: ',$)
	call read2i(isp1,isp2,*999,*602)
c extraction
c   sum spect
	rnsk=float(isk2-isk1+isk4-isk3+2)
	i=0
	if (ipar.eq.1) then
	  do 100 k=isp1,isp2
	    i=i+1
	    sky(i)=0.
c   sum sky
	    do 102 j=isk1,isk2
	      sky(i)=sky(i)+ix(j,k,nfr)
 102	    continue
	    do 103 j=isk3,isk4
	      sky(i)=sky(i)+ix(j,k,nfr)
 103	    continue
	    sky(i)=sky(i)/rnsk
c subtract image
	    nsky=nint(sky(i))
	write(6,*) i,k,nsky
	    do 104 j=isk1,isk4
	      ix(j,k,nfr)=ix(j,k,nfr)-nsky
 104	    continue
 100	  continue
	else
	  do 200 k=isp1,isp2
	    i=i+1
	    sky(i)=0.
c   sum sky
	    do 202 j=isk1,isk2
	      sky(i)=sky(i)+ix(k,j,nfr)
 202	    continue
	    do 203 j=isk3,isk4
	      sky(i)=sky(i)+ix(k,j,nfr)
 203	    continue
	    sky(i)=sky(i)/rnsk
 200	  continue
c subtract image
	    nsky=nint(sky(i))
	write(6,*) i,k,nsky
	    do 204 j=isk1,isk4
	      ix(k,j,nfr)=ix(k,j,nfr)-nsky
 204	    continue
	end if
	nfl(6,nfr)=1
 999	return1
	end
