C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO CHANGE MAXIMUM BUFFER SIZE
C
	SUBROUTINE MAXSIZE(*,NU,NV,KF,nbuff,IPAR)
	INCLUDE 'picdir.inc'
	WRITE(6,11) NU,NV
	WRITE(6,13) KF-1
 11	FORMAT('  Maximum picture size: ',I4,' X ',I4)
 13     FORMAT('  Maximum # of frames allowed in core directory:',I2,
     *           ' +1'/)
	IF (IPAR.EQ.1) RETURN1
 12	WRITE(6,15) 
 15	FORMAT('  ++ WARNING: changing max size will cause',
     *             ' current core pictures to disappear ++'
     *          /'  ENTER new maixmum size (NI, NJ), integer : ',$)
	CALL READI4(2,NU1,NV1,idut,*999,*12,*888,*20001)
20001	IF (NU1.LE.0.OR.NV1.LE.0) THEN
 888	  WRITE(6,*) '  ------ NO CHANGE MADE -------'
	  RETURN1
	ELSE
	  KF1=MIN0(14,(nbuff-1000000)/(NU1*NV1)+1)
	  KF1=MIN0(kf1,nbuff/(NU1*NV1))
C	  ELSE IF (KF1.LE.1) THEN
	  IF (KF1.LE.1) THEN
	    WRITE(6,*) '  *** Size too large, (# of frame<2) ***'
	    WRITE(6,*) '   -- NO change made...'
	    RETURN1
	  ELSE IF (KF1.EQ.2) THEN
	    WRITE(6,5) 
 5	FORMAT('  +++ Warning: size too large, only 1 frame available')
	  END IF
	END IF
C  expand to maximum size
c	IF (nu1*nv1.gt.1000000) THEN
c	  IF (NU1.GT.NV1) THEN
c	    NU=NU1
c	    NV=nbuff/(KF1*NU1)
c	  ELSE
c	    NV=NV1
c	    NU=nbuff/(KF1*NV1)
c	  END IF
c	ELSE
c	  IF (NU1.GT.NV1) THEN
c	    NU=NU1
c	    NV=(nbuff-1000000)/((KF1-1)*NU1)
c	  ELSE
c	    NV=NV1
c	    NU=(nbuff-1000000)/((KF1-1)*NV1)
c	  END IF
c	END IF
	nu=nu1
	nv=nv1
	KF=KF1
	WRITE(6,11) NU,NV
	WRITE(6,13) KF-1
	DO 100 I=1,KF
	  NII(I)=0
	  NJJ(I)=0
	  NF(I)=0
	  DO 100 J=1,5
	    NFL(J,I)=0
 100	CONTINUE
 999	RETURN1
	END
C//////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO CHANGE ARRAY SIZE
	SUBROUTINE SIZE(*,NII,NJJ,NFR,NU,NV,KF)
	INTEGER NII(7),NJJ(7)
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	WRITE(6,10) NFR,NII(NFR),NJJ(NFR)
 10	FORMAT( '  Current size for frame #',I1,' is ',I4,'x',I4)
 100	WRITE(6,11) NU,NV
 11	FORMAT('  Enter NEW picture size, NI, NJ <=',2I5,': ',$)
	CALL READI4(2,NI,NJ,idut,*999,*100,*999,*20002)
20002	IF (NI.EQ.0.AND.NJ.EQ.0) RETURN1
	NII(NFR)=NI
	NJJ(NFR)=NJ
 999	RETURN1
	END
C
C/////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE FOR CREATING BOXES FOR STATS
C
	SUBROUTINE MAKEBOX(*,NFR1,NFR2,NFR3,NFR4,NFR5,STRING,IPARS)
	CHARACTER STRING*80
	COMMON/BOX/IBOX(4,10),NBOX
	IPAR=IABS(IPARS)
c !   set box number
	IF (IPAR.EQ.0) THEN  
	  IF (NFR1.GT.0.AND.NFR1.LE.9) THEN
	    NBOX=NFR1
	  ELSE
 600	    WRITE(6,1) NBOX
 1	FORMAT('   ..Current default BOX = ',I2,/
     *      '  Enter new box number (dflt=<cr>, 0=central 30 pix): ',$)
	    call read1i(nbox,*999,*600)
	    IF (NBOX.LT.0.OR.NBOX.GT.10) GO TO 600
	  END IF
	ELSE
	  IF (NFR1.EQ.0) THEN
 601	    WRITE(6,2)
 2	FORMAT('   Enter box number (1-9): ',$)
	    call read1i(nfr1,*999,*601)
	  END IF
	  IF (IPAR.EQ.1) THEN 
C   change box dimension by entering starting rows and coland delta
	    IF (STRING.EQ.' ') THEN
 602	      WRITE(6,3) 
 3	FORMAT('  Enter starting col (I) and extend: ',$)
	      call read2i(i1,i2,*999,*602)
	      IF (I1.LE.0.OR.I2.LE.0) THEN
	        WRITE(6,*) '  *** ILLEGAL box, try again ***'
	        GO TO 602
	      END IF
 603	      WRITE(6,4)
 4	FORMAT('  Enter starting row (J) and extend: ',$)
	      call read2i(j1,j2,*999,*603)
	      IF (J1.LE.0.OR.J2.LE.0) THEN
	        WRITE(6,*) '  *** ILLEGAL box, try again ***'
	        GO TO 603
	      END IF
	    ELSE
	      I1=NFR2
	      I2=NFR3
	      J1=NFR4
	      J2=NFR5
	    END IF
	    IBOX(1,NFR1)=I1
	    IBOX(2,NFR1)=I1+I2-1
	    IBOX(3,NFR1)=J1
	    IBOX(4,NFR1)=J1+J2-1
	  ELSE IF (IPAR.EQ.2) THEN
C  define box by center+size
	    IF (STRING.EQ.' ') THEN
 604	      WRITE(6,5) 
 5	FORMAT('  Enter center I,J: ',$)
	      call read2i(i1,j1,*999,*604)
	      IF (I1.LE.0.OR.J1.LE.0) THEN
	        WRITE(6,*) '  *** ILLEGAL box, try again ***'
	        GO TO 604
	      END IF
 605	      WRITE(6,6)
 6	FORMAT('  Enter total size in I, J: ',$)
	      call read2i(i2,j2,*999,*605)
	      IF (J2.LE.0.OR.J2.LE.0) THEN
	        WRITE(6,*) '  *** ILLEGAL box, try again ***'
	        GO TO 605
	      END IF
	    ELSE
	      I1=NFR2
	      J1=NFR3
	      I2=NFR4
	      J2=NFR5
	    END IF
	    IBOX(1,NFR1)=I1-I2/2
	    IBOX(2,NFR1)=IBOX(1,NFR1)+I2-1
	    IBOX(3,NFR1)=J1-J2/2
	    IBOX(4,NFR1)=IBOX(3,NFR1)+J2-1
	  ELSE IF (IPAR.EQ.3) THEN
C  define box by upper right and lower left corners
	    IF (STRING.EQ.' ') THEN
 606	      WRITE(6,7) 
 7	FORMAT('  Enter co-ord of upper right (smallest I,J): ',$)
	      call read2i(i1,j1,*999,*606)
	      IF (I1.LE.0.OR.J1.LE.0) THEN
	        WRITE(6,*) '  *** ILLEGAL box, try again ***'
	        GO TO 606
	      END IF
 607	      WRITE(6,8)
 8	FORMAT('  Enter co-ord of lower left (largest I,J): ',$)
	      call read2i(i2,j2,*999,*607)
	      IF (I2.LE.0.OR.J2.LE.0) THEN
	        WRITE(6,*) '  *** ILLEGAL box, try again ***'
	        GO TO 607
	      END IF
	    ELSE
	      I1=NFR2
	      I2=NFR3
	      J1=NFR4
	      J2=NFR5
	    END IF
	    IBOX(1,NFR1)=I1
	    IBOX(2,NFR1)=I2
	    IBOX(3,NFR1)=J1
	    IBOX(4,NFR1)=J2
	  END IF
	  NBOX=NFR1
	END IF
	IF (IPARS.LT.0) RETURN1
	IF (NBOX.NE.0) THEN
	  WRITE(6,10) NBOX,(IBOX(I,NFR1),I=1,4)
	ELSE
	  WRITE(6,*) '  ...Box# 0 = central 31x31 pixels'
	END IF
 10	FORMAT('  ...Box#',I2,'   I=',I5,' to',I5,',   J=',I5,' to',I5)
 999	RETURN1
	END
C/////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO MANIPULATE THE DIRECTORY
C   INPUT PARAMETER IT=0  DELETE FILE AND DIR ENTRY
C                     =1  READ FILE
C                     =2  WRITE FILE, request comment
C                     =3  WRITE FILE, comment taken from core directory
C                             and no disk DIR update (for MFO operation)
c                     =4  write file, no comment field
C   OUTPUT PARAMETER IP=-1 ABANDON OPERATION
C                    IP=0 FILE NAME NOT FOUND
C                    IP=1 FILE NAME FOUND
C                    IP=2 DIRECTORY FULL
	SUBROUTINE DIREC(FILEN,FILENF,NFR,IP,IT,I)
c  FILEN=name without qualifier; FILENF=name with qualifier appended
	INTEGER NFLAG,NID,NJD
	CHARACTER*36 NCOM,NCOMC,imdir*55,fitsname*24
	CHARACTER*24 FILEN,NFILEN
	CHARACTER*24 FILENF,filenh
	INCLUDE 'picdir.inc'
	common/imagedir/imdir
	COMMON/PICC/ NCOMC(15),fitsname(15)
	COMMON/DIR/ nof,NCOM(254),NFILEN(254),NFLAG(5,254)
     *	            ,NID(254),NJD(254),nextend(254)
	IP=1
C  look for name in directory: set ip=1 name found, =0 not found
	DO 121 I=1,NOF
	  IF (FILEN.EQ.NFILEN(I)) GO TO 102
 121	CONTINUE
	IP=0
 102	IF (IT.GE.2) THEN
C  FOR WRITING FILES
c ! file name already exits
	  IF (IP.EQ.1) RETURN 
C
C other-wise add name to directory
C
	  NOF=NOF+1
	  IF (NOF.GT.250) THEN
	    WRITE(6,*) '  ******DIRECTORY FULL******, NO FILE SAVED'
	    IP=2
	    RETURN
	  END IF
 114	  IF (IT.EQ.2) THEN
 6001	    WRITE(6,*) '  ENTER comment , MAX 30 CHAR'
	    WRITE(6,*) '                              | end here'
	    call readstr(36,ncom(nof),*99,*6001)
	    ncomc(nfr)=ncom(nof)
	    GO TO 101
 99	      IP=-1
	      RETURN
 115	FORMAT(A30)
	  ELSE if (it.eq.3) then
 	    NCOM(NOF)=NCOMC(NFR)
	  END IF
 101	  NFILEN(NOF)=FILEN
	  DO 100 K=1,5
 100	    NFLAG(K,NOF)=NFL(K,NFR)
	  NID(NOF)=NII(NFR)
	  NJD(NOF)=NJJ(NFR)
	  CALL RWDIR(0)
	  RETURN
C FOR READING FILES
	ELSE
	  IF (IP.NE.1)  RETURN
 	  IF (IT.EQ.1) THEN
C	    NF(NFR)=I
C	    NII(NFR)=NID(I)
C	    NJJ(NFR)=NJD(I)
C	    DO 120 K=1,5
C120	      NFL(K,NFR)=NFLAG(K,I)
C	    NCOMC(NFR)=NCOM(I)
	    RETURN
	  END IF
C FOR DELTEING A FILE FROM DISK AND DIRECTORY
	  IF (IT.EQ.0) THEN
	    nt=lnblnk(filenf)
	    OPEN(UNIT=41,FILE=imdir(1:lnblnk(imdir))//filenf,
     *                   status='OLD',ERR=201)
	    go to 202
c check for compressed .pic version
 201	    OPEN(UNIT=41,FILE=imdir(1:lnblnk(imdir))//filenf(1:nt)//
     *                '.Z',status='OLD',ERR=200)
 202	    CLOSE(UNIT=41,status='delete')
c  if it is a .pic file, delete header file also
 	    if (filenf(nt-4:nt).eq.'.pic') then
	      filenh=filenf(1:nt-4)//'.fhd'
	      open(unit=41,FILE=imdir(1:lnblnk(imdir))//filenh,
     *                       status='old',err=210)
	      close(unit=41,status='delete')
	    end if
	    go to 210
 200	    write(6,2) filenf
 2	format('  file: ',a18,' does not exist, deleting PPPDIR entry') 
 210	    WRITE(6,*) ' *** ',NFILEN(I),' ***  DELETED'
	    WRITE(6,*) NCOM(I),NID(I),NJD(I)
	    WRITE(6,*) '   FLAGS= ',(NFLAG(L,I),L=1,5)
	    DO 104 J=I+1,NOF
	      NCOM(J-1)=NCOM(J)
	      NFILEN(J-1)=NFILEN(J)
	      NID(J-1)=NID(J)
	      NJD(J-1)=NJD(J)
	      DO 104 L=1,5
 104	        NFLAG(L,J-1)=NFLAG(L,J)
	    NOF=NOF-1
	    DO 105 J=1,7
	      IF (NF(J).EQ.I) THEN
	        NF(J)=0
	      ELSE IF (NF(J).GT.I) THEN
	        NF(J)=NF(J)-1
	      END IF
 105	    CONTINUE
 	    CALL RWDIR(0)
	  END IF
	END IF
 999	RETURN
	END
C/////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO DELETE A FILE FROM DISK AND DIRECTORY
	SUBROUTINE DELDIR(*,NF,FILENC)
c	INTEGER*2 NFLAG,NID,NJD
	INTEGER NFLAG,NID,NJD
	CHARACTER*36 NCOM,imdir*55
	CHARACTER*24 NFILEN,FILEN
	CHARACTER*24 FILENF,FILENC
	logical ex
	common/imagedir/imdir
	COMMON/DIR/ nof,NCOM(254),NFILEN(254),NFLAG(5,254)
     *	            ,NID(254),NJD(254),nextend(254)
	IF (FILENC.EQ.' ') WRITE(6,10) 
 10	FORMAT('  Enter name of the file to be DELETED, Ctr d out: ',$)
	CALL RDFILN(FILENC,NC,IPF)
	IF (IPF.LE.-1) RETURN1
	FILEN=FILENC(1:NC)
	ndir=lnblnk(imdir)
	IF (IPF.EQ.0) THEN
c ! no qualifier supplied
c  check which type of file it is
	  FILENF=FILENC(1:NC)//'.fits' 
	  inquire(file=imdir(1:ndir)//filenf,exist=ex)
	  if (ex.eqv..false.) then
	    inquire(file=imdir(1:ndir)//filenf(1:lnblnk(filenf))//'.Z'
     *       ,exist=ex)
	    if (ex.eqv..false.) then
c assume to be .pic file
	      FILENF=FILENC(1:NC)//'.pic' 
	    else
	      write(6,*) ' .... compressed version deleted...'
	    end if
	  end if 
	ELSE
c ! qualifier supplied
	  FILENF=FILENC 
	END IF
 110	CALL DIREC(FILEN,FILENF,NDUM,IP,0,IDF)
	IF (IP.EQ.0) WRITE(6,*) '--- ',FILEN,' NO SUCH FILE'
 999	RETURN1
	END
C/////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO WRITE CHANGED DIRECTORY ON TO DISK, THE INITIAL
C   DIRECTORY BEFORE RUNNING PPP IS SAVED AS THE N-1 VERSION AT
C   TIME OF EXIT FORM PPP,
C   EVERY TIME A CHANGE IN THE DIRECTORY IS MADE, AN UPDATE VERSION
C   IS CREATED, AND THE PREVIOUS VERSION (EXCEPT THE INITIAL VERSION)
C   IS DELETED
C                        NP=0 DELETE CURRENT VERSION
C                        NP=1 DO NOT DELETE CURRENT VERSION
c                              create a .bk version
c                        np=-1 load directory into ppp
C
	SUBROUTINE RWDIR(NP)
c	INTEGER*2 NFLAG,NID,NJD
	INTEGER NFLAG,NID,NJD
	CHARACTER*36 NCOM,imdir*55
	CHARACTER*24 NFILEN, tstr*1
	include 'picdir.inc'
	include 'imagepar.inc'
	common/imagedir/imdir
	COMMON/DIR/ nof,NCOM(254),NFILEN(254),NFLAG(5,254)
     *            ,NID(254),NJD(254),nextend(254)
	if (np.le.-1) then
C
C     Read disk directory
C
	  OPEN(UNIT=29,FILE=imdir(1:lnblnk(imdir))//'pppdir.dat',
     *            STATUS='OLD',err=300)
c read line 1 to see if it is a new or old format
          read(29,'(a1)',end=102,err=102) tstr
          if (tstr.eq.'P') then
	    DO 110 I=1,500
c check which version of directory is the entry
	      READ(29,1501,END=102,ERR=102) NFILEN(I),NCOM(I),
     *                                NID(I),NJD(I)
 110	      READ(29,151,END=102,ERR=102) nextend(i),(NFLAG(J,I),J=1,5)
	  else
c backspace file and read old format
            backspace 29
            DO 101 I=1,500
c             READ(29,150,END=102,ERR=102) NFILEN(I),NCOM(I),
c    *                                NID(I),NJD(I)
              READ(29,1501,END=102,ERR=102) NFILEN(I),NCOM(I),
     *                                NID(I),NJD(I)
 101          READ(29,151,END=102,ERR=102) nextend(i),(NFLAG(J,I),J=1,5)
          end if
c added sep30 2002 to prevent empty pppdir.dat file causing wrong nof
 102	  if (i.gt.1) then
	    NOF=I-1
	  else
	    nof=0
	  end if
c  check core directory
 	  do 121 i=1,15
 121	    nf(i)=0	
	  goto 107
 300	  OPEN(UNIT=29,FILE=imdir(1:lnblnk(imdir))//'pppdir.dat',
     *                  status='NEW',err=998)
c  write directory
	else
	  IF (NP.EQ.0) THEN
	    OPEN(UNIT=29,FILE=imdir(1:lnblnk(imdir))//'pppdir.dat',
     *                status='OLD',ERR=200)
	    CLOSE(UNIT=29,status='delete')
 200	    OPEN(UNIT=29,FILE=imdir(1:lnblnk(imdir))//'pppdir.dat',
     *                  status='NEW',err=998)
	  else 
	    open(unit=29,file=imdir(1:lnblnk(imdir))//'pppdir.dat.bk',
     *             status='old',err=201)
	    close(unit=29,status='delete')
 201	    open(unit=29,file=imdir(1:lnblnk(imdir))//'pppdir.dat.bk',
     *             status='new',err=998)
	  END IF
	  DO 131 I=1,NOF
	    WRITE(29,1501,ERR=131) NFILEN(I),NCOM(I),NID(I),NJD(I)
 	    WRITE(29,151,ERR=131) nextend(I),(NFLAG(J,I),J=1,5)
 131	  CONTINUE
	end if
 107	CLOSE(UNIT=29)
 150	FORMAT(1X,A9,1X,A35,I4,I4)
 1501	FORMAT(1X,A12,1X,A35,I5,I5)
 151	FORMAT(1X,i2,1x,5(i1,3x))
	RETURN
 998	write(6,*) ' ** ppp directory open error, no such directory'
     *       ,' or no write privilege **'
	close(unit=29)
	return
	END
C/////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO OUTPUT DIRECTORY ON LINE PRINTER OR TT
C
	SUBROUTINE WDIREC(*,NDT,NFR,NFR2,KF)
c	INTEGER*2 NFLAG,NID,NJD
	INTEGER NFLAG,NID,NJD
	CHARACTER*2 NDT,IH
	CHARACTER*36 NCOM,NCOMC
	CHARACTER*24 NFILEN,fitsname*24,fname*24,extstr*2
	INCLUDE 'picdir.inc'
	INCLUDE 'imagepar.inc'
	common/picc/ ncomc(15),fitsname(15)
	COMMON/DIR/ nof,NCOM(254),NFILEN(254),NFLAG(5,254)
     *	            ,NID(254),NJD(254),nextend(254)
	IDEV=6
	ITL=0
	IF (NDT.EQ.'lp') IDEV=8
	IF (NFR2.EQ.0) NFR2=NOF
	NFR=MAX0(1,NFR)
	WRITE(IDEV,121) NOF
c write pppdir
 500	FORMAT(' <CR> to continue.... Ctr d or q to quit: ',$)
 501	FORMAT(A2)
 121	FORMAT(//' //// Disk Picture Directory ////',5X,I3,' files'/)
 122	FORMAT(I3,' - ',A20,3X,A35,2I5,' [',i2,']')
c123	FORMAT(I3,'-',A12,' S',i1,': ',A35,2I5,5I2)
 123	FORMAT(I2,'- ',A16,': ',A35,2I5,5I2)
 125	FORMAT(//' Pictures currently in ppp buffer'/)
 126	FORMAT(I2,20X,'------- empty -------',14X,2I5,5I2)
 127	FORMAT(I2,' -Not in DIR ',i1,': ',A30,2I5,5I2)
 128	FORMAT(I2,' -Not in DIR ',i1,': ',30X,2I5,5I2)
	DO 100 I=MAX0(1,NFR),MIN0(NOF,NFR2)
   	  WRITE(IDEV,122) I,NFILEN(I),NCOM(I),NID(I),NJD(I),nextend(i)
c  	  WRITE(IDEV,122) I,NFILEN(I),NCOM(I),NID(I),NJD(I),(NFLAG(J,I),
c    *              J=1,5)
	  IF (IDEV.NE.8) THEN 
	    ITL=ITL+1
	    IF (ITL.GE.21) THEN
	      ITL=0
 6001	      WRITE(6,500)
	      call readstr(2,ih,*900,*6001)
	      IF (IH.EQ.'q') GO TO 900
	    END IF
	  END IF
 100	CONTINUE
	WRITE(IDEV,125)
	ITL=ITL+4
 105	CONTINUE
c write buffer dir
	DO 101 I=1,MIN0(KF,15)
	  IF (IDEV.NE.8) THEN
	    ITL=ITL+1
	    IF (ITL.GT.21) THEN 
 6002	      WRITE(6,500)
	      ITL=1
	      call readstr(2,ih,*900,*6002)
	      if (ih.eq.'q') go to 900
	    END IF
	  END IF
	  IF (NII(I).EQ.0) THEN
	    WRITE(IDEV,126) I,NII(I),NJJ(I), (NFL(J,I),J=1,5)
	  ELSE
	    IF (NF(I).EQ.0) THEN
	      IF (NCOMC(I).NE.' ') THEN
	        WRITE(IDEV,127) I,nsct(i),NCOMC(I),NII(I),NJJ(I), 
     *                 (NFL(J,I),J=1,5)
	      ELSE
	        WRITE(IDEV,128) I,nsct(i),NII(I),NJJ(I),
     *                  (NFL(J,I),J=1,5)
	      END IF
	    ELSE
c make string for name to include extension
	      istatus=encode(extstr,float(idext(i)),1,0,idum)
	      if (idext(i).gt.0) then
	        fname=nfilen(nf(i))(1:lnblnk(nfilen(nf(i))))//' ^'//extstr
	      else
	        fname=nfilen(nf(i))(1:lnblnk(nfilen(nf(i))))
	      end if
 	      WRITE(IDEV,123) I,fname,NCOMC(I),
     *             NII(I),NJJ(I),(NFL(J,I),J=1,5)
c	      WRITE(IDEV,123) I,NFILEN(NF(I)),nsct(I),NCOMC(I),
c    *             NII(I),NJJ(I),(NFL(J,I),J=1,5)
	    END IF
 	  END IF
101	CONTINUE

 900	RETURN1
	END

C------------------------------------------------------------------------
C
C  MISCELLANEOUS SUBROUTINES
C
C/////////////////////////////////////////////////////////////////////
C
C    Search for all pixels smaller/greater  than THRESHOLD /and replace 
C       ipar=1   search and replace for <= threshold
C       ipar=2   search and replace for >= threshold
C       ipar=3   search for <=threshold
c       ipar=4   search for >= threshold
C         
	SUBROUTINE SEARCHPIX(*,NFR,ICOMP,str1,str2,IPAR,IX,NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER*1 IANS,str1*60,str2*60
	INCLUDE 'picdir.inc'
	include 'ppparm.inc'
	include 'pipeparm.inc'
	common/box/ibox(4,10),nbox
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	NPIX=0
	IPRT=0
	if (ircspipe.eq.0) then
	  if (str1.eq.' '.or.str1(1:3).eq.'box') then
	    if (IPAR.EQ.1.or.ipar.eq.3) THEN
 610	      WRITE(6,9) ICOMP 
 9	FORMAT('  Enter lower limit of search (dflt:',I6,'): ',$)
	    else
	      write(6,8) icomp
 8	format('  Enter upper limit of search (dflt:',i6,'): ',$)
	    end if
	  end if
	  call read1i(icomp,*999,*610)
	else
	  icomp=irplim
	end if
	if (ircspipe.eq.0) then
	if (ipar.le.2) then
	  IREP=32767
 611	  WRITE(6,11) IREP
 11	FORMAT('  Enter replacement value (dlft:',I6,'): ',$)
	  call read1i(irep,*999,*611)
c	  IF (IREP.GT.32767) then
c	    IREP=32767
c	  else if (irep.lt.-32767) then
c	    irep=-32767
c	  end if
	end if
	else
	  irep=irprep
	end if
c  detemine box for execution
	if (str1(1:3).eq.'box') then
	  read(str1(4:4),*) mbox
	else if (str2(1:3).eq.'box') then
	  read(str2(4:4),*) mbox
	else
	  mbox=0
	  j1=1
	  j2=njj(nfr)
	  i1=1
	  i2=nii(nfr)
	end if
	if (mbox.ne.0) then
	  i1=ibox(1,mbox)
	  i2=ibox(2,mbox)
	  j1=ibox(3,mbox)
	  j2=ibox(4,mbox)
	  write(6,6) i1,i2,j1,j2 
 6	format('  .. search in box i= ',2i5,' j= ',2i5)
	end if
	if (ipar.eq.1.or.ipar.eq.3) then
	DO 100 J=j1,j2
	DO 101 I=i1,i2
	  IF (IX(I,J,NFR).GE.ICOMP) GO TO 101
c	  IF (IPRT.EQ.1) WRITE(6,*) I,J,IX(I,J,NFR)
	  IF (IPAR.EQ.1) IX(I,J,NFR)=IREP
	  NPIX=NPIX+1 
	  IF (NPIX.GT.100.AND.IPRINT.EQ.1) THEN
 6001	  WRITE(6,*) NPIX, ' bad pixels. Do you want to continue?'
	    call readstr(1,ians,*999,*6001)
	    IF (IANS.EQ.'n') GO TO 130
	    NPIX=0
	  END IF
 101	CONTINUE
 100	continue
	else
	DO 105 J=j1,j2
	DO 105 I=i1,i2
	  IF (IX(I,J,NFR).LE.ICOMP) GO TO 105
c	  IF (IPRT.EQ.1) WRITE(6,*) I,J,IX(I,J,NFR)
	  IF (IPAR.EQ.2) IX(I,J,NFR)=IREP
	  NPIX=NPIX+1 
	  IF (NPIX.GT.100.AND.IPRT.EQ.1) THEN
 6002	  WRITE(6,*) NPIX, ' bad pixels. Do you want to continue?'
	    call readstr(1,ians,*999,*6002)
	    IF (IANS.EQ.'n') GO TO 130
	    NPIX=0
	  END IF
 105	CONTINUE
	end if
 10	FORMAT(A1)
 130	IF (IPAR.le.2) then
	  nfl(6,nfr)=1
	  WRITE(6,*) '  ... ',npix,' Pixels replaced'
	else
	  write(6,*) '  ... ',npix, ' pixels located'
	end if
 999	RETURN1
	END
C/////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO OUTPUT PREVIOUS LCOM COMMANDS ON A FILE
C
	SUBROUTINE COMFIL(*,STR,CSTR,LCOM)
	CHARACTER*80 CSTR(*)
	CHARACTER*60 STR
	CHARACTER FNINT*18
	IF (STR.EQ.' ') THEN
 600	  WRITE(6,11)
 11	FORMAT('   Enter output command script name, dflt: pppcom.scr: '
     *          ,$)
	  call readstr(18,fnint,*999,*600)
	  IF (FNINT.EQ.' ') THEN
	    FNINT='pppcom.scr'
	    GO TO 110
	  END IF
	ELSE
	  FNINT=STR(1:18)
	END IF
	CALL RDFILN(FNINT,NC,IP)
	IF (IP.EQ.0) THEN
	  FNINT=FNINT(1:NC)//'.scr'
	ELSE IF (IP.EQ.-1) THEN
	  GO TO 600
	ELSE IF (IP.EQ.999) THEN
	  GO TO 999
	END IF
 110	OPEN(UNIT=31,FILE=FNINT,status='NEW',ERR=999)
	DO 100 I=1,LCOM-1
 	  IF (CSTR(I).NE.' ') THEN
	    WRITE(31,10) CSTR(I)
	  END IF
 100	CONTINUE
	CLOSE(UNIT=31)
 10	FORMAT(1X,A70)
 999	RETURN1
	END
C
C///////////////////////////////////////////////////////////////////////
C
C   SUBROUTINE TO TYPE OUT PREVIOUS 10 CURSOR VALUES
C
	SUBROUTINE CURPOS(*,NFR,IPAR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	character prog*4
	COMMON/CURSPOS/ ICUR(10),JCUR(10),ipro(10)
	INCLUDE 'picdir.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	WRITE(6,9) 
 9	FORMAT('  Cursor values:    I        J      IX(I,J)')
	DO 100 I=10,1,-1
	  K=11-I
	  IF (ICUR(I).GT.0.AND.ICUR(I).LE.NII(NFR)) THEN
	    IF (JCUR(I).GT.0.AND.JCUR(I).LE.NJJ(NFR)) then
	      if (ipro(i).eq.0) then
	        prog='sdis'
	      else if (ipro(i).eq.1) then
	        prog='cplt'
	      end if 
	      WRITE(6,10) K,ICUR(I),JCUR(I),IX(ICUR(I),JCUR(I),NFR),prog
	    end if
	  END IF
 100	CONTINUE
 10	FORMAT(10X,'# ',I2,' :',3X,I4,4X,I4,4X,I6,3x,a4)
 999	RETURN1
	END
C
C///////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO SAVE CURSOR VALUES
C
	SUBROUTINE SAVECUR(II,JJ,ip)
	common/curspos/icur(10),jcur(10),ipro(10)
	DO 100 I=10,2,-1
	  ipro(i)=ipro(i-1)
	  ICUR(I)=ICUR(I-1)
 100	  JCUR(I)=JCUR(I-1)
	ICUR(1)=II
	JCUR(1)=JJ
	ipro(1)=ip
	RETURN
	END
c////////////////////////////////////
c  subroutine to switch two numbers
        subroutine switchord(x1,x2)
	dum=x2
	x2=x1
	x1=dum
	return
	end
c/////////////////////////////////////////////
c   command to generate a set of random numbers
c       ipar=0 : uniformly distributed
c       ipar=1 : gaussianly distributed
c
        subroutine genrandoms(ipar,*)
	real ETIME, TARRAY(2)
	if (ipar.eq.1) then
 600	  write(6,1) ave,sig
 1	format('  Enter mean and sigma [',2g10.5,']: ',$)
	  call read2r(ave,sig,*999,*600)
	else if (ipar.eq.0) then
 601	  write(6,2) rg1,rg2
 2	format('  Enter range of uniform distr [',2g10.5,']: ',$)
	  call read2r(rg1,rg2,*999,*601)
	end if
 602	write(6,5) itot
 5	format('  Enter total number of randoms wanted [',i5,']: ',$)
	call read1i(itot,*999,*602)
	iseedtem=-99999
 603	write(6,3)
 3	format('  Enter an integer seed (<cr>=auto): ',$)
	call read1i(iseedtem,*999,*603)
	if (iseedtem.eq.-99999) then
	  if (ipar.eq.0) then
	    ISEED=-NINT(ETIME(TARRAY)*1000)+23
	  else
	    ISEED=-NINT(ETIME(TARRAY)*1000)
	  end if
	  write(6,4) iseed
 4	format('   .... seed = ',i7)
	else
	  iseed=iseedtem
	end if
c uniform random numbers
	if (ipar.eq.0) then
	  do 100 i=1,itot
	    ran=rg1+(rg2-rg1)*ran1(iseed)
	    write(6,10) i,ran
 100	  continue
 10	format('#',i4,4x,f12.5)
	else if (ipar.eq.1) then
	  do 110 i=1,itot
	    ran=mean+sig*gasdev(iseed)
	    write(6,10) i,ran
 110	  continue
	end if
 999	return1
	end
