c subroutines for ds display and utilities
C 
c//////////////////////////////////////////////////////////////////////////////
C
C Subroutine for calling TV commands
C (calls Sebok''s dslog program )
C
	SUBROUTINE PPPCOMTV(*,MND,NFR,SCOM,RN,ILK,ITV,JRAST,IISP,IX,NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	DIMENSION NFR(5),RN(5),ILK(263,3),IISP(0:3)
	CHARACTER*60 SCOM(6)
	CHARACTER*4 MND
	include 'ppparm.inc'
        include 'objcat.inc' 
	if (mnd.eq.'ds') call dsdriver(nfr,scom(2),1,0,0,
     *        ix,nu,nv,kf,*999)
	if (mnd.eq.'dsd') call dsdriver(nfr,scom(2),2,0,0,
     *        ix,nu,nv,kf,*999)
	if (mnd.eq.'dsl') call dsdriver(nfr,scom(2),1,1,0,
     *        ix,nu,nv,kf,*999)
	if (mnd.eq.'dds') call dsdriver(nfr,scom(2),0,0,0,
     *        ix,nu,nv,kf,*999)
	if (mnd.eq.'ddsl') call dsdriver(nfr,scom(2),0,1,0,
     *        ix,nu,nv,kf,*999)
	if (mnd.eq.'sao') call dsdriver(nfr,scom(2),1,0,1,
     *        ix,nu,nv,kf,*999)
	if (mnd.eq.'saod') call dsdriver(nfr,scom(2),2,0,1,
     *        ix,nu,nv,kf,*999)
	if (mnd.eq.'saol') call dsdriver(nfr,scom(2),1,1,1,
     *        ix,nu,nv,kf,*999)
	if (mnd.eq.'dsut') call dsutil(nfr(1),ix,nu,nv,kf,*999)
	if (mnd.eq.'e') call makecoo(*999,1,1)
	if (mnd.eq.'x') call makecoo(*999,1,0)
	if (mnd.eq.'rdap') call readaper(*999,nfr(1),scom(3),1)
	if (mnd.eq.'rdhf') call readaper(*999,nfr(1),scom(3),-1)
	if (mnd.eq.'cpap') call compaper(*999,nfr(1),0)
	if (mnd.eq.'cpat') call compaper(*999,nfr(1),1)
c	if (mnd.eq.'coo') call makecoo(*999,nfr(1),1)
 	if (mnd.eq.'coo') call makereg(*999,nfr(1),1)
	if (mnd.eq.'scoo') call saocoo(*999,nfr(1),1)
	if (mnd.eq.'scor') call saocoo(*999,nfr(1),-1)
	if (mnd.eq.'scon') call saocoo(*999,nfr(1),2)
	if (mnd.eq.'spos') call saoposf(*999,nfr(1),in,nu,nv,kf,1)
	if (mnd.eq.'rdma') call readaper(*999,nfr(1),scom(3),0)
c	if (mnd.eq.'dcoo') call makecoo(*999,nfr(1),0)
 	if (mnd.eq.'dcoo') call makereg(*999,nfr(1),0)
	if (mnd.eq.'clea') call makecoo(*999,nfr(1),2)
	if (mnd.eq.'dssp') call dispspec(*999,nfr(1),ix,nu,nv,kf,0)
	if (mnd.eq.'dssl') call dispslit(*999,nfr(1),ix,nu,nv,kf,0)
	if (mnd.eq.'dsob') call dispobj(*999,nfr(1),nfr(2),iisp(0),
     *          ix,nu,nv,kf,0)
	if (mnd.eq.'lcob') call locaobj(*999,nfr(1),nfr(2),kf,0)
	if (mnd.eq.'ppc2')  call pc2hdrfix(*999,nfr(1),scom(3),
     *          ix,nu,nv,kf)
	return
999 	RETURN1
	END
c
c////////////////////////////////////////////////////////////////
c
c  subroutine to call Sebok''s ds program for displaying images
c
C         ipar=1 -- display core frame by first writing a temp file to disk
c         ipar=2 -- display core frame which has not been changed since
c                   read in (temp file created by copying disk file)
c         ipar=0 -- display existing disk fits file
c         iparlog=0 -- linear display
c         iparlog=1 -- logarithmic display
c
c         idispar=0 - ds (sun or xwin)
c                =1 - saoimage or ds9
c                =2 - ds9
c
c   Nov 23 2005: modify to allow display of single chip from MEF file
c      if the display is for a chip, it writes it out.
	subroutine dsdriver(nfra,dfname,ipart,iparlog,idispar,
     *        ix,nu,nv,kf,*)
	integer ix(nu,nv,kf)
	dimension nfra(5),ib(10),ie(10)
	character dfname*18,name*24,headblk*2880,imdir*55
     *     ,cstring*120,objnam*35,nfrstr*2,headblkt*2880
     *     ,ddodisname*60,fitsname*24,ncomc*36
        character*18 HPLOT,SPLOT,dspstring
        common/PLOTDEV/HPLOT,SPLOT,ipinit
 	common/picc/ncomc(15),fitsname(15)
        include 'objcat.inc' 
	common/header/bzero,bscale,headblk(20),nhb
	common/imagedir/imdir
	include 'picdir.inc'
	include 'tvparm.inc'
	include 'ppparm.inc'
	include 'imagepar.inc'
	logical ex
	nfr=nfra(1)
	ipar=ipart
	if (nfr.eq.0.and.dfname.ne.' ') ipar=0
	if (ipar.eq.0) then
C display file from disk
c   check if file exists
	  name=dfname(1:lnblnk(dfname))//'.fits'
	  inquire(file=name,exist=ex)
	  if (ex.eqv..false.) then
	    write(6,2) name
 2	format('   *** file: ',a24,' does not exist ***')
	    return1
	  else
c  request limits
	    if (nfra(2).ne.0.or.nfra(3).ne.0) then
	      ilow=nfra(2)
	      iup=nfra(3)
	    else
 6001	      write(6,3) 
 3	format('  Enter lower and upper limits: ',$)
	      call read2i(ilow,iup,*999,*6001)
 159	      continue
 	    end if
	  end if
	else
c  display current core picture
	  call querynfr(nfr,kf,0,*999,*2001)
 2001	  istatus=encode(nfrstr,float(nfr),1,0,idum) 
c	  if (imemcheck.eq.1) then
c check if there is enough memory
c	    idum=system('/usr/etc/pstat -s > memcheckstr')
c	    open(unit=27,file='memcheckstr',status='old',err=980)
c	    goto 981
c 980	    write(6,*) '  *** error in reading memory stats ***'
c	    return1
c 981   	    read(27,'(a80)',err=982) cstring
c	    close(unit=27,status='delete')
c	    call fstr(cstring,120,ib,ie,ndum)
c	    read(cstring(ib(9):ie(9)-1),*) mem
c	    write(6,*) '  memory left before ds: ',mem
c	    if (mem*1000.lt.nii(nfr)*njj(nfr)*4.5) then
c	      write(6,40) mem
c 40	format('  +++',i6,'k left, not enough memory for ds'/
c     *  ' Do you want to continue? (It may crash the system) (y/n=df): '
c     *    ,$)
c	      read(5,'(a1)') upstr
c	      if (upstr.ne.'y') return1
c	    end if
c	  end if
c  check for .COO file, delete if found
	  if (ipar.eq.0) then
 982	    name='ppptemp'//nfrstr(1:lnblnk(nfrstr))//'.COO'
	    inquire(file=name,exist=ex)
	    if (ex.eqv..true.) then
c  delete temporary file if there is already one
	      open(unit=41,file=name,status='old',err=999)
	      close(unit=41,status='delete')
	    end if
	  end if
c  write out a temporary fits file
c   first check if an old one exist
	  name='ppptemp'//nfrstr(1:lnblnk(nfrstr))//'.fits'
	  inquire(file=name,exist=ex)
	  if (ex.eqv..true.) then
c  delete temporary file if there is already one
	    open(unit=41,file=name,status='old',err=999)
	    close(unit=41,status='delete')
	  end if
c  write out temporary fits file
c     if dss (ipar=2), or frame has not been changed (not in effect yet)
c        just copy the image into ppptemp
c  ^^do this only if the image is not a MEF^^ (added in pppgalfit Feb06)
 	  if ((ipar.eq.2.or.nfl(6,nfr).eq.0).and.nextendh(nfr).eq.1)then
	    write(6,*) ' -- copying temporary fitsfile from original..'
	    inquire(file=imdir(1:lnblnk(imdir))//fitsname(nfr),exist=ex)
	    if (ex.eqv..true.) then
	      idum=system('cp '//imdir(1:lnblnk(imdir))//
     *           fitsname(nfr)//' '//name)
	      iwtemp=0
	    else
	      write(6,*) '  +++ can''t find it....'
	      iwtemp=1
	    end if
	  else 
	    iwtemp=1
	  end if
	  if (iwtemp.eq.1) then
	    write(6,*) ' -- writing temporary fitsfile..... '
	    open(unit=20,file=name,status='new',access='direct',
     *	         recl=2880,err=9001)
	    objnam=' temporary file'
	    call makefhd1(nii(nfr),njj(nfr),objnam,headblkt,bzero,bscale)
	    ihb=1
	    write(20,rec=1) headblkt
C absoultely not clear why byte switch has to be turned off when
c   the display is saoimage, but not when it is ds9. (Nov 19 2004)
	    if (display.eq.'sao'.or.display.eq.'saoimage') then
	      ibytet=0
	    else
	      ibytet=1
	    end if
	    call fitsdataout(20,ihb,ix(1,1,nfr),nu,nv,
     *                      nii(nfr),njj(nfr),ibytet,bscale,bzero)
c  it seems that ibyte=0 (no byte swap in output) is need for sao image to
c   display the temp fits file properly, not sure why --  Nov 11, 2002
c    *                      nii(nfr),njj(nfr),ibyte)
	  end if
c  write out position file for 
	  if (ipar.eq.0) then
	    call wdspos(nfr,1)
	  else
	    if (nfr.le.nposfil) then
	      if (nob(nfr).gt.0) then
	        call saocoo(*222,nfr,1)
	      else
	        write(6,*) '  ... No position file attached '
	      end if
	    else
	      write(6,*) '  ... No position file attached '
	    end if
	  end if
c compute limits
 222	  if (nfra(2).eq.0.and.nfra(3).eq.0) then
	    CALL stripsky(nfr,1,1,nii(nfr),njj(nfr),10,sky,sig,
     *                   0,ix,nu,nv,kf)
 	    ilow=sky-2.5*sig
	    iup=sky+dsup*sig
c	    write(6,*) '  Sky value: ',sky, ' sig:',sig
 600	    write(6,1) dsup,ilow,iup
 1	format(' default lower and upper limits (-2.5, +',f5.1,
     *           ' sig):',2i6)
	  else
	    ilow=nfra(2)
	    iup=nfra(3)
	  end if
	end if
	if (idispar.eq.0) then
 	  call dsstring(ilow,iup,icolor,name,iparlog,cstring)

c  absolute path names
c  Toronto
c	idum=system('/homes/makalu/hyee/nddodis/ddodis '
c  UBC
c	idum=system('/astro/wendigo/yee/ppp2/ddodis '
c  Ucol pisco
c	idum=system('/user1/casa/erica/nddodis/ddodis '
c  generic alias path name
c	idum=system('ds '
c
c  setenv name
	  call getenv('PPP_DS',ddodisname)
	  write(6,199) ddodisname(1:lnblnk(ddodisname))//' '//cstring
 199	format(a70)
	  idum=system(ddodisname(1:lnblnk(ddodisname))//' '
     *      //cstring//' &')
	else if (idispar.eq.1) then
	  call saostring(ilow,iup,icolor,name,iparlog,nii(nfr),njj(nfr)
     *                ,cstring)
	write(6,*) display
	  if (display.eq.'ds9') then
	    dspstring='ds9'
	  else 
	    dspstring='saoimage'
	  end if
	  if (display.eq.'sao'.or.display.eq.'saoimage') then
	  write(6,199) ' ..'//dspstring//'  '//cstring
	  idum=system(dspstring//' '//cstring//' &')
	  else
	    idum=system(dspstring//name(1:lnblnk(name))//' &')
	  end if
	end if
 999	return1
 9001	write(6,*) ' *** error opening temp file for output ****'
	return1
	end 
c////////////////////////////////////////////
c  subroutine to make ds calling string
c
	subroutine dsstring(ilow,iup,icolor,name,iparlog,cstring)
	character name*18,costr*2,splot*18,hplot*18
     *     ,cstring*120,lowstr*5,upstr*5
        common/PLOTDEV/HPLOT,SPLOT,ipinit
	include 'ppparm.inc'
	idum=encode(lowstr,float(ilow),1,0,idum2)
	idum=encode(upstr,float(iup),1,0,idum2)
	idum=encode(costr,float(icolor),1,0,idum2)
	if (splot.eq.'/xwin') then
c  X-ds display
	  if (iparlog.eq.1) write(6,*) ' ... no X-ds log display'
	  if (iorient.eq.0) then
	    cstring=' -xflip -xyflip '//' -color '//costr//' '
     *       //name(1:lnblnk(name))//' '//lowstr(1:lnblnk(lowstr))
     *         //' '//upstr(1:lnblnk(upstr))
	  else if (iorient.eq.1) then
	    cstring=' -yflip  -zlow '//lowstr(1:lnblnk(lowstr))//
     *          ' -zhigh '//upstr(1:lnblnk(upstr))//' -color '//costr
     *           //' '//name(1:lnblnk(name))
	  else if (iorient.eq.2) then
	    cstring='  -xyflip '//' -color '//costr//' -zoom 2 '
     *       //name(1:lnblnk(name))//' '//lowstr(1:lnblnk(lowstr))
     *         //' '//upstr(1:lnblnk(upstr))
	  else if (iorient.eq.3) then
	    cstring='  -xyflip '//' -color '//costr//' -zoom 3 '
     *       //name(1:lnblnk(name))//' '//lowstr(1:lnblnk(lowstr))
     *         //' '//upstr(1:lnblnk(upstr))
	  end if
	else 
c  Sun ds display
	if (iparlog.eq.0) then
	  if (iorient.eq.0) then
	    cstring=name(1:lnblnk(name))//
     *          ' xyflip 1 xflip 1 yflip 0 zmin '
     *           //lowstr(1:lnblnk(lowstr))//' zmax '//
     *          upstr(1:lnblnk(upstr))//' color '//costr
	  else
	    cstring=name(1:lnblnk(name))//
     *          ' xyflip 0 xflip 0 yflip 1 zmin '
     *           //lowstr(1:lnblnk(lowstr))//' zmax '//
     *          upstr(1:lnblnk(upstr))//' color '//costr
	  end if
	else 
	  if (iorient.eq.0) then
	    cstring=name(1:lnblnk(name))//
     *          ' xyflip 1 xflip 1 yflip 0 zmin '
     *        //lowstr(1:lnblnk(lowstr))//' zmax '//
     *     upstr(1:lnblnk(upstr))//' color '//costr//' log_scale 1'
	  else
	    cstring=name(1:lnblnk(name))//
     *          ' xyflip 0 xflip 0 yflip 1 zmin '//
     *        lowstr(1:lnblnk(lowstr))//' zmax '//
     *     upstr(1:lnblnk(upstr))//' color '//costr//' log_scale 1'
	  end if
	end if
	end if
	return
	end
c////////////////////////////////////////////
c  subroutine to make sao calling string
c
	subroutine saostring(ilow,iup,icolor,name,iparlog,isize,jsize,
     *             cstring)
	character name*18,splot*18,hplot*18
     *     ,cstring*120,lowstr*5,upstr*5,xstr*4,ystr*3
        common/PLOTDEV/HPLOT,SPLOT,ipinit
	include 'ppparm.inc'
	idum=encode(lowstr,float(ilow),1,0,idum2)
	idum=encode(upstr,float(iup),1,0,idum2)
	if (iorient.eq.0) then
c	  xsize=amax1(100.,amin1(1050.,float(jsize)))
	  xsize=amax1(100.,amin1(1000.,float(jsize)))
c	  ysize=amax1(100.,amin1(825.,float(isize)+160.))
	  ysize=amax1(100.,amin1(700.,float(isize)+160.))
	else 
c	  xsize=amax1(100.,amin1(1050.,float(isize)))
c	  ysize=amax1(100.,amin1(825.,float(jsize)+160.))
	  xsize=amax1(100.,amin1(1000.,float(isize)))
	  ysize=amax1(100.,amin1(700.,float(jsize)+160.))
	end if
	idum=encode(xstr,xsize,1,0,idum2)
	idum=encode(ystr,ysize,1,0,idum2)
c	if (splot.eq.'/xwin') then
	if (iparlog.eq.0) then
	  if (iorient.eq.0) then
c	    cstring=' -v -linear -ul -rotate 1 -geometry 1050x825+0+0'
 	    cstring=' -v -linear -ul -rotate 1 -geometry '//
     *         xstr(1:lnblnk(xstr))//'x'//ystr(1:lnblnk(ystr))//'+0+0'
     *          //' -min '//lowstr(1:lnblnk(lowstr))//' -max '//
     *          upstr(1:lnblnk(upstr))//' '//name(1:lnblnk(name))
	  else if (iorient.eq.1) then
c	    cstring=' -v -linear -ll -geometry 1050x825+0+0'//
     	    cstring=' -v -linear -ll -geometry '//xstr(1:lnblnk(xstr))
     *        //'x'//ystr(1:lnblnk(ystr))//'+0+0 -min '
     *          //lowstr(1:lnblnk(lowstr))//' -max '//
     *          upstr(1:lnblnk(upstr))//' '//name(1:lnblnk(name))
	  end if
	else 
	  if (iorient.eq.0) then
 	    cstring=' -v -log -ul -rotate 1 '//
     *          ' -min '//lowstr(1:lnblnk(lowstr))//' -max '//
     *          upstr(1:lnblnk(upstr))//' '//name(1:lnblnk(name))
	  else if (iorient.eq.1) then
 	    cstring=' -v -log -ll '//
     *          ' -min '//lowstr(1:lnblnk(lowstr))//' -max '//
     *          upstr(1:lnblnk(upstr))//' '//name(1:lnblnk(name))
	  end if
	end if
	return
	end
c////////////////////////////////////////////////////////////
c
c  subroutine to write to disk temp position file for SUN dispaly
c    ipar=1: .coo file; ipar=2: .COO file
	subroutine wdspos(nfr,ipar)
	character nfrstr*2,posname*20
	logical ex
        include 'objcat.inc' 
	if (nfr.gt.nposfil) then
	  write(6,*) ' No position file allowed for frame# ',nfr
	  return
	end if
c write out object position file if it exist in core
	if (nob(nfr).le.0) then
	  write(6,*) '  No position file attached '
	  return
	end if
c  delete any .COO file
	istatus=encode(nfrstr,float(nfr),1,0,idum)
  	posname='ppptemp'//nfrstr(1:lnblnk(nfrstr))//'.COO'
	inquire(file=posname,exist=ex)
	if (ex.eqv..true.) then
	  open(unit=39,file=posname,status='old',err=999)
	  close(unit=39,status='delete')
	end if
	if (ipar.eq.1) then
c check .coo file
  	  posname='ppptemp'//nfrstr(1:lnblnk(nfrstr))//'.coo'
  	  write(6,1) posname
1	format(1x,' ... writing temp posfile to disk: ', a20)
	  inquire(file=posname,exist=ex)
	  if (ex.eqv..true.) then
c  delete temporary file if there is already one
	    open(unit=39,file=posname,status='old',err=999)
	    close(unit=39,status='delete')
	  end if
	end if
c  write temp position file to disk
	open(unit=39,file=posname,status='new',err=999)
	if (ipar.eq.1) then
c write 3 dummy files for .coo
	  do 109 k=1,3
	    write(39,*) '   1 dummy '
 109	  continue
	end if
	do 110 k=1,nob(nfr)
	  write(39,*) k,float(ijoi(k,nfr)),float(ijoj(k,nfr))
 110	continue
	close(unit=39)
 999	return
	end 
c////////////////////////////////////////////////////////////
c
c  subroutine to write to disk temp position file for ds dispaly
c   for individual object display
c    ipar=1: .coo file; ipar=2: .COO file
	subroutine wdtempos(ii,jj,nob,kobj,ipar)
	character nfrstr*4,posname*20
	integer ii(*),jj(*)
	logical ex
c write out object position file if it exist in core
	if (nob.le.0) then
	  write(6,*) '  No position file attached '
	  return
	end if
c  delete any .COO file
	istatus=encode(nfrstr,float(kobj),1,0,idum)
  	posname='object'//nfrstr(1:lnblnk(nfrstr))//'.COO'
	inquire(file=posname,exist=ex)
	if (ex.eqv..true.) then
	  open(unit=39,file=posname,status='old',err=999)
	  close(unit=39,status='delete')
	end if
	if (ipar.eq.1) then
c check .coo file
  	  posname='object'//nfrstr(1:lnblnk(nfrstr))//'.coo'
  	  write(6,1) posname
1	format(1x,' ... writing temp posfile to disk: ', a20)
	  inquire(file=posname,exist=ex)
	  if (ex.eqv..true.) then
c  delete temporary file if there is already one
	    open(unit=39,file=posname,status='old',err=999)
	    close(unit=39,status='delete')
	  end if
	end if
c  write temp position file to disk
	open(unit=39,file=posname,status='new',err=999)
	if (ipar.eq.1) then
c write 3 dummy files for .coo
	  do 109 k=1,3
	    write(39,*) '   1 dummy '
 109	  continue
	end if
	do 110 k=1,nob
	  write(39,*) k,float(ii(k)),float(jj(k))
 110	continue
	close(unit=39)
 999	return
	end 
C//////////////////////////////////////////////////////////////////////////////
C
C Help file for TV commands: sun view
C
	SUBROUTINE HELPTV(IDEV)
	WRITE(IDEV,1071)
 1071	FORMAT('     --- SUNview DISPLAY MONITOR COMMAND: ---'/
     *  ' +++ image in ppptempN.fits, position file in ppptempN.coo'
     *  ,', hand-marked file in ppptempN.COO'/
     &	'  ds F 2I  - display frame F '/
     *	'  dssp F   - display individual spectrum from frame F'/
     *	'  dsob F N - display object N from frame F'/
c     &	'  dds S -display image directly from disk file'/
     &  '  dsl F 2I - display frame F in log scale.'/
     *  '  dscmap F1 F2 - display color map F2 with intensity from F1'/
     *  '  dsut F - interactive ds utility commands (see subcommads).'/
     *  '  coo - combine .COO positions to current posfile'/
     *  '          or create .coo file from current posfile'/
     *  '  dcoo - delete .COO positions from current posfile'/
     *  '  e,x - short for coo 1 and dcoo 1.'/
     *  '  rdap/ma I -- read aperture/mag data from .phm file'/
     *  '  rdhf      -- read hdr.fix data plus .phm file'/
c     &	'  ddsl S -display image in log directly from disk file'//
     *  '  CANVAS keybroad function: '/
     *  '      center button: contrast'/
     *  '      left button: roam, or select canvas menu'/
     *  '      a/e : enter position for adding or deleting objects'/
     *  '          ("a" searches for nearby max pixel, "e" does not.'/
     *  '      A : display positions entered by "a" (.COO file)'/
     *  '      c : mark position from current posfile (.coo)'/
     *  '      s : write out obj number of obj pointed to by cursor'/
     *  '      t : Type pixel values around cursor'/
     *  '      Z : plot photometry aperture size from .phm file'/
     *  '      1,2,4,8 etc: zoom to indicated factor'/
     *  '      i : zoom in by factor of 2'/
     *  '      d : de-zoom '/
     *  '      Z : display rdap (aperture) or rdma (mag) data on image'/
     *  '      h,j,k,l - move cursor by 1 pixel in one of the 4',
     *  ' direction'/
     *  '      y,n,b,u - same as above, but move in diagonal')
	RETURN
	END
c//////////////////////////////////////////////////////////
c
c  subroutine to read .coo file
c
c
	subroutine readcoo(nfr,ncoo,iitem,jjtem,nmax)
	INTEGER iitem(*),jjtem(*)
	character posname*20,nfrstr*2
	logical exCOO
c  first check if there is any .COO file
	istatus=encode(nfrstr,float(nfr),1,0,idum)
  	posname='ppptemp'//nfrstr(1:lnblnk(nfrstr))//'.COO'
	inquire(file=posname,exist=exCOO)
	if (exCOO.neqv..true.) then
	  write(6,*) '  +++ no .COO file +++'
	  ncoo=0
	  return
	else
	  open(unit=39,file=posname,status='old',err=999)
c   there is a .COO file, read array of positions
	  kk=0
 121	  kk=kk+1
	    read(39,*,end=120) iitem(kk),jjtem(kk)
	    if (kk.eq.nmax) then
	      write(6,*) ' ++ max .COO obj number reached: ',nmax
	       kk=kk+1
	       go to 120
	    end if
	    go to 121
 120	  ncoo=kk-1 
 122	  close(unit=39)
	end if
 999	return
	end 
c//////////////////////////////////////////////////////////
c
c  subroutine to create or combine (delete or add) .coo/.COO file
c
c     ipar=1  add .COO from posfile
c     ipar=0  delete .COO from posfile
c     ipar=2  clear .COO file
c
	subroutine makecoo(*,nfr,ipar)
	INTEGER iitem(1000),jjtem(1000)
	character posname*20,nfrstr*3
        include 'objcat.inc' 
	logical exCOO
	CALL QUERYNFR(NFR,nposfil+1,0,*999,*20001)
20001	IF (NFR.GT.nposfil) THEN
	  write(6,12) nposfil+1
 12	format('  +++ no position file on frame # >=',i2)
	  RETURN1
	END IF
c  first check if there is any .COO file
	istatus=encode(nfrstr,float(nfr),1,0,idum)
  	posname='ppptemp'//nfrstr(1:lnblnk(nfrstr))//'.COO'
	inquire(file=posname,exist=exCOO)
	  if (exCOO.neqv..true.) then
	    if (ipar.ne.1) return1
c    if no .COO file, just write out posfil file
	    call wdspos(nfr,1)
	  else
	    open(unit=39,file=posname,status='old',err=999)
	    if (ipar.eq.2) then
c  clear .COO file
	      close(unit=39,status='delete')
	      write(6,*) '  ... .COO file cleared'
	      return1
	    else
c   there is a .COO file, create a temp array of positions
	      kk=0
 121	      kk=kk+1
	      read(39,*,end=120) iitem(kk),jjtem(kk)
	      go to 121
 120	      kk=kk-1 
	      if (ipar.eq. 1) then
c add position to posfile
	        call combinecc(nob(nfr),ijoi(1,nfr),ijoj(1,nfr)
     *            ,idob(1,nfr),kk,iitem,jjtem)
	        write(6,8) kk
 8	format(' ...',i3,' objects added to posfile')
	      else 
c delete position from file
	        call deletecc(nfr,kk,iitem,jjtem)
	      end if
	    end if
c delete the .COO file
	    close(unit=39,status='delete')
c  write the new file out as .coo
	    call wdspos(nfr,1)
	  end if
 999	return1
	end 
c//////////////////////////////////////////////////////////
c
c   new version of makecoo, but for .reg ds9 files
c  subroutine to create or combine (delete or add) .reg file
c
c  delete is accomplished by simply marking the objects that are
c   already marked, and press del;
c  add is accomplised by setting the shape to point circle; color
c   to magenta, mark the objects, and savd using saofng format
c
c     ipar=1  add .reg to posfile
c     ipar=0  delete .reg from posfile
c     ipar=2  clear .reg file
c
	subroutine makereg(*,nfr,ipar)
	INTEGER iitem(1000),jjtem(1000)
	character posname*20,nfrstr*3,ds9string*40
        include 'objcat.inc' 
	logical exCOO
	CALL QUERYNFR(NFR,nposfil+1,0,*999,*20001)
20001	IF (NFR.GT.nposfil) THEN
	  write(6,12) nposfil+1
 12	format('  +++ no position file on frame # >=',i2)
	  RETURN1
	END IF
c  first check if there is any .reg file
	istatus=encode(nfrstr,float(nfr),1,0,idum)
c 	posname='ppptemp'//nfrstr(1:lnblnk(nfrstr))//'.reg'
	posname='ds9.reg'
	inquire(file=posname,exist=exCOO)
	  if (exCOO.neqv..true.) then
	    if (ipar.ne.1) return1
c    if no .COO file, just write out posfil file
	    call wdspos(nfr,1)
	  else
	    open(unit=39,file=posname,status='old',err=999)
	    if (ipar.eq.2) then
c  clear .reg file
	      close(unit=39,status='delete')
	      write(6,*) '  ... .reg file deleted'
	      return1
	    else if (ipar.eq.1) then
c   there is a .reg file, read the added objects, should be points
	      kk=0
 121	      read(39,'(a40)',end=120) ds9string
	      if (ds9string(2:4).eq.'poi') then
c check the color: it must be magenta
	        icmark=index(ds9string,'#')
	        if (ds9string(icmark+2:icmark+5).eq.'mage') then
c	write (6,*) ds9string
	          ibeg=index(ds9string,'(')
	          iend=index(ds9string,')')
	          read(ds9string(ibeg+1:iend-1),*,err=120) temx,temy
	          kk=kk+1
	          iitem(kk)=nint(temx)
	          jjtem(kk)=nint(temy)
	write(6,*) ibeg,iend,temx,temy,iitem(kk),jjtem(kk)
	        end if
	      end if
	      go to 121
c finished reading
 120	      kk=kk-1 
c add position to posfile
	      call combinecc(nob(nfr),ijoi(1,nfr),ijoj(1,nfr)
     *            ,idob(1,nfr),kk,iitem,jjtem)
	      write(6,8) kk
 8	format(' ...',i3,' objects added to posfile')
	    else if (ipar.eq.0) then
c delete position from file, first read in the new ds9 file
	      kk=0
 131	      read(39,'(a40)',end=130) ds9string
	      if (ds9string(1:4).eq.'-box') then
c check the color
	        icmark=index(ds9string,'#')
c	        if (ds9string(icmark+2:icmark+5).eq.'gren') then
	          ibeg=index(ds9string,'(')
	          iend=index(ds9string,')')
	          read(ds9string(ibeg+1:iend-1),*,err=130) temx,temy
	          kk=kk+1
	          iitem(kk)=nint(temx)
	          jjtem(kk)=nint(temy)
 	write(6,*) ibeg,iend,temx,temy,iitem(kk),jjtem(kk)
c	        end if
	      end if
	      go to 131
c finished reading
 130	      kk=kk-1 
	      call deletecc2(nfr,kk,iitem,jjtem)
	    end if
c delete the .COO file
c	    close(unit=39,status='delete')
	    close(unit=39)
c  write the new file out as new reg file
c	    call wdspos(nfr,1)
	  end if
 999	return1
	end 

c//////////////////////////////////////////////////////////////
c
c  subroutine to combine .coo and .COO file
c
 	subroutine combinecc(nob,ijoi,ijoj,idob,nadd,iitem,jjtem)
	INTEGER IJOI(*),IJOJ(*),IDOB(*),iitem(*),jjtem(*)
c combine the tem and real file
	naddt=0
	do 100 k=1,nadd
	  if (iitem(k).lt.0.or.jjtem(k).lt.0) then
	    write(6,1) iitem(k),jjtem(k)
 1	format('  +++ warning, negative co-ordinate at',2I7,
     *        ' object not added +++')
	    go to 100
	  end if
	  ijoi(nob+k)=iitem(k)
	  ijoj(nob+k)=jjtem(k)
	  idob(nob+k)=1
	  naddt=naddt+1
 100	continue
	nob=nob+naddt
	call arranpos(nob,ijoi,ijoj,idob)
	return
	end
c////////////////////////////////////////////////////////
c
c  subroutine to delete objects in posfil marked in .COO file
c
 	subroutine deletecc(nfr,nsub,iitem,jjtem)
	INTEGER iitem(*),jjtem(*)
        include 'objcat.inc' 
	do 100 i=1,nsub
	  ii=iitem(i)
	  jj=jjtem(i)
	  call zapobj(nfr,ii,jj,iir,jjr,idel)
	  if (idel.eq.1) then
	    write(6,10) i,iir,jjr
 10	format('  ++ marked obj #',I5,' @',2I6,'  ... deleted')
	  end if
 100	continue
	return
	end
c////////////////////////////////////////////////////////
c
c  subroutine to delete objects in posfil marked in ds9.reg file
c   in this case, the objects are actually deleted within ds9
c    already. All this routine does is to take the temp array
c    and assign it to the posfil array, and figure out how
c    many objects are deleted.
c
 	subroutine deletecc2(nfr,nnew,iitem,jjtem)
	INTEGER iitem(*),jjtem(*)
        include 'objcat.inc' 
	nobold=nob(nfr)
	nob(nfr)=nnew
	do 100 i=1,nnew
	  ijoi(i,nfr)=iitem(i)
	  ijoj(i,nfr)=jjtem(i)
c	  if (idel.eq.1) then
c	    write(6,10) i,iir,jjr
c 10	format('  ++ marked obj #',I5,' @',2I6,'  ... deleted')
c	  end if
 100	continue
	write(6,1) nobold-nnew
 1	format(' ++',i5,' objects deleted from original pos file')
	return
	end
c///////////////////////////////////////////////////////////////
c
c  ultility program for ds.  Uses the last entry of .COO file
c       as input
	subroutine dsutil(nfr,ix,nu,nv,kf,*)
	dimension idumnfr(5),ib(4),ie(4)
	parameter (maxmark=3000)
	integer ix(nu,nv,kf),iit(maxmark),jjt(maxmark),
     *    ndel(10),iipsf(maxmark),jjpsf(maxmark)
	integer npsf(maxmark)
	character dumstr1*60,dumstr2*60,name*15,nfrstr*2,ch*3,
     *     text*30,filout*18,cooout*18,bpstr*6,bpcomment*40,itok*5,
     *     refstr*4,filoutf*18,secstr*1
	include 'picdir.inc'
	include 'objcat.inc'
	include 'ppparm.inc'
 2000	call querynfr(nfr,kf,0,*999,*2001)
 2001 	istatus=encode(nfrstr,float(nfr),1,0,idum) 
	name='ppptemp'//nfrstr(1:lnblnk(nfrstr))//'.COO'
	idumnfr(1)=nfr
	dumstr1=' '
	dumstr2=' '
 600	write(6,1)
 1	format('  ds utility commands: +,*,w,d,t,con,bp,st,ref,',
     *          'rfe,pen,h(elp),q'/
     *        '    (use "a"/"e" on canvas to enter position(s))')
920	write(6,'(''    ds>> '',$)')
	call readstr(3,ch,*999,*600)
	if (ch.eq.'st') then
 609	  write(6,5)
 5	format('  Text string file for cplt/pgim: Enter'
     *      ,' output file name: ',$)
          CALL readstr(18,filout,*920,*609)
	  if (csiz.lt.0.01) csiz=1.
	  if (wld.lt.1.) wld=1.
 610      WRITE(6,6) WLD,CSIZ
 6	FORMAT('  Enter label plot thickness and char. siz:'
     *        ,'(dflt:',F4.0,F6.2,'): ',$)
          CALL READ2R(WLD,CSIZ,*920,*610)
          IWD=NINT(WLD)
 611      WRITE(6,7) ANG,FJUST
          CALL READ2R(ANG,FJUST,*920,*611)
 7	FORMAT('   Enter angle(horiz=0) and Fjust(0.0-1.0)'
     *         ,' (dflt:',F6.1,F4.2,'): ',$)
	  if (scale.le.0.00001) scale=1.0
 613	  write(6,11) scale
 11	format('  Enter multiplicative pixel scaling: [',f8.4,']: ',$)
	  call read1r(scale,*920,*613)
	  call opennew(28,1,18,filout,*999)
          write(28,9) iwd,csiz
 9        format(1x,i2,1x,f6.2)
 301	  write(6,*) '  Mark position with "a", BEFORE'
 612      WRITE(6,8)
 8	FORMAT('   entering text string (30 chars. max., end to end): ',$)
          CALL readstr(30,text,*921,*612)
	  goto 500
 921	    close(unit-28)
	    goto 920
 500	  continue
	  call readdsco(name,ii,jj,last,*301)
  	  write(28,10) float(jj)*scale,float(ii)*scale,ang,fjust
 10     format(1x,2f9.2,2x,f7.2,f5.2)
c  write file
	  write(28,'(a30)') text
	  if (text.eq.'end') then
	    close(unit=28)
	  else
	    go to 301
	  end if
	  go to 920
	else if (ch.eq.'bp') then
	  filout='dscrbp.macro'
	  iline=0
	  write(6,21)
 21     format('  Interactive creation of crbp (bad pixel map) macro:'/
     *       '  b - box, (and I row, J row): using last 2 canvas pts'/
     *       '  p R - point/circle of radius R, centered on last pt'/
     *       '  m T - meteor defined by 2 pts of T pixels thick'/
     *       '  d - delete last entry from macro file'/
     *       '    <cr>=exit.  Macro stored in dscrbp.macro')
 614	  write(6,24)
 24	format('  Enter comment: ',$)
	  read(5,'(a40)',end=920) bpcomment
 615      write(6,25) nmask
 25      format('   Enter frame number for mask [',i2,']: ',$)
          call read1i(nmask,*920,*615) 
          call opennew(29,1,18,filout,*920) 
	write(29,23) bpcomment
 23	format('## ',a40)
	  iip=-12
	  jjp=-12
	  write(29,26) nmask,nii(nfr),njj(nfr)
 26	format('crbp'/1x,i2/1x,2i6)
 616	  write(6,27) 
 27	format('  Enter position(s) with "e" and then shape type: ',$)
	  read(5,28,end=919) bpstr
	  goto 918
 919	  bpstr=' '
 918	  if (bpstr.eq.' ') then
	    write(6,*) ' ..MACRO creation ended, stored in dscrbp.macro'
	    write(29,*) ' '
	    write(29,31)
 31	format('end')
	    close(unit=29)
	    go to 920
	  else if (bpstr.eq.'d') then
	    if (iline.ge.1) backspace 29
	    go to 616
	  end if
c read cursor
	  call readdsco(name,ii,jj,last,*616)
	  if (last.eq.0) then 
	    write(6,*) '  +++ no current position +++ '
	    go to 616
	  end if
c check if the user has entered new point
	  if (ii.eq.iip.and.jj.eq.jjp) then
	    write(6,12)
 12	format('  +++ warning: co-ordinates the same as last entry'/
     *       '     Do you want to re-enter? (y=dflt/n): ',$)
	    read(5,28,end=919) bpstr
 28	format(a6)
	    if (bpstr.ne.'n') go to 616
	  end if
c  read the 2nd last point
          if (last.gt.1) then
            open(unit=27,file=name,status='old',err=130)
            do 107 i=1,last-1
              read(27,*,end=616) ii2,jj2
 107        continue
 	    close(unit=27)
 130	    continue
	  end if
c  read command
	  if (bpstr.eq.'b') then
	    if (ii.lt.ii2.or.jj.lt.jj2) then
	      write(6,13) ii2,jj2,ii,jj
 13	format(2x,4i5,/'  First pt must be smaller than 2nd pt',
     *         ' +++TRY AGAIN+++')
	      call rbell(1)
	      go to 616
	    end if
	    write(29,14) ii2,jj2,ii,jj
	    write(6,14) ii2,jj2,ii,jj
 14	format('b',4i6)
	  else 
c parse string
	    call fstr(bpstr,6,ib,ie,nk) 
	    if (bpstr(ib(1):ie(1)).eq.'p') then
	      if (nk.eq.1) then
	        write(29,15) ii,jj
	        write(6,15) ii,jj
	      else
	        read(bpstr(ib(2):ie(2)),*,err=135) irad
	        write(29,15) ii,jj,irad
	        write(6,15) ii,jj,irad
 15	format('p',2i6,i6)
	        go to 136
 135	        write(6,*) '  +++ input error +++'
	        go to 616
	      end if
	    else if (bpstr(ib(1):ie(1)).eq.'m') then
	      if (nk.eq.1) then
	        write(6,*) '  ++ assuming thickness to be 1 ++'
	        irad=1
	      else
	        read(bpstr(ib(2):ie(2)),*,err=237) irad
	      end if
	      write(29,36) ii2,jj2,ii,jj
	      write(29,'(i3)') irad
	      write(6,'(i3)') irad
	      write(6,36) ii2,jj2,ii,jj
 36	format('m',4i6)
	      go to 136
 237	      write(6,*) '  +++ input error +++'
	      go to 616
	    else
	      write(6,*) '  +++ illegal entry +++'
	      go to 616
	    end if
	  end if
 136	  iip=ii
	  jjp=jj
	  iline=iline+1
	  go to 616
	else if (ch.eq.'q') then
	  call makecoo(*990,nfr,2)
 990	  return1
c command for MAKING REFERENCE STAR LIST
	else if (ch.eq.'ref'.or.ch.eq.'rfe') then
	  call makecoo(*631,nfr,2)
c631	  write(6,*) '  ... .COO file cleared...'
c  make COO file name
 631	  istatus=encode(nfrstr,float(nfr),1,0,idum)
	  cooout='ppptemp'//nfrstr(1:lnblnk(nfrstr))//'.COO'
	  if (ch.eq.'rfe') then
 6291	    write(6,41) filout
 41	format('  Enter old ref file name (.ref appended)[',a18,']: ',$)
 	    read(5,'(A18)',end=999) filout
	    if (filout.ne.' ') then
	      filoutf=filout(1:lnblnk(filout))//'.ref'
	      if (nsct(nfr).ne.0) then
	        istatus=encode(secstr,float(nsct(nfr)),1,0,idum)
	        filoutf=filoutf(1:lnblnk(filoutf))//'.'//secstr
              end if
	    end if
 268	    open(unit=26,name=filoutf,status='old',err=6291)
c  read old ref file and write it out as a .COO file
	    read(26,'(1x)')
	    do 157 i=1,maxmark
	      read(26,*,err=158,end=159) idum,iit(i),jjt(i)
 157	    continue
 158	    write(6,*) '  *** error in reading ref file, obj# ',i
 159	    close(unit=26)
	    call opennew(39,2,18,cooout,*999)
	    do 110 k=1,i-1
	      write(39,381) iit(k),jjt(k)
 381	format(i4,1x,i4)
 110        continue
            close(unit=39)
	    write(6,*) ' .. new .COO file created from ref file '
	    ipsf=i-1
	  else
	    ipsf=0
	  end if
c first clear co-ordinate list
 639	  write(6,16)
 16	format(
     *   '  Creating input file for reference stars for a/ppph:',
     *   /'    subcommands (on session window): ',
     *   /'            x n - delete obj n from list',
     *   /'            i n - add one obj ppp#n to list',
     *   /'            t n - type current list starting from n ',
     *   /'            T   - t plus output SAO region file for ref list',
     *  /'            R   - read SAO region file for appending ref list',
     *   /'            m   - make inital list based on peak value'
     *   /'            a   - add more objs by lowering peak limit '
     *   /'            c   - create c2 vs mag plot for checking',
     *   /'            s   - save file  and exit',
     *   /'            q   - return to dsut'
     *   /'            h   - type this',
     *   /'   to enter single star use cursor command "a" on image')
 640	  write(6,80)
 80	format('    >>ref>: ',$)
 214	  read(5,'(a5)',end=920) itok
	  if (itok(1:1).eq.'h') then 
	    go to 639
	  else if (itok(1:1).eq.'i') then
	    read(itok(2:5),*,err=675,end=675) nadd
	    goto 510
 675	    nadd=0
 510	    if (nadd.le.0) then
 676	      write(6,68) nadd
 68	format('  Enter psf # to be added [',i5,']: ',$)
	      call read1i(nadd,*640,*676)
	    end if
	    if (nadd.gt.nob(nfr)) then
	      write(6,*) '  +++ obj number too large '
	      goto 640
	    end if
	    ipsf=ipsf+1
	    npsf(ipsf)=nadd
c out put new .COO file
            call opennew(39,2,18,cooout,*999)
            do 249 i=1,ipsf
              write(39,381) ijoi(npsf(i),nfr),ijoj(npsf(i),nfr)
 249        continue
            close(unit=39)
c	write(6,*) ' new ipsf ',ipsf, npsf(ipsf)
	  else if (itok(1:1).eq.'x') then
	    read(itok(2:5),*,err=645,end=645) ndel(1)
	    if (ndel(1).gt.0) then
c delete one obj only
	      nx=1
	      goto 271
	    end if
 645	    write(6,89)
 89	format('  Enter psf #s to be deleted (MFO format): ',$)
	    read(5,'(a60)',end=640) dumstr1
c parse string   
	    call mfnum(dumstr1,60,ndel,10,nx,0)
 271	    continue
c  remove objects
c      mark obj to be removed by -1
	    write(6,*) ' .. obj(s) to be removed:'
	    do 230 i=1,nx
	      k=ndel(i)
	      write(6,91) npsf(k),ijoi(npsf(k),nfr),ijoj(npsf(k),nfr),
     *         ix(ijoi(npsf(k),nfr),ijoj(npsf(k),nfr),nfr)
 91	format('  ppp#',i5,' @ ',2i5,'  peak:',i7)
	      npsf(k)=-1
 230	    continue
	    ict=0
c remove object and shift the list up 1
	    i=1
 231	       if (i.gt.ipsf-nx) goto 234
 233	       if (npsf(i).lt.0) then
	        ict=ict+1
	        do 232 k=i,ipsf-ict
	          npsf(k)=npsf(k+1)
 232	        continue
	        npsf(ipsf-ict+1)=0
	      end if
	      if (npsf(i).lt.0) then
c  check if the following object is also -1
	        goto 233
	      else
	        i=i+1
	      end if
	      goto 231
 234	    continue
	    ipsf=ipsf-nx
c out put new .COO file
	    call opennew(39,2,18,cooout,*999)
	    do 238 i=1,ipsf
	      write(39,381) ijoi(npsf(i),nfr),ijoj(npsf(i),nfr)
 238        continue
            close(unit=39)
	  else if (itok(1:1).eq.'t'.or.itok(1:1).eq.'T') then
	    read(itok(2:5),*,err=220,end=220) nstart
	    goto 221
 220	    nstart=1
 221	    nstart=max0(1,nstart)
c update list
	    call updateref(nfr,ipsf,npsf,maxmark)
	    write(6,*) '  N   ppp#     I       J      peak '
	    icount=0
	    do 222 i=nstart,ipsf
	      icount=icount+1
	      write(6,85) i,npsf(i),ijoi(npsf(i),nfr),ijoj(npsf(i),nfr),
     *                  ix(ijoi(npsf(i),nfr),ijoj(npsf(i),nfr),nfr)
 85	format(i4,2x,i5,2(2x,i5),2x,i6)
	      if (itok(1:1).eq.'t') then
	      if (mod(icount,25).eq.0) then
	        write(6,86)
 86	format('     ..... <cr> to continue : ',$)
	        read(5,*,end=640)
	      end if
	      end if
 222	    continue
	    if (itok(1:1).eq.'T') then
c out put sao region file
	      call saocoo(*223,nfr,0)
 223	      do 224 i=1,ipsf
	        istatus=encode(refstr,float(npsf(i)),1,0,idum)
	        if (iorient.eq.0) then
	          idel=5
	        else
	          idel=-5
	        end if
	        write(32,87) ijoi(npsf(i),nfr)-idel,
     *                ijoj(npsf(i),nfr)-idel,refstr
	        write(32,88) ijoi(npsf(i),nfr),ijoj(npsf(i),nfr),.5*iir
 87	format(' TEXT(',i5,',',i5,', 4,"',a4,'")')
 88	format(' CIR(',i5,',',i5,',',f5.1,')')
 224	      continue
	      close(unit=32)
	      write(6,90)
 90	format(' .. To add: mark obj with CIRCLE (e), then  "R" in dsut ')
	    end if
	  else if (itok(1:1).eq.'R') then
c  read sao region file to get ref list update
	    call rdsaoref(nfr,ipsf,npsf)
c  also update .COO file
	    call opennew(39,2,18,cooout,*999)
	    do 239 i=1,ipsf
	      write(39,381) ijoi(npsf(i),nfr),ijoj(npsf(i),nfr)
 239        continue
            close(unit=39)
	  else if (itok(1:1).eq.'m'.or.itok(1:1).eq.'a') then
	    call initref(nfr,itok(1:1),ipsf,npsf,maxmark,ix,nu,nv,kf)
	    write(6,'(''...'',i4,'' PSF canidates found'')') ipsf
c output .COO file
	    call opennew(39,2,18,cooout,*999)
	    do 218 k=1,ipsf
	      write(39,381) ijoi(npsf(k),nfr),ijoj(npsf(k),nfr)
 218        continue
            close(unit=39)
c
c  compute C2 and plot
	  else if (itok(1:1).eq.'c') then
c save positions in a file and do photometry
	    do 269 k=1,ipsf
	      iipsf(k)=ijoi(npsf(k),nfr)
	      jjpsf(k)=ijoj(npsf(k),nfr)
 269	    continue
	    call psfc2(nfr,iipsf,jjpsf,npsf,ipsf,0,0,
     *              ix,nu,nv,kf)
c out put new .COO file
	    call opennew(39,2,18,cooout,*999)
	    do 278 i=1,ipsf
	      write(39,381) ijoi(npsf(i),nfr),ijoj(npsf(i),nfr)
 278        continue
            close(unit=39)
c
c  save output
	  else if (itok(1:1).eq.'s') then
	    write(6,81) filout
 81	format('   Enter output file name (.ref appended)[',a18,']: ',$)
	    read(5,'(a18)',end=920) filout
c  read file
	    if (filout.ne.' ') then
	      filoutf=filout(1:lnblnk(filout))//'.ref'
	      if (nsct(nfr).ne.0) then
	        istatus=encode(secstr,float(nsct(nfr)),1,0,idum)
	        filoutf=filoutf(1:lnblnk(filoutf))//'.'//secstr
	      end if
            end if
	    call opennew(28,1,18,filoutf,*999)
	    call updateref(nfr,ipsf,npsf,maxmark)
	    write(6,18) filout,ipsf
	    write(28,18) filout,ipsf
 18	format('  ppp#   I   J   //// PSF input for ',A18,
     *        i5,' objs entered')
	    do 137 i=1,ipsf
	      write(6,17) i,npsf(i),ijoi(npsf(i),nfr),
     *              ijoj(npsf(i),nfr)
 17	format('  Ref#',i4,' ppp #:',i5,' @ ',2i5)
	      write(28,*) npsf(i),ijoi(npsf(i),nfr),ijoj(npsf(i),nfr)
 137	    continue
	    close(unit=28)
	    go to 920
	  else if (itok(1:1).eq.'q') then
	    go to 920
	  else
	    write(6,*) ' ... invalid >ref> command '
	  end if
	  go to 640
	end if
c  other commands, read last co-ordinate entered
	call readdsco(name,ii,jj,last,*920)
	if (ch.eq.' ') then
	  go to 920
	else if (ch.eq.'con') then
	  write(6,*) '  -- contour plot --'
	  call contourpg(*920,nfr,dumstr1,ii,jj,0,ix,nu,nv,kf)
	else if (ch.eq.'pen') then 
	  call pgclose(*920)
	else if (ch.eq.'cfr') then
 632	  write(6,19) nfr
 19	format('  Enter new frame number [',i2,']: ',$)
	  call read1i(nfr,*632,*999)
	  go to 2000
	else if (ch.eq.'h') then
	  write(6,3)
 3	format(' ds utilities: performs function based on ds image ',
     *           'cursor.'
     *         /'   Use "a"/"e" on canvass to enter cursor positions,'
     *            ,' then issue subcommand(s).'/
     *         '   +: centroid'/
     *         '   *: aperture photometry'/
     *         '   w: FWHM'/
     *         '   d: distance (pixels) between last 2 cursor points'/
     *         '   t: tty around cursor point'/
     *         '   con: contour plot centered on cursor point'/
     *         '   pen: save previous pgplot window (=pend)'/
     *         '   cfr: change to new frame number'/
     *         '   bp: create macro for bpcr (bad pixel map'/
     *         '   ref: create a file of obj number for ref stars'/
     *         '   st: create text string file for cplt and pgim'/
     *         '   h: help,  q: return to ppp')
	else if (ch.eq.'w') then
	  write(6,*) '  -- estimated FWHM -- '
	  idumnfr(2)=ii
	  idumnfr(3)=jj
	  idumnfr(4)=21
	  idumnfr(5)=55
	  call apdri(*920,idumnfr,dumstr1,dumstr2,3,ix,nu,nv,kf)
c 't' for type out a region of 10X10 around cursor
	else if (ch.eq.'t') then
	  idumnfr(2)=ii
	  idumnfr(3)=jj
	  idumnfr(4)=11
	  idumnfr(5)=11
	  call printz(*920,idumnfr,dumstr1,0,ix,nu,nv,kf)
c '+' for computing centroid
	else if (ch.eq.'+') then
	  write(6,*) '  -- centroid --'
	  idumnfr(2)=ii
	  idumnfr(3)=jj
	  idumnfr(4)=5
	  idumnfr(5)=49
	  call dpcent(*920,idumnfr,ix,nu,nv,kf,0)
c '*' for aperture photometry
	else if (ch.eq.'*') then
	  write(6,*) '  -- apterture photometry --'
	  idumnfr(2)=ii
	  idumnfr(3)=jj
	  idumnfr(4)=0
	  idumnfr(5)=0
	  call phodri(*920,idumnfr,dumstr1,dumstr2,1,ix,nu,nv,kf)
c 'd' for distance between last 2 positions
	else if (ch.eq.'d') then
	  open(unit=27,file=name,status='old',err=120)
	  go to 123
 120	  write(6,*) ' ++++ no current position +++'
	  go to 920
 123	  if (last.le.1) then
 	    write(6,*) '  ++ Only 1 marked position,',
     *               ' no distance determined ++'
	  else
 	    do 106 i=1,last-1
	      read(27,*,end=1222) ii2,jj2
 106	    continue
	    goto 1221
 1222	    write(6,*) '  ++ Only 1 marked position,',
     *               ' no distance determined ++'
	    goto 1223
 1221	    continue
	    dist=sqrt(float((ii-ii2)*(ii-ii2)+(jj-jj2)*(jj-jj2)))
	    write(6,4) ii2,jj2,dist
 4	format('  distance from ',2i5,' = ',f8.2)
	  endif
 1223	  close(unit=27)
	else
	  write(6,*) '  +++ invalid ds utility command ++'
	end if
	go to 920
 999	RETURN1
	END
c///////////////////////////////////////////
c  subroutine to initiate psf list
c  ipsf=number of psfs
c  npsf=ppp# of psf
c  maxmark=max # of psfs allowed
c  itok: 'm'=start new, 'a', add to existent
c
	subroutine initref(nfr,itok,ipsf,npsf,maxmark,ix,nu,nv,kf)
	integer ix(nu,nv,kf)
	integer npsf(maxmark)
	character itok*1
        include 'picdir.inc'
        include 'objcat.inc'
        include 'ppparm.inc'
	include 'pipeparm.inc'
c  compute sky, iadulow is not allow to be less than 200 ADU from sky
	CALL stripsky(nfr,1,1,nii(nfr),njj(nfr),10,sky,sig,
     *                   0,ix,nu,nv,kf)
	if (adulow.lt.0.001) adulow=0.10
	if (ircspipe.eq.1) adulow=adulowpipe
	iaduhi=nint(adusat*.95)
	iadulow=nint(adusat*adulow+sky)
	if (ircspipe.eq.0) then
 601	  write(6,2) adulow,iaduhi,iadulow
 2	format('  Enter lower (net) ADU lim as fraction of ADUSAT '/
     *         '      [',f5.3,'] (range=',2i7,'): ',$)
	  call read1r(adulow,*999,*601)
	end if
	write(6,*) '  adulow: ',adulow
	iaduhi=nint(adusat*.95)
	iadulow=nint(adusat*adulow+sky)
	iaduneig=nint(5*sig+sky)
	write(6,3) iaduhi,iadulow,iaduneig
 3	format(' ... high ADU lim:',i6,',  low ADU lim:',i6, 
     *         '  close neighbour ADU lim:',i6)
c  go through catalog and search for candidates
	if (itok.eq.'m')  ipsf=0
 	ior2=4*ior*ior
 	ior3=9*ior*ior
 	ior1=nint(2.25*ior*ior)
	ncheck=nob(nfr)/10
	do 100 i=1,nob(nfr)
	  if (ijoi(i,nfr).le.0.or.ijoj(i,nfr).le.0.or.
     *        ijoi(i,nfr).gt.nii(nfr).or.ijoj(i,nfr).gt.njj(nfr)) 
     *        goto 100
	  if (ix(ijoi(i,nfr),ijoj(i,nfr),nfr).ge.iadulow.and.
     *      ix(ijoi(i,nfr),ijoj(i,nfr),nfr).le.iaduhi) then
c check 1: it is not within ior from edge
	    if (ijoi(i,nfr).le.ior.or.
     *         ijoi(i,nfr).gt.nii(nfr)-ior) go to 100
	    if (ijoj(i,nfr).le.ior.or.
     *         ijoj(i,nfr).gt.njj(nfr)-ior) go to 100
c  check 2: it is not within some radius of another object
c    there are 3 regimes: (1) objects at iaduhi: at least 3*ior away
c                         (2) objects at iadulow or higher: at least 2*ior away
c                         (3) objects between 5 sigma sky to iadulow:
c                             1.5 ior away
	    do 101 k=max0(1,i-ncheck),min0(nob(nfr),i+ncheck)
	      ipeak=ix(ijoi(k,nfr),ijoj(k,nfr),nfr)
	      if (ipeak.ge.iaduneig) then
	        if (k.ne.i) then
	          ik=ijoi(i,nfr)-ijoi(k,nfr)
	          jk=ijoj(i,nfr)-ijoj(k,nfr)
	          idis=ik*ik+jk*jk
	          if (idis.le.ior3) then
c check peak value, go to next psf candidate if any of it fails
	            if (ipeak.gt.iaduhi) then
	              goto 100
	            else if (idis.le.ior2) then
	              if (ipeak.gt.iadulow) then
	                 goto 100
	              else if (idis.le.ior1) then
	                  goto 100
	              end if
	            end if
	          end if
	        end if
	      end if
 101	    continue
	    if (itok.eq.'a') then
c  search if the object is already in list
	      do 102 k=1,ipsf
	        if (npsf(k).eq.i) go to 100
 102	      continue
	    end if
c passed all checks
	    ipsf=ipsf+1
	    if (ipsf.lt.maxmark) then
	      npsf(ipsf)=i
	    else
	      write(6,15) maxmark
 15	format('  ++Max psf number (',i3,') reached, not added ++')
	      ipsf=ipsf-1
	    end if
	  end if
 100	continue
 999	return
	end
c//////////////////////////////////////////////////
c  subroutine to read sao region file to update ref list
c
c   only appends new objects, marked with -CIR, no deleting
	subroutine rdsaoref(nfr,ipsf,npsf)
	integer npsf(*)
	character string*40,numstring*30,filename*20
	include 'objcat.inc'
	include 'tvparm.inc'
	call makecooname(saoregname,'reg',nfr,filename)
	open(unit=30,file=filename,status='old',err=900)
c  read dummies
	do 100 i=1,3
	  read(30,*)
 100	continue
c read co-ordinates
	do 101 i=1,100000
	  read(30,'(a40)',end=102) string
c read co-ord
	  call saonumst(string,numstring)
c  to reconstruct original posfil
	  if (string(1:4).eq.'-CIR') then
	    read(numstring,*,err=901) xp,yp
	    iip=nint(xp)
	    jjp=nint(yp)
	    call locobj(iip,jjp,num,2,nob(nfr),ijoi(1,nfr),ijoj(1,nfr))
	    if (num.gt.0) then
	      ipsf=ipsf+1
	      npsf(ipsf)=num
	      write(6,1) ipsf,num,iip,jjp
 1	format('... psf#',i3,' ppp#',i5,'  @ ',2i5,' added...')
	    end if
	  end if
 101	continue
 102	close(unit=30)
 999	return
 901	write(6,*) '   *** SAO region file read error ***'
	return
 900	write(6,10) filename
 10	format('  ++ No such SAO region file: ',a20)
	return
	end
c///////////////////////////////////////////////////////////////
c  subroutine to up date ref psf file from COO file
c
	subroutine updateref(nfr,ipsf,npsf,maxn)
	integer iit(maxn),jjt(maxn)
	integer npsf(maxn)
	include 'objcat.inc'
	call readcoo(nfr,ncoo,iit,jjt,maxn)
c   locate object number
	nref=0
	do 137 i=1,ncoo
	  iip=iit(i)
	  jjp=jjt(i)
	  call locobj(iip,jjp,num,3,nob(nfr),ijoi(1,nfr),ijoj(1,nfr))
	  if (num.gt.0) then
c  found object
	    nref=nref+1
	    if (nref.gt.maxn) then
	      write(6,*) '  ++ max ',maxn,' reached, obj not included'
	      nref=nref-1
	    else
	      npsf(nref)=num
	    end if
	  else
	    call rbell(1)
	    write(6,*) '  ++++ NO object at ',iip,jjp,' +++'
	  end if
 137	continue
	write(6,1) ipsf,nref
 1	format('  ...updating psf file, last update:',i3,' new ',i3)
	ipsf=nref
	return
	end
c///////////////////////////////////////////////////
c subroutine to 
c   read ds co-ordinate
	subroutine readdsco(name,ii,jj,last,*)
	character name*15
	open(unit=27,file=name,status='old',err=120)
	go to 121
 120	  write(6,*) ' ++++ no current position +++'
	  return1
 121	do 105 i=1,500
	  read(27,*,end=122) ii,jj
 105	continue
 122	last=i-1 
	close(unit=27)
	write(6,2) ii,jj
 2	format(' ..last marked coordinate: ',2i6)
	return
	end
c////////////////////////////////////////////////////////////////
c  subroutine to read aperture information and produce a .ap file
c
c   ipar=-1 aperture plus hdr.fix file
c   ipar=1 aperture
c   ipar=0 magnitude
c
	subroutine readaper(*,nfr,comstr,ipart)
	parameter(nmax=50000)
	INTEGER icl(nmax),iref(3000)
	dimension rad(nmax),c2(nmax),rmag(nmax),err(nmax)
	character posname*20,phmname*20,nfrstr*3,refstr*4,sign*1,
     *           comstr*60,fixname*20,fixstr(100)*20,secstr*1
	logical exap
	include 'objcat.inc'
	include 'ppparm.inc'
	include 'picdir.inc'
	include 'tvparm.inc'
	include 'apert.inc'
	CALL QUERYNFR(NFR,nposfil+1,0,*999,*20001)
20001	IF (NFR.GT.nposfil) THEN
	  write(6,12) nposfil+1
 12	format('  +++ no position file on frame # >=',i2)
	  RETURN1
	END IF
	ipar=iabs(ipart)
	if (display.eq.'ds') then
c  first check if there is any .ap file
	  istatus=encode(nfrstr,float(nfr),1,0,idum)
  	  posname='ppptemp'//nfrstr(1:lnblnk(nfrstr))//'.ap'
	  inquire(file=posname,exist=exap)
	  if (exap.eqv..true.) then
	    open(unit=39,file=posname,status='old',err=999)
c  clear .ap file
	    close(unit=39,status='delete')
	    write(6,*) '  ... old .ap file cleared'
	  end if
	else if (display.eq.'sao'.or.display.eq.'ds9') then
	  call makecooname(saoregname,'reg',nfr,posname)
c	  write(6,13) posname
c13	format('  ... aperture file name: ',a20)
	else
	  write(6,*) '  ++ invalid display platform ++ ',display
	end if
c request .phm file and read position and compute diameter
 600	if (comstr.eq.' ') then
	  write(6,20)
 20	format('  Enter .phm name (++posfil array will',
     *         ' be over-written++): ',$)
	  read(5,'(a20)',end=999) phmname
	else
	  phmname=comstr(1:lnblnk(comstr))
	end if
c add .phm if it does not end in ".B"
	if (phmname(lnblnk(phmname)-1:lnblnk(phmname)).ne.'.B') 
     *     phmname=phmname(1:lnblnk(phmname))//'.phm'
c add section number if needed
	if (nsct(nfr).gt.0) then
	  istatus=encode(secstr,float(nsct(nfr)),1,0,idum)
          phmname=phmname(1:lnblnk(phmname))//'.'//secstr
	end if
	open(unit=34,file=phmname,status='old',err=601)
	go to 150
 601	  write(6,1) phmname
 1	format('  +++ ',a20,' does not exist ++++')
	  comstr=' '
	  go to 600
 150    call readrad(34,nob(nfr),ijoi(1,nfr),ijoj(1,nfr),
     *     rad,rmag,err,c2,icl,ipar,ideld,nref,iref,nmax,icflag)
	close(unit=34)
c read hdr.fix file
	if (ipart.lt.0) then
 602	  write(6,25)
 25	format('  Enter hdr.fix file name [hdr.fix]: ',$)
	  read(5,'(a20)',end=999) fixname
	  if (fixname.eq.' ') fixname='hdr.fix'
	  if (nsct(nfr).gt.0) 
     *       fixname=fixname(1:lnblnk(fixname))//'.'//secstr
	  open(unit=34,file=fixname,status='old',err=602)
	  read(34,'(1x)')
	  do 110 i=1,100
	    read(34,'(a20)',end=108) fixstr(i)
 110	  continue
 108	  nfix=i-1
	  write(6,*) '  ....# of hdr fixes: ',nfix
	  close(unit=34)
	end if
c out put file
	call opennew(39,2,18,posname,*999)
c	open (unit=39,file=posname,status='new')
	if (display.eq.'ds') then
c write 3 dummy files for .coo
	  do 109 k=1,3
	    write(39,*) '   1 dummy '
 109	  continue
  	  do 100 i=1,nob(nfr)
	    write(39,17) i,float(ijoi(i,nfr)),float(ijoj(i,nfr))
     *                ,nint(rad(i))
 100	  continue
 17	format(i5,2f11.4,i4)
	else if (display.eq.'sao'.or.display.eq.'ds9') then
	  call fixsaocor(delx,dely,iorient,nii(nfr),njj(nfr))
c write 3 dummy lines
	  write(6,29) posname
 29	format(' Aperture file name: ',a20/
     *  ' ..For .hdr fix:',
     *         ' CIRCLE(s/y)/ARROW(s/y): galaxy apert size/classif'/
     *  '                BOX(s/y)/-ARROW(e/r): star apert size/classif'/
     *  '                POINT (s/y or e/r) : class 0.  '/)
	  do 111 k=1,3
	    write(39,21) phmname 
 21	format('# aperture file for ',a20)
 111	  continue
  	  do 112 i=1,nob(nfr)
	    if (icl(i).ge.3.or.icl(i).le.0) then
c  stars or class 0
	      write(39,22) float(ijoi(i,nfr))-delx,
     *               float(ijoj(i,nfr))-dely,2.*rad(i),2.*rad(i)
 22	format('-BOX(',f6.0,',',f6.0,',',f6.1,',',f6.1,')')
c saturated stars
c  write out two boxes of having one size zero (a cross)
	      if (icl(i).eq.4) then
	        write(39,22) float(ijoi(i,nfr))-delx,
     *               float(ijoj(i,nfr))-dely,0.0,2.*rad(i)
	        write(39,22) float(ijoi(i,nfr))-delx,
     *               float(ijoj(i,nfr))-dely,2.*rad(i),0.0
	      end if
	    else
	      write(39,23) float(ijoi(i,nfr))-delx,
     *                    float(ijoj(i,nfr))-dely,rad(i)
 23	format('-CIRCLE(',f6.0,',',f6.0,',',f6.1,')')
	    end if
 112	  continue
c  write out object numbers for bright objects : objects
c       at 1/2 mag fainter or 1 mag brighter and c2>-2
c        and objects 1 mag brighter and c2>0.3.
c      first find the faintest ref star
	  if (ipart.ge.0) then
	  faint=-100
	  do 120 i=1,nref
	    if (rmag(iref(i)).gt.faint) faint=rmag(iref(i))
 120	  continue
	  bright=faint-1.
	  faint=faint+1.
	write(6,*) ' bright and faint limits of ppp# ',bright,faint
c out put marked objects
	  do 121 i=1,nob(nfr)
	    if (rmag(i).lt.faint) then
	      if (c2(i).gt.-0.2.or.
     *             (rmag(i).lt.bright.and.c2(i).gt.-0.3)) then
c check if it is a ref star
	        sign='-'
	        do 122 k=1,nref
	          if (i.eq.iref(k)) then
	            sign=' '
	            goto 123
	          end if
 122	        continue
 123	        istatus=encode(refstr,float(i),1,0,idum)
	        if (iorient.eq.0) then
	          idel=8
	        else
	          idel=-8
	        end if
	        write(39,87) sign,ijoi(i,nfr)-idel,
     *                    ijoj(i,nfr)-idel,refstr
 87	format(a1,'TEXT(',i5,',',i5,', 4,"',a4,'")')
	      end if
	    end if
 121	  continue
c write out hdr.fix
	  else
      	    call whdrfix(nfr,nfix,fixstr,1,delx,dely,ideld)
	  end if
	end if
	close(unit=39)
 999	return1
	end 
c////////////////////////////////////////////////////////////////
c  subroutine to compare aperture size from two different .phm
c    files.  Only those objects with different aperture sizes
c     are compared.
c   
c   ipar=0: assume objects are all numbered the same way
c   ipar=1: phm files have different number of objects/obj numbers
c
	subroutine compaper(*,nfr,ipar)
	parameter (nmax=5000)
	INTEGER icl(5000,2),iref(100),id(1000)
	dimension rad(5000,2),rmag(5000),c2(5000),ib(4),ie(4)
	character posname*20,phmname*20,refstr*4,fixstr(100)*20
	include 'objcat.inc'
	include 'ppparm.inc'
	include 'picdir.inc'
	include 'tvparm.inc'
	CALL QUERYNFR(NFR,nposfil+1,0,*999,*20001)
20001	IF (NFR.GT.nposfil) THEN
	  write(6,12) nposfil+1
 12	format('  +++ no position file on frame # >=',i2)
	  RETURN1
	END IF
	if (display.eq.'ds') then
	  write(6,*) '  ++ this command does not work for ds, use sao'
	else if (display.eq.'sao'.or.display.eq.'ds9') then
	  call makecooname(saoregname,'reg',nfr,posname)
	  write(6,13) posname
 13	format('  ... aperture file name: ',a20)
	else
	  write(6,*) '  ++ invalid display platform ++ ',display
	end if
c request .phm files and read positions and compute diameters
 600	write(6,20)
 20	format('  Enter first .phm name (++posfil array will',
     *         ' be over-written++): ',$)
	read(5,'(a20)',end=999) phmname
c add .phm if it does not end in "B"
	if (phmname(lnblnk(phmname):lnblnk(phmname)).ne.'B') 
     *     phmname=phmname(1:lnblnk(phmname))//'.phm'
	open(unit=34,file=phmname,status='old',err=601)
	go to 150
 601	  write(6,1) phmname
 1	format('  +++ ',a20,' does not exist ++++')
	  go to 600
 150    call readrad(34,nob(nfr),ijoi(1,nfr),ijoj(1,nfr),
     *     rad(1,1),rmag,err,c2,icl(1,1),1,ideld,nref,iref,nmax,icflag)
	close(unit=34)
	nob1=nob(nfr)
 602	write(6,21)
 21	format('  Enter second .phm name: ',$)
	read(5,'(a20)',end=999) phmname
c add .phm if it does not end in "B"
	if (phmname(lnblnk(phmname):lnblnk(phmname)).ne.'B') 
     *     phmname=phmname(1:lnblnk(phmname))//'.phm'
	open(unit=34,file=phmname,status='old',err=603)
	go to 151
 603	  write(6,1) phmname
	  go to 602
 151    call readrad(34,nob(nfr),ijoi(1,nfr),ijoj(1,nfr),
     *     rad(1,2),rmag,err,c2,icl(1,2),1,ideld,nref,iref,nmax,icflag)
	close(unit=34)
	if (nob1.ne.nob(nfr))  write(6,27) nob1,nob(nfr)
 27	format('  **** comparison will not work, different numbers of'
     *   ,' objects (',2i6,') in phm files')
c  read in fix file, if exists
 604	write(6,22)
 22	format('  Enter hdr fixing file name, df=hdr.fix, n=none: ',$)
	read(5,'(a20)',end=999) phmname
	if (phmname.ne.'n') then
	  if (phmname.eq.' ') phmname='hdr.fix'
	  open(unit=34,file=phmname,status='old',err=604)
	  read(34,'(1x)')
	  ifor=1
	  do 110 i=1,100
	    read(34,'(a20)',end=108) fixstr(i)
c  sense if it is a old fix or new fix file 
	    call fstr(fixstr(i),20,ib,ie,nc)
	    if (nc.eq.4) ifor=0
 110	  continue
 108	  nfix=i-1
	  write(6,*) '  ....# of hdr fixes: ',nfix
	  close(unit=34)
	else 
	  nfix=0
	end if
c compare radii to find ones that have changed
	ndif=0
	do 120 i=1,nob(nfr)
	  if (abs(rad(i,1)-rad(i,2)).gt.0.5) then
	    ndif=ndif+1
	    id(ndif)=i
	    if (ndif.ge.1000) then
	      write(6,*) '  ++ max array size for dif reached (1000)'
	      goto 121
	    end if
	  end if
 120	continue
c make saoimage reg file
 121	call opennew(39,2,18,posname,*999)
	if (display.eq.'ds') then
	  write(6,*) '  ++ this command does not work for ds, use sao'
	else if (display.eq.'sao'.or.display.eq.'ds9') then
	  call fixsaocor(delx,dely,iorient,nii(nfr),njj(nfr))
	  if (iorient.eq.0) then
	    idel=8
	  else
	    idel=-8
	  end if
c write 3 dummy lines
	  write(6,29) posname
 29	format(' Aperture file name: ',a20/
     *  ' .. Second file: with crosses, fix.hdr: yellow ..')
	  do 111 k=1,3
	    write(39,41) 
 41	format('# aperture file for comparison ',a20)
 111	  continue
  	  do 112 j=1,ndif
	    i=id(j)
	    do 113 m=1,2
	      if (icl(i,m).ge.3.or.icl(i,m).le.0) then
c  stars or class 0
	        write(39,42) float(ijoi(i,nfr))-delx,
     *           float(ijoj(i,nfr))-dely,2.*rad(i,m),2.*rad(i,m)
 42	format('-BOX(',f6.0,',',f6.0,',',f6.1,',',f6.1,')')
	      else
	        write(39,43) float(ijoi(i,nfr))-delx,
     *                    float(ijoj(i,nfr))-dely,rad(i,m)
 43	format('-CIRCLE(',f6.0,',',f6.0,',',f6.1,')')
	      end if
c  write out two boxes of having one size zero (a cross) for 2
	      if (m.eq.2) then
	        write(39,42) float(ijoi(i,nfr))-delx,
     *               float(ijoj(i,nfr))-dely,0.0,2.*rad(i,m)
	        write(39,42) float(ijoi(i,nfr))-delx,
     *               float(ijoj(i,nfr))-dely,2.*rad(i,m),0.0
c  write out object numbers 
 	        istatus=encode(refstr,float(i),1,0,idum)
	        write(39,87) ijoi(i,nfr)-idel,
     *                    ijoj(i,nfr)-idel,refstr
 87	format('-TEXT(',i5,',',i5,', 4,"',a4,'")')
	      end if
 113	    continue
 112	  continue
	  call whdrfix(nfr,nfix,fixstr,ifor,delx,dely,ideld)
	end if
	close(unit=39)
 999	return1
	end 
c//////////////////////////////////////////////////////////
c  subroutine to write out hdr.fix file to saoimage.reg file
c
	subroutine whdrfix(nfr,nfix,fixstr,ifor,delx,dely,ideld)
	character fixstr(nfix)*20,refstr*4
	dimension ib(4),ie(4)
	include 'objcat.inc'
c  write out fixed file
	  do 114 i=1,nfix
	    call fstr(fixstr(i),20,ib,ie,nc)
	    read(fixstr(i)(ib(1):ie(1)),*) num
	    aper=0.
	    if (ifor.eq.1) then
	      read(fixstr(i)(ib(2):ie(2)),*) iclass
	      if (nc.eq.3)  read(fixstr(i)(ib(3):ie(3)),*) aper
	    else
	      read(fixstr(i)(ib(3):ie(3)),*) iclass
	      if (nc.eq.4) read(fixstr(i)(ib(4):ie(4)),*) aper
	    end if
	    iaper=aper
	    write(6,88)i, num,iclass, iaper
 88	    format (i3,i6,i3,i3)
	    if (iaper.eq.0) then
c  put down arrow
	      if (iclass.eq.1) then
	        write(39,30) float(ijoi(num,nfr))-delx,
     *           float(ijoj(num,nfr))-dely
 30	format(' ARROW(',f6.0,',',f6.0,',30.0,0.0)')
	      else
	        write(39,31) float(ijoi(num,nfr))-delx,
     *           float(ijoj(num,nfr))-dely
 31	format('-ARROW(',f6.0,',',f6.0,',30.0,0.0)')
	      end if
	    else
c  **note that iap1 is fixed at 3
	      radt=(3+ideld*(iaper-1))*.5
	      if (iclass.ge.3.or.iclass.le.0) then
c  stars or class 0
	        write(39,32) float(ijoi(num,nfr))-delx,
     *           float(ijoj(num,nfr))-dely,2.*radt,2.*radt
 32	format(' BOX(',f6.0,',',f6.0,',',f6.1,',',f6.1,')')
	      else
	        write(39,33) float(ijoi(num,nfr))-delx,
     *                    float(ijoj(num,nfr))-dely,radt
 33	format(' CIRCLE(',f6.0,',',f6.0,',',f6.1,')')
	      end if
	    end if
c  write object number
 	    istatus=encode(refstr,float(num),1,0,idum)
	    write(39,87) ijoi(num,nfr)+8,
     *                    ijoj(num,nfr)+8,refstr
 87	format('-TEXT(',i5,',',i5,', 4,"',a4,'")')
 114	  continue
	return
	end
c///////////////////////////////////////////
c  subroutine to read .phm file
c     ipar=1: normal read, rad() is the radius in pixels
c     ipar=0: rad() is used to store scaled magnitude values
c                     for plot size
c
	subroutine readrad(idev,nob,ii,jj,rad,rmag,err,c2,icl,
     *         ipar,ideldt,nref,iref,nmax,icflag)
	character teststr*2,teststr2*3,string*80
	integer ii(*),jj(*),icl(*),iref(*)
	dimension rad(*),rmag(*),err(*),c2(*)
	if (ipar.eq.0)write(6,*)' 1 mag difference = 4 pixels'
c   read first line, including ref star numbers
	read(idev,1) (iref(k),k=1,7)
 1	format(68x,7i4)
	nref=0
	do 130 k=1,7
	  if (iref(k).le.0) goto 131
	  nref=nref+1
 130	continue
c read aperture info
 131	READ(idev,9,ERR=998) IAP1,IAP2,ideld,SIZ1,SIZ2
 9	FORMAT(27X,I2,13X,I3,1x,i1,7X,F4.0,1X,F4.0)
 	if (ideld.eq.0)  then
	  write(6,*) ' ++ ideld from ppparm.dat used ++ '
	  ideld=ideldt
	end if
        NAP=(IAP2-IAP1)/ideld+1
	nline=(nap-1)/10+1
c determine how many lines there are in the growth curve
	write(6,10) IAP1,IAP2,ideld, NAP,nline
 10	format(' 1st aper ',i3,'; last aper ',i3,', deld:',i2,
     *     '; max aperture number:',i3, ' #line:',i2)
c read additional reference stars if there are any
 199    read(idev,'(1x,3a)',end=998) teststr2
        backspace idev
        if (teststr2.eq.'Ref') then
	  k1=nref+1
	  read(idev,2,err=199) (iref(k),k=k1,k1+9)
 2	format(36x,10i5)
	  do 132 k=k1,k1+9
	    if (iref(k).le.0) goto 199
	    nref=nref+1
 132	  continue
	  go to 199
        end if
c read section info
	do 200 i=1,5
	  read(idev,'(a80)') string
	  if (string(1:1).eq.'#') then
c  it is an additional header line
c    *** need to read the section info
	  else
            backspace idev
	    goto 201
	  end if
 200	continue
 201	if (ipar.eq.1) then
c read data, need I and J, and ids
	do 100 i=1,nmax  
          READ(idev,11,END=999,ERR=998) RI,RJ,rmag(i),err(i),
     *            c2(i),icl(i)
 11     FORMAT(5X,2(F6.2,1X),7x,f7.2,7x,f7.2,56x,f6.2,i2)
	  ii(i)=nint(ri)
	  jj(i)=nint(rj)
	  if (icflag.eq.0) then
            READ(idev,12,END=999,ERR=998) ids
 12	FORMAT(23X,83x,I2)
	  else
            READ(idev,212,END=999,ERR=998) ids
 212	FORMAT(23X,93x,I2)
	  end if
c check if it is a big galaxy
	  read(idev,13,end=999,err=998) teststr,idum
 13	format(10x,a2,1x,i3)
	  if (teststr.eq.'BG') then
c  read aperture number
	    rad(i)=idum/2
c	write(6,*) '#',i,ii(i),jj(i),idum,irad(i)
	  else
c compute size
	    rad(i)=(iap1+ideld*(ids-1))*.5
	  end if
c	  read(idev,'(1x)',end=999)
c  read one more line
          if (nline.eq.3) read(idev,'(1x)',end=999)
 100	continue
c..................................................
	else
c  read mag and scale it
c   scaling: min = 1, -7=2, goes by 4 each mag
	do 110 i=1,10000
          READ(idev,21,END=999,ERR=998) RI,RJ,rmag(i)
 21     FORMAT(5X,2(F6.2,1X),7x,f7.2)
	  ii(i)=nint(ri)
	  jj(i)=nint(rj)
          READ(idev,12,END=999,ERR=998) ids
	  read(idev,13,end=999,err=998) teststr
c compute size
	  rad(i)=amax1(1.,-(rrm+7.*2.)+4)
	  read(idev,'(1x)',end=999)
c  read one more line
          if (nline.eq.3) read(idev,'(1x)',end=999)
 110	continue
	end if
 999	nob=i-1
	return
 998	write(6,*) ' ** .phm file read error, reading aborted at line'
     *      ,i
	nob=i-1
	return
	end
c////////////////////////////////////////////////////////
c  subroutine to mark with .COO file  specified objects
c
	subroutine locaobj(*,nfr,iobj,kf,ipar)
	integer nnum(50),item(50),jtem(50)
	character cooout*18,nfrstr*2,string*60
	include 'objcat.inc'
	include 'ppparm.inc'
	if (nfr.gt.nposfil) then
	  write(6,*) '  +++ position file for fr#',nfr,' not allowed'
	  nfr=0
	end if
	call querynfr(nfr,kf,0,*999,*2001)
 2001	if (iobj.le.0) then
 601	  write(6,1)
 1	format('  (warning: ++ current .COO file will be erased++)'/
     *     '      Enter object #s to be located (mfo format): ',$)
	  read(5,'(a60)',end=999) string
	  call mfnum(string,60,nnum,50,nlo,0)
	else
	  nlo=1
	  nnum(1)=iobj
	end if
	do 100 i=1,nlo
c get co-ordinate
	  item(i)=ijoi(nnum(i),nfr)
	  jtem(i)=ijoj(nnum(i),nfr)
	  write(6,2) nnum(i),item(i),jtem(j)
 2	format('  Obj#',i5,' @ I:',i5,' J:',i5)
 100	continue
c  clear old .COO file	
	call makecoo(*102,nfr,2)
c output new .COO file
 102	istatus=encode(nfrstr,float(nfr),1,0,idum)
	cooout='ppptemp'//nfrstr(1:lnblnk(nfrstr))//'.COO'
	call opennew(39,2,18,cooout,*999)
	do 218 i=1,nlo
	  write(39,381) item(i),jtem(i)
 218    continue
 381	format(i4,1x,i4)
        close(unit=39)
 999	return1
	end
c////////////////////////////////////////////////////////////////
c   subroutine to display individual objects, with a size 200X200 box
c
	subroutine dispobj(*,nfr,iobj,koldobj,ix,nu,nv,kf,ipar)
	dimension ib(10),ie(10)
	integer ix(nu,nv,kf),iarray(400,400),itemp(7000),jtemp(7000)
	character name*18,headblk*2880,ddodisname*60
     *     ,cstring*120,objnam*35,head*10,headblkt*2880
        CHARACTER NCOM*36,NFILEN*24
        COMMON/DIR/ nof,NCOM(254),NFILEN(254),NFLAG(5,254)
     *              ,NID(254),NJD(254)
	include 'tvparm.inc'
	include 'pppcore.inc'
	include 'picdir.inc'
	include 'objcat.inc'
	include 'ppparm.inc'
	common/header/bzero,bscale,headblk(20),nhb
	equivalence (iscr(1),iarray(1,1))
	if (nfr.gt.nposfil) then
	  write(6,*) '  +++ position file for fr#',nfr,' not allowed'
	  nfr=0
	end if
	head='pppobj'
	call querynfr(nfr,kf,0,*999,*2001)
c compute sky, to be used for all objects
 2001	CALL stripsky(nfr,1,1,nii(nfr),njj(nfr),10,sky,sig,
     *                   0,ix,nu,nv,kf)
c  clear the previous object.fits file
	if (koldobj.ne.0) call chfitsname(name,koldobj,head)
 	ilow=sky-2.5*sig
	iup=sky+dsup*sig
c	write(6,1) dsup,ilow,iup
 1	format(' default lower and upper limits (-2.5, +',f5.1,
     *           ' sig):',2i6)
 600	continue
	if (iobj.le.0) then
 601	  write(6,2) kobj
 2	format('  Enter object number [',i5,']: ',$)
	  call read1i(kobj,*999,*601)
	else
	  kobj=iobj
	end if
	if (kobj.gt.nob(nfr)) then
	  write(6,*) '  +++ object number too large +++ '
	  iobj=0
	  goto 600
	else if (kobj.eq.0) then
	  call chfitsname(name,koldobj,head)
	  return1
	end if
c isize= 1/2 size
	isize=min0(199,10*ior+10)
c temporarily hardwired to sao image display only
	idispar=1
c lower bound
	itr=max0(1,ijoi(kobj,nfr)-isize)
	jtr=max0(1,ijoj(kobj,nfr)-isize)
c upper bound
	ibl=min0(nii(nfr),ijoi(kobj,nfr)+isize)
	jbl=min0(njj(nfr),ijoj(kobj,nfr)+isize)
c  adjustment for objects near edge so that the object is
c   always centered
	if (itr.eq.1) then
	  ibl=2*ijoi(kobj,nfr)+1
	else if (ibl.eq.nii(nfr)) then
	  itr=2*ijoi(kobj,nfr)-nii(nfr)
	end if
	if (jtr.eq.1) then
	  jbl=2*ijoj(kobj,nfr)+1
	else if (jbl.eq.njj(nfr)) then
	  jtr=2*ijoj(kobj,nfr)-njj(nfr)
	end if
c set up small array
	n=0
	do 100 j=jtr,jbl
	  n=n+1
	  m=0
	  do 100 i=itr,ibl
	    m=m+1
	    iarray(m,n)=ix(i,j,nfr)
 100	continue
	js=jbl-jtr+1
	is=ibl-itr+1
c
c display object
	write(6,10) kobj,ijoi(kobj,nfr),ijoj(kobj,nfr),js,is
 10	format('  ...object #',i5,' @I/x:',i5,' J/y:',i5,
     *     '     (size:',2i4,')')
c make a temporary position file
	iis=is/2+1
	jjs=js/2+1
c	do 160 i=1,nob(nfr)
c	  itemp(i)=ijoi(i,nfr)-ijoi(kobj,nfr)-itr+1
c	  jtemp(i)=ijoj(i,nfr)-ijoj(kobj,nfr)-jtr+1
c	  if (itemp(i).gt.is.and.jtemp(i).gt.js) go to 161
c 160	continue
 161	ntemp=i-1
c  write out a temporary fits file
c   first check if an old one exist
	call chfitsname(name,kobj,head)
c   write temporary fitsfile..
	open(unit=20,file=name,status='new',access='direct',
     *	         recl=2880,err=9001)
	objnam=' cutout image '//
     *         nfilen(nf(nfr))(1:lnblnk(nfilen(nf(nfr))))
	call makefhd1(is,js,objnam,headblkt,bzero,bscale)
	ihb=1
	write(20,rec=1) headblkt
	call fitsdataout(20,ihb,iarray(1,1),400,400,is,js,ibyte,
     *                bscale,bzero)
	close(unit=20)
 150	if (idispar.eq.0) then
	  call dsstring(ilow,iup,icolor,name,0,cstring)
c  setenv name
c	call wdtempos(itemp,jtemp,ntemp,kobj,1)
	  call getenv('PPP_DS',ddodisname)
	  idum=system(ddodisname//cstring//' &')
	else if (idispar.eq.1) then
	  call saostring(ilow,iup,icolor,name,0,is,js,cstring)
c	  write(6,'(a70)') ' saoimage '//cstring
	  idum=system('saoimage '//cstring//' &')
	end if
	if (iobj.eq.0) go to 600
 999	koldobj=kobj
	return1
 9001	write(6,*) ' *** error opening temp file for output ****'
	return1
	end 
c////////////////////////////////////////////////////////////////
c   subroutine to display individual spectrum based on axf input
c
	subroutine dispspec(*,nfr,ix,nu,nv,kf,ipar)
	dimension xm(200),ym(200),rmagm(200),xright(200),xleft(200)
     *        ,ib(10),ie(10)
	integer ix(nu,nv,kf),iarray(200,1200)
	character name*18,headblk*2880,ddodisname*60
     *     ,cstring*120,objnam*35,head*10
	include 'pppcore.inc'
	include 'picdir.inc'
	include 'ppparm.inc'
	include 'tvparm.inc'
	common/header/bzero,bscale,headblk(20),nhb
	equivalence (iscr(1),iarray(1,1))
	call querynfr(nfr,kf,0,*999,*2001)
 2001   call readaxf(nslit,xm,ym,xright,xleft,
     *      rmagm,sshift,speclen)
 6001	write(6,8) xshift
 8	format('  Enter x shift [',f7.1,']: ',$)
	call read1r(xshift,*999,*6001)
	speclen2=amin1(600.,speclen*.5)
c compute sky, to be used for all spectra
	CALL stripsky(nfr,1,1,nii(nfr),njj(nfr),10,sky,sig,
     *                   0,ix,nu,nv,kf)
 	ilow=sky-2.5*sig
	iup=sky+dsup*sig
 	write(6,1) dsup,ilow,iup
 1	format(' default lower and upper limits (-2.5, +',f5.1,
     *           ' sig):',2i6)
	head='mospec'
 600	write (6,2)
 2	format('  Enter spectrum number (0=q, -''ve=new fr): ',$)
	call read1i(isp,*999,*600)
c  determine section of spectrum:
	if (isp.gt.nslit) then
	  write(6,*) '  +++ spectrum number too large +++ '
	  goto 600
	else if (isp.eq.0) then
	  call chfitsname(name,ispp,head)
	  return1
	else if (isp.lt.0) then
	  nfr=iabs(isp)
	  call querynfr(nfr,kf,0,*999,*2002)
 2002	  write(6,*) '  ... displaying spectra from frame',nfr
	  go to 600
	end if
	size=(xleft(isp)-xright(isp))*.5+20
	itr=max0(1,nint(xm(isp)-size+xshift))
	jtr=max0(1,nint(ym(isp)+sshift-speclen2-30))
	ibl=min0(nii(nfr),nint(xm(isp)+size+xshift))
	jbl=min0(njj(nfr),nint(ym(isp)+sshift+speclen2+30))
	if (ibl-itr+1.gt.200) then
	  ihalf=(ibl-itr-200)/2
	  itr=itr+ihalf
	  ibl=ibl-ihalf
	end if
	if (jbl-jtr+1.gt.1200) then
	  ihalf=(jbl-jtr-1200)/2
	  jtr=jtr+ihalf
	  jbl=jbl-ihalf
	end if
c set up small array
	n=0
	do 100 j=jtr,jbl
	  n=n+1
	  m=0
	  do 100 i=itr,ibl
	    m=m+1
	    iarray(m,n)=ix(i,j,nfr)
 100	continue
	js=jbl-jtr+1
	is=ibl-itr+1
c
c display spectrum
	write(6,10) isp,xm(isp),ym(isp),rmagm(isp)
 10	format('  ... spectrum #',i3,' @ I/x:',f8.2,' J/y:',f8.2,
     *              f6.2,' mag')
c  write out a temporary fits file
c   first check if an old one exist
	call chfitsname(name,ispp,head)
	call chfitsname(name,isp,head)
c   write temporary fitsfile..
	open(unit=20,file=name,status='new',access='direct',
     *	         recl=2880,err=9001)
	objnam=' temporary file'
	call makefhd(nfr,is,js,0,objnam)
	ihb=1
	write(20,rec=1) headblk(ihb)
	call fitsdataout(20,ihb,iarray(1,1),200,1200,is,js,ibyte,
     *                bscale,bzero)
 150	call dsstring(ilow,iup,icolor,name,0,cstring)
199	format(a70)
c  setenv name
	call getenv('PPP_DS',ddodisname)
	idum=system(ddodisname
     *    //cstring//' &')
	ispp=isp
	go to 600
 999	call chfitsname(name,ispp,head)
	return1
 9001	write(6,*) ' *** error opening temp file for output ****'
	return1
	end 
c//////////////////////////////////////
c  subroutine to create a fits file name and also
c    delete exisiting any fits image with the same name
c
	subroutine chfitsname(name,inum,head)
	character name*18,numstr*4,head*10
	logical ex
	istatus=encode(numstr,float(inum),1,0,idum) 
	name=head(1:lnblnk(head))//numstr(1:lnblnk(numstr))//
     *            '.fits'
	inquire(file=name,exist=ex)
	if (ex.eqv..true.) then
c  delete temporary file if there is already one
	  open(unit=41,file=name,status='old',err=999)
	  close(unit=41,status='delete')
	end if
 999	return
	end

c////////////////////////////////////////////////////
c  subroutine to create a region file to make marks of existing
c   objects in saoimage
c    ipar=1  objects are marked with red boxes, with idob=1 objects with
c         smaller circles
c    ipar=0 same as 1 but no output
c    ipar=2 objects are marked with numbers
c  
c  May 28 2001: ipar=-1, same as 1, but out put a fixed range
	subroutine saocoo(*,nfr,ipart)
	character filename*20,refstr*4,strl*1,formstr*80
	include 'objcat.inc'
	include 'ppparm.inc'
	include 'picdir.inc'
	include 'tvparm.inc'
	ipar=abs(ipart)
	call querynfr(nfr,nposfil+1,0,*999,*2001)
 2001	call makecooname(saoregname,'reg',nfr,filename)
	if (ipart.eq.-1) then
 600	  write(6,25) ifirst,ilast
 25	format('  Enter object number range [',2i6,']: ',$)
	  call read2i(ifirst,ilast,*999,*600)
	  ifirst=max0(1,ifirst)
	  ilast=min0(nob(nfr),ilast)
	else
	  ifirst=1
	  ilast=nob(nfr)
	end if
 	call opennew(32,1,20,filename,*999)
	write(32,1) pcomment(nfr)
 1	format('# sao region file for: '/'# ...',a60/
     *     '# type  x y (circle=afin, box=hand edited)')
	write(6,10) filename
 10	format(' ... posfil written out as: ',a20)
c out put grid, grid size=500X310
	ngy=0.5*njj(nfr)
	ngx=0
	ngridy=0
	do 110 i=1,20
	  ngridy=ngridy+1
	  if (ngx.gt.nii(nfr)) goto 111
	  if (iorient.eq.0) then
	    ngx=ngx+310
c  grid line
	    write(32,21) ngx,ngy,njj(nfr)
	  else
	    ngx=ngx+500
	    write(32,20) ngx,ngy,njj(nfr)
	  end if
 20	format(' BOX(',i5,',',i5,', 0,',i5,')')
 21	format(' BOX(',i5,',',i5,',',i5,', 0)')
 110	continue
 111	ngx=0.5*nii(nfr)
	ngy=0
	ngridx=0
	do 112 i=1,20
	  ngridx=ngridx+1
	  if (ngy.gt.njj(nfr)) goto 113
	  if (iorient.eq.0) then
	    ngy=ngy+500
	    write(32,20) ngx,ngy,nii(nfr)
	  else
	    ngy=ngy+310
	    write(32,21) ngx,ngy,nii(nfr)
	  end if
 112	continue
 113	nlen=7  
c grid centers (long box)
	if (iorient.eq.0) then
	  ngx=-310/2
	  do 114 i=1,ngridx
	    ngx=ngx+310
	    ngy=-500/2
	    do 115 j=1,ngridy
	      ngy=ngy+500
	      write(32,20) ngx,ngy,nlen    
	      write(32,21) ngx,ngy,nlen    
 115	    continue
 114	  continue
	else if (iorient.eq.1) then
	  ngx=-500/2
	  do 116 i=1,ngridx
	    ngx=ngx+500
	    ngy=-310/2
	    do 117 j=1,ngridy
	      ngy=ngy+310
	      write(32,21) ngx,ngy,nlen    
	      write(32,20) ngx,ngy,nlen    
 117	    continue
 116	  continue
	end if
c   set delta to correct for sao bug
	call fixsaocor(delpx,delpy,iorient,nii(nfr),njj(nfr))
c write objects
	if (ipar.le.1) then
	  ireadsaoreg=0
	  do 100 i=ifirst,ilast
	    xt=ijoi(i,nfr)-delpx
	    yt=ijoj(i,nfr)-delpy
	    if (idob(i,nfr).eq.0) then
	      write(32,2) xt,yt,float(iir)*.5,float(iir)*.5
 2	format('-BOX(',f7.1,',',f7.1,',',f5.1,',',f5.1,')')
	    else
	      write(32,2) xt,yt,float(iir)*.3,float(iir)*.3
	    end if
 100	  continue
	else
c write objects with numbers
c	  do 101 i=1,nob(nfr)
	  do 101 i=ifirst,ilast
	    istatus=encode(refstr,float(i),1,0,idum)
	    istatus=encode(strl,float(lnblnk(refstr)),1,0,idum)
	    if (iorient.eq.0) then
	      idel=5
	    else
	      idel=-5
	    end if
	    if (idob(i,nfr).eq.0) then
	      formstr='('' TEXT('',i5,'','',i5,'','//strl//
     *            ' ,"'',a'//strl//',''")'')'
c	      write(32,3) ijoi(i,nfr)-idel,ijoj(i,nfr)-idel,refstr
c3	format(' TEXT(',i5,',',i5,', 4,"',a4,'")')
	    else
	      formstr='(''-TEXT('',i5,'','',i5,'','//strl//
     *            ' ,"'',a'//strl//',''")'')'
c	      write(32,4) ijoi(i,nfr)-idel,ijoj(i,nfr)-idel,refstr
c4	format('-TEXT(',i5,',',i5,',',f5.1,',',f5.1,')')
	    end if
 	    write(32,formstr) ijoi(i,nfr)-idel,ijoj(i,nfr)-idel,refstr
 101	  continue
	end if
	if (ipar.ge.0) then
	  if (ipar.eq.1) then
	    write(6,5)
 5	format('  SAO image posfil display: BOX=original objects,'
     *    /'    add obj: CIRCLE(e); delete obj: CIRCLE(s) or d')
	  end if
	  close(unit=32)
	end if
 999	continue
	return1
	end

c//////////////////////////////////////////////////////////////
c  subroutine to fix sao co-ordinate bug
c         for rotated image: if y=odd, (1,1)=(.5,1.5)
c                               x=odd  (1,1)=(1.5,.5)
c         all other cases (including x and y size both odd, 1,1=1,1
	subroutine fixsaocor(delpx,delpy,iorient,ni,nj)
	delpx=0.
	delpy=0.
	if (iorient.eq.0) then
	  if (mod(ni,2).eq.1.and.mod(nj,2).eq.0) then
	    delpx=1.5
	    delpy=.5
	  else if (mod(ni,2).eq.0.and.mod(nj,2).eq.1) then
	    delpx=.5
	    delpy=1.5
	  end if
	end if
	return
	end
c////////////////////////////////////////////////////
c  subroutine to edit position file based on sao image region
c      file out put.
c        BOXes (of different sizes) are ignored (as originalobjects),
c         +CIR +POINTS +ELLIPSES are objects to be deleted and
c         also objects can be deleted by "d"
c         -CIR -POINTS -ELLIPSES are objects to be added
c         positions marked as box or points will be searched for local max
c                          as ellipses will be used as is
c    
c     The complete position files are read (ie +circle will be used
c                   to re-create the original catalog)
c      the position file is updated and a new sao region file is
c           produced automatically
	subroutine saoposf(*,nfr,ix,nu,nv,kf,ipar)
	integer ix(nu,nv,kf)
	character string*40,numstring*30,filename*20,bcstr(100)*2,
     *             bcnumstr(100)*30
	include 'objcat.inc'
	include 'ppparm.inc'
	include 'tvparm.inc'
	include 'picdir.inc'
	call querynfr(nfr,nposfil+1,0,*999,*2001)
2001	if (nfr.gt.nposfil) then
	  write(6,*) '  no pos file allow for frame ',nfr
	  goto 999
	end if
	call makecooname(saoregname,'reg',nfr,filename)
	open(unit=30,file=filename,status='old',err=900)
c  read dummies
	do 100 i=1,3
	  read(30,*,end=998)
 100	continue
c read co-ordinates
	iadd=0
	idel=0
	inodel=0
	iadu=nint(adusat) 
	smallrad=float(iir)*.4
	noborig=nob(nfr)
	nob(nfr)=0
	call fixsaocor(delpx,delpy,iorient,nii(nfr),njj(nfr))
	nbc=0
	do 101 i=1,100000
	  read(30,'(a40)',end=120) string
c check for header lines
	  if (string(1:1).eq.'#') goto 101
c read co-ord
	  call saonumst(string,numstring)
c  to reconstruct original posfil
	  if (string(1:4).eq.'-BOX') then
c read the radius also
	    read(numstring,*,err=901,end=901) xp,yp,rad
	    nob(nfr)=nob(nfr)+1
	    if (rad.gt.smallrad) then
	      idob(nob(nfr),nfr)=0
	    else 
	      idob(nob(nfr),nfr)=1
	    end if
	    ijoi(nob(nfr),nfr)=nint(xp+delpx)
	    ijoj(nob(nfr),nfr)=nint(yp+delpy)
c  added Dec 24 1999, arrows: delete all objects within the arrow
	  else if (string(3:5).eq.'ARR') then
	    nbc=nbc+1
	    if (nbc.gt.100) then
	      write(6,*)
     *          ' ***  Too many bad columns (max=100), rest not done' 
	      goto 101
	    end if
	    bcstr(nbc)=string(2:3)
	    bcnumstr(nbc)=numstring
	  else
	    read(numstring,*,err=901,end=901) xp,yp
	    ixp=nint(xp+delpx)
	    iyp=nint(yp+delpy)
	    if (string(2:3).eq.'EL') call 
     *        localmax(ix(1,1,nfr),nu,nv,nii(nfr),njj(nfr),ixp,iyp,2)
c check box type
	    if (string(1:3).eq.'-PO'.or.string(1:3).eq.'-EL'.or.
     *        string(1:3).eq.'-CI') then
c add obj
	      if (ixp.le.0.or.iyp.lt.0) then
	        write(6,1) ixp,iyp
 1	format('  +++ warning, negative co-ordinate at',2I7,
     *        ' object not added +++')
	        go to 101
	      end if
	      nob(nfr)=nob(nfr)+1
	      ijoi(nob(nfr),nfr)=ixp
	      ijoj(nob(nfr),nfr)=iyp
	      idob(nob(nfr),nfr)=1
	      iadd=iadd+1
	    else if (string(1:3).eq.' PO'.or.string(i:3).eq.' EL'.or.
     *             string(1:3).eq.' CI') then
c delete obj
	      call zapobj(nfr,ixp,iyp,iact,jact,ide)
	      if (ide.eq.1) then
c	        idel=idel+1
	      else
	        inodel=inodel+1
	        write(6,2) inodel,ixp,iyp
 2	format(' ',i3,': marked for delete @',2i5,' + no obj found +')
	      end if
	    end if
	  end if
 101	continue
 120	call deline(nfr,bcstr,bcnumstr,nbc,ideld,iadu,nbcdel,ix(1,1,nfr)
     *             ,nu,nv,delpx,delpy)
    	idel=noborig-nob(nfr)+iadd
	write(6,3) iadd,idel,nbcdel,inodel,nob(nfr)
 3	format(' .. Total of',i4,' objs added;   ',i5,
     *         ' objs deleted of which',i6,' from bad lines'/'       '
     *      ,i4,' position marked for deletion with no objs found'/
     *    '    New total number of objects:',i6,/
     *   '  ---  pos file rearranged ordered in j, .reg NOT upated.')
	close(unit=30)
	call arranpos(nob(nfr),ijoi(1,nfr),ijoj(1,nfr),idob(1,nfr))
c	call saocoo(*121,nfr,0)
 121	ireadsaoreg=1
 999	return1
 900	write(6,4) filename
 4	format(' ** ',a20,' file does not exist')
	return1
 901	write(6,*) ' *** .reg input format error ***'
	goto 902
 998    write(6,*) ' *** empty .reg file, no pos update done '
 902	close(unit=30)
	return1
	end
c///////////////////////////////////////////////////////
c  subroutine to delete a line of objects definted by a SAO arrow
c
c     yellow arrow (# ARROW): leave saturated object in center untouched
c     read   arrow (#-ARROW): delete everything
c     IWID                  : total width in pixel of the swath
	subroutine deline(nfr,strhd,numstr,nbc,iwd,iadu,ndel,
     *       ix,nu,nv,delpx,delpy)
	character strhd(nbc)*2,numstr(nbc)*30
	dimension bcx1(100),bcx2(100),bcy1(100),bcy2(100),slope(100)
	integer ix(nu,nv),nx1(100),nx2(100),ny1(100),ny2(100)
	include 'objcat.inc'
c make an array of the arrow data
    	wid=iwd
	do 100 i=1,nbc
	  read(numstr(i),*,end=999,err=112) bcx1(i),bcy1(i),rlen,
     *           dum,angle 
c  determine the end point
	  bcx1(i)=bcx1(i)+delpx
	  bcy1(i)=bcy1(i)+delpy
	  bcx2(i)=bcx1(i)-rlen*sin(angle/57.2958)
	  bcy2(i)=bcy1(i)+rlen*cos(angle/57.2958)
c sort the co-ordinate so that x1 is always smaller than x2
	  if (bcx1(i).gt.bcx2(i)) then
	    call switchord(bcx1(i),bcx2(i))
	    call switchord(bcy1(i),bcy2(i))
	  end if
	  nx1(i)=nint(bcx1(i)-iwd)
	  nx2(i)=nint(bcx2(i)+iwd)
	  ny1(i)=nint(bcy1(i))
	  ny2(i)=nint(bcy2(i))
	  if (abs(bcx2(i)-bcx1(i)).gt.2.) then
	    slope(i)=(bcy2(i)-bcy1(i))/(bcx2(i)-bcx1(i))
	  else
	    slope(i)=1000.
	  end if
	  write(6,90) strhd(i),numstr(i),nx1(i),ny1(i),nx2(i),
     *         ny2(i),slope(i)
 90	format(a2,1x,a30,4i5,f9.3)
	  goto 100
 112	  write(6,*) '  +++ read error ARROW entry ',i
 100	continue
	ndel=0
c search for objects in the marked areas
	do 101 i=1,nob(nfr)
	  do 102 k=1,nbc
	    if (ijoi(i,nfr).ge.nx1(k).and.ijoi(i,nfr).le.nx2(k)) then
	      if (ijoj(i,nfr).ge.min0(ny1(k),ny2(k)).and.
     *              ijoj(i,nfr).le.max0(ny1(k),ny2(k))) then
c the object is within a box, now see if it is within the bad area
c  given x compute its y, and see if the real y is with 1/2 wid
c    if so, the object is deleted (by saving its obj number)
	        if (abs(slope(k)).lt.100.) then
	          ypred=(float(ijoi(i,nfr))-bcx1(k))*slope(k)+bcy1(k)
	          ybig=ypred+wid
	          ysmall=ypred-wid
	        else
	          ybig=amax1(bcy1(k),bcy2(k))
	          ysmall=amin1(bcy1(k),bcy2(k))
	        end if
	        if (float(ijoj(i,nfr)).gt.ysmall.and.
     *                 float(ijoj(i,nfr)).lt.ybig) then
	          if (ndel.ge.2000) then
	            write(6,*) 
     *                '  ***bad column delete array overflow 2000 **'
	              goto 120
	          end if
	          if (strhd(k).eq.' A') then
c  check if the object is saturated
	            if (ix(ijoi(i,nfr),ijoj(i,nfr)).ge.iadu) goto 101
	          end if
	          ndel=ndel+1
	          idob(i,nfr)=-999
	          goto 101
	        end if
	      end if
	    end if
 102	  continue
 101	continue
c now change pos file
 120	nobold=nob(nfr)
	nob(nfr)=nob(nfr)-ndel
	do 105 i=1,nob(nfr)
	  if (idob(i,nfr).eq.-999) then
	    do 106 k=i,nobold-1
	      ijoi(k,nfr)=ijoi(k+1,(nfr))
	      ijoj(k,nfr)=ijoj(k+1,(nfr))
	      idob(k,nfr)=idob(k+1,(nfr))
 106	    continue
	  end if
 105	continue
 999	return
	end
c//////////////////////////////////////////////////////
c
C subroutine to  check for neighboring pixels for largest value
	subroutine localmax(ix,nu,nv,nii,njj,iin,jin,irad)
	integer ix(nu,nv)
        iout=iin
        jout=jin
        DO 140 M=MAX0(1,jin-irad),MIN0(njj,jin+irad)
          DO 141 L=MAX0(1,iin-irad),MIN0(nii,iin+irad)
              IF (IX(L,M).GT.IX(iout,jout)) THEN
                iout=L
                jout=M
              END IF
 141	  continue
 140    CONTINUE
	iin=iout
	jin=jout
	return
	end
c/////////////////////////////////////////////
c  subroutine to create a bpfi macro from saoimage.reg box input
c      it creates 2 files: saocrbp1.macro and saocrbp2.macro
c       ipar=0 from box and -box
c       ipar=1 from point and -point
	subroutine saocrbp(*,nfr,iorient,ipar)
	integer ix1,iy1,ix2,iy2
	character inname*20,tempname*20,filout1*16,filout2*16,
     *     string1*40,string2*40,comment*60
	include 'picdir.inc'
c input file name
c	if (tempname.ne.' ') then
c	  inname=tempname
c	else
	  inname='saoimage.reg'
c	end if
	tempname=' '
 600	write(6,1) inname
 1	format('  Enter sao region file name [',a20,']: ',$)
	read(5,'(a20)',end=999) tempname
	if (tempname.ne.' ') inname=tempname
	open(unit=25,file=inname,status='old',err=600)
c read size etc
 601	write(6,2) nfrout
 2	format('  Enter frame # for creating badpix map [',i2,']: ',$)
	call read1i(nfrout,*601,*999)
	if (nfr.gt.0) then
	  if (nii(nfr).eq.0) then
 602	    write(6,3) nti,ntj
 3	format('  No size associated, enter I,J size [',2i5,']: ',$)
	    call read2i(nti,ntj,*602,*999)
	  else
	    write(6,4) nii(nfr),njj(nfr)
 4	format(' ... size assumed to be ',2i5)
	    nti=nii(nfr)
	    ntj=njj(nfr)
	  end if
	else
 603      write(6,5) nti,ntj
 5      format('  Enter I,J size [',2i5,']: ',$)
          call read2i(nti,ntj,*6021,*999)
 	  goto 6022
 6021	  write(6,3) nti,ntj
	  call read2i(nti,ntj,*6021,*999)
 6022	  continue
	end if
	iopen1=0
	iopen2=0
c  read comment lines
	do 100 m=1,10
	  read(25,'(a40)') string1
	  if (string1(1:1).ne.'#') then
	    backspace 25
	    goto 101
	  end if
 100	continue
c read data
 101	continue
	filout1='saocrbp1.macro'
	filout2='saocrbp2.macro'
	if (ipar.eq.0) then
	  read(25,'(a40)',end=111) string1
	  call rdcoobox(string1,ix1,iy1,ix2,iy2,iorient,nii(nfr),
     *       njj(nfr),*998)
	else
	  read(25,'(a40)',end=111) string1
	  read(25,'(a40)',end=111) string2
	  call rdcoopt(string1,string2,ix1,iy1,ix2,iy2,iorient,
     *       nii(nfr),njj(nfr),*998)
	end if
c check if it is a + or - box
	if (string1(1:1).eq.'-') then
	  isave=32
	  if (iopen2.eq.0) then
	    call opennew(32,1,16,filout2,*999)
	    write(6,21)
 21	format('  Enter comment for saocrbp2.macro (red marks): ',$)
	    read(5,'(60a)',end=999) comment
	    iopen2=1
c write header
	    write(isave,10) comment,nfrout,nti,ntj
 10 	format('# ',a60,/' crbp '/i2/' ',2i5)
	  end if
	else
	  isave=31
	  if (iopen1.eq.0) then
	    call opennew(31,1,16,filout1,*999)
	    write(6,22)
 22	format('  Enter comment for saocrbp1.macro (yellow marks): ',$)
	    read(5,'(60a)',end=999) comment
	    iopen1=1
	    write(isave,10) comment,nfrout,nti,ntj
	  end if
	end if
c write bad pixel map
	write(isave,11) ix1,iy1,ix2,iy2
 11	format('b',4i5)
	goto 101
 111	close(unit=25)
	if (iopen1.eq.1) then
	  write(31,12)
 12	format(' '/'end')
	  close(unit=31)
	  write(6,*) '  .. badpixel map saved in saocrbp1.macro '
	end if
 	if (iopen2.eq.1) then
	  write(32,12)
	   close(unit=32)
	  write(6,*) '  .. badpixel map saved in saocrbp2.macro '
	end if
 999	return1
 998	write(6,*) '  *** incorrect format ***'
	return1
	end
c/////////////////////////////////////////////////
c  subroutine to read a saoimage.reg file and create a fix file
c     for a hdr file
c       code:   CIRCLE: new aperture size for galaxies
c               BOX   : new aperture size for stars
c               ARROW:    change classification to galaxy
c              -ARROW:    change classification to star
c               POINT:   change classification to  0     
	subroutine fixhdr(*,nfr,ipar)
        character string*40,numstring*30,galstring*5,starstring*5,
     *       zerostring*5,filout*20,filename*20,secstr
	include 'objcat.inc'
	include 'ppparm.inc'
	include 'tvparm.inc'
	include 'picdir.inc'
	include 'apert.inc'
	call querynfr(nfr,nposfil+1,0,*999,*2001)
 2001	if (nob(nfr).eq.0) then
	  write(6,*) '  ** no position file, can''t create hdr,fix'
	  return1
	end if
	call makecooname(saoregname,'reg',nfr,filename)
 	open(unit=30,file=filename,status='old',err=900)
	if (nsct(nfr).ne.0) then
	  istatus=encode(secstr,float(nsct(nfr)),1,0,idum)
	  filout='hdr.fix.'//secstr
	else
	  filout='hdr.fix'
	end if
	write(6,10) filout
 10	format( '  .. hdr fix file is saved as: ',a18)
	call opennew(31,1,20,filout,*999)
c  make class string
 	if (ipar.eq.-1) then
c old mspos format
	  write(6,*) '  ... old .hdr format (use fhdr for new format)'
	  galstring=' 1 1 '
	  starstring=' 1 3 '
	  zerostring=' 1 0 '
	else
	  galstring=' 1 '
	  starstring=' 3 '
	  zerostring=' 0 '
	end if
c  read comment lines
	do 100 m=1,10
	  read(30,'(a40)') string
	  if (string(1:1).ne.'#') then
	    backspace 30
	    goto 101
	  end if
	  if (m.eq.1) write(31,1) string
 1	format('# hdr fix file for ',a40)
 100	continue
c loop for reading data
	iring=0
 101	read(30,'(a40)',end=111) string
	if (string(3:5).eq.'TEX') goto 101
c parse string
	call saonumst(string,numstring)
c read co-ordinate and search for object number
	read(numstring,*,err=301) xc,yc,rad
	goto 302
c  in case where no radius is read
 301	read(numstring,*,err=901) xc,yc
	rad=0.
c  search for object number
 302	call locobj(nint(xc+.5),nint(yc+.5),numppp,2,nob(nfr),
     *       ijoi(1,nfr),ijoj(1,nfr))
	if (numppp.le.0) then
	  if (iring.eq.0) then
	    call rbell(1)
	    iring=1
	  end if
	  write(6,9) xc+.5,yc+.5
 9	format(' +++ position: ',2f7.1,' -- no obj found, not entered')
	  go to 101
	end if
c  changing aperture of galaxies
	if (string(1:4).eq.' BOX'.or.string(1:4).eq.' CIR') then
c  compute aperture number from radius
	  iaper=nint(float(int(2*rad+0.9)-iapmin)/float(ideld))
	  if (string(2:2).eq.'B') then
c  star 
	    write(31,2) numppp,starstring,iaper
 2	format(i5,a5,i3)
	  else
c  galaxy
	    write(31,2) numppp,galstring,iaper
	  end if
	else if (string(3:5).eq.'ARR') then
	  if (string(2:2).eq.'-') then
c  star 
	    write(31,2) numppp,starstring
	  else
c  galaxy
	    write(31,2) numppp,galstring
	  end if
	else if (string(2:4).eq.'POI') then
c  change class to zer0
	  write(31,2) numppp,zerostring
	end if
	goto 101
 111	close(unit=31)
 999	close(unit=30)
	return1
 900	write(6,*) '  *** no sao region file **'
	return1
 901	write(6,*) '  *** saoimage.reg file read format error ***'
	write(6,'('' ++: '',a40)') string
	return1
	end
c/////////////////////////////////////////
c   subroutine to make co-ord file names for various displays
c
	subroutine makecooname(inname,appen,nfr,outname)
	character inname*20,appen*3,outname*20,nfrstr*2
c make string for frame number
	istatus=encode(nfrstr,float(nfr),1,0,idum) 
c  get rid of any appending qualifier in the input name
	do 100 i=1,20
	  if (inname(i:i).eq.'.'.or.inname(i:i).eq.' ') goto 101
 100	continue
 101	leng=i-1
	outname=inname(1:leng)//nfrstr(1:lnblnk(nfrstr))//'.'//appen
	return
	end
c//////////////////////////////////////////
c  subroutine to read box co-ordinates (smallest xy and largest xy)
c    input=a string with optional format:
c                    (1) ppp crbp b format (b n1 n2 n3 n4)
c                    (2) simple 4 number format (n1 n2 n3 n4)
c                    (3) saoimage box format: _BOX(xc,yc,dx,dy)
	subroutine rdcoobox(string,ix1,iy1,ix2,iy2,iorient,ni,nj,*)
	integer ix1,ix2,iy1,iy2
        integer ib(6),ie(6)
        character string*40,numstring*30
	call fixsaocor(delx,dely,iorient,ni,nj)
        if (string(2:4).eq.'BOX') then
c parse sao string
          call saonumst(string,numstring)
c saoimage format, read in xc etc
	  if (iorient.eq.0) then
            read(numstring,*,err=999) xc,yc,ysize,xsize
	  else
            read(numstring,*,err=999) xc,yc,xsize,ysize
	  end if
          ix1=max0(1,int(xc-0.5*xsize+delx))
          iy1=max0(1,int(yc-0.5*ysize+dely))
          ix2=max0(1,int(xc+0.5*xsize+delx))
          iy2=max0(1,int(yc+0.5*ysize+dely))
c         ix1=nint(xc-0.5*(xsize-1.))
c         iy1=nint(yc-0.5*(ysize-1.))
c         ix2=nint(xc+0.5*(xsize-1.))
c         iy2=nint(yc+0.5*(ysize-1.))
        else
          call fstr(string,40,IB,IE,np)
          if (string(ib(1):ie(1)).eq.'b') then
            istart=2
          else
            istart=1
          end if
	  read(string(ib(istart):ie(istart)),*,err=999) ix1
          read(string(ib(istart+1):ie(istart+1)),*,err=999) iy1
          read(string(ib(istart+2):ie(istart+2)),*,err=999) ix2
          read(string(ib(istart+3):ie(istart+3)),*,err=999) iy2
        end if
        return
 999    write(6,*) '    *** read error ***'
        return1
        end
c//////////////////////////////////////////
c  subroutine to read 2 point co-ordinates (smallest xy and largest xy)
c      * they must in order*
c    input=a string with format:
c                    saoimage point format: _POINT(xc,yc)
	subroutine rdcoopt(string1,string2,
     *                 ix1,iy1,ix2,iy2,iorient,ni,nj,*)
c	integer*2 ix1,ix2,iy1,iy2
	integer ix1,ix2,iy1,iy2
        integer ib(6),ie(6)
        character string1*40,string2*40,numstring1*30,numstring2*30
	call fixsaocor(delx,dely,iorient,ni,nj)
        if (string1(2:4).eq.'POI'.and.string2(2:4).eq.'POI') then
c parse sao string
          call saonumst(string1,numstring1)
          call saonumst(string2,numstring2)
c saoimage format, read in xc etc
	  if (iorient.eq.1) then
            read(numstring1,*,err=999) xc1,yc1
            read(numstring2,*,err=999) xc2,yc2
	  else
	    write(6,*) ' ** iroient=0 not supported ** '
	  end if
          ix1=max0(1,nint(xc1))
          iy1=max0(1,nint(yc1))
          ix2=max0(1,nint(xc2))
          iy2=max0(1,nint(yc2))
	else
	  ix1=-999
	  iy1=-999
	  ix2=-999
	  iy2=-999
	end if
        return
 999    write(6,*) '    *** read error ***'
        return1
        end

c///////////////////////////////////////////////////////
c  subroutine to return a string of only numbers from a sao string
c
	subroutine saonumst(string,stringout)
	character string*40,stringout*30
	do 100 i=1,40
	  if (string(i:i).eq.'(') go to 120
 100	continue
 120	ibeg=i+1
	do 101 i=ibeg,40
	  if (string(i:i).eq.')') go to 121
 101	continue
 121	iend=i-1
	stringout=string(ibeg:iend)
	return
	end
c//////////////////////////////////////////////////////////
c  subroutine to display marked objects on pc2 plot and
c             enter hdr.fix file entry
c
	subroutine pc2hdrfix(*,nfr,comstr,ix,nu,nv,kf)
	parameter(nmax=12000)
	INTEGER IX(NU,NV,KF),icl(nmax),iref(300),ichn(100),
     *            newcl(100),newap(100)
	character phmname*20,comstr*60,phmtem*18,hdrfixname*18,
     *            secstr*1
	dimension rad(nmax),c2(nmax),rmag(nmax),err(nmax),itr(300)
	include 'ppparm.inc'
        include 'objcat.inc' 
        include 'picdir.inc' 
 2000	call querynfr(nfr,kf,0,*999,*2001)
 2001	if (nfr.gt.nposfil) then
	  write(6,2) nposfil+1
 2	format(' +++This command must be run with nframe <',i2,'+++')
	  nfr=0
	  goto 2000
	end if
c read .phm data
	if (comstr.ne.' ') then
	  phmname=comstr(1:18)
	else
 600	  write(6,1) 
 1	format('  Enter .phm name (default .phm added): ',$)
	  read(5,'(a20)',end=999) phmname
	end if
	do 100 i=1,20
	  if (phmname(i:i).eq.'.') goto 101
 100	continue
c add .phm if it does not end in ".B"
	if (phmname(lnblnk(phmname)-1:lnblnk(phmname)).ne.'.B') 
     *     phmname=phmname(1:lnblnk(phmname))//'.phm'
c add section number if needed
	if (nsct(nfr).gt.0) then
	  istatus=encode(secstr,float(nsct(nfr)),1,0,idum)
          phmname=phmname(1:lnblnk(phmname))//'.'//secstr
	end if
 101	open(unit=28,file=phmname,status='old',err=6001)
	goto 6002
 6001	read(5,'(a20)',end=999) phmname
	goto 101
 6002	call readrad(28,nob(nfr),ijoi(1,nfr),ijoj(1,nfr),
     *     rad,rmag,err,c2,icl,1,ideld,nref,iref,nmax,icflag)
	close(unit=28)
c plot pc2 file
	phmtem=phmname
	do 110 i=1,nref
	  itr(i)=iref(i)
 110	continue
	call pc2plot(nfr,rmag,c2,err,itr,nref,clsc,icl,phmtem,
     *      nsct(nfr),nfix,ichn,newcl,newap,ix,nu,nv,kf)
c save hdr.fix file
 601	write(6,22) 
 22	format('   Enter hdr.fix file name (.fix.n appended'
     *      ,', <cr>=none): ',$)
	read(5,'(a18)',end=998) hdrfixname
	if (hdrfixname.eq.' ') goto 998
c add section number if needed
	hdrfixname=hdrfixname(1:lnblnk(hdrfixname))//'.fix'
	if (nsct(nfr).gt.0) then
          hdrfixname=hdrfixname(1:lnblnk(hdrfixname))//'.'//secstr
	end if
	call opennew(28,1,18,hdrfixname,*999)
	write(28,10) hdrfixname(1:(lnblnk(hdrfixname)-4))
 10	format('# hdr fix file for ',a14)
	do 111 i=1,nfix
	  write(28,11) ichn(i),newcl(i),newap(i),ijoi(ichn(i),nfr),
     *                 ijoj(ichn(i),nfr)
 11	format(i5,i3,i4,4x,2i6)
 111	continue
	close(unit=28)
c delete all obj*.fits files
 998	call system('\\rm pppobj*.fits')
 999	return1
	end
c////////////////////////////////////////////////////////////
c  subroutine to plot multiobject slits on image
c         uses .puma file
c
	subroutine dispslit(*,nfr,ix,nu,nv,kf,ipar)
	parameter (maxsl=1200)
	dimension slx(maxsl),sly(maxsl),slen(maxsl),swid(maxsl)
 	integer ix(nu,nv,kf)
	character name*18,headblk*2880,ddodisname*60
     *     ,cstring*120,objnam*35,head*10
	include 'pppcore.inc'
	include 'picdir.inc'
	common/header/bzero,bscale,headblk(20),nhb
	call querynfr(nfr,kf,0,*999,*2001)
c  read puma file
 2001   call rdpuma(nslit,slx,sly,slen,swid,maxsl,*999)
c  make reg file for saoimage
	if (specl.lt.1.0) then
	  specl=700.
	  specsh=0.
	end if
 600	write(6,1) specl,specsh
 1	format('  Enter spectral length and shift in pixels [',2f6.0,
     *         ']: ',$)
	call read2r(specl,specsh,*999,*600)
	ipart=0
	call saoslit(nfr,maxsl,nslit,slx,sly,slen,swid,specl,
     *               specsh,ipart)
 999	return1
	end

c////////////////////////////////////////////////////////
c
c  subroutine to read puma file
c
	subroutine rdpuma(ndr,slx,sly,slen,swid,nmax,*)
	dimension slx(nmax),sly(nmax),slen(nmax),swid(nmax)
	character pumaname*60,str*90
 600	write(6,1)
 1	format('  Enter puma file name: ',$)
	read(5,'(a60)',end=999) pumaname
	do 100 i=1,lnblnk(pumaname)
	  if (pumaname(i:i).eq.'.') go to 101
 100	continue
c append .puma
	pumaname=pumaname(1:lnblnk(pumaname))//'.puma'
 101	open(unit=35,file=pumaname,status='old',err=601)
	go to 102
 601	write(6,2) pumaname
 2	format('  *** file ',a20,' does not exist **')
	go to 600
 102	ndr=0
 103	read(35,3,end=998) str
 3	format(a90)
	if (str(2:4).ne.'MOS') go to 103
	ndr=ndr+1
	read(str,4,err=800) slx(ndr),sly(ndr),slen(ndr),swid(ndr)
     *          ,numppp,slitmag,ipc
c    *          ,numppp(ndr),slitmag(ndr),ipc(ndr)
 4	format(10x,f6.1,1x,f6.1,1x,f6.2,1x,f5.2,6x,i5,22x,f6.2,i2)
c	if (slen(ndr).eq.swidt) then
c it is an alignment star
c	  nal=nal+1
c	  alwidp=swidt
c	  alx(nal)=slx(ndr)
c	  aly(nal)=sly(ndr)
c	  almag(nal)=slitmag(ndr)
c	  ipal(nal)=ipc(ndr)
c	  numpal(nal)=numppp(ndr)
c	  ndr=ndr-1
c	  write(6,5) nal,alx(nal),aly(nal),alwidp,alwidp,numpal(nal),
c     *          almag(nal),ipal(nal)
c	else
c	  swid=swidt
	write(6,5) ndr,slx(ndr),sly(ndr),slen(ndr),swid(ndr),numppp,
     *          slitmag,ipc
 5	format(i3,' MOS_SLIT(',f6.1,',',f6.1,',',f6.2,',',f5.2,')',2x,
     *         'ppp# ',i5,'  mag:',f7.2,3x,i1)
	go to 103
 800	write(6,*) '   +++ read error, line ',ndr-npr
	ndr=ndr-1
	go to 103
 998	close(unit=35)
	return
 999	return1
	end
c////////////////////////////////////////////////////
c  subroutine to create a region file to mark slits from puma file
c   objects in saoimage
c    ipar=1  objects are marked with red boxes, with idob=1 objects with
c         smaller circles
c    ipar=0 same as 1 but no output
c    ipar=2 objects are marked with numbers
c  
	subroutine saoslit(nfr,nmax,ndr,slx,sly,slen,swid,specl,
     *       specsh,ipart)
	dimension slx(nmax),sly(nmax),slen(nmax),swid(nmax)
	character filename*20,refstr*4,strl*1,formstr*80
	include 'objcat.inc'
	include 'ppparm.inc'
	include 'picdir.inc'
	include 'tvparm.inc'
 	call makecooname(saoregname,'reg',nfr,filename)
 	call opennew(32,1,20,filename,*999)
	write(6,10) filename
 10	format(' ... slit file written out as: ',a20)
c   set delta to correct for sao bug
	call fixsaocor(delpx,delpy,iorient,nii(nfr),njj(nfr))
c write objects
	ipar=1
	write(6,*) ' number of slits',ndr
	if (ipar.le.1) then
	  ireadsaoreg=0
	  do 100 i=1,ndr
	    xt=slx(i)-delpx
	    yt=sly(i)-delpy
	    write(32,2) xt,yt,slen(i),swid(i)
	    write(32,3) xt,yt+specsh,slen(i),specl
 2	format('-BOX(',f7.1,',',f7.1,',',f5.1,',',f7.1,')')
 3	format('BOX(',f7.1,',',f7.1,',',f5.1,',',f7.1,')')
 100	  continue
	else
c write objects with numbers
	  do 101 i=1,ndr
	    istatus=encode(refstr,float(i),1,0,idum)
	    istatus=encode(strl,float(lnblnk(refstr)),1,0,idum)
	    if (iorient.eq.0) then
	      idel=5
	    else
	      idel=-5
	    end if
	    formstr='(''-TEXT('',i5,'','',i5,'','//strl//
     *            ' ,"'',a'//strl//',''")'')'
 	    write(32,formstr) slx(i)-idel,sly(i)-idel,refstr
 101	  continue
	end if
	close(unit=32)
 999	continue
	return
	end
