C/////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO ADD  POINT SPREAD FUNCTION TO PICTURE
C
C////////////////////////////////////////////////////////////////
	SUBROUTINE PSFADD(*,NFR,kpsf,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF),iob2,job2,ipsf2,jpsf2
	INTEGER IX(NU,NV,KF),iob2,job2,ipsf2,jpsf2
	INCLUDE 'picdir.inc'
	INCLUDE 'ppparm.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*2000)
 2000	if (kpsf.eq.0) then
 600	  WRITE(6,1)
 1	FORMAT('  Enter frame number of PSF (created from cpsf): ',$)
	  call read1i(kpsf,*999,*600)
	end if
	CALL QUERYNFR(kpsf,KF,0,*999,*2001)
c make a copy of the psf on the corner of the array buffer
 2001	if (nii(kpsf)*2.le.nu.and.njj(kpsf)*2.le.nv) then
	  nit=nii(kpsf)
	  njt=njj(kpsf)
	  do 110 j=1,njj(kpsf)
	    njt=njt+1
	    do 110 i=1,nii(kpsf) 
	      nit=nit+1
 110	      ix(nit,njt,kpsf)=ix(i,j,kpsf)
	  imov=1
	else
	  write(6,*) '  +++ warning: psf frame will be altered +++'
	  imov=0
	end if  
 601	write(6,2) xadd,yadd
 2	format('  Enter coord (real) of position for added PSF [dflt:'
     *           ,2f8.3,/
     *     '     (0.,0.) if you want to add relative to an obj.: ',$)
	call read2r(xadd,yadd,*999,*601)
	if (xadd.lt.0.0001.and.yadd.lt.0.0001) then
c  ask for central object
 602	  WRITE(6,3) IOB,JOB
 3	FORMAT('  Enter integer co-ordinates of object (dflt',2I5,
     *           '): ',$)
	  CALL READ2I(IOB,JOB,*999,*602)
	  idiam=5
	  irobj=65
	  write(6,*)' ..Diameters [5,75] used for centroid determination'
c 6002	  WRITE(6,40) IDIAM,IROBJ
c 40	FORMAT('   Enter inner and outer sky ring diameters for object ',
c     *     '(dflt',2I4,'): ',$)
c	CALL READ2I(IDIAM,IROBJ,*999,*6002)
	  CDIAM=IDIAM
C determine fractional centroid and back ground
 	  iob2=iob
	  job2=job
	  CALL PCENTR(NFR,0,IX,NU,NV,KF,CENOX,CENOY,DUM,OBJSKY,
     *              IOB2,JOB2,1,CDIAM,IROBJ,1,20)
	  WRITE(6,4) CENOX,CENOY,OBJSKY
 4	  FORMAT( '     Centroid: ',2F9.4,'   Sky: ',F8.2)
 603	  write(6,5) delx,dely
 5	format('  Enter delta x and y for added PSF from objecti [',
     *         2f7.3,']: ',$)
	  call read2r(delx,dely,*999,*603)
	  xadd=cenox+delx
	  yadd=cenoy+dely
	  write(6,6) xadd,yadd
 6	format('  ... Position of added PSF: ',2f9.4)
	end if
 604	WRITE(6,7) IPSF,JPSF
 7	FORMAT('  Enter integer co-ordinates of PSF (dflt:',2I5,'): ',$)
	CALL READ2I(IPSF,JPSF,*999,*604)
 605	WRITE(6,8) ,IRPSF
 8	FORMAT('   Enter outer ring diameter for PSF centroid'
     *       ,' (dflt',I4,'): ',$)
	CALL READ1I(IRPSF,*999,*605)
	ipsf2=ipsf
	jpsf2=jpsf
	CALL PCENTR(KPSF,0,IX,NU,NV,KF,CENSX,CENSY,DUM,PSFSKY,
     *             IPSF2,JPSF2,1,CDIAM,IRPSF,1,20)
	WRITE(6,9) CENSX,CENSY,PSFSKY
 9	FORMAT( '     Centroid: ',2F9.4,'   Sky: ',F8.2)
 606	WRITE(6,10) IDSUB
 10	FORMAT('   Enter SIZE (int pix) of area around PSF to be', 
     *         ' added (dflt',I4,'): ',$)
	CALL READ1I(IDSUB,*999,*606)
 607	write(6,11) scale
 11 	format('  Enter flux scaling for psf [dflt:',f6.2,']: ',$)
	call read1r(scale,*999,*607)
c   determine shift of psf needed to match object
	ixadd=xadd
	iyadd=yadd
	shx=xadd-float(ixadd)-(censx-float(ipsf))
	shy=yadd-float(iyadd)-(censy-float(jpsf))
c sinc shift psf, scale, and add
	call sincshif(*200,kpsf,shx,shy,ix,nu,nv,kf)
 200	call psadd(nfr,kpsf,ixadd,iyadd,ipsf,jpsf,psfsky,scale,idsub,
     *                ix,nu,nv,kf)	
c move original psf bacl
	if (imov.eq.1) then
	  nit=nii(kpsf)
	  njt=njj(kpsf)
	  do 111 j=1,njj(kpsf)
	    njt=njt+1
	    do 111 i=1,nii(kpsf) 
	      nit=nit+1
 111	      ix(i,j,kpsf)=ix(nit,njt,kpsf)
	end if
 999	return1
	end
C
C////////////////////////////////////////////////////////////////////
C
C   add psf
C
	SUBROUTINE PSADD(NFR,NFR2,IOB,JOB,IPSFF,JPSFF,PSFSKY,SCALE,
     *                      IDSUB,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INCLUDE 'picdir.inc'
	IDSQ=NINT(.25*IDSUB*IDSUB)
	SCSKY=SCALE*PSFSKY
	DO 100 J=2,NJJ(NFR2)-1
	  JJ=JOB-JPSFF+J
	  JSQ=(J-JPSFF)*(J-JPSFF)
	  DO 100 I=2,NII(NFR2)-1
	    IF ((I-IPSFF)*(I-IPSFF)+JSQ.GT.IDSQ) GO TO 100
	    II=IOB-IPSFF+I
    	    ITT=INTLIMI(NINT(SCALE*IX(I,J,NFR2)-SCSKY))
	    IX(II,JJ,NFR)=IX(II,JJ,NFR)+ITT
 100	CONTINUE
 999	RETURN
	END

