C/////////////////////////////////////////////////////////////////////
C  Subroutine to generate an array of radndom number between 0 and 1
C    (the seed is tied to the second of the VAX timer *100)
C    The seed is tied to the elapsed execution time
C    given by the Sun timer *100 (real function etime(tarray))
C    RANGENG distributed Guassianly, with sigma=SIGMA
C    RANGENU distributed uniformly
C    testing of this program can be done by running TRANDOM
C     NN= SIZE OF ARRAY
C     RNUM= ARRAY OF RANDOM NUMBER
C
	subroutine randomcheck(*)
	dimension rnum(100)
 600 	write(6,1) nn
 1	format('  Enter the number of random numbers wanted:',i4,': ',$)
	nn=min0(nn,100)
	call read1i(nn,*999,*600)
	call rangenu(nn,rnum)
 999	return1
	end
	SUBROUTINE RANGENU(NN,RNUM)
	DIMENSION RNUM(1)
c	REAL ETIME, TARRAY(2)
c	T=ETIME(TARRAY)
C	T=SECNDS(0.)
c	ISEED=NINT(T*100)-(INT(T/100))*100000
c	TEST=RAN1(-ISEED)
c 	WRITE(6,*) t,tarray(1),tarray(2),ISEED,TEST
	iseed=itimeseed()
	DO I=1,NN
	  RNUM(I)=RAN1(ISEED)
	  write(6,*) rnum(i),iseed
	END DO
	RETURN
	END
C
C
	SUBROUTINE RANGENG(NN,RNUM,SIGMA)
	DIMENSION RNUM(1)
	REAL ETIME, TARRAY(2)
	T=ETIME(TARRAY)
C	T=SECNDS(0.)
	ISEED=NINT(T*100)-(INT(T/100))*10000
	ISEED=-((ISEED*10000.)/2)*2+1
	DO I=1,NN
	  RNUM(I)=SIGMA*GASDEV(ISEED)
	END DO
	RETURN
	END
C
C
	FUNCTION RANGAUSS(ISEED,SIGMA)
	A=0.
	DO K=1,12
	  A=A+RAN1(ISEED)
	END DO
	RANGAUSS=(A-6.)*SIGMA
	RETURN
	END
